(function($) {
  // Used by dateinput
  $.expr = {':': {}};

  // Used by bootstrap
  $.support = {};

  // Used by dateinput
  $.fn.clone = function(){
      var ret = $();
      this.each(function(){
          ret.push(this.cloneNode(true))
      });
      return ret;
  };

  // Used by util.js
  $.fn.scrollTop = function(scrollTop) {
    this.each(function() {
      this.scrollTop = scrollTop;
    });
    return this;
  };

  // Used by colorslider.js
  ['width', 'height'].forEach(function(dimension) {
    var offset, Dimension = dimension.replace(/./, function(m) { return m[0].toUpperCase() });
    $.fn['outer' + Dimension] = function(margin) {
      var elem = this;
      if (elem) {
        var size = elem[dimension]();
        var sides = {'width': ['left', 'right'], 'height': ['top', 'bottom']};
        sides[dimension].forEach(function(side) {
          if (margin) size += parseInt(elem.css('margin-' + side), 10);
        });
        return size;
      } else {
        return null;
      }
    };
  });

  // Used by bootstrap
  $.proxy = function( fn, context ) {
    if ( typeof context === "string" ) {
      var tmp = fn[ context ];
      context = fn;
      fn = tmp;
    }

    // Quick check to determine if target is callable, in the spec
    // this throws a TypeError, but we will just return undefined.
    if ( !$.isFunction( fn ) ) {
      return undefined;
    }

    // Simulated bind
    var args = Array.prototype.slice.call( arguments, 2 ),
      proxy = function() {
        return fn.apply( context, args.concat( Array.prototype.slice.call( arguments ) ) );
      };

    // Set the guid of unique handler to the same of original handler, so it can be removed
    proxy.guid = fn.guid = fn.guid || proxy.guid || $.guid++;

    return proxy;
  };

  // Used by timeago
  var nativeTrim = String.prototype.trim;
  $.trim = function(str, characters){
    if (!characters && nativeTrim) {
      return nativeTrim.call(str);
    }
    characters = defaultToWhiteSpace(characters);
    return str.replace(new RegExp('\^[' + characters + ']+|[' + characters + ']+$', 'g'), '');
  };

  // Used by util.js
  var rtable = /^t(?:able|d|h)$/i,
  rroot = /^(?:body|html)$/i;
  $.fn.position = function() {
    if ( !this[0] ) {
      return null;
    }

    var elem = this[0],

    // Get *real* offsetParent
    offsetParent = this.offsetParent(),
    // Get correct offsets
    offset       = this.offset(),
    parentOffset = rroot.test(offsetParent[0].nodeName) ? { top: 0, left: 0 } : offsetParent.offset();

    // Subtract element margins
    // note: when an element has margin: auto the offsetLeft and marginLeft
    // are the same in Safari causing offset.left to incorrectly be 0
    offset.top  -= parseFloat( $(elem).css("margin-top") ) || 0;
    offset.left -= parseFloat( $(elem).css("margin-left") ) || 0;

    // Add offsetParent borders
    parentOffset.top  += parseFloat( $(offsetParent[0]).css("border-top-width") ) || 0;
    parentOffset.left += parseFloat( $(offsetParent[0]).css("border-left-width") ) || 0;

    // Subtract the two offsets
    return {
      top:  offset.top  - parentOffset.top,
      left: offset.left - parentOffset.left
    };
  };

  $.fn.offsetParent = function() {
    var ret = $();
    this.each(function(){
      var offsetParent = this.offsetParent || document.body;
      while ( offsetParent && (!rroot.test(offsetParent.nodeName) && $(offsetParent).css("position") === "static") ) {
        offsetParent = offsetParent.offsetParent;
      }
      ret.push(offsetParent);
    });
    return ret;
  };
  
  // For dateinput
  Event.prototype.isDefaultPrevented = function() {
    return this.defaultPrevented;
  };
 
 //     Zepto.js
 //     (c) 2010-2014 Thomas Fuchs
 //     Zepto.js may be freely distributed under the MIT license.
 
 ;(function($, undefined){
   var document = window.document, docElem = document.documentElement,
   origShow = $.fn.show, origHide = $.fn.hide, origToggle = $.fn.toggle
   
   function anim(el, speed, opacity, scale, callback) {
   if (typeof speed == 'function' && !callback) callback = speed, speed = undefined
   var props = { opacity: opacity }
   if (scale) {
   props.scale = scale
   el.css($.fx.cssPrefix + 'transform-origin', '0 0')
   }
   return el.animate(props, speed, null, callback)
   }
   
   function hide(el, speed, scale, callback) {
   return anim(el, speed, 0, scale, function(){
               origHide.call($(this))
               callback && callback.call(this)
               })
   }
   
   $.fn.show = function(speed, callback) {
   origShow.call(this)
   if (speed === undefined) speed = 0
   else this.css('opacity', 0)
   return anim(this, speed, 1, '1,1', callback)
   }
   
   $.fn.hide = function(speed, callback) {
   if (speed === undefined) return origHide.call(this)
   else return hide(this, speed, '0,0', callback)
   }
   
   $.fn.toggle = function(speed, callback) {
   if (speed === undefined || typeof speed == 'boolean')
   return origToggle.call(this, speed)
   else return this.each(function(){
                         var el = $(this)
                         el[el.css('display') == 'none' ? 'show' : 'hide'](speed, callback)
                         })
   }
   
   $.fn.fadeTo = function(speed, opacity, callback) {
   return anim(this, speed, opacity, null, callback)
   }
   
   $.fn.fadeIn = function(speed, callback) {
   var target = this.css('opacity')
   if (target > 0) this.css('opacity', 0)
   else target = 1
   return origShow.call(this).fadeTo(speed, target, callback)
   }
   
   $.fn.fadeOut = function(speed, callback) {
   return hide(this, speed, null, callback)
   }
   
   $.fn.fadeToggle = function(speed, callback) {
   return this.each(function(){
                    var el = $(this)
                    el[
                       (el.css('opacity') == 0 || el.css('display') == 'none') ? 'fadeIn' : 'fadeOut'
                       ](speed, callback)
                    })
   }
 
})(Zepto);