Array.prototype.contains = function(obj) {
	var i = this.length;
	while (i--) {
		if (this[i] == obj) {
			return true;
		}
	}
	return false;
}

var clearhistorybool = false;

function clickedTopLogo() {
	clearhistorybool = true;
	clearHistory();
	loadDashboard(true);
	hideMenu();
}

function clearMainDivs() {
	$('#eventDiv').hide();
	$('#loginDiv').hide();
	$('#homeDiv').hide();
	$('#homeSingleCodeDiv').hide();
	$('#eventListDiv').hide();
}


function choosePostActions(post_id) {
	var options = {
		'androidTheme': window.plugins.actionsheet.ANDROID_THEMES.THEME_HOLO_LIGHT, // default is THEME_TRADITIONAL
		'title': trd('choose-post-actions-title'),
		'buttonLabels': [trd('delete-post')],
		'androidEnableCancelButton': true, // default false
		'winphoneEnableCancelButton': true, // default false
		'addCancelButtonWithLabel': trd('choose-post-actions-cancel'),
		'position': [20, 40] // for iPad pass in the [x, y] position of the popover
	};
	context_post_id = post_id;
	window.plugins.actionsheet.show(options, chosenPostAction);
}

function choosePhotoMethod(context) {
	if (context) {
		context_action_sheet_action = context;
	}
	var options = {
		'androidTheme': window.plugins.actionsheet.ANDROID_THEMES.THEME_HOLO_LIGHT, // default is THEME_TRADITIONAL
		'title': trd('choose-photo-feed-capture-method-title'),
		'buttonLabels': [trd('choose-photo-feed-capture-method-camera'), trd('choose-photo-feed-capture-method-library')],
		'androidEnableCancelButton': true, // default false
		'winphoneEnableCancelButton': true, // default false
		'addCancelButtonWithLabel': trd('choose-photo-feed-capture-method-cancel'),
		'position': [20, 40] // for iPad pass in the [x, y] position of the popover
	};
	window.plugins.actionsheet.show(options, chosenPhotoMethod);
}

function chosenPostAction(buttonIndex) {
	setTimeout(function() {
		if (buttonIndex == 1) {
			deletePost(context_post_id);
		} else if (buttonIndex == 1) {
			photo_share.imageLink();
		} else {
			// do nothing, john snow
		}
	});
}

function chosenPhotoMethod(buttonIndex) {
	setTimeout(function() {
		if (buttonIndex == 1) {
			takePhotoForFeed();
		} else if (buttonIndex == 2) {
			choosePhotoForFeed();
		} else {
			// do nothing, john snow
		}
	});
}

function loginWithFB() {
	// After device ready, create a local alias
	var facebookConnect = window.plugins.facebookConnect;

	facebookConnect.login({ permissions: ["email", "user_about_me"], appId: "1508352492711803" }, function(result) {
		console.log("FacebookConnect.login:" + JSON.stringify(result));

		// Check for cancellation/error
		if (result.cancelled || result.error) {
			console.log("FacebookConnect.login:failedWithError:" + result.message);
			return;
		}

		// Basic graph request example
		facebookConnect.requestWithGraphPath("/me", function(result) {

			var profile_data = {};
			profile_data.user_name = result.first_name + " " + result.last_name;
			profile_data.user_email = result.email;
			profile_data.user_subtitle = result.bio;
			profile_data.user_bio = '';
			profile_data.user_website = result.website;
			profile_data.user_fb_id = result.id;

			do_login_with_facebook(profile_data);

		});
	});
}

function loadCGHome() {

	var homeDivHtml = '';
	homeDivHtml += '<div id="homeDiv" class="homeDiv hidden scroll">';
	homeDivHtml += '<div class="home_content">';
	homeDivHtml += '<div class="home_logo">';
	homeDivHtml += '<img src="img/Logo_medium.png" />';
	homeDivHtml += '</div>';
	homeDivHtml += '<input type="text" id="event_code_input" placeholder="e.g. DEMOCONGRESS" />';
	homeDivHtml += '<div class="btn-home font_bold" onclick="getEventWithCode($(\'#event_code_input\').val());">' + trd('bt-submit-code') + '</div>';
	homeDivHtml += '</div>';
	if (isIOS) {
		homeDivHtml += '<div class="bt-qr-code" onclick="showScanner();"></div>';
	}

	homeDivHtml += '</div>';

	$('#homeDiv').remove();

	$('body').append(homeDivHtml);

	FastClick.attach(document.body);
}

function loadSingleCodeHome() {

	var homeDivHtml = '';
	homeDivHtml += '<div id="homeSingleCodeDiv" class="homeSingleCodeDiv color_bg_division_1 hidden scroll" style="display:flex;align-items:center;justify-content:center;flex-direction: column;text-align:center;">';
	homeDivHtml += '<div class="code_div" style="display:block;width:90%;margin:auto;">';
	homeDivHtml += '<img src="config/login_logo.png" width="200" height="200" />';
	homeDivHtml += '<input type="text" id="event_code_input" placeholder="Insira o código do evento" style="background-color:transparent;color:white;border:2px solid white;width:100%;box-sizing:border-box;" />';
	homeDivHtml += '<div class="block_button font_color_dark" onclick="getEventWithCode($(\'#event_code_input\').val());" style="margin-top:30px;background-color:white;padding-top:15px;padding-bottom:15px;margin-left:0;margin-right:0;">ENTRAR</div>';
	homeDivHtml += '</div>';
	homeDivHtml += '</div>';

	$('#homeSingleCodeDiv').remove();

	$('body').append(homeDivHtml);

	FastClick.attach(document.body);
}

function showCGHome() {
	clearMainDivs();
	$('#homeDiv').show();
}


function showSingleCodeHome() {

	clearMainDivs();

	$('#homeSingleCodeDiv').show();

}


function showCongressList() {
	clearMainDivs();
	$('#eventListDiv').show();
}

function showEventDiv() {
	clearMainDivs();
	$('#eventDiv').show();
}

function showLoginDiv() {
	clearMainDivs();
	loadLoginPage();
	$('.header').removeClass('pulledright');
	$('#loginDiv').show();
}


function showScanner() {

	cordova.plugins.barcodeScanner.scan(
		function(result) {
			/*alert("We got a barcode\n" +
			      "Result: " + result.text + "\n" +
			      "Format: " + result.format + "\n" +
			      "Cancelled: " + result.cancelled);*/
			console.log("We got a barcode\n" +
				"Result: " + result.text + "\n" +
				"Format: " + result.format + "\n" +
				"Cancelled: " + result.cancelled);
			if (!result.cancelled) {
				var code = result.text;
				var url_array = code.split("ec=");
				if (url_array.length > 1) {
					code = url_array[url_array.length - 1];
				} else {
					code = url_array[0];
				}

				getEventWithCode(code);
			}

		},
		function(error) {
			showToastrAlert('error', "Scanning failed: " + error);
		}
		/*{
		    "preferFrontCamera" : true, // iOS and Android
		    "showFlipCameraButton" : true, // iOS and Android
		    "prompt" : "Place a barcode inside the scan area", // supported on Android only
		    "formats" : "QR_CODE,PDF_417", // default: all but PDF_417 and RSS_EXPANDED
		    "orientation" : "landscape" // Android only (portrait|landscape), default unset so it rotates with the device
		}*/
	);
}

function scanLink() {
	cordova.plugins.barcodeScanner.scan(
		function(result) {
			/*alert("We got a barcode\n" +
			      "Result: " + result.text + "\n" +
			      "Format: " + result.format + "\n" +
			      "Cancelled: " + result.cancelled);*/
			console.log("We got a barcode\n" +
				"Result: " + result.text + "\n" +
				"Format: " + result.format + "\n" +
				"Cancelled: " + result.cancelled);
			if (!result.cancelled) {
				openLink(result.text);
			}

		},
		function(error) {
			showToastrAlert('error', "Scanning failed: " + error);
		}
	);

}

function scanUserBadge() {
	cordova.plugins.barcodeScanner.scan(
		function(result) {
			/*alert("We got a barcode\n" +
			      "Result: " + result.text + "\n" +
			      "Format: " + result.format + "\n" +
			      "Cancelled: " + result.cancelled);*/
			console.log("We got a barcode\n" +
				"Result: " + result.text + "\n" +
				"Format: " + result.format + "\n" +
				"Cancelled: " + result.cancelled);
			if (!result.cancelled) {
				var code = result.text;
				var url_array = code.split("ec=");
				if (url_array.length > 1) {
					code = url_array[url_array.length - 1];
				} else {
					code = url_array[0];
				}

				getUserProfile('code', code);
			}

		},
		function(error) {
			showToastrAlert('error', "Scanning failed: " + error);
		}
	);
}

function scanParticipantBadge() {

	cordova.plugins.barcodeScanner.scan(
		function(result) {
			/*alert("We got a barcode\n" +
			      "Result: " + result.text + "\n" +
			      "Format: " + result.format + "\n" +
			      "Cancelled: " + result.cancelled);*/
			console.log("We got a barcode\n" +
				"Result: " + result.text + "\n" +
				"Format: " + result.format + "\n" +
				"Cancelled: " + result.cancelled);
			if (!result.cancelled) {
				var code = result.text;
				var url_array = code.split("ec=");
				if (url_array.length > 1) {
					code = url_array[url_array.length - 1];
				} else {
					code = url_array[0];
				}

				getProfileForCode(code);
			}

		},
		function(error) {
			showToastrAlert('error', "Scanning failed: " + error);
		}
		/*{
		    "preferFrontCamera" : true, // iOS and Android
		    "showFlipCameraButton" : true, // iOS and Android
		    "prompt" : "Place a barcode inside the scan area", // supported on Android only
		    "formats" : "QR_CODE,PDF_417", // default: all but PDF_417 and RSS_EXPANDED
		    "orientation" : "landscape" // Android only (portrait|landscape), default unset so it rotates with the device
		}*/
	);
}

function getProfileForCode(code) {

	var params = {
		f: 'getProfileForCode',
		user_id: user_data.profile.user_id,
		user_data: user_data,
		event_id: this_congress.congress_information.congress_id,
		code: code
	};

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function profileRetrieved(response) {
			if (response.success) {
				var this_profile = response.object;
				loadProfileDetail(this_profile.user_id);
				hideMenu();
			} else {
				showToastrAlert('success', trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('ERROR:' + JSON.stringify(xhr));
			showToastrAlert('error', trd('error-getting-code'));
		}
	});
}

function refreshUserProfile() {

}

function checkMandatory() {
	var all_checked = true;
	if (!this_congress.congress_information.mandatory_feedback) {
		return true;
	}
	if (user_data.profile.anonymous == '1') {
		return true;
	} else {
		var mandatory_items = this_congress.congress_information.mandatory_feedback.split(',');
		$.each(mandatory_items, function(index, this_mandatory_item) {
			if (this_mandatory_item.indexOf('feedback_') > -1) {
				var feedback_id = this_mandatory_item.split('_')[1];
				if (!user_data.profile.feedback['' + feedback_id]) {
					getInstantFeedback(feedback_id);
					all_checked = false;
					return false;
				}
			} else if (this_mandatory_item == 'user_location') {
				if (!user_data.location && isMobile) {
					showQueryUserLocation();
					all_checked = false;
					return false;
				}

			}
		});
	}
	return all_checked;
}

function getUserProfile(auth_mode, auth_value, quiet, fromHistory) {

	var isRefreshing = (auth_mode == 'refresh');

	if (auth_mode == 'code' && !auth_value) {
		auth_value = $('#auth_code').val();
	}

	if (auth_mode == 'email' && !auth_value) {
		auth_value = $('#auth_email').val();
	}

	if (auth_mode == 'profile_email_or_code' && !auth_value) {
		auth_value = $('#auth_by_email_or_code').val();
	}

	if (auth_mode == 'profile_email_and_code' && !auth_value) {
		auth_value = $('#auth_email').val();
		var auth_validation = $('#auth_code').val();
	}

	if (auth_mode == 'refresh') {
        //this could provoke showDuplicateUsersModal
		//if (user_data.profile && user_data.profile.user_email) {
			//auth_mode = 'email';
			//auth_value = user_data.profile.user_email;
		if (user_data.profile && user_data.profile.user_id) {
			auth_mode = 'profile_user_id';
			auth_value = user_data.profile.user_id;
		} else {
			if (!quiet) {
				loadAuthPage();
				return;
			} else {
				return;
			}
		}
	}

	showLoadingOverlay();
	var params = {
		f: 'getUserProfile',
		user_id: user_data.profile.user_id,
		user_data: user_data,
		event_id: this_congress.congress_information.congress_id
	};
	if (breaking_changes.user_pic_file) { params.user_pic_file = true; }
	if (auth_mode == 'email') {
		params.profile_email = auth_value;
	}
	if (auth_mode == 'code') {
		params.profile_code = auth_value;
	}
	if (auth_mode == 'profile_email_or_code') {
		params.profile_email_or_code = auth_value;
	}
	if (auth_mode == 'profile_email_and_code') {
		params.profile_email_and_code = auth_value;
		params.profile_validation = auth_validation;
	}

	if (auth_mode == 'profile_user_id') {
		params.profile_user_id = auth_value;
	}

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function profileRetrieved(response) {
			hideLoadingOverlay();
			if (response.success) {
				if (response.message == 'select-a-profile') {
					showDuplicateUsersModal(response.object);
					return;
				}
				console.log('new user profile is ' + JSON.stringify(response.object.rating));
				user_data.profile = response.object;
				saveUserDataToStorage();
				if (!quiet) {
					if (isRefreshing) {
						showToastrAlert('success', trd('user-profile-updated'));
					}
					if (after_login_action == 'new_post') {
						loadPhotoFeed();
						showNewPostModal();
						after_login_action = false;
					} else if (after_login_action == 'user_location') {
						showQueryUserLocation();
						after_login_action = false;
					} else if (after_login_action == 'scored_feedback') {
						closeModal();
						loadScoredFeedbackIndex();
						after_login_action = false;
					} else if (after_login_action == 'quick_refresh') {
						closeModal();
						after_login_action = false;
					} else if (after_login_action == 'suggest_check_profile') {
						closeModal();
						after_login_action = false;
						if (this_congress.congress_information.has_networking == '1' && this_congress.congress_information.show_tips == '1') {
							showToastrAlert('custom', {
								message: trd('your-profile-has-been-prefilled'),
								button_title: trd('check-my-profile'),
								button_javascript: 'renderMyProfile()',
								title: user_data.profile.user_name
							});
						}
					} else if (!checkMandatory()) {
						loadDashboard();
					} else {
						//loadMyProfile();
						if (isRefreshing) {
							renderMyProfile(fromHistory);
						} else {
							loadDashboard();
							closeModal();
						}

					}

					updateProfile();

					validateUser();

				}
			} else {
				showToastrAlert('error', trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('ERROR:' + JSON.stringify(xhr));
			showToastrAlert('error', trd('error-profile-not-retrieved'));
		}
	});

	$('#session_question_text').val('');
}


var cg_home = 'http://www.cms.cloudguideapp.com/';
var services_home = cg_home + 'services/';
var media_home = cg_home + 'media/';
var post_images_home = media_home + 'photo_feed/'
var user_pic_home = media_home + 'user/'

var update_timer_event_info;
var update_timer_session_info;
var registration_interval;
var refresh_news_timer;

var pushNotification;

var app_started = false;

var after_login_action = false;

var page_moving = false;

var MY_AGENDA_NO_FILTER = -1;
var MY_AGENDA_FILTER_SESSIONS = 1;
var MY_AGENDA_FILTER_EXHIBITORS = 2;
var MY_AGENDA_FILTER_POSTERS = 3;
var MY_AGENDA_FILTER_PROFILES = 4;
var MY_AGENDA_FILTER_NOTES = 5;
var MY_AGENDA_FILTER_MEETINGS = 6;

var SESSION_FILTER_DAY = -1;
var SESSION_FILTER_SESSION_TYPE = -1;
var SESSION_FILTER_LOCATION = -1;
var SESSION_FILTER_TAGS = [];

var open_days = [];
var open_groups = [];
var pastScroll = 0;
var pastScrollGrid = 0;
var pastScrollSpeakers = 0;
var pastScrollProfiles = 0;
var pastScrollConversations = 0;
var context_congress_id = 0;
var context_post_id = 0;
var context_event_code = '';
var context_action_sheet_action = false;

var EXHIBITOR_FILTER_TYPE = -1;

var SPONSOR_FILTER_TYPE = -1;

var SPEAKER_FILTER_TYPE = -1;

var POSTER_FILTER_TYPE = -1;

var POI_FILTER_TYPE = -1;

var RESOURCE_FILTER_TYPE = -1;

var DEFAULT_PINPOINT_SIZE = 60;
var DEFAULT_PINPOINT_FONT_SIZE = 24;

var FLOORPLAN_FILTER_FLOORPLAN = -1;
var FLOORPLAN_FILTER_EXHIBITOR_TYPE = -1;
var FLOORPLAN_FILTER_LOCATION_TYPE = -1;

var SEARCH_STRING = '';


var wwwRoot = '';
var fsRoot = '';

var fsDir = '';
var agent = window.navigator.userAgent;
var app_version = 4;

var isIOS;
var isTablet;
var isMobile = true;
var clickAttribute = 'ontouchstart';

var user_agendas = {};
var user_data = {};
var access_data = {};

var schedule = new Array();

var events_user_data = {};
var saved_congress = {};
var loaded_event_id = 0;
var public_events = {};

var this_congress = null;

var congress_information = {};
var day_information = {};
var sessions_information = {};
var speakers_information = {};
var sponsors_information = {};
var speakers_list_alphabetical = [];
var speaker_types = {};
var resources_information = {};
var resources_types_information = {};
var entity_information = {};
var sponsors_information = {};
var sponsor_types_information = {};
var maps_information = {};
var maps = [];
var posters_information = {};
var posters_gallery = [];
var newsList = [];
var news_information = {};
var exhibitors_information = {};
var exhibitor_types_information = {};
var session_groups_information = {};
var media_information = {};
var poi_information = {};
var poi_types_information = {};

var hasDownloadedImages = false;
var hasLoadedCongressInformation = false;

var message_to_process = false;
/*var message_to_process = {
  message: 'New question in your daily Quiz! Can you answer all questions correctly today?',
  message_id: 'link_vimeo.com/143457459',
};*/

var event_lang = 'pt';

var isEventLoaded = false;

var downloadedImages = 0;
var downloadedMedia = [];
var myScroll;
var mapScroll;

var currentDay = 0;

var my_history = new Array();

var last_server_time = '2018-01-01 00:00:00';

function emptyProfile() {
	var profile = {};
	profile.rating = {};
	profile.rating.sessions = {};
	profile.rating.posters = {};
	profile.rating.speakers = {};
	profile.rating.exhibitors = {};
	profile.feedback = {};
	profile.agenda = {};
	profile.agenda.exhibitors = [];
	profile.agenda.posters = [];
	profile.notes = {};
	profile.notes.session = {};
	profile.notes.poster = {};
	profile.notes.speaker = {};
	profile.notes.exhibitor = {};
	profile.notes.user = {};
	profile.anonymous = "1";
	return profile;
}

function initUserData() {
	user_data = {};
	user_data.profile = {};
	user_data.device = {};
	user_data.event_profiles = {};
	user_data.profile = emptyProfile();
	user_data.app_version = app_version;
	if (this_congress) {
		user_data.event_profiles[this_congress.congress_information.congress_id] = user_data.profile;
	}
}

function clearHistory() {
	my_history = ['dashboard'];
}

function showLoadingPage(loading_message, has_loading_progress) {
	if ($('.loading_page').length > 0) {
		return;
	}


	var loadingPageHtml = '';
	loadingPageHtml += '<div class="loading_page absolute_page hide">';
	loadingPageHtml += '<div class="show_loading_text">' + trd('loading-app') + '</div>'
	if (this_congress) {
		loadingPageHtml += '<div class="retry_button" onclick="loadCongressData(' + this_congress.congress_information.congress_id + ',\'' + this_congress.congress_information.congress_lang + '\',true);">' + trd('try-again') + '</div>';
	} else {
		loadingPageHtml += '<div class="retry_button" onclick="loadCongressData(' + app_event_id + ',\'' + app_default_lang + '\',true);">' + trd('try-again') + '</div>';
	}
	loadingPageHtml += '</div>';
	$('body').append(loadingPageHtml);
}

function hideLoadingPage() {
	if (this_congress && hasDownloadedImages && hasLoadedCongressInformation) {
		showSponsorshipBanner();
	}
	setTimeout(function() {
		$('.loading_page').remove()
	}, 500);
}

function showSponsorshipBanner() {
	var url_img = '';

	if (this_congress.media_information['app-sponsorship-banner'] && this_congress.media_information['app-sponsorship-banner']['' + this_congress.congress_information.congress_id]) {
		var this_media = this_congress.media_information['app-sponsorship-banner']['' + this_congress.congress_information.congress_id];

		if (!this_media.offline) {
			url_img = this_media.imgURL_small;
		} else {
			url_img = fsRoot + '/' + this_media.name;
		}

		var sponsorshipPageHtml = '';
		sponsorshipPageHtml += '<div class="sponsorship_page absolute_page hide" style="background-image:url(' + url_img + ');">';
		sponsorshipPageHtml += '</div>';
		$('body').append(sponsorshipPageHtml);

		setTimeout(function() {
			$('.sponsorship_page').remove();
		}, 3000);


	}
}

function hideLoadingOverlay() {
	$('.loading_overlay').remove();
}

function showLoadingOverlay() {
	if ($('.loading_overlay').length > 0) {
		return;
	}
	var loadingPageHtml = '';
	loadingPageHtml += '<div class="loading_overlay">';
	loadingPageHtml += '<div class="black_overlay"></div>'
	loadingPageHtml += '<div class="black_overlay_text" style="text-align:center;padding:20px;"><table class="just_valign"><tr><td>' + trd('loading-overlay-text') + '</td></tr></table></div>';
	loadingPageHtml += '</div>';
	$('body').append(loadingPageHtml);
}


function showAlert(alert_message, alert_type) {
	if (!alert_type) {
		alert_type = 'info';
	}

	var alertHtml = '';
	alertHtml += '<div class="alertDiv ">';
	alertHtml += '<table>';
	alertHtml += '<tr>';
	alertHtml += '<td><img src="img/cg_loading_color.gif" width="150" /><br><span class="loading_message font_color_dark"><br>' + loading_message + '</span>"';
	if (has_loading_progress) {
		alertHtml += '<div class="progress_indicator font_color_dark"></div>';
	}
	alertHtml += '</td>';
	alertHtml += '</tr>';
	alertHtml += '</table>';
	alertHtml += '</div>';
	$('body').append(loadingPageHtml);
}

function unloadGuide() {
	showLoadingPage(trd('loading-app'));
	hideHeaderButtons();
	clearOverlays();
	this_congress = null;
	user_data.profile = emptyProfile();
	loadDynamicStyles();
	localStorage.setItem('saved_event', null);
	$('.current').remove();
	$('.mainDiv').html('');
	hideMenu(true);
	setTimeout("hideLoadingPage();", 1000);
	clearGuideFilters();

	if (app_type == 'multi_home') {
		if (localStorage.getItem('home_event') && JSON.parse(localStorage.getItem('home_event')) != null) {
			this_congress = JSON.parse(localStorage.getItem('home_event'));
			if (this_congress.congress_information.congress_shortcut_ids && this_congress.congress_information.congress_shortcut_ids.length > 0) {
				shortcuts = this_congress.congress_information.congress_shortcut_ids;
			} else {
				shortcuts = [];
			}
			if (this_congress.congress_information.congress_sidemenu_ids && this_congress.congress_information.congress_sidemenu_ids.length > 0) {
				sidemenu = this_congress.congress_information.congress_sidemenu_ids;
			} else {
				sidemenu = [];
			}

			app_config_next_session_interval = parseInt(this_congress.congress_information.next_session_timespan);

			event_lang = this_congress.congress_information.congress_lang;

			loadCongressData(this_congress.congress_information.congress_id);
		} else {
			loadCongressData(multi_home_event_id, '');
		}
	} else if (app_type == 'multi') {
		if (user_data.access_data && user_data.access_data.access_id) {
			loadCongressList();
		} else {
			loadCongressListForClient();
		}

	}

}

function clearGuideFilters() {
	MY_AGENDA_NO_FILTER = -1;
	MY_AGENDA_FILTER_SESSIONS = 1;
	MY_AGENDA_FILTER_EXHIBITORS = 2;
	MY_AGENDA_FILTER_POSTERS = 3;
	MY_AGENDA_FILTER_PROFILES = 4;
	MY_AGENDA_FILTER_NOTES = 5;

	SESSION_FILTER_DAY = -1;
	SESSION_FILTER_SESSION_TYPE = -1;
	SESSION_FILTER_LOCATION = -1;

	SPEAKER_FILTER_SPEAKER_TYPE = -1;

	EXHIBITOR_FILTER_EXHIBITOR_TYPE = -1;

	POSTER_FILTER_POSTER_TYPE = -1;

	RESOURCE_FILTER_RESOURCE_TYPE = -1;

	FLOORPLAN_FILTER_FLOORPLAN = -1;
	FLOORPLAN_FILTER_EXHIBITOR_TYPE = -1;
	FLOORPLAN_FILTER_LOCATION_TYPE = -1;
}


function hideHeaderButtons() {
	$('.toggle_menu_button').hide();
	$('#back_button').hide();
	$('#filter_button').hide();
}

function loadHome() {



	if (page_moving) {
		return;
	}


	clearMainDivs();
	if (requires_auth && (!user_data || !user_data.access_data || !user_data.access_data.access_id)) {
		showLoginDiv();
		loadLoginPage();
		hideLoadingPage();
		return;
	}

	if (app_type == 'mother') {
		showLoadingPage(trd('loading-app'));

		if (hasDownloadedImages && hasLoadedCongressInformation) {
			loadCGHome();
			showCGHome();
			setTimeout("hideLoadingPage();", 1000);
		}
	}
	if (app_type == 'single_code') {
		showLoadingPage(trd('loading-app'));

		if (hasDownloadedImages && hasLoadedCongressInformation) {
			loadSingleCodeHome();
			showSingleCodeHome();
			setTimeout("hideLoadingPage();", 1000);
		}
	} else if (app_type == 'multi') {
		showLoadingPage(trd('loading-multi-event'));
		if (user_data.access_data && user_data.access_data.access_id) {
			loadCongressList();
		} else {
			loadCongressListForClient();
		}

		showCongressList();
	} else if (app_type == 'single') {
		loadDashboard();
		showEventDiv();
	} else {
		showToastrAlert('error', trd('guide-type-not-recognized'));
	}
}

function loadClientEventsList(fromHistory) {
	if (page_moving) {
		console.log('cant start, page is moving');
		return;
	} else {
		page_moving = true;
	}

	var clientEventsHtml = '';

	var isCurrent = ($('#client_events_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	clientEventsHtml += '<div class="normal_page ' + initialPosition + ' eventListDiv" id="client_events_index">';


	clientEventsHtml += '<div class="list_page_header ">';
	clientEventsHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('client-events') + '</div></div>';
	clientEventsHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">' + trd('filter-label') + '</div></div>';

	clientEventsHtml += '<div class="list_page scroll">';

	clientEventsHtml += '<div class="scroll_lock">';

	clientEventsHtml += '<div id="client_events_list"></div>';

	clientEventsHtml += '</div>';
	clientEventsHtml += '</div>';
	$('#client_events_index').remove();
	$('.mainDiv').append(clientEventsHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('client_events_index');", 1);
		} else {
			setTimeout("bringforward('client_events_index');", 1);
		}
	} else {
		onPageChanged();
	}

	refreshClientEvents();
}

function getDateIntervalString(date1, date2) {
	moment.locale(this_congress.congress_information.congress_lang);
	date1 = moment(date1);
	date2 = moment(date2);
	var format_days = 'Do';
	var format_general = 'MMM';
	if (date1.isSame(date2)) {
		return date1.format('MMM Do YYYY');
	} else {
		if (date1.month() != date2.month()) {
			format_days = 'MMM Do';
			format_general = 'YYYY';
		} else {
			format_general = 'MMM YYYY';
		}
		if (date1.year() != date2.year()) {
			format_days += ' YYYY';
			format_general = '';
		}
	}
	return date1.format(format_days) + ' ' + trd('-date-to-') + ' ' + date2.format(format_days) + (format_general != '' ? ' ' + date1.format(format_general) : '');
}

function refreshClientEvents() {
	var url = services_home + 'services.php';

	console.log(JSON.stringify(user_data.profile));
	showLoadingOverlay();


	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'loadEventListForClient',
				client_id: app_client_id,
				user_data: user_data,
				access_data: user_data.access_data,
				lang: app_default_lang
			}
		},
		dataType: 'json',
		success: function eventsLoaded(response) {
			if (response.success) {

				var congress_list = response.object;

				var congressListHtml = '';

				congressListHtml += '<div class="congress_list_content">';
				//congressListHtml += '<div class="congress_list_title">' + trd('apps-for-events') + '</div>';
				$.each(congress_list, function(index, this_event) {

					var eventlogo = 'img/event_image_placeholder.png';

					if (this_event.imgURL) {
						eventlogo = this_event.imgURL;
					}

					var img = new Image();
					img.onload = function() {
						$('#congress_img_' + this_event.id).attr('src', eventlogo);
					};
					img.src = eventlogo;

					congressListHtml += '<div class="congress_list_item" onclick="cgConfirmOpenGuide(' + this_event.id + ',\'' + this_event.event_code + '\');">';



					var date_string = '';
					if (this_event.start_date && this_event.end_date) {
						moment.locale(this_congress.congress_information.congress_lang);
						if (this_event.start_date == this_event.end_date) {
							date_string = trd('date-on-') + ' ' + moment(this_event.start_date).format("MMM Do YYYY");
						} else {
							date_string = trd('date-from-') + ' ' + moment(this_event.start_date).format("MMM Do YYYY") + trd('-date-to-') + moment(this_event.end_date).format("MMM Do YY");
						}
					}

					var icon_img = media_home + 'app-event-icon/' + this_event.id + '/original/' + this_event.event_icon;

					congressListHtml += '<table class="just_align">';
					congressListHtml += '<tr>';
					congressListHtml += '<td width="120"><img src="' + icon_img + '" width="100%" style="" /></td>';
					congressListHtml += '<td style="padding-left:20px"><span class="event_title font_bold font_color_dark">' + this_event.congress_name + '</span><br><span class="event_date font_color_gray_1">' + date_string + '<br>' + this_event.congress_location + '</span></td>';
					congressListHtml += '</tr>';
					congressListHtml += '</table>';
					congressListHtml += '</div>';

				});

				$('#client_events_list').html(congressListHtml);

				hideLoadingOverlay();
				setTimeout("hideLoadingPage();", 1000);
			} else {

			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('got' + JSON.stringify(xhr));
		}
	});
}

function loadCongressData(this_event_id, lang, reload) {



	showLoadingPage(trd('loading-app'));
	$('.retry_button').hide();
	$('.show_loading_text').show();
	isEventLoaded = false;
	downloadedImages = 0;
	hasLoadedCongressInformation = false;
	hasDownloadedImages = false;

	setUpdateTimer();


	clearMainDivs();

	showLoadingPage(trd('loading-congress-info'), true);
	hideMenu();

	if (this_congress && this_congress != null && !reload) {
		hasLoadedCongressInformation = true;
		loadMyAgendaFromStorage();

		checkFinishedLoading();

		if (isMobile) {
			window.requestFileSystem = window.requestFileSystem || window.webkitRequestFileSystem;
			window.requestFileSystem(LocalFileSystem.TEMPORARY, 0, function(fileSystem) {
					if (isIOS) {
						wwwRoot = cordova.file.dataDirectory;
						fsRoot = cordova.file.dataDirectory;
					} else {
						wwwRoot = cordova.file.dataDirectory;
						fsRoot = cordova.file.dataDirectory;
					}

					downloadImages();
				},
				failedLoadingFileSystem);
		} else {
			hasDownloadedImages = true;
		}
		checkFinishedLoading();
		return;
	}

	if (!lang) {
		lang = '';
	}

	var url = services_home + 'load_congress_info.php?id=' + this_event_id + '&locale=' + lang;

	$.ajax({
		type: 'GET',
		url: url,
		cache: false,
		dataType: 'json',
		success: function loadStructure(response) {
			console.log('loaded structure is : ' + JSON.stringify(response));

			this_congress = response;
			this_congress.congress_information.lastupdate = (new Date()).getTime() / 1000;
			if (this_congress.congress_information.congress_shortcut_ids && this_congress.congress_information.congress_shortcut_ids.length > 0) {
				shortcuts = this_congress.congress_information.congress_shortcut_ids;
			} else {
				shortcuts = [];
			}
			if (this_congress.congress_information.congress_sidemenu_ids && this_congress.congress_information.congress_sidemenu_ids.length > 0) {
				sidemenu = this_congress.congress_information.congress_sidemenu_ids;
			} else {
				sidemenu = [];
			}
			app_config_next_session_interval = parseInt(this_congress.congress_information.next_session_timespan);
			event_lang = this_congress.congress_information.congress_lang;

			if (app_type == 'multi_home' && this_congress.multievent_home && this_congress.multievent_home == "1") {
				localStorage.setItem('home_event', JSON.stringify(this_congress));
			} else {
				localStorage.setItem('saved_event', JSON.stringify(this_congress));
			}


			hasLoadedCongressInformation = true;

			if (isMobile) {
				window.requestFileSystem = window.requestFileSystem || window.webkitRequestFileSystem;
				window.requestFileSystem(LocalFileSystem.TEMPORARY, 0, function(fileSystem) {
						if (isIOS) {
							wwwRoot = cordova.file.dataDirectory;
							fsRoot = cordova.file.dataDirectory;
						} else {
							wwwRoot = cordova.file.dataDirectory;
							fsRoot = cordova.file.dataDirectory;
						}
						downloadImages();


					},
					failedLoadingFileSystem);
			} else {
				hasDownloadedImages = true;
			}

			loadMyAgendaFromStorage();
			checkFinishedLoading();

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('ERROR:' + JSON.stringify(xhr));
			showToastrAlert('error', 'Couldn\'t connect to server to get your event information. Check your internet connection.');
			$('.retry_button').show();
			$('.show_loading_text').hide();
		}
	});





}

function showModal() {
	$('.modal_page').addClass('show');
}

function loadModalAuthPage(dismissable) {

	var loginPageHtml = '';

	loginPageHtml += '<div class="normal_page scroll">';

	loginPageHtml += '<div class="scroll_lock">';


	if (auth_scan_code) {
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-scan') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-explain-text') + '</div>';
		loginPageHtml += '<div class="scan_badge_button color_bg_division_2 font_color_white" onclick="scanUserBadge()">' + trd('auth-button-label') + '</div>';
	}
	if (auth_by_code) {
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-code') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-insert-code-label') + '</div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-code') + '" id="auth_code" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-bottom:20px" onclick="getUserProfile(\'code\');">OK</div>';
	}

	if (auth_by_email) {
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-email') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-insert-email-label') + '</div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-email') + '" id="auth_email" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-bottom:20px" onclick="getUserProfile(\'email\');">OK</div>';
	}
	if (auth_by_email_and_code) {
		var send_code_url = 'http://cms.cloudguideapp.com/services/tools/sendMail/code.php?congress_id=' + this_congress.congress_information.congress_id + '&lang=' + this_congress.congress_information.congress_lang;
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-code') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-insert-email-and-code-label') + '</div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-email') + '" id="auth_email" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-code') + '" id="auth_code" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-bottom:80px" onclick="getUserProfile(\'profile_email_and_code\');">OK</div>';
		loginPageHtml += '<div class="block_button font_color_white" style="margin-bottom:30px; background-color:grey; text-transform:none;" onclick="openLink(\'' + send_code_url + '\');">' + trd('request-a-code') + '</div>';
	}

	if (auth_by_email_or_code) {
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-email-code') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-insert-email-or-code-label') + '</div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-email-or-code') + '" id="auth_by_email_or_code" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-bottom:30px" onclick="getUserProfile(\'profile_email_or_code\');">OK</div>';
	}

	if (dismissable) {
		loginPageHtml += '<div class="modal_button_bottom font_color_white color_bg_division_1" onclick="closeModal();">' + trd('bt-cancel') + '</div>';
	}


	loginPageHtml += '</div>';
	loginPageHtml += '</div>';

	$('.modal_page').html(loginPageHtml);

}

function confirmMustRegister(message) {
	navigator.notification.confirm(
		message,
		function(button) {
			if (button == 2) {
				loadModalRegisterPage(true);
				showModal();
			}
		},
		trd('confirm-register-title'), [trd('confirm-register-cancel'), trd('confirm-register-now')]);
}

function loadModalRegisterPage(dismissable) {

	var registerPageHtml = '';

	registerPageHtml += '<div class="normal_page">';

	registerPageHtml += '<div class="normal_page scroll">';

	registerPageHtml += '<div class="register_user_explain_div font_color_gray_1">' + trd('register-user-explain') + '</div>';
	registerPageHtml += '<div class="section_title font_bold font_color_white color_bg_division_1">' + trd('register-user-photo-label') + '</div>';

	registerPageHtml += '<div class="register_user_photo_div font_color_gray_1"  onclick="choosePhotoMethod(\'register_user\');">';
	registerPageHtml += '<table width="100%" style="text-align:right"><tr><td width="50%"><div class="register_user_photo" id="register_user_photo"></div></td><td width="50%" style="padding:20px;text-align:left"><span class="font_color_gray_2" id="user_photo_explain" style="font-size:10px;line-height:12px">' + trd('user-photo-explain') + '</span></td></tr></table>';
	registerPageHtml += '</div>';
	registerPageHtml += '<input type="hidden" id="user_img_src" value="" />';
	registerPageHtml += '<div class="section_title font_bold font_color_white color_bg_division_1">' + trd('register-user-email-label') + '</div>';
	registerPageHtml += '<div class="block_text_holder"><textarea onkeypress="returnDismiss();" type="text" placeholder="' + trd('register-user-email-ph') + '" id="register_user_email" class="user_field_write"></textarea></div>';
	registerPageHtml += '<div class="section_title font_bold font_color_white color_bg_division_1">' + trd('register-user-name-label') + '</div>';
	registerPageHtml += '<div class="block_text_holder"><textarea type="text" placeholder="' + trd('register-user-name-ph') + '" id="register_user_name" class="user_field_write"></textarea></div>';
	registerPageHtml += '<div class="section_title font_bold font_color_white color_bg_division_1">' + trd('register-user-subtitle-label') + '</div>';
	registerPageHtml += '<div class="block_text_holder"><textarea type="text" placeholder="' + trd('register-user-subtitle-ph') + '" id="register_user_subtitle" class="user_field_write"></textarea></div>';
	registerPageHtml += '<hr /><br><br>';
	registerPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="font-size:10px" onclick="closeModal();loadAuthPage();">' + trd('register-already-have-account') + '</div>';
	registerPageHtml += '<br><br><br><br>';
	registerPageHtml += '</div>';

	registerPageHtml += '<div class="bottom_button_list" style="position:absolute;bottom:0;left:0;right:0;z-index:99">';
	registerPageHtml += '<table width="100%"><tr>';
	if (dismissable) {
		registerPageHtml += '<td width="50%" class="color_bg_division_2 font_color_white" style="padding:10px;text-align:center;border-right:1px solid white;" onclick="closeModal();">' + trd('bt-register-cancel') + '</td>';
	}
	registerPageHtml += '<td class="color_bg_division_2 font_color_white" style="padding:10px;text-align:center;" onclick="submitRegisterUserProfile();">' + trd('bt-register-submit') + '</td>';
	registerPageHtml += '</tr></table>';
	registerPageHtml += '</div>';


	registerPageHtml += '</div>';

	$('.modal_page').html(registerPageHtml);

	$('textarea').keypress(function(event) {
		// Check the keyCode and if the user pressed Enter (code = 13) 
		// disable it
		if (event.keyCode == 13) {
			event.preventDefault();
			$(this).blur();
		}
	});
}

function submitRegisterUserProfile(quiet) {
	var user_pic = $('#user_img_src').val();
	var user_name = $('#register_user_name').val();
	var user_subtitle = $('#register_user_subtitle').val();
	var user_email = $('#register_user_email').val();

	if (!user_name || user_name == '') {
		showToastrAlert('error', trd('register-validation-empty-user-name'));
	} else if (!user_subtitle || user_subtitle == '') {
		showToastrAlert('error', trd('register-validation-empty-user-subtitle'));
	} else if (!user_email || user_email == '') {
		showToastrAlert('error', trd('register-validation-empty-user-email'));
	} else if (!validateEmail(user_email)) {
		showToastrAlert('error', trd('register-validation-invalid-user-email'));
	} else {
		// SUBMIT DATA
		user_data.profile.user_name = user_name;
		user_data.profile.user_pic = user_pic;
		user_data.profile.user_subtitle = user_subtitle;
		user_data.profile.user_email = user_email;

		var params = {
			f: 'createUserProfile',
			user_data: user_data,
			event_id: this_congress.congress_information.congress_id
		};
		var url = services_home + 'services.php?rand=' + (new Date()).getTime();
		console.log('calling ' + url);
		showLoadingOverlay();

		$.ajax({
			type: 'POST',
			url: url,
			cache: false,
			dataType: 'json',
			data: { params: params },
			success: function profileCreated(response) {
				hideLoadingOverlay();
				if (response.success) {
					console.log('new user profile is ' + JSON.stringify(response.object.agenda));
					user_data.profile = response.object;
					saveUserDataToStorage();
					closeModal();
					if (!quiet) {
						showToastrAlert('success', trd('user-profile-registered'));
					}
					if (after_login_action == 'new_post') {
						loadPhotoFeed();
						showNewPostModal();
						after_login_action = false;
					} else if (after_login_action == 'user_location') {
						showQueryUserLocation();
						after_login_action = false;
					} else if (after_login_action == 'scored_feedback') {
						closeModal();
						loadScoredFeedbackIndex();
						after_login_action = false;
					} else {
						loadMyProfile();
					}
				} else {
					showToastrAlert('error', trd(response.message));
				}

			},
			error: function(xhr, ajaxOptions, thrownError) {
				hideLoadingOverlay();
				console.log('ERROR:' + JSON.stringify(xhr));
				showToastrAlert('error', trd('error-profile-not-created'));
			}
		});
	}


}

function validateEmail(email) {
	var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	return re.test(email);
}

function checkFinishedLoading() {
	if (isEventLoaded) {
		return;
	}

	if (hasLoadedCongressInformation && hasDownloadedImages) {
		isEventLoaded = true;
		loadDynamicStyles();

		$('.mainDiv').html('');
		$('.toggle_menu_button').show();
		if (app_type == 'multi_home' && this_congress.multievent_home && this_congress.multievent_home == "1") {
			localStorage.setItem('home_event', JSON.stringify(this_congress));
		} else {
			localStorage.setItem('saved_event', JSON.stringify(this_congress));
		}

		loadMenu();
		setTimeout("hideLoadingPage();", 1000);
		showEventDiv();

		if ($('.widescreen').length > 0) {
			showMenu();
		}

		this_congress.congress_information.user_warned = false;
		setTimeout("loadDashboard(true);", 500);

		if (message_to_process) {
			var string_divide = message_to_process.additionalData.message_id.split("_");
			var ntype = '';
			var nvalue = '';


			if (string_divide.length > 1) {
				ntype = string_divide[0];
				//nvalue = string_divide[string_divide.length - 1];
				nvalue = message_to_process.additionalData.message_id.replace(ntype + '_', '');
			} else {
				ntype = string_divide[0];
			}
			if (message_to_process.message) {
				message_to_process.alert = message_to_process.message;
			}
			processMessage(message_to_process.alert, ntype, nvalue);
			message_to_process = false;
		}
		if (access_data && access_data.access_id) {
			getUserProfile('email', access_data.email, true);
		} else if (app_type == 'multi_home' && user_data.profile.anonymous == "0") {
			getUserProfile('profile_user_id', user_data.profile.user_id, true);
		} else if (user_data && user_data.event_profiles && user_data.event_profiles[this_congress.congress_information.congress_id]) {
			user_data.profile = safeProfile(user_data.event_profiles[this_congress.congress_information.congress_id]);
			updateProfile();
		} else {
			user_data.profile = emptyProfile();
			updateProfile();
		}

		validateUser();

        if(this_congress && this_congress.congress_information && this_congress.congress_information.requires_full_profile){
            if(this_congress.congress_information.requires_full_profile == '1'){ requires_full_profile = true; }
            else{ requires_full_profile = false; }
        }
        if(this_congress && this_congress.congress_information && this_congress.congress_information.free_registration){
            if(this_congress.congress_information.free_registration == '1'){ free_registration = true; }
            else{ free_registration = false; }
        }

		if (requires_full_profile && user_data.profile.anonymous == "1") {
			if (this_congress && this_congress.congress_information && this_congress.congress_information.has_user_location == '1') {
				after_login_action = 'user_location';
			} else {
				after_login_action = 'suggest_check_profile';
			}
			loadModalAuthPage();
			showModal();
		} else if (free_registration && user_data.profile.anonymous == "1") {
			loadModalRegisterPage(true);
			showModal();
		}
	}
}

function safeProfile(this_profile) {

	var safeprofile = this_profile;

	if (!safeprofile.rating) {
		safeprofile.rating = {};
	}
	if (!safeprofile.rating.sessions) {
		safeprofile.rating.sessions = {};
	}
	if (!safeprofile.rating.posters) {
		safeprofile.rating.posters = {};
	}
	if (!safeprofile.rating.speakers) {
		safeprofile.rating.speakers = {};
	}
	if (!safeprofile.rating.exhibitors) {
		safeprofile.rating.exhibitors = {};
	}
	if (!safeprofile.feedback) {
		safeprofile.feedback = {};
	}
	if (!user_data.event_profiles) {
		user_data.event_profiles = {};
	}
	if (!safeprofile.notes) {
		safeprofile.notes = {};
	}

	if (!safeprofile.notes.session) {
		safeprofile.notes.session = {};
	}

	if (!safeprofile.notes.poster) {
		safeprofile.notes.posters = {};
	}

	if (!safeprofile.notes.speaker) {
		safeprofile.notes.speakers = {};
	}

	if (!safeprofile.notes.exhibitor) {
		safeprofile.notes.exhibitors = {};
	}

	if (!safeprofile.notes.user) {
		safeprofile.notes.users = {};
	}

	return safeprofile;
}

function failedLoadingFileSystem(errorCode) {
	console.log("failed to get filesystem: " + JSON.stringify(errorCode));
}



function downloadImages() {

	downloadedMedia = [];

	if (this_congress.congress_information.congress_media.length == 0) {
		hasDownloadedImages = true;
	}

	$.each(this_congress.media_information, function(index_group, this_media_group) {
		$.each(this_media_group, function(index_media, this_media) {


			var url = '';
			if (this_media.media_section == 'map') {
				url = this_media.imgURL_original;
			} else if (this_media.media_section == 'poster') {
				url = this_media.imgURL_original;
			} else if (this_media.media_section == 'shortcut') {
				url = this_media.imgURL_original;
			} else if (this_media.media_section == 'event-logo') {
				url = this_media.imgURL_original;
			} else if (this_media.media_section == 'sponsor-banner') {
				url = this_media.imgURL_original;
			} else if (this_media.media_section == 'highlight') {
				url = this_media.imgURL_original;
			} else if (this_media.media_section.indexOf('app-') > -1) {
				url = this_media.imgURL_original;
			} else if (this_media.media_section == 'link') {
				url = this_media.imgURL_original;
			} else if (this_media.extension == 'pdf') {
				url = this_media.fileURL;
			} else {
				url = this_media.imgURL_small;
			}
			var filePath = fsRoot + '/' + this_media.name;


			var downloadFilePath = wwwRoot + '/' + this_media.name;

			window.resolveLocalFileSystemURL(filePath, function success() {


				// FILE ALREADY EXISTS
				if (!array_contains(downloadedMedia, this_media.media_id)) {
					downloadedImages++;
					var progress = Math.round(100 * downloadedImages / this_congress.congress_information.congress_media.length);

					if (progress > 100) {
						progress = 100;
					}

					$('.progress_indicator').html(progress + '%');
					downloadedMedia.push(this_media.media_id);
				}


				console.log('downloaded images: ' + downloadedImages + ' of total ' + this_congress.congress_information.congress_media.length);
				this_congress.media_information[this_media.media_section]['' + this_media.media_value].offline = true;



				if (downloadedImages >= this_congress.congress_information.congress_media.length) {
					if (!hasDownloadedImages) {
						hasDownloadedImages = true;
						checkFinishedLoading();
					}

				}


			}, function error(evt) {
				// FILE DOES NOT EXIST
				var fileTransfer = new FileTransfer();


				fileTransfer.download(
					url,
					downloadFilePath,
					function(entry) {

						if (!array_contains(downloadedMedia, this_media.media_id)) {
							downloadedImages++;
							var progress = Math.round(100 * downloadedImages / this_congress.congress_information.congress_media.length);

							if (progress > 100) {
								progress = 100;
							}

							$('.progress_indicator').html(progress + '%');
							downloadedMedia.push(this_media.media_id);
						}
						console.log('downloaded images: ' + downloadedImages + ' of total ' + this_congress.congress_information.congress_media.length);

						this_congress.media_information[this_media.media_section]['' + this_media.media_value].offline = true;
						this_congress.media_information[this_media.media_section]['' + this_media.media_value].offline_path = entry.fullPath;


						if (downloadedImages >= this_congress.congress_information.congress_media.length) {
							hasDownloadedImages = true;
							checkFinishedLoading();
						}

					},
					function(error) {
						console.log("couldn't download!");
						if (!array_contains(downloadedMedia, this_media.media_id)) {
							downloadedImages++;
							var progress = Math.round(100 * downloadedImages / this_congress.congress_information.congress_media.length);

							if (progress > 100) {
								progress = 100;
							}

							$('.progress_indicator').html(progress + '%');
							downloadedMedia.push(this_media.media_id);
						}
						console.log('downloaded images: ' + downloadedImages + ' of total ' + this_congress.congress_information.congress_media.length);
						this_congress.media_information[this_media.media_section]['' + this_media.media_value].offline = false;
						console.log("download error source " + error.source);
						console.log("download error target " + error.target);
						console.log("download error code " + error.code);

						if (downloadedImages >= this_congress.congress_information.congress_media.length) {
							hasDownloadedImages = true;
							checkFinishedLoading();
						}
					}
				);


			});
		});


	});


}






function getNameForAreaType(this_area_type) {

	var area_name = this_area_type;

	$.each(this_congress.congress_information.congress_areas, function(index_area, this_area_id) {

		var this_area = this_congress.areas_information['' + this_area_id];

		if (this_area.area_type == this_area_type) {
			area_name = this_area.area_title;
		}
	});

	return area_name;
}

function doAppPause() {
	clearInterval(update_timer_event_info);
	clearInterval(refresh_news_timer);
}

function doAppResume() {
	doOrientationChange();
	refreshNextSessions();
	setUpdateTimer();
	//if(user_data.profile && user_data.profile.user_email){//hammertime
	//getUserProfile('refresh', '', true);
	//}
}

function doOrientationChange(event) {

	$('.side_menu_container').hide();
	$('.side_menu_filter_container').hide();


	clearMainDivs();

	var el = $('meta[name=viewport]');
	if (window.orientation == 90 || window.orientation == -90) {
		//el.attr('content', 'width=device-height');
		//el.attr('content', 'height=device-width');
		$('body').removeClass('landscape');
		$('body').addClass('portrait');
	} else {
		$('body').removeClass('portrait');
		$('body').addClass('landscape');
		//el.attr('content', 'width=device-width');
		//el.attr('content', 'height=device-height');
	}

	if (this_congress && this_congress.congress_information) {
		showEventDiv();
	} else if (app_type == 'mother') {
		showCGHome();
	} else if (app_type == 'multi') {
		if (requires_auth) {
			if (user_data && (!user_data || !user_data.access_data || !user_data.access_data.access_id)) {
				showLoginDiv();
				loadLoginPage();
				hideLoadingPage();
			} else {
				showCongressList();
			}
		} else {
			showCongressList();
		}
	} else if (app_type == 'single') {
		showEventDiv();
	} else if (app_type == 'multi_home') {
		showEventDiv();
	} else if (app_type == 'single_code') {
		showSingleCodeHome();
	} else {
		showToastrAlert('error', 'Unknown app configuration. Please update app version.');
	}



	setTimeout("redoLayout();", 500);

}


function redoLayout() {
	evaluateScreenSize();
	loadDynamicStyles();
	setTimeout("resetFeaturedSwipe();", 300);

	$('.side_menu_container').show();
	$('.side_menu_filter_container').show();

}

evaluateScreenSize();

function onLoad() {

	try {
		if (cordova) {
			isMobile = true;
		}
	} catch (err) {
		isMobile = false;
	}

	evaluateScreenSize();
	if (!isMobile) {
		onDeviceReady();
	} else {
		document.addEventListener('deviceready', onDeviceReady, false);
		document.addEventListener('resume', doAppResume, false);
		document.addEventListener("pause", doAppPause, false);
	}

	if (isMobile) { clickAttribute = 'ontouchstart'; } else { clickAttribute = 'onmousedown'; }
}
var realOrientation = {
	portrait: 1,
	flip: 0
};
var keyboard = {
	opened: false,
	open: function() {
		$('body').addClass('keyboard');
		keyboard.opened = true;
	},
	close: function() {
		$('body').removeClass('keyboard');
		keyboard.opened = false;
	}
};

var network = {
    online: false,
    fast: true,
    wentOnline: function(){
        if(isMobile && navigator.connection && window.Connection){
            var networkState = navigator.connection.type;
            var states = {};
            states[Connection.UNKNOWN]  = 'network';
            states[Connection.ETHERNET] = 'Ethernet';
            states[Connection.WIFI]     = 'WiFi';
            states[Connection.CELL_2G]  = 'Mobile 2G';
            states[Connection.CELL_3G]  = 'Mobile 3G';
            states[Connection.CELL_4G]  = 'Mobile 4G';
            states[Connection.CELL]     = 'Mobile';
            states[Connection.NONE]     = false;
            network.online = states[networkState];
            console.log('online: ' + this.state);
        }
    },
    wentOffline: function(){
        if(isMobile && navigator.connection && window.Connection && network.online){
            showToastrAlert('error', trd('network-lost-connection') + ' '+ network.online)
            network.online = false;
            console.log('offline');
        }
    },
    wentSlow: function(){
        if(isMobile && navigator.connection && window.Connection && network.online && network.fast){
            showToastrAlert('error', trd('network-difficult-connection') + ' '+ network.online)
            network.fast = false;
        }
    },
    wentFast: function(){
        if(isMobile && navigator.connection && window.Connection && network.online){ network.fast = true; }
    }
}

function onDeviceReady() {

	document.addEventListener("backbutton", function(event_back) {

		event_back.preventDefault();
		event_back.stopPropagation();

		goBack();
	}, false);

	if (isMobile) { // listeners for the functions that add/remove the class keyboard
		window.addEventListener('native.hidekeyboard', keyboard.close);
		window.addEventListener('native.showkeyboard', keyboard.open);
	}

	if (isMobile) { // changing the app_version global variable to what the plugin indicates
		cordova.getAppVersion.getVersionNumber(function(version) { app_version = version; });
	}

    if(isMobile && navigator.connection){
        network.wentOnline();
        document.addEventListener("offline", network.wentOffline, false);
        document.addEventListener("online", network.wentOnline, false);
    }

	evaluateScreenSize();
	lockScreenOrientation();

	if (app_started) {
		return;
	}
	try {
		cordova.plugins.notification.local.on("trigger", function(notification) {
			var data = JSON.parse(notification.data);
			if (hasLoadedCongressInformation) {
				console.log(data);
				processMessage(notification.text, data.ntype, data.nvalue);
			} else {
				console.log('else - ' + data);
				message_to_process = {
					message: notification.text,
					alert: notification.text,
					message_id: data.ntype + '_' + data.nvalue

				}
			}
		});

		cordova.plugins.notification.local.on("click", function(notification) {
			var data = JSON.parse(notification.data);
			if (hasLoadedCongressInformation) {
				console.log(data);
				processMessage(notification.text, data.ntype, data.nvalue);
			} else {
				console.log('else - ' + data);
				message_to_process = {
					message: notification.text,
					alert: notification.text,
					message_id: data.ntype + '_' + data.nvalue

				}
			}
		});
	} catch (err) {
		isMobile = false;
	}

	isIOS = (agent.indexOf('iPhone') > -1 || agent.indexOf('iPad') > -1);
	loadUserDataFromStorage();
	updateDevice();

	registerPush();

	showLoadingPage(trd('loading-app'));

	if (reload_storage) {
		localStorage.setItem('home_event', null);
		localStorage.setItem('saved_event', null);
	}

	console.log('user data is ' + JSON.stringify(user_data));
	if (requires_auth && (!user_data || !user_data.access_data || !user_data.access_data.access_id)) {
		showLoginDiv();
		loadLoginPage();
		hideLoadingPage();
		return;
	}

	if (app_type == 'mother') {

		if (localStorage.getItem('saved_event') && JSON.parse(localStorage.getItem('saved_event')) != null) {
			this_congress = JSON.parse(localStorage.getItem('saved_event'));
			if (this_congress.congress_information.congress_shortcut_ids && this_congress.congress_information.congress_shortcut_ids.length > 0) {
				shortcuts = this_congress.congress_information.congress_shortcut_ids;
			} else {
				shortcuts = [];
			}
			if (this_congress.congress_information.congress_sidemenu_ids && this_congress.congress_information.congress_sidemenu_ids.length > 0) {
				sidemenu = this_congress.congress_information.congress_sidemenu_ids;
			} else {
				sidemenu = [];
			}

			app_config_next_session_interval = parseInt(this_congress.congress_information.next_session_timespan);


			event_lang = this_congress.congress_information.congress_lang;

			loadCongressData(this_congress.congress_information.congress_id);
		} else {
			loadCGHome();
			showCGHome();
			setTimeout("hideLoadingPage();", 1000);
		}
	} else if (app_type == 'single') {

		if (localStorage.getItem('saved_event') && JSON.parse(localStorage.getItem('saved_event')) != null && JSON.parse(localStorage.getItem('saved_event')).congress_information.congress_id == app_event_id) {
			this_congress = JSON.parse(localStorage.getItem('saved_event'));
			if (this_congress.congress_information.congress_shortcut_ids && this_congress.congress_information.congress_shortcut_ids.length > 0) {
				shortcuts = this_congress.congress_information.congress_shortcut_ids;
			} else {
				shortcuts = [];
			}
			if (this_congress.congress_information.congress_sidemenu_ids && this_congress.congress_information.congress_sidemenu_ids.length > 0) {
				sidemenu = this_congress.congress_information.congress_sidemenu_ids;
			} else {
				sidemenu = [];
			}

			app_config_next_session_interval = parseInt(this_congress.congress_information.next_session_timespan);

			event_lang = this_congress.congress_information.congress_lang;

			loadCongressData(this_congress.congress_information.congress_id);
		}

		loadCongressData(app_event_id);
	} else if (app_type == 'multi_home') {

		if (localStorage.getItem('saved_event') && JSON.parse(localStorage.getItem('saved_event')) != null) {
			this_congress = JSON.parse(localStorage.getItem('saved_event'));
			if (this_congress.congress_information.congress_shortcut_ids && this_congress.congress_information.congress_shortcut_ids.length > 0) {
				shortcuts = this_congress.congress_information.congress_shortcut_ids;
			} else {
				shortcuts = [];
			}
			if (this_congress.congress_information.congress_sidemenu_ids && this_congress.congress_information.congress_sidemenu_ids.length > 0) {
				sidemenu = this_congress.congress_information.congress_sidemenu_ids;
			} else {
				sidemenu = [];
			}

			app_config_next_session_interval = parseInt(this_congress.congress_information.next_session_timespan);

			event_lang = this_congress.congress_information.congress_lang;

			loadCongressData(this_congress.congress_information.congress_id);
		} else if (localStorage.getItem('home_event') && JSON.parse(localStorage.getItem('home_event')) != null) {
			this_congress = JSON.parse(localStorage.getItem('home_event'));
			if (this_congress.congress_information.congress_shortcut_ids && this_congress.congress_information.congress_shortcut_ids.length > 0) {
				shortcuts = this_congress.congress_information.congress_shortcut_ids;
			} else {
				shortcuts = [];
			}
			if (this_congress.congress_information.congress_sidemenu_ids && this_congress.congress_information.congress_sidemenu_ids.length > 0) {
				sidemenu = this_congress.congress_information.congress_sidemenu_ids;
			} else {
				sidemenu = [];
			}

			app_config_next_session_interval = parseInt(this_congress.congress_information.next_session_timespan);

			event_lang = this_congress.congress_information.congress_lang;

			loadCongressData(this_congress.congress_information.congress_id);
		}

		loadCongressData(multi_home_event_id);
	} else if (app_type == 'single_code') {

		if (localStorage.getItem('saved_event') && JSON.parse(localStorage.getItem('saved_event')) != null) {
			this_congress = JSON.parse(localStorage.getItem('saved_event'));
			if (this_congress.congress_information.congress_shortcut_ids && this_congress.congress_information.congress_shortcut_ids.length > 0) {
				shortcuts = this_congress.congress_information.congress_shortcut_ids;
			} else {
				shortcuts = [];
			}
			if (this_congress.congress_information.congress_sidemenu_ids && this_congress.congress_information.congress_sidemenu_ids.length > 0) {
				sidemenu = this_congress.congress_information.congress_sidemenu_ids;
			} else {
				sidemenu = [];
			}

			app_config_next_session_interval = parseInt(this_congress.congress_information.next_session_timespan);

			event_lang = this_congress.congress_information.congress_lang;

			loadCongressData(this_congress.congress_information.congress_id);
		} else {
			loadSingleCodeHome();
			showSingleCodeHome();
			hideLoadingPage();
		}

		//loadCongressData(app_event_id);
	} else if (app_type == 'multi') {
		if (localStorage.getItem('saved_event') && JSON.parse(localStorage.getItem('saved_event')) != null) {
			this_congress = JSON.parse(localStorage.getItem('saved_event'));
			if (this_congress.congress_information.congress_shortcut_ids && this_congress.congress_information.congress_shortcut_ids.length > 0) {
				shortcuts = this_congress.congress_information.congress_shortcut_ids;
			} else {
				shortcuts = [];
			}
			if (this_congress.congress_information.congress_sidemenu_ids && this_congress.congress_information.congress_sidemenu_ids.length > 0) {
				sidemenu = this_congress.congress_information.congress_sidemenu_ids;
			} else {
				sidemenu = [];
			}
			app_config_next_session_interval = parseInt(this_congress.congress_information.next_session_timespan);

			event_lang = this_congress.congress_information.congress_lang;



			loadCongressData(this_congress.congress_information.congress_id);
		} else {
			if (user_data.access_data && user_data.access_data.access_id) {
				loadCongressList();
			} else {
				loadCongressListForClient();
			}

			if (message_to_process) {
				var string_divide = message_to_process.additionalData.message_id.split("_");
				var ntype = '';
				var nvalue = '';


				if (string_divide.length > 1) {
					ntype = string_divide[0];
					//nvalue = string_divide[string_divide.length - 1];
					nvalue = message_to_process.additionalData.message_id.replace(ntype + '_', '');
				} else {
					ntype = string_divide[0];
				}
				if (message_to_process.message) {
					message_to_process.alert = message_to_process.message;
				}
				processMessage(message_to_process.alert, ntype, nvalue);
				message_to_process = false;
			}
		}
	} else {
		showToastrAlert('error', 'app type not recognized, loading mother app');
		loadCGHome();
		showCGHome();
		setTimeout("hideLoadingPage();", 1000);
	}




	loadDynamicStyles();

	window.addEventListener('orientationchange', function(event) {
		doOrientationChange(event);

	});

	evaluateScreenSize();

	setTimeout("resetFeaturedSwipe();", 300);





	$(window).on('swipeRight', function() {
		if ($('#mapDiv.current').length > 0) {
			return;
		}
		if ($('#zoomableImage').length > 0) {
			return;
		}
		if (!this_congress) {
			return;
		}
		if ($('#dashboard.current').length > 0) {
			if ($('.side_menu_filter_container.hidden').length > 0) {
				showMenu();
			} else {
				hideFilter();
			}
		} else if ($('.modal_page').length > 0) {
			closeModal();
		} else if ($('#photo_feed.current').length > 0) {
			if ($('.side_menu_filter_container.hidden').length > 0) {
				showMenu();
			} else {
				hideFilter();
			}
		} else {
			goBack();
		}



	});

	/*$(window).on('swipeLeft', function(){

	  if ($('#mapDiv.current').length> 0){
	    return;
	  }

	  if ($('#zoomableImage').length> 0){
	    return;
	  }

	  if ($('.side_menu_container.hidden').length > 0){
	    showFilter();
	  }
	  else{
	    hideMenu();
	  }
	});*/


	doOrientationChange();

	FastClick.attach(document.body);

	app_started = true;
}


function resetFeaturedSwipe() {

	if ($('#dashboard.current').length > 0) {
		console.log('swiper heiht is' + $('#featuredIndexSwipe').height());
		if (window.featuredSwipe) {
			window.featuredSwipe.kill();

			//$('sponsor-banner img').css('width','100%');
			//$('sponsor-banner img').attr('width','100%');


			$('.featured_element').css('font-size', 'inherit');
			$('.featured_element .featured_session_name').css('font-size', 'inherit');
			$('.featured_element .featured_session_day').css('font-size', 'inherit');
			$('.featured_element .featured_session_time').css('font-size', 'inherit');

			//$('.swipe-wrap > div').css('height',$('.swipe-wrap > div img').height() + 'px');

			$('#dashboard .scroll').css('bottom', $('.swipe-wrap > div img').height() + 'px');
			$('#dashboard').focus();

			var elem = document.getElementById('featuredIndexSwipe');
			window.featuredSwipe = Swipe(elem, {
				lockDirection: false,
				auto: 3000,
				speed: 600,
				continuous: true,
				stopPropagation: true
			});
		}

		//$('.swipe-wrap > div').css('height',$('#featuredIndexSwipe').height()+'px');

		var ratio = $('#featuredIndexSwipe').height() / 120;

		var font_size = parseInt(10 * ratio);
		var small_font_size = parseInt(8 * ratio);

		$('.featured_element').css('font-size', small_font_size + 'pt');
		$('.featured_element .featured_session_name').css('font-size', font_size + 'pt');
		$('.featured_element .featured_session_day').css('font-size', small_font_size + 'pt');
		$('.featured_element .featured_session_time').css('font-size', small_font_size + 'pt');


	}
}


function registerPush() {

	if (!isMobile) {
		return;
	}

	pushNotification = window.plugins.pushNotification;

	var push = PushNotification.init({
		android: {
			senderID: "311239789110"
		},
		ios: {
			alert: "true",
			badge: "true",
			sound: "true"
		}
	});
	push.on('registration', function(data) {
		// data.registrationId
		if (data.registrationId.length > 0) {

			console.log("regID = " + data.registrationId);
			console.log('device token = ' + data.registrationId);

			user_data.device.token = data.registrationId;

			updateDevice();
			saveUserDataToStorage();
		}
	});

	push.on('notification', function(data) {
		// data.message,
		// data.title,
		// data.count,
		// data.sound,
		// data.image,
		// data.additionalData

		var message = data;
		//message.message = data.title;

		var string_divide = message.additionalData.message_id.split("_");
		var ntype = '';
		var nvalue = '';
		var news_id = message.additionalData.news_id;


		if (string_divide.length > 1) {
			ntype = string_divide[0];
			//nvalue = string_divide[string_divide.length - 1];
			nvalue = message.additionalData.message_id.replace(ntype + '_', '');
		} else {
			ntype = string_divide[0];
		}

		var message_text = message.message;
		if (hasLoadedCongressInformation) {
			processMessage(message.message, ntype, nvalue, news_id);
		} else {
			message_to_process = message;
			message_to_process.alert = message.message;
		}



		//navigator.notification.confirm(e.payload.message,alertNotificationCallback,trd('notification-title'),[trd('notification-ok'),trd('notification-open-messages')]);

		/*if ( e.foreground )
		              {
		               var my_media = new Media("/android_asset/www/"+e.soundname);
		               my_media.play();
		             }
		             else
		              {  // otherwise we were launched because the user touched a notification in the notification tray.
		                if ( e.coldstart )
		                {
		                  console.log('coldstart notification');
		                }
		                else
		                {
		                 console.log('background notification');
		               }
		             }*/
	});

	push.on('error', function(e) {
		console.log(JSON.stringify(e));
		// e.message
	});




	/*if ( device.platform == 'android' || device.platform == 'Android' )
	{
	  pushNotification.register(
	    successHandler,
	    errorHandler, {
	      "senderID":"311239789110",
	      "ecb":"onNotificationGCM"
	    });
	}
	else
	{
	  pushNotification.register(
	    tokenHandler,
	    errorHandler, {
	      "badge":"true",
	      "sound":"true",
	      "alert":"true",
	      "ecb":"onNotificationAPN"
	    });
	}*/
}

// result contains any message sent from the plugin call
function successHandler(result) {
	console.log(JSON.stringify(result));
	console.log('result = ' + result);
}

function successHandlerUnregister(result) {
	console.log(JSON.stringify(result));
	console.log('result = ' + result);
}

function errorHandlerUnregister(result) {
	console.log('error result = ' + result);
}


// result contains any error description text returned from the plugin call
function errorHandler(error) {
	consol.e.log(JSON.stringify(error));
	console.log('error = ' + error);
}


// Android
function onNotificationGCM(e) {
	console.log('EVENT RECEIVED: ' + e.event);
	switch (e.event) {
		case 'registered':
			if (e.regid.length > 0) {

				console.log("regID = " + e.regid);
				console.log('device token = ' + e.regid);

				user_data.device.token = e.regid;

				updateDevice();
				saveUserDataToStorage();
			}
			break;

		case 'message':
			// if this flag is set, this notification happened while we were in the foreground.
			// you might want to play a sound to get the user's attention, throw up a dialog, etc.
			var message = e.payload;

			var string_divide = message.additionalData.message_id.split("_");
			var ntype = '';
			var nvalue = '';


			if (string_divide.length > 1) {
				ntype = string_divide[0];
				//nvalue = string_divide[string_divide.length - 1];
				nvalue = message.additionalData.message_id.replace(ntype + '_', '');
			} else {
				ntype = string_divide[0];
			}

			var message_text = message.message;
			if (hasLoadedCongressInformation) {
				processMessage(message.message, ntype, nvalue);
			} else {
				message_to_process = message;
				message_to_process.alert = message.message;
			}



			//navigator.notification.confirm(e.payload.message,alertNotificationCallback,trd('notification-title'),[trd('notification-ok'),trd('notification-open-messages')]);

			if (e.foreground) {
				var my_media = new Media("/android_asset/www/" + e.soundname);
				my_media.play();
			} else { // otherwise we were launched because the user touched a notification in the notification tray.
				if (e.coldstart) {
					console.log('coldstart notification');
				} else {
					console.log('background notification');
				}
			}




			console.log('MESSAGE: ' + e.payload.message);
			console.log('MESSAGECNT: ' + e.payload.msgcnt);
			break;

		case 'error':
			console.log('ERROR: ' + e.msg);
			break;

		default:
			console.log('unknown event!');
			break;
	}
}


function tokenHandler(result) {
	// Your iOS push server needs to know the token before it can push to this device
	// here is where you might want to send it the token for later use.
	console.log('device token = ' + result);
	if (result && result != '') {
		user_data.device.token = result;
	}

	updateDevice();
	saveUserDataToStorage();
}

function alertNotificationCallback(button) {
	if (button == 2) {
		loadNewsIndex(false);
	} else {

	}
}

function processMessage(message, ntype, nvalue, news_id) {
    message = stripTags(message);
	//console.log(message + ',' + ntype + ',' + nvalue);
	saveActionInHistory("processMessage([message]," + ntype + "," + nvalue + "," + news_id + ")");
	if (ntype == 'link') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					openLink('http://' + nvalue);
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'meetinginvite') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					meetings.refreshDetail(parseInt(nvalue));
				}
			},
			trd('notification-meeting-title'), [trd('notification-ok'), trd('notification-meeting-reply')]);
	} else if (ntype == 'meetingstatus') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					meetings.refreshDetail(parseInt(nvalue));
				}
			},
			trd('notification-meeting-title'), [trd('notification-ok'), trd('notification-meeting-status')]);
	} else if (ntype == 'meetingreminder') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					meetings.refreshDetail(parseInt(nvalue));
				}
			},
			trd('notification-meeting-title'), [trd('notification-ok'), trd('notification-meeting-status')]);
	} else if (ntype == 'exhibitor') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					loadExhibitorDetail(nvalue, false);
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'customarea') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					loadCustomArea(nvalue);
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'sponsor') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					loadSponsorDetail(nvalue);
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'session') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					loadSessionDetail(nvalue);
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'speaker') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					loadSpeakerDetail(nvalue);
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'location') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					var this_location = this_congress.locations_information['' + nvalue];

					if (this_location && this_location.location_map && nvalue) {
						var map_id = this_location.location_map;
						loadFloorplan(map_id, nvalue);
					}
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'feedback') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					loadFeedbackDetail(nvalue);
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'conversation') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					loadConversationDetail(false, nvalue);
					getConversationWithUser(nvalue);
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'poll') {
		var this_feedback = this_congress.feedback_information['' + nvalue];

		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					getInstantFeedback(nvalue);
				}
			},
			this_feedback.feedback_title, [trd('notification-answer-later'), trd('notification-answer-now')]);
	} else if (ntype == 'chat') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					chat_rooms.lobby.page();
				}
			},
			trd('notification-title'), [trd('notification-ok'), trd('notification-open-link')]);
	} else if (ntype == 'javascript') {
		navigator.notification.confirm(
			message,
			function(button) {
				if (button == 2) {
					if ($('.auth_explain_text').length == 0) { closeModal(); }
					saveActionInHistory("notification-open([message]," + ntype + "," + nvalue + "," + news_id + ")");
					eval(nvalue);
				}
			},
			trd('notification-title'), [trd('notification-later'), trd('notification-open')]);
	} else {
		navigator.notification.alert(message, cgAlertCallback, trd('alert-title'), trd('alert-ok'));
	}
}

function onNotificationAPN(event) {
	console.log('notification received');
	if (event.alert) {
		//navigator.notification.confirm(event.alert,alertNotificationCallback,trd('notification-title'),[trd('notification-ok'),trd('notification-open-messages')]);
		//navigator.notification.confirm(event.message_id,alertNotificationCallback,trd('notification-title'),[trd('notification-ok'),trd('notification-open-messages')]);

		var message = event;

		var string_divide = message.additionalData.message_id.split("_");
		var ntype = '';
		var nvalue = '';


		if (string_divide.length > 1) {
			ntype = string_divide[0];
			//nvalue = string_divide[string_divide.length - 1];
			nvalue = message.additionalData.message_id.replace(ntype + '_', '');
		} else {
			ntype = string_divide[0];
		}

		var message_text = message.alert;
		if (hasLoadedCongressInformation) {
			processMessage(message.alert, ntype, nvalue);
		} else {
			message_to_process = message;
		}
	}

	if (event.sound) {
		var snd = new Media(event.sound);
		snd.play();
	}

	if (event.badge) {
		pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, event.badge);
	}
}

function errorHandler(error) {
	console.log('error = ' + error);
}

function setUpdateTimer() {
	clearInterval(update_timer_event_info);
	clearInterval(refresh_news_timer);
	update_timer_event_info = setInterval("checkEventUpdate();", 5000);
	refresh_news_timer = setInterval("refreshNews()", 6000);
	refreshNews();
}

function checkSessionUpdate() {
	if ($(".current.session_detail").length > 0) {
		var string_divide = $('.current').attr('id').split("_");
		var session_id = string_divide[string_divide.length - 1];
		var this_session = this_congress.sessions_information['' + session_id];
		if (this_session.has_polling && this_session.has_polling == "1") {
			getSessionQuestionnaires(session_id);
		}
	} else if ($('.polling_modal').length > 0) {
		var string_divide = $('.polling_modal').attr('id').split("_");
		var session_id = string_divide[string_divide.length - 1];
		var this_session = this_congress.sessions_information['' + session_id];
		if (this_session.has_polling && this_session.has_polling == "1") {
			getSessionQuestionnaires(session_id);
		}
	} else if ($(".current.feedback_index_for_session").length > 0) {
		var string_divide = $('.current').attr('id').split("_");
		var session_id = string_divide[string_divide.length - 1];
		var this_session = this_congress.sessions_information['' + session_id];
		if (this_session.has_polling && this_session.has_polling == "1") {
			getSessionQuestionnaires(session_id);
		}
	}
}

function checkEventUpdate() {
	//console.log('checking if event info is up to date');
	if(!this_congress || !this_congress.congress_information || polling_socket || moderation_socket || chat_rooms.room.socket){ return false; }
	//console.log('refreshing sessions');
	refreshNextSessions();
	//console.log(' sessions refreshed');
	var now = new Date();
    var request_start = now.getTime();
	var request_data = { id: this_congress.congress_information.congress_id }
	var url = services_home + 'check_event_update.php?id=' + this_congress.congress_information.congress_id + '&rand=' + now.getTime();
	if (isMobile && app_version) { //app_version was set by the plugin onDeviceReady
		request_data.app_version = app_version;
		url += '&app_version=' + app_version;
	}
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: request_data,
		headers: {
			"Cache-Control": "no-cache"
		},
		beforeSend: function(xhr) {
			xhr.setRequestHeader("Cache-Control", "no-cache");
			xhr.setRequestHeader("pragma", "no-cache");
		},
		success: function(response) {
            var request_end = new Date().getTime();
            var delay = request_end - request_start;
            if(delay > 5000 && this_congress){ network.wentSlow(); }else{ network.wentFast(); }
			last_server_time = response.last_server_time;
			if (this_congress.congress_information.lastupdate && response.lastupdate) {
				if (parseInt(response.lastupdate) > parseInt(this_congress.congress_information.lastupdate)) {
					console.log('event info needs update');
					if (!this_congress.congress_information.user_warned) {
						//cgConfirm(trd('message-needs-update'));
						this_congress.congress_information.user_warned = true;
						cgConfirm(trd('message-must-update'));
					}
				} else {
					// EVENT INFO IS UP TO DATE
					if (isMobile && app_version && response.app_version) {
						if (parseFloat(response.app_version) > parseFloat(app_version)) {
							console.log('app needs to be updated');
							if (!this_congress.congress_information.user_warned) {
								this_congress.congress_information.user_warned = true;
								navigator.notification.alert(trd('app-update-needed'), cgAlertCallback, trd('alert-title'), trd('alert-ok'));
							}
						} else {
							// APP VERSION IS UP TO DATE
						}
					}
				}
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('Cant check for updates..network connection?');
		},
		dataType: 'json'
	});

	logSavedHistory();
}

function evaluateScreenSize() {
	if ($(document).width() > 720) {
		$('body').removeClass('smallscreen');
		$('body').addClass('widescreen');

	} else {
		$('body').removeClass('widescreen');
		$('body').addClass('smallscreen');
	}
}

function lockScreenOrientation() {
	if (!isMobile) {
		return;
	}
	var widerDim = $(window).width() > $(window).height() ? $(window).width() : $(window).height();
	if (widerDim > 740)
		window.screen.lockOrientation('landscape');
	else
		window.screen.lockOrientation('portrait');
}

function loadCongressList() {

	clearMainDivs();

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();

	console.log(JSON.stringify(user_data.profile));
	showLoadingOverlay();

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'loadEventList',
				client_id: app_client_id,
				user_data: user_data,
				access_data: user_data.access_data,
				lang: app_default_lang
			}
		},
		dataType: 'json',
		success: function eventsLoaded(response) {
			hideLoadingOverlay();
			console.log('got success' + JSON.stringify(response));
			if (response.success) {
				public_events = response.object;
				loadDynamicStyles();
				loadCongressListMenu();
				setTimeout("hideLoadingPage();", 1000);
			} else {

			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got error:' + JSON.stringify(xhr));
		}
	});
}

function loadCongressListForClient() {

	clearMainDivs();

	var url = services_home + 'services.php';

	console.log(JSON.stringify(user_data.profile));


	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'loadEventListForClient',
				client_id: app_client_id,
				user_data: user_data,
				lang: app_default_lang
			}
		},
		dataType: 'json',
		success: function eventsLoaded(response) {
			console.log('got' + JSON.stringify(response));
			if (response.success) {
				public_events = response.object;
				loadCongressListMenu();
				setTimeout("hideLoadingPage();", 1000);
			} else {

			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('got' + JSON.stringify(xhr));
		}
	});
}

function loadCongressListMenu() {
	var congressListHtml = '';

	congressListHtml += '<div class="congress_list_content">';
	congressListHtml += '<img src="config/multi_banner.jpg" onerror="this.style.display = \'none\';" width="100%" />';
	//congressListHtml += '<div class="congress_list_title">' + trd('apps-for-events') + '</div>';
	$.each(public_events, function(index, this_event) {


		//congressListHtml += '<div class="congress_list_element clearfix" style="background-color:'+color_dark+'">';

		var eventlogo = 'img/event_image_placeholder.png';

		if (this_event.imgURL) {
			eventlogo = this_event.imgURL;
		}

		var img = new Image();
		img.onload = function() {
			$('#congress_img_' + this_event.id).attr('src', eventlogo);
		};
		img.src = eventlogo;


		congressListHtml += '<div class="congress_list_item" onclick="cgConfirmOpenGuide(' + this_event.id + ',\'' + this_event.event_code + '\');">';

		//congressListHtml += '<img id="congress_img_'+this_event.id+'" src="img/event_image_placeholder.png" width="100%" />';

		/*congressListHtml += '<div class="name font_color_dark">'+this_event.congress_name+'</div>';
		congressListHtml += '<div class="dates" >'+this_event.event_date+'</div>';
		congressListHtml += '<div class="location">'+this_event.congress_location+'</div>';
		congressListHtml += '<div class="buttons">';
		  congressListHtml += '<div class="button">ABRIR APP ></div>';
		  congressListHtml += '<div class="clearfix"></div>';
		congressListHtml += '</div>';*/

		var date_string = '';
		if (this_event.start_date && this_event.end_date) {
			if (this_event.start_date == this_event.end_date) {
				date_string = trd('date-on-') + this_event.start_date;
			} else {
				date_string = trd('date-from-') + this_event.start_date + trd('-date-to-') + this_event.end_date;
			}
		} else if (this_event.start_date) {

		}

		var icon_img = media_home + 'app-event-icon/' + this_event.id + '/original/' + this_event.event_icon;

		congressListHtml += '<table class="just_align">';
		congressListHtml += '<tr>';
		congressListHtml += '<td width="120"><img src="' + icon_img + '" width="100%" style="border-radius:10px;border:1px solid #A6A6A6" /></td>';
		congressListHtml += '<td style="padding-left:10px"><span class="event_title font_bold font_color_dark" style="font-size:12px">' + this_event.congress_name + '</span><br><span style="color:#8c8c8c;font-size:10px;">' + date_string + '</span><br><span class="" style="color:#8c8c8c;font-size:10px;">' + this_event.congress_location + '</span></td>';
		congressListHtml += '</tr>';
		congressListHtml += '</table>';
		congressListHtml += '</div>';



		/*congressListHtml += '<div class="congress_image" onclick="cgConfirmOpenGuide('+this_event.id+');"><img id="congress_img_'+this_event.id+'" src="img/event_image_placeholder.png" /><div id="loading_spinner_'+this_event.id+'" class="loading_spinner"><img src="img/cg_loading_gray.gif" width="40" /></div></div>';
		congressListHtml += '<div class="event_details"  style="background-color:'+color_dark+';color:white;">';
		congressListHtml += '<div class="congress_name font_bold">'+this_event.congress_name+'</div>';
		congressListHtml += '<div class="congress_date">'+this_event.event_date+'</div>';
		congressListHtml += '<div class="congress_location"><span class="cg-icon-character icon-pinpoint selected" style="font-size:8pt;"></span>&nbsp;&nbsp;'+this_event.congress_location+'</div>';

		congressListHtml += '<span class="download_guide_button cg-icon cg-icon-resources"></span>';
		congressListHtml += '</div>';
		congressListHtml += '</div>';*/

	});

	if (requires_auth) {
		congressListHtml += '<div class="block_button" style="margin-bottom:15px;background-color:#0460a9;color:white;" onclick="doLogout()">' + trd('bt-do-logout') + '</div>';
	}


	congressListHtml += '</div>';

	$('#eventListDiv .congress_list').html(congressListHtml);
	$('#eventListDiv').show();

	FastClick.attach(document.body);

	$('.header').removeClass('pulledright');
	$('#headerOverlay').remove();
}

function areaExists(area_type) {
	var found = false;

	$.each(this_congress.congress_information.congress_areas, function(index, this_area_id) {
		var this_area = this_congress.areas_information['' + this_area_id];
		if (this_area.area_type == area_type) {
			if (this_area.area_available && this_area.area_available == "1") {
				found = true;
				return false;
			}
		}
	});
	return found;
}

function loadMenu() {


	var sideMenuHtml = '';

	if (this_congress.media_information['app-top-side-menu-banner'] && this_congress.media_information['app-top-side-menu-banner']['' + this_congress.congress_information.congress_id]) {
		var this_media = this_congress.media_information['app-top-side-menu-banner']['' + this_congress.congress_information.congress_id];
		var mediaUrl = '';
		if (this_media.offline) {
			mediaUrl = wwwRoot + '/' + this_media.name;
		} else {
			mediaUrl = this_media.imgURL_original;
		}
		sideMenuHtml += '<div class="top_side_menu" style="background-image:url(' + mediaUrl + ');">';

		sideMenuHtml += '<table><tr>';

		sideMenuHtml += '</tr></table>';

		sideMenuHtml += '</div>';
	}


	if (this_congress.media_information['app-bottom-side-menu-banner'] && this_congress.media_information['app-bottom-side-menu-banner']['' + this_congress.congress_information.congress_id]) {
		var this_media = this_congress.media_information['app-bottom-side-menu-banner']['' + this_congress.congress_information.congress_id];
		var mediaUrl = '';
		if (this_media.offline) {
			mediaUrl = wwwRoot + '/' + this_media.name;
		} else {
			mediaUrl = this_media.imgURL_original;
		}
		sideMenuHtml += '<div class="bottom_side_menu" style="background-image:url(' + mediaUrl + ');">';

		sideMenuHtml += '<table><tr>';

		sideMenuHtml += '</tr></table>';

		sideMenuHtml += '</div>';
	}

	sideMenuHtml += '<div class="side_menu_elements scroll">';

	$.each(sidemenu, function(index, shortcut_id) {
		var clickBehaviour = '';
		var area_title = '';
		var iconHtml = '';
		var icon_class = '';
		var this_shortcut = this_congress.sidemenu_information[shortcut_id];

		var area_type_split = this_shortcut.area_type.split('_');
		if (area_type_split.length > 1) { this_shortcut.area_target = this_shortcut.area_type.replace(area_type_split[0] + '_', ''); }
		this_shortcut.area_type = area_type_split[0];

		if (this_shortcut.area_type == 'division') {
			//alert('its a division ' + JSON.stringify(this_shortcut));
			sideMenuHtml += '<div class="font_bold color_bg_side_division color_font_side_division" style="padding:10px;">' + this_shortcut.area_title + '</div>';
			return true;

		} else if (this_shortcut.area_available == '0') {
			clickBehaviour = 'availableSoon(\'' + stringEscape(htmlEntities(this_shortcut.area_title)) + '\');';
		} else if (this_shortcut.available_when && moment(last_server_time).isBefore(this_shortcut.available_when)) {
			clickBehaviour = 'availableSoon(\'' + stringEscape(htmlEntities(this_shortcut.area_title)) + '\');';
		} else if (this_shortcut.area_type == 'program') {
			if (this_shortcut.area_target) { clickBehaviour = 'loadSessionDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'SESSION_FILTER_SESSION_TYPE=-1;clearHistory();loadSessionIndex(false);'; }
		} else if (this_shortcut.area_type == 'speakers') {
			if (this_shortcut.area_target) { clickBehaviour = 'loadSpeakerDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadSpeakersIndex();'; }
		} else if (this_shortcut.area_type == 'exhibitors') {
			if (this_shortcut.area_target) { clickBehaviour = 'loadExhibitorDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadExhibitorsIndex(false);'; }
		} else if (this_shortcut.area_type == 'spaces') {
			if (this_shortcut.area_target) { clickBehaviour = 'loadFloorplan(' + this_shortcut.area_target + ',-1,false);'; } else { clickBehaviour = 'clearHistory();loadFloorplan(-1,-1,false);'; }
		} else if (this_shortcut.area_type == 'posters') {
			if (this_shortcut.area_target) { clickBehaviour = 'loadPosterDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadPostersIndex();'; }
		} else if (this_shortcut.area_type == 'sponsors') {
			if (this_shortcut.area_target) { clickBehaviour = 'loadSponsorDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadSponsorsIndex();'; }
		} else if (this_shortcut.area_type == 'points-of-interest') {
			if (this_shortcut.area_target) { clickBehaviour = 'loadPOIDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadPOIIndex();'; }
		} else if (this_shortcut.area_type == 'resources') {
			clickBehaviour = 'clearHistory();loadResourcesIndex();';
		} else if (this_shortcut.area_type == 'feedback') {
			if (this_shortcut.area_target) { clickBehaviour = 'loadFeedbackDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadFeedbackIndex();'; }
		} else if (this_shortcut.area_type == 'other') {
			clickBehaviour = 'clearHistory();loadCustomArea(' + this_area_id + ',false);';
		} else if (this_shortcut.area_type == 'myagenda') {
			//clickBehaviour = 'clearHistory();loadMyAgenda('+MY_AGENDA_NO_FILTER+',false);';
			clickBehaviour = 'loadMyAgendaIndex(false);'
		} else if (this_shortcut.area_type == 'link') {
			clickBehaviour = clickBehaviour = 'clearHistory();openLink(\'' + this_shortcut.area_target + '\');';
		} else if (this_shortcut.area_type == 'pdf') {
			clickBehaviour = clickBehaviour = 'clearHistory();openPDF(\'' + this_shortcut.area_target + '\');';
		} else if (this_shortcut.area_type == 'search') {
			clickBehaviour = clickBehaviour = 'clearHistory();loadSearch(false);';
		} else if (this_shortcut.area_type == 'notification') {
			clickBehaviour = clickBehaviour = 'clearHistory();loadNewsIndex(false);';
		} else if (this_shortcut.area_type == 'nextsessions') {
			clickBehaviour = 'clearHistory();loadNextSessions(false);';
		} else if (this_shortcut.area_type == 'participants') {
			clickBehaviour = 'clearHistory();loadProfilesIndex(false);';
		} else if (this_shortcut.area_type == 'userconversations') {
			clickBehaviour = 'clearHistory();loadConversationsIndex(false);';
		} else if (this_shortcut.area_type == 'chatrooms') {
			clickBehaviour = 'clearHistory();chat_rooms.lobby.page();';
		} else if (this_shortcut.area_type == 'userprofile') {
			clickBehaviour = 'clearHistory();loadMyProfile(false);';
		} else if (this_shortcut.area_type == 'photofeed') {
			clickBehaviour = 'clearHistory();loadPhotoFeed();';
		} else if (this_shortcut.area_type == 'pollingsessions') {
			if (this_shortcut.area_target) { clickBehaviour = 'showPollingModal(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadPollingSessions(false);'; }
		} else if (this_shortcut.area_type == 'moderationsessions') {
			if (this_shortcut.area_target) { clickBehaviour = 'showSessionQuestionModal(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadModerationSessions(false);'; }
		} else if (this_shortcut.area_type.indexOf('customarea') > -1) {
			//var string_divide = this_shortcut.area_type.split("_");
			//var area_id = string_divide[string_divide.length - 1];
			//var this_area = this_congress.areas_information['' + area_id];
			clickBehaviour = 'clearHistory();loadCustomArea(' + this_shortcut.area_target + ',false);';
		} else if (this_shortcut.area_type.indexOf('javascript') > -1) {
			//var string_divide = this_shortcut.area_type.split("_");
			//var javascript = string_divide[string_divide.length - 1];
			//var javascript = this_shortcut.area_type.replace('javascript_', '');
			clickBehaviour = this_shortcut.area_target;
		} else if (this_shortcut.area_type.indexOf('trackschedule') > -1) {
			//var string_divide = this_shortcut.area_type.split("_");
			//var session_type_id = string_divide[string_divide.length - 1];
			//var this_session_type = this_congress.session_types_information['' + session_type_id];
			if (this_shortcut.area_target) { clickBehaviour = 'SESSION_FILTER_SESSION_TYPE=' + this_shortcut.area_target + ';SESSION_FILTER_DAY=-1;clearHistory();loadSessionIndex(false);'; } else { clickBehaviour = 'SESSION_FILTER_SESSION_TYPE=-1;clearHistory();loadSessionIndex(false);'; }
		} else if (this_shortcut.area_type.indexOf('linkgroup_') > -1) {
			//var string_divide = this_shortcut.area_type.split("_");
			//var link_group_id = string_divide[string_divide.length - 1];
			clickBehaviour = 'clearHistory();loadLinksIndex(' + this_shortcut.area_target + ');';
		} else {
			console.log('code not recognized:' + this_shortcut.area_type);
			return true;
		}

		area_title = this_shortcut.area_title;

		if (this_congress.media_information['sidemenu'] && this_congress.media_information['sidemenu']['' + this_shortcut.shortcut_id]) {
			var this_media = this_congress.media_information['sidemenu']['' + this_shortcut.shortcut_id];
			var customIconUrl = '';
			if (this_media.offline) {
				customIconUrl = wwwRoot + '/' + this_media.name;
			} else {
				customIconUrl = this_media.imgURL_original;
			}
			iconHtml = '<span class="area_icon"><img src="' + customIconUrl + '" width=30 /></span>';
		} else {
			icon_class = 'cg-icon-' + this_shortcut.area_type;
			iconHtml = '<span class="area_icon cg-icon ' + icon_class + ' color_icon_side_menu" ></span>';
		}

		sideMenuHtml += '<div class="side_menu_item menu_area ' + this_shortcut.area_type + ' area_' + this_shortcut.shortcut_id + ' " onclick="' + clickBehaviour + '">' + iconHtml + '<span class="area_division"></span><span class="area_title font_semibold color_font_side_menu"><table class="just_valign"><tr><td>' + area_title + '</td></tr></table></span></div>';
	});

	sideMenuHtml += '<div class="side_menu_item menu_area news " onclick="loadCongressData(' + this_congress.congress_information.congress_id + ',\'' + this_congress.congress_information.congress_lang + '\',true);"><span class="area_icon cg-icon cg-icon-refresh color_icon_side_menu" ></span><span class="area_division"></span><span class="area_title font_semibold color_font_side_menu">' + trd('update-content') + '</span></div>';

	//var lastupdate = new Date(this_congress.congress_information.lastupdate * 1000);
	//sideMenuHtml += '<div style="font-style:italic;font-size: 4px;margin-top: 50px;margin-left: 5px;opacity: 0.5;">'+lastupdate+'</div>';

	if ((app_type == 'multi_home' && this_congress.congress_information.congress_id != multi_home_event_id) || app_type == 'multi') {
		sideMenuHtml += '<div class="side_menu_item menu_area news " onclick="confirmCloseGuide();"><span class="area_icon cg-icon cg-icon-back color_icon_side_menu" ></span><span class="area_division"></span><span class="area_title font_semibold color_font_side_menu">' + trd('close-guide-button') + '</span></div>';
	}

	/*if (this_congress.congress_information.congress_langs.length > 1){
	  sideMenuHtml += '<div class="side_menu_item bg_color_white"><span class="area_icon languages_item cg-icon cg-icon-flag color_icon_side_menu"></span><span class="area_division"></span>';         
	  $.each(this_congress.congress_information.congress_langs,function(index,this_lang){   
	         var selectedModifier = '';
	         if (this_lang == event_lang){
	          selectedModifier = 'selected';
	         }
	          sideMenuHtml += '<div class="lang_option border_color_dark color_icon_side_menu selected_color_bg_division_1 '+selectedModifier+'" onclick="loadCongressData('+this_congress.congress_information.congress_id+',\''+this_lang+'\',true)">'+this_lang+'</div>';
	         });
	 sideMenuHtml += '</div>';
	}*/


	sideMenuHtml += '</div>';

	$('.side_menu_container').html(sideMenuHtml);

	$('.side_menu_container').show();

}

function setSelectedMenuArea(area_id) {
	$('.menu_area').removeClass('selected');
	$('.top_side_menu_button').removeClass('selected');

	if (area_id == 'news' || area_id == 'profile') {
		$('.top_side_menu_button').addClass('notselected');
		$('.top_side_menu_button.' + area_id).removeClass('notselected');
		$('.top_side_menu_button.' + area_id).addClass('selected');
	} else {
		$('.top_side_menu_button').removeClass('notselected');
		$('.top_side_menu_button').removeClass('selected');


		$('.menu_area.' + area_id).addClass('selected');
	}
}

function dismissZoom() {
	window.removeEventListener("deviceorientation", orientationCallback, true);
	if (window.pinchZoom) {
		window.pinchZoom.destroy();
		delete window.pinchZoom;
	}
	if (orientation_interval) {
		window.clearInterval(orientation_interval);
		orientation_interval = undefined;
	}
	$('#imageZoom').html('');
	$('#imageZoom').remove();

	if (myScroll) {
		myScroll.destroy();
	}
}


function doZoomOnImage(imageUrl) {

	if (imageUrl == '') {

	}

	$('#imageZoom').show();

	var zoomHtml = '';
	zoomHtml += '<div id="imageZoom">';
	zoomHtml += '<div id="imageZoomImg"><table><tr><td><img id="zoomableImage" src="" /></td></tr></table><div class="close_button" onclick="dismissZoom();"></div><img class="loading_spinner" src="img/cg_loading_gray.gif" /></div>';
	zoomHtml += '</div>';

	$('#imageZoom').remove();

	$('.mainDiv').append(zoomHtml);

	var img = new Image();

	img.onload = function() {
		$('#zoomableImage').attr('src', imageUrl);
		$('.loading_spinner').hide();
		myScroll = new iScroll('imageZoomImg', { zoom: true, zoomMin: 1 });
	};

	$('#imageZoom').show();
	$('#imageZoom').css('z-index', '100');

	img.src = imageUrl;

	// zoomInterval = setInterval(function() {
	//     if (realOrientation.portrait) {
	//         if (realOrientation.flip)
	//             $('#zoomableImage').css('transform', 'rotateZ(180deg)')
	//         else
	//             $('#zoomableImage').css('transform', 'rotateZ(0deg)')
	//     } else {
	//         if (realOrientation.flip)
	//             $('#zoomableImage').css('transform', 'rotateZ(90deg)')
	//         else
	//             $('#zoomableImage').css('transform', 'rotateZ(-90deg)')
	//     }
	//     myScroll.refresh();
	// }, 1000);

}

var current_orientation = false;
var orientation_interval = false;
var orientationCallback = null;

function doZoomOnImage2(imageUrl) {
	realOrientation = {
		portrait: 1,
		flip: 0
	};
	$('#imageZoom').remove();
	var zoomHtml = '';
	zoomHtml += ' <div id="imageZoom" style="width: 100%; height: 100%;position:relative; overflow:hidden" onclick="event.stopPropagation()"> <img class="loading_spinner" style="display:block;position:absolute;top:50%;transform:translateY(-50%)" src="img/cg_loading_gray.gif" /> <canvas id="imageZoomCanvas" style="width: 100%; height: 100%"></canvas> <div onclick="dismissZoom()" style="position:absolute;top:8px;right:8px;height:30px;width:30px;z-index:100;border-radius:3px;background-color:rgba(0,0,0,.3);background-image:url(\'img/exit_fullscreen.png\');background-repeat:no-repeat;background-position:center;background-size:30px;"></div> </div> ';
	$('#eventDiv').append(zoomHtml);
	$('#imageZoom').show();
	if (!isMobile) {
		showRotatedImage(imageUrl);
	} else {
		window.addEventListener("deviceorientation", orientationChangeCallback, true);
		showRotatedImage(imageUrl);
		orientation_interval = setInterval(function() {
			if (JSON.stringify(realOrientation) != JSON.stringify(current_orientation)) {
				showRotatedImage(imageUrl);
				current_orientation = JSON.parse(JSON.stringify(realOrientation));
			}
			current_orientation = JSON.parse(JSON.stringify(realOrientation));
		}, 1000);
	}

}

function orientationChangeCallback(event) {
	//console.log(Math.round(event.beta),Math.round(event.gamma));
	var beta = Math.abs(event.beta);
	var gamma = Math.abs(event.gamma);
	if ((beta > 20 && beta < 160) || ((beta < 20 && beta > gamma) || (beta - 180 > -20 && beta - 180 < -gamma))) {
		realOrientation.portrait = 1;
		if (event.beta < 0)
			realOrientation.flip = 1;
		else
			realOrientation.flip = 0;
	} else {
		realOrientation.portrait = 0;
		if ((event.gamma > 0 && beta > 160) || (event.gamma < 0 && beta < 20))
			realOrientation.flip = 1;
		else
			realOrientation.flip = 0;
	}


	//console.log(event.beta,event.gamma);
}


function showRotatedImage(imageUrl) {
	var deg = 0;
	if (isMobile && realOrientation != undefined) {
		if (realOrientation.portrait == 1) {
			if (realOrientation.flip)
				deg = 180;
			else
				deg = 0;
		} else if (realOrientation.portrait == 0) {
			if (realOrientation.flip)
				deg = 90;
			else
				deg = -90;
		}
	}
	getRotatedImage(imageUrl, deg, function(base64) {

		if (window.pinchZoom) {
			window.pinchZoom.pause();
			if (!window.pinchZoom.destroyed) {
				window.pinchZoom.destroy();
			}
			delete window.pinchZoom;
		}


		window.pinchZoom = new PinchZoomCanvas({
			canvas: document.getElementById('imageZoomCanvas'),
			path: base64,
			momentum: true,
			zoomMax: 2,
			doubletap: true,
			onZoomEnd: function(zoom, zoomed) {
				console.log("---> is zoomed: %s", zoomed);
				console.log("---> zoom end at %s", zoom);
			},
			onZoom: function(zoom) {
				console.log("---> zoom is %s", zoom);
			},
			onReady: function() {
				$('#imageZoom img').hide();
			}
		});
		// setTimeout(function() {
		//     window.pinchZoom.zoom(0, 0, 0);
		//     if (!window.pinchZoom.impetus || window.pinchZoom.impetus == null) {
		//         window.pinchZoom._createImpetus();
		//     } else {
		//         window.pinchZoom._updateImpetus();
		//     }
		// }, 100);
	});
}

function getRotatedImage(imageUrl, degrees, callback) {
	var image = new Image();
	image.crossOrigin = "Anonymous";
	var result = '';
	image.onload = function() {
		var canvas = document.createElement('canvas');
		var ctx = canvas.getContext('2d');

		var w = image.width;
		var h = image.height;
		var rads = degrees * Math.PI / 180;
		var c = Math.cos(rads);
		var s = Math.sin(rads);
		if (s < 0) { s = -s; }
		if (c < 0) { c = -c; }
		//use translated width and height for new canvas
		canvas.width = h * s + w * c;
		canvas.height = h * c + w * s;
		//draw the rect in the center of the newly sized canvas
		ctx.translate(canvas.width / 2, canvas.height / 2);
		ctx.rotate(degrees * Math.PI / 180);
		ctx.drawImage(image, -image.width / 2, -image.height / 2);

		result = canvas.toDataURL('image/png');
		callback(result);

	}
	image.src = imageUrl;

}


function buildZoom() {
	if (imageUrl == '') {

	}

	$('#imageZoom').show();

	var zoomHtml = '';
	zoomHtml += '<div id="imageZoom">';
	zoomHtml += '<div id="imageZoomImg"><table><tr><td><img id="zoomableImage" src="" /></td></tr></table><div class="close_button" onclick="dismissZoom();"></div><img class="loading_spinner" src="img/cg_loading_gray.gif" /></div>';
	zoomHtml += '</div>';

	$('#imageZoom').remove();

	$('.mainDiv').append(zoomHtml);

	var img = new Image();

	img.onload = function() {
		$('#zoomableImage').attr('src', imageUrl);
		$('.loading_spinner').hide();
		myScroll = new iScroll('imageZoomImg', { zoom: true, zoomMin: 1 });
	};

	$('#imageZoom').show();
	$('#imageZoom').css('z-index', '100');

	img.src = imageUrl;
}

function zoomToLocation(location_id) {
	var this_location = this_congress.locations_information['' + location_id];

	var mapWidth = $('#zoomableImage').width();
	var mapHeight = $('#zoomableImage').height();

	var left_padding = $('.mainDiv').width() / 2;
	var top_padding = $('.mainDiv').height() / 3;



	var zoomed_location_left = parseFloat(this_location.location_left) * mapScroll.scale - (left_padding);
	var zoomed_location_top = parseFloat(this_location.location_top) * mapScroll.scale - (top_padding);



	if (zoomed_location_left < 0)
		zoomed_location_left = 0;
	if (zoomed_location_top < 0)
		zoomed_location_top = 0;


	if (parseFloat(this_location.location_top) * mapScroll.scale + top_padding >= mapHeight)
		zoomed_location_top += (mapHeight - (parseFloat(this_location.location_top) * mapScroll.scale + top_padding));

	if (parseFloat(this_location.location_left) * mapScroll.scale + left_padding >= mapWidth)
		zoomed_location_left += (mapWidth - (parseFloat(this_location.location_left) * mapScroll.scale + left_padding));

	var zoomed_scale = mapScroll.scale;

	mapScroll.scrollTo(-parseInt(zoomed_location_left), -parseInt(zoomed_location_top), 100, false);

	$('.pinpoint').removeClass('selected');
	$('#pinpoint_location_' + location_id).addClass('selected');
}


function attachPinpoint() {

	$('.pinpoint').remove();


	$.each(this_congress.locations_information, function(index, this_location) {
		if (this_location) {
			if (FLOORPLAN_FILTER_FLOORPLAN != this_location.location_map) {
				return true;
			}
			if (FLOORPLAN_FILTER_LOCATION_TYPE != -1) {
				if (FLOORPLAN_FILTER_LOCATION_TYPE != this_location.location_type)
					return true;
			}
			if (FLOORPLAN_FILTER_EXHIBITOR_TYPE != -1) {
				var hasExhibitorType = false;

				var exhibitorImageUrl = '';





				$.each(this_location.exhibitors, function(index, this_exhibitor_id) {
					var this_exhibitor = this_congress.exhibitors_information['' + this_exhibitor_id];

					if (this_congress.media_information['exhibitor'] && this_congress.media_information['exhibitor']['' + this_exhibitor_id]) {

						exhibitor_media = this_congress.media_information['exhibitor']['' + this_exhibitor_id];

						if (exhibitor_media.offline) {
							exhibitorImageUrl = fsRoot + '/' + exhibitor_media.name;
						} else {
							exhibitorImageUrl = exhibitor_media.imgURL_small;
						}
					}


					if (this_exhibitor.exhibitor_type == FLOORPLAN_FILTER_EXHIBITOR_TYPE) {
						hasExhibitorType = true;
						return false;
					}
				});
				if (!hasExhibitorType) {
					return true;
				}
			}

			var oldScale = mapScroll.scale;

			$('#mapScrollPane').append('<div class="pinpoint cg-icon-font icon-pinpoint" id="pinpoint_location_' + this_location.location_id + '" onclick="touchedLocation(' + this_location.location_id + ');" style="top:' + (parseInt(this_location.location_top)) + 'px;left:' + (parseInt(this_location.location_left)) + 'px;"></div>');
			resizePinpoints();
		}
	});



}

function touchedLocation(this_location_id) {
	var this_location = this_congress.locations_information['' + this_location_id];



	var mapInfoDivHtml = '';
	mapInfoDivHtml += '<div class="section_title font_bold font_color_white color_bg_division_1">' + this_location.location_name + '</div>';

	mapInfoDivHtml += '<div id="mapInfoDiv_content" class="">';
	mapInfoDivHtml += '<div class="scroll_lock">';

	if (this_location.exhibitors.length > 0) {
		$.each(this_location.exhibitors, function(index, this_exhibitor_id) {
			var this_exhibitor = this_congress.exhibitors_information['' + this_exhibitor_id];

			var exhibitorImageUrl = '';

			if (this_congress.media_information['exhibitor'] && this_congress.media_information['exhibitor']['' + this_exhibitor_id]) {

				exhibitor_media = this_congress.media_information['exhibitor']['' + this_exhibitor_id];

				if (exhibitor_media.offline) {
					exhibitorImageUrl = fsRoot + '/' + exhibitor_media.name;
				} else {
					exhibitorImageUrl = exhibitor_media.imgURL_small;
				}
			}

			mapInfoDivHtml += getHtmlForExhibitorInfo(this_exhibitor_id);

		});
	}


	if (this_location.sessions.length > 0) {
		$.each(this_location.sessions, function(index, this_session_id) {
			var this_session = this_congress.sessions_information['' + this_session_id];
			mapInfoDivHtml += getHtmlForMiniSessionInfo(this_session_id);

		});
	}
	mapInfoDivHtml += '</div>';
	mapInfoDivHtml += '</div>';

	$('#mapInfoDiv').html(mapInfoDivHtml);

	var mapInfoDivHeight = parseInt($(window).height() / 2);

	$('#mapInfoDiv').css('max-height', mapInfoDivHeight + 'px');
	$('#mapInfoDiv_content').css('max-height', (mapInfoDivHeight - 30) + 'px');
	$('.pinpoint').removeClass('selected');
	$('#pinpoint_location_' + this_location_id).addClass('selected');

	$('#mapZoomImg').css('bottom', '155px');



	mapScroll.refresh();

	zoomToLocation(this_location_id);


}


function showExhibitorPopOver(exhibitor_id) {

	var this_exhibitor = this_congress.exhibitors_information['' + exhibitor_id];

	var popOverHtml = '';
	popOverHtml += '<div class="exhibitor_popover">';
	popOverHtml += '<div class="close_button" onclick="$(\'.exhibitor_popover\').remove();"></div>';
	popOverHtml += '<div class="kinda_title_color font_bold font_color_dark">' + this_exhibitor.exhibitor_name + '</div>';
	popOverHtml += '<div class="kinda_button" onclick="clearOverlays();loadExhibitorDetail(' + exhibitor_id + ',false);">Go to exhibitor\'s page</div>';


	popOverHtml += '</div>';
	$('body').append(popOverHtml);
}

function dismissMap() {
	$('#mapDiv').hide();
}

function onSwipeTransitionEnd(index, element) {
	$('#page_marker_0').removeClass('selected');
	$('#page_marker_1').removeClass('selected');
	$('#page_marker_' + index).addClass('selected');
}

function add_to_my_agenda(this_session_id, from_registration) {
	if (from_registration == undefined)
		from_registration = false;
	saveActionInHistory("add_to_my_agenda(" + this_session_id + ")");
	window.event.stopPropagation();
	if (!user_data.profile.agenda["sessions"]) {
		user_data.profile.agenda["sessions"] = [];
	}
	if (!array_contains(user_data.profile.agenda["sessions"], this_session_id)) {
		user_data.profile.agenda["sessions"].push(this_session_id);
		$('#session_element_' + this_session_id).addClass('favourite');
		$('.add_to_favs').addClass('selected');
		$('.cg-icon-myagenda').addClass('in_agenda');
		$('.agenda_text').html(trd('remove-from-agenda'));
		saveUserDataToStorage();
		if (!from_registration) {
			showToastrAlert('success', trd('session-added-to-agenda') + '');
		}

		var this_session = this_congress.sessions_information['' + this_session_id];

		var this_day = this_congress.day_information['' + this_session.session_day_id];
		var this_day_string = '' + this_day.day_time;
		if (from_registration) {
			if (this_session.registration_feedback && !user_data.profile.feedback['' + this_session.registration_feedback]) {
				getInstantFeedback(this_session.registration_feedback);
			}
		}
		if (this_congress.congress_information.has_calendar && this_congress.congress_information.has_calendar == '1') {
			addSessionToCalendar(this_session_id);
		}

		schedule_local_notification('session', this_session_id, trd('session-reminder-title'), trd('session-reminder-message'), this_day_string + ' ' + this_session.session_start_time, 10);
	} else {
		remove_from_my_agenda(this_session_id);
		saveUserDataToStorage();
		if ($('#myagenda.current').length > 0) {
			$('#session_element_' + this_session_id).fadeOut(200, function() {
				if (!from_registration)
					showToastrAlert('success', trd('session-removed-from-agenda'));
			});
		} else {
			if (!from_registration)
				showToastrAlert('success', trd('session-removed-from-agenda') + '');
		}
		$('#session_element_' + this_session_id).removeClass('favourite');
		$('.add_to_favs').removeClass('selected');
		$('.cg-icon-myagenda').removeClass('in_agenda');
		$('.agenda_text').html(trd('add-to-agenda'));
	}
	updateProfile();
}

function conflictingSessions(this_session_id) {
	if (this_session_id) { //compares to sessions in the user agenda
		var conflicting_sessions = user_data.profile.agenda.sessions.filter(function(session_id) {
			if (!this_congress.sessions_information[session_id]) { return false; }
			var start_time = this_congress.sessions_information[session_id].session_start_time;
			var this_start_time = this_congress.sessions_information[this_session_id].session_start_time;
			var day_id = this_congress.sessions_information[session_id].session_day_id;
			var this_day_id = this_congress.sessions_information[this_session_id].session_day_id;
			return (start_time == this_start_time && day_id == this_day_id && session_id != this_session_id);
		});
	} else { //compares all sessions in the event
		var conflicting_sessions = [];
		$.each(this_congress.sessions_information, function(index, session) {
			var session_id = index;
			$.each(this_congress.sessions_information, function(this_index, this_session) {
				var this_session_id = this_index
				var start_time = this_congress.sessions_information[session_id].session_start_time;
				var this_start_time = this_congress.sessions_information[this_session_id].session_start_time;
				var day_id = this_congress.sessions_information[session_id].session_day_id;
				var this_day_id = this_congress.sessions_information[this_session_id].session_day_id;
				if (start_time == this_start_time && day_id == this_day_id && session_id != this_session_id) {
					conflicting_sessions.push(this_session_id);
				}
			});
		});
		conflicting_sessions = conflicting_sessions.length > 0;
	}
	return conflicting_sessions;
}


function add_profile_to_my_agenda(this_profile_id) {
	saveActionInHistory("add_profile_to_my_agenda(" + this_profile_id + ")");

	window.event.stopPropagation();

	if (!user_data.profile.agenda["profiles"]) {
		user_data.profile.agenda["profiles"] = [];
	}

	if (!array_contains(user_data.profile.agenda["profiles"], this_profile_id)) {
		user_data.profile.agenda["profiles"].push(this_profile_id);
		$('.add_profile_to_fav_btn').html(trd('profile-remove-from-favourites'));
		$('.add_profile_to_fav_btn').addClass('selected');
		saveUserDataToStorage();
		showToastrAlert('success', trd('profile-added-to-agenda'));
	} else {

		remove_profile_from_my_agenda(this_profile_id);

		saveUserDataToStorage();


		if ($('#myagenda.current').length > 0) {
			$('#session_element_' + this_profile_id).fadeOut(200, function() { showToastrAlert('success', trd('session-removed-from-agenda')); });
		} else {
			showToastrAlert('success', trd('profile-removed-from-agenda'));
		}
		$('.add_profile_to_fav_btn').html(trd('profile-add-to-favourites'));
		$('.add_profile_to_fav_btn').addClass('selected');


	}

	updateProfile();
}


function add_poster_to_my_agenda(this_poster_id) {
	saveActionInHistory("add_poster_to_my_agenda(" + this_poster_id + ")");

	window.event.stopPropagation();

	if (!user_data.profile.agenda["posters"]) {
		user_data.profile.agenda["posters"] = [];
	}

	if (!array_contains(user_data.profile.agenda["posters"], this_poster_id)) {
		user_data.profile.agenda["posters"].push(this_poster_id);
		$('#poster_element_' + this_poster_id).addClass('favourite');
		$('.add_to_favs').addClass('selected');
		saveUserDataToStorage();
		showToastrAlert('success', trd('poster-added-to-agenda') + '');
	} else {

		remove_poster_from_my_agenda(this_poster_id);

		saveUserDataToStorage();


		if ($('#myagenda.current').length > 0) {
			$('#poster_element_' + this_poster_id).fadeOut(200, function() { showToastrAlert('success', trd('poster-removed-from-agenda')); });
		} else {
			showToastrAlert('success', trd('poster-removed-from-agenda') + '');
		}

		$('#poster_element_' + this_poster_id).removeClass('favourite');
		$('.add_to_favs').removeClass('selected');


	}

	updateProfile();
}

function add_exhibitor_to_my_agenda(this_exhibitor_id) {
	saveActionInHistory("add_exhibitor_to_my_agenda(" + this_exhibitor_id + ")");

	window.event.stopPropagation();

	if (!user_data.profile.agenda["exhibitors"]) {
		user_data.profile.agenda["exhibitors"] = [];
	}

	if (!user_data.profile.agenda["exhibitors"].contains(this_exhibitor_id)) {
		user_data.profile.agenda["exhibitors"].push(this_exhibitor_id);
		$('#exhibitor_element_' + this_exhibitor_id).addClass('favourite');
		$('.add_to_favs').addClass('selected');
		saveUserDataToStorage();
		showToastrAlert('success', trd('exhibitor-added-to-agenda') + '');
	} else {
		remove_exhibitor_from_my_agenda(this_exhibitor_id);
		$('#exhibitor_element_' + this_exhibitor_id).removeClass('favourite');
		$('.add_to_favs').removeClass('selected');

		saveUserDataToStorage();

		if ($('#myagenda.current').length > 0) {
			$('#exhibitor_element_' + this_exhibitor_id).fadeOut(200, function() { showToastrAlert('success', trd('exhibitor-removed-from-agenda')); });
		} else {
			showToastrAlert('success', trd('exhibitor-removed-from-agenda') + '');
		}
	}

	updateProfile();
}

function do_rate_poster(poster_id, rating, skipalert) {
	for (var i = 1; i <= 5; i++) {
		if (i != rating) {
			$('#rate_poster_' + poster_id + 'star_' + i).css('opacity', '0.2');
		} else {
			$('#rate_poster_' + poster_id + 'star_' + i).css('opacity', '1');
		}
	}
	user_data.profile.rating.posters['' + poster_id] = rating;
	saveUserDataToStorage();
	updateProfile();
	if (!skipalert) {
		showToastrAlert('success', trd('message-rated-poster'));
	}


}

function do_rate_speaker(speaker_id, rating, skipalert) {

	for (var i = 1; i <= 5; i++) {
		if (i != rating) {
			$('#rate_speaker_' + speaker_id + 'star_' + i).css('opacity', '0.2');
		} else {
			$('#rate_speaker_' + speaker_id + 'star_' + i).css('opacity', '1');
		}
	}

	user_data.profile.rating.speakers['' + speaker_id] = rating;
	saveUserDataToStorage();
	updateProfile();

	if (!skipalert) {
		showToastrAlert('success', trd('message-rated-speaker'));
	}
}


function do_rate_exhibitor(exhibitor_id, rating, skipalert) {
	for (var i = 1; i <= 5; i++) {
		if (i != rating) {
			$('#rate_exhibitor_' + exhibitor_id + 'star_' + i).css('opacity', '0.2');
		} else {
			$('#rate_exhibitor_' + exhibitor_id + 'star_' + i).css('opacity', '1');
		}
	}
	user_data.profile.rating.exhibitors['' + exhibitor_id] = rating;
	saveUserDataToStorage();
	updateProfile();

	if (!skipalert) {
		showToastrAlert('success', trd('message-rated-exhibitor'));
	}
}



function do_rate_session(session_id, rating, skipalert) {
	/*  $('#rate_session_'+session_id+'star_1').removeClass('selected');
	  $('#rate_session_'+session_id+'star_2').removeClass('selected');
	  $('#rate_session_'+session_id+'star_3').removeClass('selected');
	  $('#rate_session_'+session_id+'star_4').removeClass('selected');
	  $('#rate_session_'+session_id+'star_5').removeClass('selected');*/

	for (var i = 1; i <= 5; i++) {
		if (i != rating) {
			$('#rate_session_' + session_id + 'star_' + i).css('opacity', '0.2');
			//$('#rate_session_'+session_id+'star_'+i).css('filter','grayscale(100%)');
		} else {
			$('#rate_session_' + session_id + 'star_' + i).css('opacity', '1');
			//$('#rate_session_'+session_id+'star_'+i).css('filter','none');
		}
	}


	user_data.profile.rating.sessions['' + session_id] = rating;
	saveUserDataToStorage();
	updateProfile();

	if (!skipalert) {
		showToastrAlert('success', trd('message-rated-session'));
	}
}

function showToastrAlert(type, text, positionClass) {
	if (positionClass == undefined) {
		positionClass = "toast-bottom-center";
	}
	if ($('.session_bottom_actions').length > 0) {
		positionClass = "toast-bottom-center-offset";
	}
	toastr.options = {
		"closeButton": false,
		"debug": false,
		"newestOnTop": true,
		"progressBar": false,
		"positionClass": positionClass,
		"preventDuplicates": true,
		"onclick": null,
		"showDuration": "300",
		"hideDuration": "1000",
		"timeOut": "3000",
		"extendedTimeOut": "1000",
		"showEasing": "swing",
		"hideEasing": "linear",
		"showMethod": "fadeIn",
		"hideMethod": "fadeOut"
	}
	if (type == 'custom') {
		toastr.options.toastClass = 'color_bg_division_1 font_size_small';
		toastr.options.timeOut = 5000;
		toastr.options.closeButton = true;
		if (text.button_title && text.button_javascript) {
			text.message += "<button onclick=" + text.button_javascript;
			text.message += " style='font-size:10px;width:80%;padding:5px;background-color:#f2f2f2;color:black;border-radius:5px;margin-top:5px'>";
			text.message += text.button_title + "</button>";
		}
		toastr.info(text.message, text.title);
	} else {
		toastr[type](text);
	}
}

function remove_poster_from_my_agenda(poster_id) {
	saveActionInHistory("remove_poster_from_my_agenda(" + poster_id + ")");
	user_data.profile.agenda["posters"] = $.grep(user_data.profile.agenda["posters"], function(value) {
		return value != poster_id;
	});

}

function remove_profile_from_my_agenda(profile_id) {
	saveActionInHistory("remove_profile_from_my_agenda(" + profile_id + ")");
	user_data.profile.agenda["profiles"] = $.grep(user_data.profile.agenda["profiles"], function(value) {
		return value != profile_id;
	});
}

function remove_from_my_agenda(session_id) {
	saveActionInHistory("remove_from_my_agenda(" + session_id + ")");
	user_data.profile.agenda["sessions"] = $.grep(user_data.profile.agenda["sessions"], function(value) {
		return value != session_id;
	});
	if (this_congress.congress_information.has_calendar && this_congress.congress_information.has_calendar == '1' && isMobile) {
		removeSessionFromCalendar(session_id);
	}
	if (isMobile) {
		cancel_local_notification('session', session_id);
	}
}

function remove_from_tag_filter(alternative_id) {
	SESSION_FILTER_TAGS = $.grep(SESSION_FILTER_TAGS, function(value) {
		return value != alternative_id;
	});

}

function remove_exhibitor_from_my_agenda(exhibitor_id) {
	saveActionInHistory("remove_exhibitor_from_my_agenda(" + exhibitor_id + ")");
	user_data.profile.agenda["exhibitors"] = $.grep(user_data.profile.agenda["exhibitors"], function(value) {
		return value != exhibitor_id;
	});
}

function loadDynamicStyles() {

	var dynamicStyles = '';

	if (!isIOS) {
		$('body').css('top', '0px');
	}
	if (!isMobile) {
		$('body').css('max-width', '768px');
		$('body').css('margin', 'auto');
		$('body').css('background', 'none');
		$('body').css('background-color', 'black');
	}

	if (this_congress && this_congress.congress_information) {
		color_darker = this_congress.congress_information.color_darker;
		color_dark = this_congress.congress_information.color_dark;
		color_medium = this_congress.congress_information.color_medium;
		color_light = this_congress.congress_information.color_light;
		color_highlighted = this_congress.congress_information.color_highlighted;
		color_icon_top_menu = this_congress.congress_information.color_icon_top_menu;
		color_icon_second_menu = this_congress.congress_information.color_icon_second_menu;
		color_icon_side_menu = this_congress.congress_information.color_icon_side_menu;
		color_font_side_menu = this_congress.congress_information.color_font_side_menu;
		color_font_second_menu = this_congress.congress_information.color_font_second_menu;
		color_font_dark = this_congress.congress_information.color_font_dark;
		color_bg_division_1 = this_congress.congress_information.color_bg_division_1;
		color_bg_division_2 = this_congress.congress_information.color_bg_division_2;
		color_icon_clickable = this_congress.congress_information.color_icon_clickable;
		color_bg_side_menu = this_congress.congress_information.color_bg_side_menu;
		color_bg_filter_menu = this_congress.congress_information.color_bg_filter_menu;
		color_bg_header = this_congress.congress_information.color_bg_header;
		color_bg_list_page_header = this_congress.congress_information.color_bg_list_page_header;
		color_shortcut_icon = this_congress.congress_information.color_shortcut_icon;
		color_bg_shortcut_icon = this_congress.congress_information.color_bg_shortcut_icon;
		color_font_gray = this_congress.congress_information.color_font_gray;
		color_pinpoint = this_congress.congress_information.color_pinpoint;
		color_pinpoint_selected = this_congress.congress_information.color_pinpoint_selected;
		color_bg_card = this_congress.congress_information.color_bg_card;
		color_bg_side_division = this_congress.congress_information.color_bg_side_division;
		color_font_side_division = this_congress.congress_information.color_font_side_division;

	} else {
		color_darker = app_color_darker;
		color_dark = app_color_dark;
		color_medium = app_color_medium;
		color_light = app_color_light;
		color_featured = app_color_featured;
	}

	var largestSide = $(window).width();
	if ($(window).height() > $(window).width()) {
		largestSide = $(window).height();
	}

	dynamicStyles += '.smallscreen .mainDiv.pulledright { left:90%; right:-90%; } \n\n';

	dynamicStyles += '.smallscreen .header.pulledright { left:90%; right:-90%; } \n\n';

	dynamicStyles += '.smallscreen .mainDiv.pulledleft { right:90%; left:-90%; } \n\n';

	dynamicStyles += '.smallscreen .header.pulledleft { right:90%; left:-90%; } \n\n';

	dynamicStyles += '.smallscreen .side_menu_filter_container { right:0px; left:10%; } \n\n';

	dynamicStyles += '.smallscreen .side_menu_container.hidden { left:-' + largestSide + 'px; right:' + largestSide + 'px; } \n\n';

	dynamicStyles += '.smallscreen .side_menu_filter_container.hidden { left:' + largestSide + 'px; right:-' + largestSide + 'px; } \n\n';

	dynamicStyles += '.widescreen .mainDiv.pulledright { left:25%;} \n\n';

	dynamicStyles += '.widescreen .header.pulledright { left:25%; } \n\n';

	dynamicStyles += '.widescreen .mainDiv.pulledleft { right:25%; } \n\n';

	dynamicStyles += '.widescreen .header.pulledleft { right:25%; } \n\n';

	dynamicStyles += '.widescreen .side_menu_container { left:0px; right:75%; } \n\n';

	dynamicStyles += '.widescreen .side_menu_filter_container { right:0px; left:75%; } \n\n';

	dynamicStyles += '.widescreen .side_menu_container.hidden { left:-' + $(window).width() + 'px; right:' + $(window).width() + 'px; } \n\n';

	dynamicStyles += '.widescreen .side_menu_filter_container.hidden { left:' + $(window).width() + 'px; right:-' + $(window).width() + 'px; } \n\n';


	dynamicStyles += '.menu_container.hidden { top:-' + $(window).height() + 'px; bottom:' + $(window).height() + 'px; } \n\n';

	dynamicStyles += '.normal_page.past { left:-' + $(window).width() + 'px; right:' + $(window).width() + 'px; } \n\n';

	dynamicStyles += '.normal_page.future { left:' + $(window).width() + 'px; right:-' + $(window).width() + 'px; } \n\n';

	dynamicStyles += '.font_color_darker { color:' + color_darker + ' !important; }\n\n';

	dynamicStyles += '.font_color_dark { color:' + color_dark + ' !important; }\n\n';

	dynamicStyles += '.font_color_medium { color:' + color_medium + ' !important; }\n\n';

	dynamicStyles += '.font_color_light { color:' + color_light + ' !important; }\n\n';

	/*dynamicStyles += '.font_color_gray_1 { color:#4e4d50 !important; }\n\n';

	dynamicStyles += '.font_color_gray_1 { color:#999999 !important; }\n\n';

	dynamicStyles += '.font_color_gray_3 { color:#b3b3b3 !important; }\n\n';

	dynamicStyles += '.font_color_gray_4 { color:#f0f0f0 !important; }\n\n';*/

	dynamicStyles += '.font_color_gray_1 { color:' + color_font_gray + ' !important;  }\n\n';

	dynamicStyles += '.font_color_gray_1 { color:' + color_font_gray + ' !important; }\n\n';

	dynamicStyles += '.font_color_gray_3 { color:' + color_font_gray + ' !important; }\n\n';

	dynamicStyles += '.font_color_gray_4 { color:' + color_font_gray + ' !important; }\n\n';

	dynamicStyles += '.font_color_white { color:white !important; }\n\n';

	dynamicStyles += '.font_color_raw { color:#fffffa !important; }\n\n';

	dynamicStyles += '.cg_button { background-color:' + color_bg_division_2 + ' !important; color:white; }\n\n';

	dynamicStyles += '.side_menu_container { background-color:' + color_bg_side_menu + ' !important; }\n\n';
	dynamicStyles += '.side_menu_filter_container { background-color:' + color_bg_filter_menu + ' !important; }\n\n';
	dynamicStyles += '.header { background-color:' + color_bg_header + ' !important; }\n\n';
	dynamicStyles += '.list_page_header { background-color:' + color_bg_list_page_header + ' !important; }\n\n';
	dynamicStyles += '.shortcut_icon { background-color:' + color_bg_shortcut_icon + ' !important; color:' + color_shortcut_icon + '; }\n\n';
	dynamicStyles += '.color_bg_shortcut_icon { background-color:' + color_bg_shortcut_icon + ' !important; }\n\n';
	dynamicStyles += '.rate_session { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.poster_description { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.description { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.description a { color:' + color_font_dark + '; }\n\n';
	dynamicStyles += '.detailDiv.session .session_description { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.speaker_button .speaker_short_description { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.speakerHeader .speaker_short_description { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.exhibitorHeader .exhibitor_short_description { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.poster_author_name { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.detailDiv.session .session_time { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.detailDiv.session .session_day { color:' + color_font_gray + '; }\n\n';
	dynamicStyles += '.detailDiv.session .session_room { color:' + color_font_gray + '; }\n\n';

	dynamicStyles += '.color_icon_top_menu { color:' + color_icon_top_menu + ' !important; }\n\n';
	dynamicStyles += '.color_icon_second_menu { color:' + color_icon_second_menu + ' !important; }\n\n';
	dynamicStyles += '.color_icon_side_menu { color:' + color_icon_side_menu + ' !important; }\n\n';
	dynamicStyles += '.color_font_side_menu { color:' + color_font_side_menu + ' !important; }\n\n';
	dynamicStyles += '.color_font_second_menu { color:' + color_font_second_menu + ' !important; }\n\n';
	dynamicStyles += '.color_font_dark { color:' + color_font_dark + ' !important; }\n\n';
	dynamicStyles += '.color_bg_division_1 { background-color:' + color_bg_division_1 + ' !important; }\n\n';
	dynamicStyles += '.color_bg_division_2 { background-color:' + color_bg_division_2 + ' !important; }\n\n';
	dynamicStyles += '.selected_color_bg_division_1.selected { background-color:' + color_bg_division_1 + ' !important; color:white !important; }\n\n';
	dynamicStyles += '.color_icon_clickable { color:' + color_icon_clickable + ' !important; }\n\n';
	//dynamicStyles += '.shortcut_icon { border:1px solid '+color_icon_clickable+' !important; }\n\n';
	dynamicStyles += '.selected_color_bg_clickable.selected { color:white;background-color:' + color_icon_clickable + ' !important; }\n\n';

	dynamicStyles += 'a { color:' + color_font_dark + ' !important; }\n\n';
	dynamicStyles += 'a:visited { color:' + color_font_dark + ' !important; }\n\n';
	dynamicStyles += 'a:active { color:' + color_font_dark + ' !important; }\n\n';

	dynamicStyles += '.bg_color_dark { background-color:' + color_dark + ' !important; }\n\n';

	dynamicStyles += '.border_bottom_color_dark { border-bottom:1px solid ' + color_dark + ' !important; }\n\n';

	dynamicStyles += '.border_top_color_dark { border-top:1px solid ' + color_dark + ' !important; }\n\n';

	dynamicStyles += '.border_color_dark { border:1px solid ' + color_dark + ' !important; }\n\n';

	dynamicStyles += '.bg_color_medium { background-color:' + color_medium + ' !important; }\n\n';

	dynamicStyles += '.bg_color_light { background-color:' + color_light + ' !important; }\n\n';

	dynamicStyles += '.bg_color_gray_1 { background-color:#4e4d50 !important; }\n\n';

	dynamicStyles += '.bg_color_gray_1 { background-color:#999999 !important; }\n\n';

	dynamicStyles += '.bg_color_gray_3 { background-color:#b3b3b3 !important; }\n\n';

	dynamicStyles += '.bg_color_gray_4 { background-color:#f0f0f0 !important; }\n\n';

	dynamicStyles += '. { background-color:white !important; }\n\n';

	dynamicStyles += '.bg_color_dirty { background-color:#fafafa !important; }\n\n';

	dynamicStyles += '. { background-color:#fffffa !important; }\n\n';

	dynamicStyles += '.selected_bg_color_dark.selected { color:white !important; background-color:' + color_dark + ' !important; }\n\n';

	dynamicStyles += '.open .selected_bg_color_light { color:white !important; background-color:' + color_light + ' !important; }\n\n';

	dynamicStyles += '.selected_bg_color_light.open { color:white !important; background-color:' + color_light + ' !important; }\n\n';

	dynamicStyles += '.selected_font_color_white.selected { color:white !important; }\n\n';

	dynamicStyles += '.selected_font_color_darker.selected { color:' + color_darker + ' !important; }\n\n';

	dynamicStyles += '.selected_font_color_dark.selected { color:' + color_dark + ' !important; }\n\n';

	dynamicStyles += '.selected_font_color_medium.selected { color:' + color_medium + ' !important; }\n\n';

	dynamicStyles += '.selected_font_color_light.selected { color:' + color_light + ' !important; }\n\n';

	dynamicStyles += '.description h1 { color:' + color_dark + ' }\n\n';

	dynamicStyles += '.description h2 { color:' + color_dark + ' }\n\n';

	dynamicStyles += '.description strong { color:' + color_dark + ' }\n\n';

	dynamicStyles += '.description hr { border-top: 0.5pt solid ' + color_light + ' }\n\n';

	dynamicStyles += '.sponsor-banner img { width:100%; }\n\n';

	dynamicStyles += '.icon-pinpoint.selected { color:' + color_pinpoint_selected + ' }\n\n';

	dynamicStyles += '.icon-pinpoint { color:' + color_pinpoint + ' }\n\n';
	dynamicStyles += '.color_bg_card { background-color:' + color_bg_card + ' }\n\n';
	dynamicStyles += '.dashboard_news { border-top:5px solid ' + color_bg_division_1 + ' }\n\n';

	dynamicStyles += '.custom .list_element { border-bottom: 1px solid ' + color_dark + ' !important;margin-top:-1px; }';
	dynamicStyles += '.color_bg_side_division { background-color: ' + color_bg_side_division + ' }';
	dynamicStyles += '.color_font_side_division { color: ' + color_font_side_division + ' }';


	if (this_congress && this_congress.media_information && this_congress.media_information['app-top-side-menu-banner'] && this_congress.media_information['app-top-side-menu-banner']['' + this_congress.congress_information.congress_id]) {
		dynamicStyles += '.side_menu_elements { top:45px }\n\n';
	} else {
		dynamicStyles += '.side_menu_elements { top:0px }\n\n';
	}

	if (this_congress && this_congress.media_information && this_congress.media_information && this_congress.media_information['app-top-logo'] && this_congress.media_information['app-top-logo']['' + this_congress.congress_information.congress_id]) {
		var this_media = this_congress.media_information['app-top-logo']['' + this_congress.congress_information.congress_id];

		var url_img = '';
		if (!this_media.offline) {
			url_img = this_media.imgURL_original;
		} else {
			url_img = fsRoot + '/' + this_media.name;
		}
		$('.congress_logo').css('background-image', 'url(' + url_img + ')');

	}


	// hidden menu
	$('#dynamicStyles').html(dynamicStyles);

	var transitionsAppendHtml = '';

	if ($('.smallscreen').length > 0 && !isIOS) {
		transitionsAppendHtml += '.menu_container { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '.side_menu_container { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '.side_menu_filter_container { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
	}

	if ($('.widescreen').length > 0 || isIOS) {
		transitionsAppendHtml += '.menu_container { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '.side_menu_container { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '.side_menu_filter_container { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '.normal_page { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '.mainDiv { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '.header { -webkit-transition: all 0.2s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '#mapInfoDiv { -webkit-transition: all 0.5s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
		transitionsAppendHtml += '#mapInfoDiv_content { -webkit-transition: all 0.5s linear; -webkit-transform: translate3d(0px,0px,0px); }\n\n';
	}

	$('#dynamicStyles').append(transitionsAppendHtml);
	loadDynamicScript();
}

function loadDynamicScript() {
	var dynamicScript = '';
	if (this_congress && this_congress.congress_information && this_congress.congress_information.onload_dynamic_script) {
		console.log('loadDynamicScript ' + this_congress.congress_information.onload_dynamic_script);
		dynamicScript += this_congress.congress_information.onload_dynamic_script;
	}

	eval(dynamicScript);
	//$('#dynamicScript').html('');
	//$('#dynamicScript').html(dynamicScript);
}

function removeDiacritics(str) {

	var defaultDiacriticsRemovalMap = [
		{ 'base': 'a', 'letters': /[\u0041\u24b6\uff21\u00c0\u00c1\u00c2\u1ea6\u1ea4\u1eaa\u1ea8\u00c3\u0100\u0102\u1eb0\u1eae\u1eb4\u1eb2\u0226\u01e0\u00c4\u01de\u1ea2\u00c5\u01fa\u01cd\u0200\u0202\u1ea0\u1eac\u1eb6\u1e00\u0104\u023a\u2c6f]/g },
		{ 'base': 'aa', 'letters': /[\ua732]/g },
		{ 'base': 'ae', 'letters': /[\u00c6\u01fc\u01e2]/g },
		{ 'base': 'ao', 'letters': /[\ua734]/g },
		{ 'base': 'au', 'letters': /[\ua736]/g },
		{ 'base': 'av', 'letters': /[\ua738\ua73a]/g },
		{ 'base': 'ay', 'letters': /[\ua73c]/g },
		{ 'base': 'b', 'letters': /[\u0042\u24b7\uff22\u1e02\u1e04\u1e06\u0243\u0182\u0181]/g },
		{ 'base': 'c', 'letters': /[\u0043\u24b8\uff23\u0106\u0108\u010a\u010c\u00c7\u1e08\u0187\u023b\ua73e]/g },
		{ 'base': 'd', 'letters': /[\u0044\u24b9\uff24\u1e0a\u010e\u1e0c\u1e10\u1e12\u1e0e\u0110\u018b\u018a\u0189\ua779]/g },
		{ 'base': 'dz', 'letters': /[\u01f1\u01c4]/g },
		{ 'base': 'dz', 'letters': /[\u01f2\u01c5]/g },
		{ 'base': 'e', 'letters': /[\u0045\u24ba\uff25\u00c8\u00c9\u00ca\u1ec0\u1ebe\u1ec4\u1ec2\u1ebc\u0112\u1e14\u1e16\u0114\u0116\u00cb\u1eba\u011a\u0204\u0206\u1eb8\u1ec6\u0228\u1e1c\u0118\u1e18\u1e1a\u0190\u018e]/g },
		{ 'base': 'f', 'letters': /[\u0046\u24bb\uff26\u1e1e\u0191\ua77b]/g },
		{ 'base': 'g', 'letters': /[\u0047\u24bc\uff27\u01f4\u011c\u1e20\u011e\u0120\u01e6\u0122\u01e4\u0193\ua7a0\ua77d\ua77e]/g },
		{ 'base': 'h', 'letters': /[\u0048\u24bd\uff28\u0124\u1e22\u1e26\u021e\u1e24\u1e28\u1e2a\u0126\u2c67\u2c75\ua78d]/g },
		{ 'base': 'i', 'letters': /[\u0049\u24be\uff29\u00cc\u00cd\u00ce\u0128\u012a\u012c\u0130\u00cf\u1e2e\u1ec8\u01cf\u0208\u020a\u1eca\u012e\u1e2c\u0197]/g },
		{ 'base': 'j', 'letters': /[\u004a\u24bf\uff2a\u0134\u0248]/g },
		{ 'base': 'k', 'letters': /[\u004b\u24c0\uff2b\u1e30\u01e8\u1e32\u0136\u1e34\u0198\u2c69\ua740\ua742\ua744\ua7a2]/g },
		{ 'base': 'l', 'letters': /[\u004c\u24c1\uff2c\u013f\u0139\u013d\u1e36\u1e38\u013b\u1e3c\u1e3a\u0141\u023d\u2c62\u2c60\ua748\ua746\ua780]/g },
		{ 'base': 'lj', 'letters': /[\u01c7]/g },
		{ 'base': 'lj', 'letters': /[\u01c8]/g },
		{ 'base': 'm', 'letters': /[\u004d\u24c2\uff2d\u1e3e\u1e40\u1e42\u2c6e\u019c]/g },
		{ 'base': 'n', 'letters': /[\u004e\u24c3\uff2e\u01f8\u0143\u00d1\u1e44\u0147\u1e46\u0145\u1e4a\u1e48\u0220\u019d\ua790\ua7a4]/g },
		{ 'base': 'nj', 'letters': /[\u01ca]/g },
		{ 'base': 'nj', 'letters': /[\u01cb]/g },
		{ 'base': 'o', 'letters': /[\u004f\u24c4\uff2f\u00d2\u00d3\u00d4\u1ed2\u1ed0\u1ed6\u1ed4\u00d5\u1e4c\u022c\u1e4e\u014c\u1e50\u1e52\u014e\u022e\u0230\u00d6\u022a\u1ece\u0150\u01d1\u020c\u020e\u01a0\u1edc\u1eda\u1ee0\u1ede\u1ee2\u1ecc\u1ed8\u01ea\u01ec\u00d8\u01fe\u0186\u019f\ua74a\ua74c]/g },
		{ 'base': 'oi', 'letters': /[\u01a2]/g },
		{ 'base': 'oo', 'letters': /[\ua74e]/g },
		{ 'base': 'ou', 'letters': /[\u0222]/g },
		{ 'base': '', 'letters': /[\u0303\u0302\u0327\u0301\u0300]/g },
		{ 'base': 'p', 'letters': /[\u0050\u24c5\uff30\u1e54\u1e56\u01a4\u2c63\ua750\ua752\ua754]/g },
		{ 'base': 'q', 'letters': /[\u0051\u24c6\uff31\ua756\ua758\u024a]/g },
		{ 'base': 'r', 'letters': /[\u0052\u24c7\uff32\u0154\u1e58\u0158\u0210\u0212\u1e5a\u1e5c\u0156\u1e5e\u024c\u2c64\ua75a\ua7a6\ua782]/g },
		{ 'base': 's', 'letters': /[\u0053\u24c8\uff33\u1e9e\u015a\u1e64\u015c\u1e60\u0160\u1e66\u1e62\u1e68\u0218\u015e\u2c7e\ua7a8\ua784]/g },
		{ 'base': 't', 'letters': /[\u0054\u24c9\uff34\u1e6a\u0164\u1e6c\u021a\u0162\u1e70\u1e6e\u0166\u01ac\u01ae\u023e\ua786]/g },
		{ 'base': 'tz', 'letters': /[\ua728]/g },
		{ 'base': 'u', 'letters': /[\u0055\u24ca\uff35\u00d9\u00da\u00db\u0168\u1e78\u016a\u1e7a\u016c\u00dc\u01db\u01d7\u01d5\u01d9\u1ee6\u016e\u0170\u01d3\u0214\u0216\u01af\u1eea\u1ee8\u1eee\u1eec\u1ef0\u1ee4\u1e72\u0172\u1e76\u1e74\u0244]/g },
		{ 'base': 'v', 'letters': /[\u0056\u24cb\uff36\u1e7c\u1e7e\u01b2\ua75e\u0245]/g },
		{ 'base': 'vy', 'letters': /[\ua760]/g },
		{ 'base': 'w', 'letters': /[\u0057\u24cc\uff37\u1e80\u1e82\u0174\u1e86\u1e84\u1e88\u2c72]/g },
		{ 'base': 'x', 'letters': /[\u0058\u24cd\uff38\u1e8a\u1e8c]/g },
		{ 'base': 'y', 'letters': /[\u0059\u24ce\uff39\u1ef2\u00dd\u0176\u1ef8\u0232\u1e8e\u0178\u1ef6\u1ef4\u01b3\u024e\u1efe]/g },
		{ 'base': 'z', 'letters': /[\u005a\u24cf\uff3a\u0179\u1e90\u017b\u017d\u1e92\u1e94\u01b5\u0224\u2c7f\u2c6b\ua762]/g },
		{ 'base': 'a', 'letters': /[\u0061\u24d0\uff41\u1e9a\u00e0\u00e1\u00e2\u1ea7\u1ea5\u1eab\u1ea9\u00e3\u0101\u0103\u1eb1\u1eaf\u1eb5\u1eb3\u0227\u01e1\u00e4\u01df\u1ea3\u00e5\u01fb\u01ce\u0201\u0203\u1ea1\u1ead\u1eb7\u1e01\u0105\u2c65\u0250]/g },
		{ 'base': 'aa', 'letters': /[\ua733]/g },
		{ 'base': 'ae', 'letters': /[\u00e6\u01fd\u01e3]/g },
		{ 'base': 'ao', 'letters': /[\ua735]/g },
		{ 'base': 'au', 'letters': /[\ua737]/g },
		{ 'base': 'av', 'letters': /[\ua739\ua73b]/g },
		{ 'base': 'ay', 'letters': /[\ua73d]/g },
		{ 'base': 'b', 'letters': /[\u0062\u24d1\uff42\u1e03\u1e05\u1e07\u0180\u0183\u0253]/g },
		{ 'base': 'c', 'letters': /[\u0063\u24d2\uff43\u0107\u0109\u010b\u010d\u00e7\u1e09\u0188\u023c\ua73f\u2184]/g },
		{ 'base': 'd', 'letters': /[\u0064\u24d3\uff44\u1e0b\u010f\u1e0d\u1e11\u1e13\u1e0f\u0111\u018c\u0256\u0257\ua77a]/g },
		{ 'base': 'dz', 'letters': /[\u01f3\u01c6]/g },
		{ 'base': 'e', 'letters': /[\u0065\u24d4\uff45\u00e8\u00e9\u00ea\u1ec1\u1ebf\u1ec5\u1ec3\u1ebd\u0113\u1e15\u1e17\u0115\u0117\u00eb\u1ebb\u011b\u0205\u0207\u1eb9\u1ec7\u0229\u1e1d\u0119\u1e19\u1e1b\u0247\u025b\u01dd]/g },
		{ 'base': 'f', 'letters': /[\u0066\u24d5\uff46\u1e1f\u0192\ua77c]/g },
		{ 'base': 'g', 'letters': /[\u0067\u24d6\uff47\u01f5\u011d\u1e21\u011f\u0121\u01e7\u0123\u01e5\u0260\ua7a1\u1d79\ua77f]/g },
		{ 'base': 'h', 'letters': /[\u0068\u24d7\uff48\u0125\u1e23\u1e27\u021f\u1e25\u1e29\u1e2b\u1e96\u0127\u2c68\u2c76\u0265]/g },
		{ 'base': 'hv', 'letters': /[\u0195]/g },
		{ 'base': 'i', 'letters': /[\u0069\u24d8\uff49\u00ec\u00ed\u00ee\u0129\u012b\u012d\u00ef\u1e2f\u1ec9\u01d0\u0209\u020b\u1ecb\u012f\u1e2d\u0268\u0131]/g },
		{ 'base': 'j', 'letters': /[\u006a\u24d9\uff4a\u0135\u01f0\u0249]/g },
		{ 'base': 'k', 'letters': /[\u006b\u24da\uff4b\u1e31\u01e9\u1e33\u0137\u1e35\u0199\u2c6a\ua741\ua743\ua745\ua7a3]/g },
		{ 'base': 'l', 'letters': /[\u006c\u24db\uff4c\u0140\u013a\u013e\u1e37\u1e39\u013c\u1e3d\u1e3b\u017f\u0142\u019a\u026b\u2c61\ua749\ua781\ua747]/g },
		{ 'base': 'lj', 'letters': /[\u01c9]/g },
		{ 'base': 'm', 'letters': /[\u006d\u24dc\uff4d\u1e3f\u1e41\u1e43\u0271\u026f]/g },
		{ 'base': 'n', 'letters': /[\u006e\u24dd\uff4e\u01f9\u0144\u00f1\u1e45\u0148\u1e47\u0146\u1e4b\u1e49\u019e\u0272\u0149\ua791\ua7a5]/g },
		{ 'base': 'nj', 'letters': /[\u01cc]/g },
		{ 'base': 'o', 'letters': /[\u006f\u24de\uff4f\u00f2\u00f3\u00f4\u1ed3\u1ed1\u1ed7\u1ed5\u00f5\u1e4d\u022d\u1e4f\u014d\u1e51\u1e53\u014f\u022f\u0231\u00f6\u022b\u1ecf\u0151\u01d2\u020d\u020f\u01a1\u1edd\u1edb\u1ee1\u1edf\u1ee3\u1ecd\u1ed9\u01eb\u01ed\u00f8\u01ff\u0254\ua74b\ua74d\u0275]/g },
		{ 'base': 'oi', 'letters': /[\u01a3]/g },
		{ 'base': 'ou', 'letters': /[\u0223]/g },
		{ 'base': 'oo', 'letters': /[\ua74f]/g },
		{ 'base': 'p', 'letters': /[\u0070\u24df\uff50\u1e55\u1e57\u01a5\u1d7d\ua751\ua753\ua755]/g },
		{ 'base': 'q', 'letters': /[\u0071\u24e0\uff51\u024b\ua757\ua759]/g },
		{ 'base': 'r', 'letters': /[\u0072\u24e1\uff52\u0155\u1e59\u0159\u0211\u0213\u1e5b\u1e5d\u0157\u1e5f\u024d\u027d\ua75b\ua7a7\ua783]/g },
		{ 'base': 's', 'letters': /[\u0073\u24e2\uff53\u00df\u015b\u1e65\u015d\u1e61\u0161\u1e67\u1e63\u1e69\u0219\u015f\u023f\ua7a9\ua785\u1e9b]/g },
		{ 'base': 't', 'letters': /[\u0074\u24e3\uff54\u1e6b\u1e97\u0165\u1e6d\u021b\u0163\u1e71\u1e6f\u0167\u01ad\u0288\u2c66\ua787]/g },
		{ 'base': 'tz', 'letters': /[\ua729]/g },
		{ 'base': 'u', 'letters': /[\u0075\u24e4\uff55\u00f9\u00fa\u00fb\u0169\u1e79\u016b\u1e7b\u016d\u00fc\u01dc\u01d8\u01d6\u01da\u1ee7\u016f\u0171\u01d4\u0215\u0217\u01b0\u1eeb\u1ee9\u1eef\u1eed\u1ef1\u1ee5\u1e73\u0173\u1e77\u1e75\u0289]/g },
		{ 'base': 'v', 'letters': /[\u0076\u24e5\uff56\u1e7d\u1e7f\u028b\ua75f\u028c]/g },
		{ 'base': 'vy', 'letters': /[\ua761]/g },
		{ 'base': 'w', 'letters': /[\u0077\u24e6\uff57\u1e81\u1e83\u0175\u1e87\u1e85\u1e98\u1e89\u2c73]/g },
		{ 'base': 'x', 'letters': /[\u0078\u24e7\uff58\u1e8b\u1e8d]/g },
		{ 'base': 'y', 'letters': /[\u0079\u24e8\uff59\u1ef3\u00fd\u0177\u1ef9\u0233\u1e8f\u00ff\u1ef7\u1e99\u1ef5\u01b4\u024f\u1eff]/g },
		{ 'base': 'z', 'letters': /[\u007a\u24e9\uff5a\u017a\u1e91\u017c\u017e\u1e93\u1e95\u01b6\u0225\u0240\u2c6c\ua763]/g }
	];

	for (var i = 0; i < defaultDiacriticsRemovalMap.length; i++) {
		str = str.replace(defaultDiacriticsRemovalMap[i].letters, defaultDiacriticsRemovalMap[i].base);
	}

	return str;

}

function hasOverflowScrolling() {
	var prefixes = ['webkit', 'moz', 'o', 'ms'];
	var div = document.createElement('div');
	var body = document.getElementsByTagName('body')[0];
	var hasIt = false;

	body.appendChild(div);

	for (var i = 0; i < prefixes.length; i++) {
		var prefix = prefixes[i];
		div.style[prefix + 'OverflowScrolling'] = 'touch';
	}

	// And the non-prefixed property
	div.style.overflowScrolling = 'touch';

	// Now check the properties
	var computedStyle = window.getComputedStyle(div);

	// First non-prefixed
	hasIt = !!computedStyle.overflowScrolling;

	// Now prefixed...
	for (var i = 0; i < prefixes.length; i++) {
		var prefix = prefixes[i];
		if (!!computedStyle[prefix + 'OverflowScrolling']) {
			hasIt = true;
			break;
		}
	}

	// Cleanup old div elements
	div.parentNode.removeChild(div);

	return hasIt;
}


function loadOrientationIndex(fromHistory) {

	var orientationIndexHtml = '';

	var isCurrent = ($('#information_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	orientationIndexHtml += '<div class="normal_page ' + initialPosition + ' scroll" id="orientation_index">';

	orientationIndexHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">Orientação</div>';
	orientationIndexHtml += '<div class="division_gray_double_line"></div>';

	var first = true;

	$.each(this_congress.maps_information, function(index, this_map) {
		orientationIndexHtml += '<div class="map_element gradient_background_gray">';
		if (first) {
			first = false;
		} else {}

		if (this_map.resource_id) {
			var this_resource = this_congress.resources_information[this_map.resource_id];
			orientationIndexHtml += '<div class="resource_button"><span class="resource_name">' + this_map.name + '</span> <span class="resource_format">' + this_resource.format + '</span><div class="download_button" id="download_button_map_' + this_resource.resource_id + '" onclick="window.open(' + this_resource.image + ',\'_blank\',\'location=no\');"></div></div>';
		}

		orientationIndexHtml += '<div class="division_bottom color_bg_division_1"></div>';


		orientationIndexHtml += '<div class="map_image_wrapper" onclick="doZoomOnImage(\'' + this_map.image + '\')"><div class="map_image scroll" id="map_image_' + this_map.id + '"><img src="img/' + this_map.image + '" /></div><div id="zoom_map_' + this_map.id + '" class="zoom_map_button"></div></div>';

		orientationIndexHtml += '</div>'
		orientationIndexHtml += '<div class="division_gray_double_line"></div>';
	});

	orientationIndexHtml += '</div>';

	$('#orientation_index').remove();
	$('.mainDiv').append(orientationIndexHtml);



	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('orientation_index');", 1);
		} else {
			setTimeout("bringforward('orientation_index');", 1);
		}
	} else {
		onPageChanged();
	}

}

function toggleZoom(mapId) {
	if ($('#map_image_' + mapId).hasClass('zoomed')) {
		$('#map_image_' + mapId).removeClass('zoomed')
	} else {
		$('#map_image_' + mapId).addClass('zoomed')
	}
}

function loadInformationIndex(fromHistory) {

	var informationIndexHtml = '';

	var isCurrent = ($('#information_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	informationIndexHtml += '<div class="normal_page ' + initialPosition + '" id="information_index">';

	informationIndexHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">Contactos</div>';

	var first = true;

	$.each(this_congress.entity_information, function(index, this_entity) {

		if (first) {
			first = false;
		} else {
			informationIndexHtml += '<div class="division_bottom color_bg_division_1"></div>';
		}
		informationIndexHtml += '<div class="entity_information">';
		informationIndexHtml += '<div class="entity_image"><img src="img/' + this_entity.image + '" /></div>';
		informationIndexHtml += '<div class="entity_phone"><span class="color_bold">T: </span>' + this_entity.contact_phone + ' | <span class="color_bold">F: </span>' + this_entity.contact_fax + '</div>';
		informationIndexHtml += '<div class="entity_email">' + this_entity.contact_email + '</div>';
		informationIndexHtml += '<div class="entity_website">' + this_entity.website + '</div>';
		informationIndexHtml += '<div class="entity_address"><span class="color_bold">' + this_entity.name + '</span><br>' + this_entity.address + '<br>' + this_entity.address2 + '<br><span class="color_bold">GPS: </span>' + this_entity.gps_coordinates + '</div>';
		informationIndexHtml += '</div>';


	});

	informationIndexHtml += '</div>';
	$('#information_index').remove();
	$('.mainDiv').append(informationIndexHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('information_index');", 1);
		} else {
			setTimeout("bringforward('information_index');", 1);
		}
	} else {
		onPageChanged();
	}

}

function saveUserDataToStorage() {
	if (this_congress && user_data.profile) {
		if (!user_data.event_profiles) {
			user_data.event_profiles = {};
		}
		user_data.event_profiles[this_congress.congress_information.congress_id] = user_data.profile;
	}

	localStorage.setItem('user_data', JSON.stringify(user_data));
}

function loadUserDataFromStorage() {

	var loadFromLocalStorage = true;

	if (localStorage.getItem('user_data') && loadFromLocalStorage) {
		user_data = JSON.parse(localStorage.getItem('user_data'));

		if (!user_data.profile.rating) {
			user_data.profile.rating = {};
		}
		if (!user_data.profile.rating.sessions) {
			user_data.profile.rating.sessions = {};
		}
		if (!user_data.profile.rating.posters) {
			user_data.profile.rating.posters = {};
		}
		if (!user_data.profile.rating.speakers) {
			user_data.profile.rating.speakers = {};
		}
		if (!user_data.profile.rating.exhibitors) {
			user_data.profile.rating.exhibitors = {};
		}
		if (!user_data.profile.feedback) {
			user_data.profile.feedback = {};
		}
		if (!user_data.event_profiles) {
			user_data.event_profiles = {};
		}
		if (!user_data.profile.notes) {
			user_data.profile.notes = {};
		}

		if (!user_data.profile.notes.session) {
			user_data.profile.notes.session = {};
		}

		if (!user_data.profile.notes.poster) {
			user_data.profile.notes.posters = {};
		}

		if (!user_data.profile.notes.speaker) {
			user_data.profile.notes.speakers = {};
		}

		if (!user_data.profile.notes.exhibitor) {
			user_data.profile.notes.exhibitors = {};
		}

		if (!user_data.profile.notes.user) {
			user_data.profile.notes.users = {};
		}


		user_data.app_version = app_version;

	} else {
		initUserData();
	}

	saveUserDataToStorage();

}

function loadMyAgendaFromStorage() {
	/*var loadMyAgendaFromStorage = false;
  if (localStorage.getItem('my_agenda') != null && localStorage.getItem('my_agenda') != "null" && loadMyAgendaFromStorage){

    user_data.profile.agenda = JSON.parse(localStorage.getItem('my_agenda'));
    if (!user_data.profile.agenda["exhibitors"]){
      user_data.profile.agenda["exhibitors"] = [];
    }
    if (!user_data.profile.agenda["sessions"]){
      user_data.profile.agenda["sessions"] = [];
    }

    if (!user_data.profile.agenda["posters"]){
      user_data.profile.agenda["posters"] = [];
    }
  }

  if (localStorage.getItem('user_agendas') != null && localStorage.getItem('user_agendas') != "null"){

    user_agendas = JSON.parse(localStorage.getItem('user_agendas'));

    if (user_agendas[''+this_congress.congress_information.congress_id]){
      my_agenda = user_agendas[''+this_congress.congress_information.congress_id];
    }
    else{
      my_agenda = {};
    }
    if (!my_agenda["exhibitors"]){
      my_agenda["exhibitors"] = [];
    }
    if (!my_agenda["sessions"]){
      my_agenda["sessions"] = [];
    }
    if (!my_agenda["posters"]){
      my_agenda["posters"] = [];
    }
  }
*/
}

function getTimeForSession(session_id) {
	var this_session = this_congress.sessions_information['' + session_id];
	var this_day = this_congress.day_information['' + this_session.session_day_id];

	var dateString = this_day.day_time + 'T' + this_session.session_start_time + ':00';

	var sessiondate = new Date(dateString);

	sessiondate.setTime(sessiondate.getTime() + sessiondate.getTimezoneOffset() * 60 * 1000);

	return sessiondate.getTime();
}

function getEndTimeForSession(session_id) {
	var this_session = this_congress.sessions_information['' + session_id];
	var this_day = this_congress.day_information['' + this_session.session_day_id];

	var dateString = this_day.day_time + 'T' + this_session.session_end_time + ':00';

	var sessiondate = new Date(dateString);

	return sessiondate.getTime();
}

function nextSessions() {

	var nextSessions = [];

	$.each(this_congress.congress_information.congress_days, function(index_day, this_day_id) {
		var this_day = this_congress.day_information['' + this_day_id];

		$.each(this_day.sessions, function(index, this_session_id) {
			var this_session = this_congress.sessions_information['' + this_session_id];
			var session_start_millis = getTimeForSession(this_session_id);
			var session_end_millis = getEndTimeForSession(this_session_id);
			var now = new Date();
			var now_millis = now.getTime();
			var difference = session_start_millis - now_millis;
			if ((difference > 0 && difference < app_config_next_session_interval * 60 * 1000) || app_config_next_session_interval == 0) {
				nextSessions.push(this_session_id);
			}

			if (session_end_millis > now_millis && now_millis > session_start_millis) {
				nextSessions.push(this_session_id);
			}

		});
	});
	return nextSessions;
}

function previousSessions() {
	var previousSessions = [];
	$.each(this_congress.congress_information.congress_days, function(index_day, this_day_id) {
		var this_day = this_congress.day_information['' + this_day_id];
		$.each(this_day.sessions, function(index, this_session_id) {
			var this_session = this_congress.sessions_information['' + this_session_id];
			var session_start_millis = getTimeForSession(this_session_id);
			var session_end_millis = getEndTimeForSession(this_session_id);
			var now = new Date();
			var now_millis = now.getTime();
			var difference = session_start_millis - now_millis;
			if ((difference < 0 && (difference * -1) > app_config_next_session_interval * 60 * 1000) || app_config_next_session_interval == 0) {
				previousSessions.push(this_session_id);
			}
		});
	});
	return previousSessions;
}

function pollingSessions() {

	var polling_sessions = [];

	$.each(this_congress.congress_information.congress_days, function(index_day, this_day_id) {
		var this_day = this_congress.day_information['' + this_day_id];

		$.each(this_day.sessions, function(index, this_session_id) {
			var this_session = this_congress.sessions_information['' + this_session_id];
			if (this_session.has_polling && this_session.has_polling == "1") {
				polling_sessions.push(this_session.session_id);
			}
		});
	});

	return polling_sessions;
}

function moderationSessions() {

	var moderation_sessions = [];

	$.each(this_congress.congress_information.congress_days, function(index_day, this_day_id) {
		var this_day = this_congress.day_information['' + this_day_id];

		$.each(this_day.sessions, function(index, this_session_id) {
			var this_session = this_congress.sessions_information['' + this_session_id];
			if (this_session.has_moderation && (this_session.has_moderation == "1" || this_session.has_moderation == "2")) {
				moderation_sessions.push(this_session.session_id);
			}
		});
	});

	return moderation_sessions;
}

function loadMyAgendaIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	var isCurrent = ($('#myagendaindex.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var myAgendaIndexHtml = '';
	myAgendaIndexHtml += '<div class="normal_page  ' + initialPosition + '" id="myagendaindex">';

	myAgendaIndexHtml += '<div class="list_page_header ">';
	myAgendaIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('header-my-agenda-index') + '</div></div>';
	if (this_congress.congress_information.has_calendar && this_congress.congress_information.has_calendar == '1' && !isMobile) {
		myAgendaIndexHtml += '<div class="refresh_button cg-icon cg-icon-refresh cg-icon-size-14 color_icon_second_menu selected_font_color_white" onclick="syncMyAgendaWithCalendar();"></div>';
	}

	myAgendaIndexHtml += '</div>';


	myAgendaIndexHtml += '<div class="list_page scroll">';
	myAgendaIndexHtml += '<div class="scroll_lock">';

	if (areaExists('program') && this_congress.congress_information.has_myagenda == '1') {
		myAgendaIndexHtml += '<div class="list_element font_color_dark border_bottom_color_dark" onclick="loadMyAgenda(MY_AGENDA_FILTER_SESSIONS);">';
		myAgendaIndexHtml += '<span class="cg-icon cg-icon-program"></span><span class="">' + trd('my-sessions') + '</span>';
		myAgendaIndexHtml += '<div class="gotodetail_button"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_gray_1"></span></div>';
		myAgendaIndexHtml += '</div>';
	}
	if (areaExists('posters')) {
		myAgendaIndexHtml += '<div class="list_element font_color_dark border_bottom_color_dark" onclick="loadMyAgenda(MY_AGENDA_FILTER_POSTERS);">';
		myAgendaIndexHtml += '<span class="cg-icon cg-icon-posters"></span><span class="">' + getNameForAreaType('posters') + '</span>';
		myAgendaIndexHtml += '<div class="gotodetail_button"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_gray_1"></span></div>';
		myAgendaIndexHtml += '</div>';
	}
	if (areaExists('exhibitors')) {
		myAgendaIndexHtml += '<div class="list_element font_color_dark border_bottom_color_dark" onclick="loadMyAgenda(MY_AGENDA_FILTER_EXHIBITORS);">';
		myAgendaIndexHtml += '<span class="cg-icon cg-icon-exhibitors"></span><span class="">' + getNameForAreaType('exhibitors') + '</span>';
		myAgendaIndexHtml += '<div class="gotodetail_button"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_gray_1"></span></div>';
		myAgendaIndexHtml += '</div>';
	}
	if (this_congress.congress_information.has_session_notes && this_congress.congress_information.has_session_notes == "1") {
		myAgendaIndexHtml += '<div class="list_element font_color_dark border_bottom_color_dark" onclick="loadMyAgenda(MY_AGENDA_FILTER_NOTES);">';
		myAgendaIndexHtml += '<span class="cg-icon cg-icon-notes"></span><span class="">' + trd('my-notes') + '</span>';
		myAgendaIndexHtml += '<div class="gotodetail_button"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_gray_1"></span></div>';
		myAgendaIndexHtml += '</div>';
	}
	if (this_congress.congress_information.has_networking && this_congress.congress_information.has_networking == "1") {
		myAgendaIndexHtml += '<div class="list_element font_color_dark border_bottom_color_dark" onclick="loadMyAgenda(MY_AGENDA_FILTER_PROFILES,false);">';
		myAgendaIndexHtml += '<span class="cg-icon cg-icon-user"></span><span class="">' + trd('my-profiles') + '</span>';
		myAgendaIndexHtml += '<div class="gotodetail_button"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_gray_1"></span></div>';
		myAgendaIndexHtml += '</div>';
	}

	if (this_congress.congress_information.has_meetings && this_congress.congress_information.has_meetings == "1") {
		myAgendaIndexHtml += '<div class="list_element font_color_dark border_bottom_color_dark" onclick="loadMyAgenda(MY_AGENDA_FILTER_MEETINGS,false);">';
		myAgendaIndexHtml += '<span class="cg-icon cg-icon-user"></span><span class="">' + trd('my-meetings') + '</span>';
		myAgendaIndexHtml += '<div class="gotodetail_button"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_gray_1"></span></div>';
		myAgendaIndexHtml += '</div>';
	}

	myAgendaIndexHtml += '</div>';
	myAgendaIndexHtml += '</div>';
	myAgendaIndexHtml += '</div>';

	$('#myagendaindex').remove();

	$('.mainDiv').append(myAgendaIndexHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('myagendaindex');", 1);
		} else {
			setTimeout("bringforward('myagendaindex');", 1);
		}

	} else {
		onPageChanged();
	}
}

function loadMyAgenda(agenda_filter, fromHistory) {

	if (agenda_filter == MY_AGENDA_NO_FILTER) {
		agenda_filter = MY_AGENDA_FILTER_SESSIONS;
	}

	setSelectedMenuArea('myagenda');

	var isCurrent = ($('#myagenda.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var myAgendaHtml = '';
	myAgendaHtml += '<div id="myagenda" class="normal_page ' + initialPosition + '">';

	myAgendaHtml += '<div class="list_page_header ">';

	myAgendaHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('header-my-agenda') + '</div></div>';
	//myAgendaHtml += '<div class="edit_button cg-icon cg-icon-refresh cg-icon-size-14 color_icon_second_menu selected_font_color_white" onclick="getUserProfile(\'refresh\');"></div><div  onclick="getUserProfile(\'refresh\');" class="filter_label right color_icon_second_menu">'+trd('label-refresh')+'</div>';
	if (user_data.profile && user_data.profile.anonymous != "1") {
		//myAgendaHtml += '<div class="logout_button cg-icon cg-icon-logout cg-icon-size-14 color_icon_second_menu selected_font_color_white" onclick="do_logout();"></div><div  onclick="do_logout();" class="filter_label left color_icon_second_menu">'+trd('label-logout')+'</div>';
	}


	/*myAgendaHtml += '<table cellpadding="0" cellspacing="0" class="filter_table_my_agenda"><tr>';


	if (areaExists('program') && this_congress.congress_information.has_myagenda == '1'){
	  if (agenda_filter == MY_AGENDA_FILTER_SESSIONS){
	    myAgendaHtml += '<td width="50%"><span class="font_semi_bold filter_button_my_agenda selected font_color_gray_1"><span class="cg-icon-character cg-icon-size-16 cg-icon-program color_icon_clickable "></span>&nbsp;&nbsp;&nbsp;'+trd('filter-sessions')+'</span></td>';
	  }
	  else{
	    myAgendaHtml += '<td><span class="font_bold filter_button_my_agenda" onclick="loadMyAgenda(MY_AGENDA_FILTER_SESSIONS,false);hideBothMenus();"><span class="cg-icon-character cg-icon-size-16 cg-icon-program font_color_dark"></span></span></td>';
	  }
	}

	if (areaExists('exhibitors')){
	  if (agenda_filter == MY_AGENDA_FILTER_EXHIBITORS){
	    myAgendaHtml += '<td width="50%"><span class="font_semi_bold filter_button_my_agenda selected font_color_gray_1"><span class="cg-icon-character cg-icon-exhibitors cg-icon-size-16 color_icon_clickable"></span>&nbsp;&nbsp;&nbsp;'+trd('filter-exhibitors')+'</span></td>';
	  }
	  else{
	    myAgendaHtml += '<td><span class="font_bold filter_button_my_agenda" onclick="loadMyAgenda(MY_AGENDA_FILTER_EXHIBITORS,false);hideBothMenus();"><span class="cg-icon-character cg-icon-exhibitors cg-icon-size-16 font_color_dark"></span></span></td>';
	  }
	}

	if (areaExists('posters')){
	  if (agenda_filter == MY_AGENDA_FILTER_POSTERS){
	    myAgendaHtml += '<td width="50%"><span class="font_semi_bold filter_button_my_agenda selected font_color_gray_1"><span class="cg-icon-character cg-icon-size-16 cg-icon-posters color_icon_clickable"></span>&nbsp;&nbsp;&nbsp;'+trd('filter-posters')+'</span></td>';
	  }
	  else{
	    myAgendaHtml += '<td><span class="font_bold filter_button_my_agenda" onclick="loadMyAgenda(MY_AGENDA_FILTER_POSTERS,false);hideBothMenus();"><span class="cg-icon-character cg-icon-posters cg-icon-size-16 font_color_dark"></span></span></td>';
	  }
	}

	if (this_congress.congress_information.has_session_notes && this_congress.congress_information.has_session_notes=="1"){
	  if (agenda_filter == MY_AGENDA_FILTER_NOTES){
	    myAgendaHtml += '<td width="50%"><span class="font_semi_bold filter_button_my_agenda selected font_color_gray_1"><span class="cg-icon-character cg-icon-size-16 cg-icon-notes color_icon_clickable"></span>&nbsp;&nbsp;&nbsp;'+trd('filter-notes')+'</span></td>';
	  }
	  else{
	    myAgendaHtml += '<td><span class="font_bold filter_button_my_agenda" onclick="loadMyAgenda(MY_AGENDA_FILTER_NOTES,false);hideBothMenus();"><span class="cg-icon-character cg-icon-notes cg-icon-size-16 font_color_dark"></span></span></td>';
	  }
	}

	if (this_congress.congress_information.has_networking && this_congress.congress_information.has_networking=="1"){
	  if (agenda_filter == MY_AGENDA_FILTER_PROFILES){
	    myAgendaHtml += '<td width="50%"><span class="font_semi_bold filter_button_my_agenda selected font_color_gray_1"><span class="cg-icon-character cg-icon-size-16 cg-icon-user color_icon_clickable"></span>&nbsp;&nbsp;&nbsp;'+trd('filter-profiles')+'</span></td>';
	  }
	  else{
	    myAgendaHtml += '<td><span class="font_bold filter_button_my_agenda" onclick="loadMyAgenda(MY_AGENDA_FILTER_PROFILES,false);hideBothMenus();"><span class="cg-icon-character cg-icon-user cg-icon-size-16 font_color_dark"></span></span></td>';
	  }
	}

	if (this_congress.congress_information.has_meetings && this_congress.congress_information.has_meetings=="1"){
	  if (agenda_filter == MY_AGENDA_FILTER_MEETINGS){
	    myAgendaHtml += '<td width="50%"><span class="font_semi_bold filter_button_my_agenda selected font_color_gray_1"><span class="cg-icon-character cg-icon-size-16 cg-icon-user color_icon_clickable"></span>&nbsp;&nbsp;&nbsp;'+trd('filter-meetings')+'</span></td>';
	  }
	  else{
	    myAgendaHtml += '<td><span class="font_bold filter_button_my_agenda" onclick="loadMyAgenda(MY_AGENDA_FILTER_MEETINGS,false);hideBothMenus();"><span class="cg-icon-character cg-icon-user cg-icon-size-16 font_color_dark"></span></span></td>';
	  }
	}

	myAgendaHtml += '</tr></table>';*/
	myAgendaHtml += '</div>';



	myAgendaHtml += '<div class="list_page scroll">';

	myAgendaHtml += '<div class="scroll_lock">';



	if (agenda_filter == MY_AGENDA_FILTER_SESSIONS || agenda_filter == MY_AGENDA_NO_FILTER) {
		var total_sessions = 0;
		$.each(this_congress.congress_information.congress_days, function(index_day, this_day_id) {
			var this_day = this_congress.day_information['' + this_day_id];

			if (this_congress.congress_information.separate_by_day && this_congress.congress_information.separate_by_day == "1") {
				myAgendaHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_day.day_name + '</div>';
			}


			var day_sessions = 0;

			$.each(this_day.sessions, function(index, this_session_id) {

				if (array_contains(user_data.profile.agenda["sessions"], this_session_id)) {
					day_sessions++;
					total_sessions++;
					myAgendaHtml += getHtmlForSessionInfo(this_session_id);
				}
			});

			if (this_congress.congress_information.separate_by_day && this_congress.congress_information.separate_by_day == "1") {
				if (day_sessions == 0) {
					myAgendaHtml += '<div class="no_sessions kinda_description font_color_gray_1">' + trd('no-sessions-added-for-day') + '</div>';
				}
			}

		});
		if (total_sessions == 0) {
			if (!this_congress.congress_information.separate_by_day || this_congress.congress_information.separate_by_day == "0") {
				myAgendaHtml += '<div class="no_sessions kinda_description font_color_gray_1">' + trd('no-sessions-added-to-agenda') + '</div>';
			}
		}

	}

	if (agenda_filter == MY_AGENDA_NO_FILTER || agenda_filter == MY_AGENDA_FILTER_EXHIBITORS) {
		if (user_data.profile.agenda["exhibitors"].length == 0) {
			myAgendaHtml += '<div class="info_div font_color_gray_1">' + trd('myagenda-no-exhibitors') + '</div>';
		}

		$.each(this_congress.congress_information.congress_exhibitors, function(index_exhibitor, this_exhibitor_id) {
			if (array_contains(user_data.profile.agenda["exhibitors"], this_exhibitor_id)) {
				myAgendaHtml += getHtmlForExhibitorInfo(this_exhibitor_id);
			}
		});
	}

	if (agenda_filter == MY_AGENDA_NO_FILTER || agenda_filter == MY_AGENDA_FILTER_POSTERS) {

		if (user_data.profile.agenda["posters"].length == 0) {
			myAgendaHtml += '<div class="info_div font_color_gray_1">' + trd('myagenda-no-posters') + '</div>';
		}

		$.each(this_congress.congress_information.congress_posters, function(index_poster, this_poster_id) {
			if (array_contains(user_data.profile.agenda["posters"], this_poster_id)) {
				myAgendaHtml += getHtmlForPosterInfo(this_poster_id);
			}
		});
	}

	if (agenda_filter == MY_AGENDA_NO_FILTER || agenda_filter == MY_AGENDA_FILTER_NOTES) {
		if ($.isEmptyObject(user_data.profile.notes.session)) {
			myAgendaHtml += '<div class="info_div font_color_gray_1">' + trd('myagenda-no-notes') + '</div>';
		} else {
			var needs_with_bottom_input_class = 'with_bottom_input_double';
			var note_email = '';
			if (user_data.profile.user_email) { note_email = user_data.profile.user_email; }
			$.each(user_data.profile.notes.session, function(session_id, this_note) {
				var this_session = this_congress.sessions_information['' + session_id];
				if (!this_session) {
					return true;
				}
				myAgendaHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_session.session_title + '</div>';
				myAgendaHtml += '<div class="font_color_gray_1 list_element border_bottom_color_dark" style="padding-left:20px;padding-right:30px" onclick="showNoteModal(\'session\',' + session_id + ');">';
				myAgendaHtml += '<div class="font_color_gray_1" style="font-size:10px">' + shortNoteText(this_note) + '</div>';
				//myAgendaHtml += '<div class="font_color_gray_1" style="font-size:10px">'+this_session.session_title+'</div>';
				myAgendaHtml += '<div class="gotodetail_button"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_gray_1"></span></div>';
				myAgendaHtml += '</div>';
			});
			myAgendaHtml += '</div></div><div class="bottom_input" style="height:120px;overflow:hidden;background-color:white;z-index:990">';
			myAgendaHtml += '<div class="font_color_dark" style="font-size:12px;padding: 5px 12px 5px 12px;">' + trd('notes-label-explain') + '</div><div class="block_text_holder" style="height:45px"><input type="text" id="notes_email" placeholder="' + trd('register-user-email-ph') + '" class="block_text_visible font_color_gray_1" value="' + note_email + '" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white"></div><div class="block_button color_bg_division_2" onclick="sendNotes();" style="font-size:14px">' + trd('bt-send') + '</div></div>';
		}
	}
	if (agenda_filter == MY_AGENDA_NO_FILTER || agenda_filter == MY_AGENDA_FILTER_PROFILES) {
		if (!this_congress.congress_information.congress_profiles) {
			refreshUserProfiles('loadMyAgenda(' + agenda_filter + ',' + fromHistory + ')');
			return;
		}

		if (user_data.profile.agenda["profiles"].length == 0) {
			myAgendaHtml += '<div class="info_div font_color_gray_1">' + trd('myagenda-no-profiles') + '</div>';
		}

		$.each(this_congress.congress_information.congress_profiles, function(index_profile, this_profile_id) {
			if (array_contains(user_data.profile.agenda["profiles"], this_profile_id)) {
				var this_profile = '';
				var this_profile_pic = 'img/defaults/img_user.png';
				if (this_profile.user_pic) {
					if (breaking_changes.user_pic_file) {
						this_profile_pic = user_pic_home + this_profile.user_pic;
					} else {
						this_profile_pic = 'data:image/jpeg;base64,' + this_profile.user_pic;
					}
				}

				myAgendaHtml += getHtmlForProfileInfo(this_profile_id);
			}
		});
	}

	if (agenda_filter == MY_AGENDA_NO_FILTER || agenda_filter == MY_AGENDA_FILTER_MEETINGS) {
		var needs_with_bottom_input_class = 'with_bottom_button';
		myAgendaHtml += '<div id="myAgenda_meeting_list"></div>';
		myAgendaHtml += '</div></div>'
		myAgendaHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom" onclick="showEditMeetingModal()">' + trd('button-meeting-new') + '</div>';

		meetings.getMyAgendaList();
	}



	if (!needs_with_bottom_input_class) {
		myAgendaHtml += '</div>';
		myAgendaHtml += '</div>';
	}
	myAgendaHtml += '</div>';

	$('#myagenda').remove();
	$('.mainDiv').append(myAgendaHtml);

	if (needs_with_bottom_input_class) { $('.list_page_lower').addClass(needs_with_bottom_input_class); }

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('myagenda');", 1);
		} else {
			setTimeout("bringforward('myagenda');", 1);
		}

	} else {
		onPageChanged();
	}
}

function sendNotes() {
	var notes_email = $('#notes_email').val();
	notes_email = $.trim(notes_email);
	if (!validateEmail(notes_email)) {
		showToastrAlert('error', trd('register-validation-invalid-user-email'));
		return;
	} else {
		var url = services_home + '/tools/sendMail/notes.php';
		var request = { email: notes_email, user_id: user_data.profile.user_id }
		var after_success = "showToastrAlert('success', trd('notes-email-sent')); loadDashboard();";
		postRequest(url, request, after_success);
		return;
	}
}

function shortNoteText(noteText) {
	if (noteText.length > 100) {
		noteText = noteText.substr(0, 100) + '...';
	}
	return nl2br(noteText);
}

function nl2br(str, is_xhtml) {
	var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
	return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2');
}

function getHtmlForProfileInfo(this_profile_id) {
	var this_profile = this_congress.profiles_information['' + this_profile_id];

	var thisProfileHtml = '';
	var this_profile_pic = 'img/defaults/img_user.png';
	if (this_profile.user_pic) {
		if (breaking_changes.user_pic_file) {
			this_profile_pic = user_pic_home + this_profile.user_pic;
		} else {
			this_profile_pic = 'data:image/jpeg;base64,' + this_profile.user_pic
		}
	}
	thisProfileHtml += '<div class="speaker_button border_bottom_color_dark" id="participant_button_' + this_profile.user_id + '" onclick="loadProfileDetail(' + this_profile.user_id + ');">';
	thisProfileHtml += '<table><tr><td><div class="small_pic"><img src="' + this_profile_pic + '" /></td>';
	thisProfileHtml += '<td><div class="speaker_name font_bold font_color_dark">' + this_profile.user_name + '</div>';
	thisProfileHtml += '<div class="speaker_short_description">' + (this_profile.user_subtitle ? this_profile.user_subtitle : (trd('user-subtitle-undefined'))) + '</div></td></tr></table>';
	thisProfileHtml += '<div class="gotodetail_button" id="gotodetail_button_speaker_' + this_profile.user_id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
	thisProfileHtml += '</div>';

	return thisProfileHtml;
}

function saveUserProfile(quiet) {
	if (!this_congress) {
		return;
	}
	showLoadingOverlay();

	var url = services_home + 'services.php';

	user_data.profile.lang = this_congress.congress_information.congress_lang;
	if ($('#edit_user_subtitle').val()) {
		user_data.profile.user_subtitle = $('#edit_user_subtitle').val();
	}
	if ($('#edit_user_bio').val()) {
		user_data.profile.user_bio = $('#edit_user_bio').val();
	}
	if ($('#edit_user_phone').val()) {
		user_data.profile.user_phone = $('#edit_user_phone').val();
	}
	if ($('#edit_user_website').val()) {
		user_data.profile.user_website = $('#edit_user_website').val();
	}
	if ($('#user_pic_src').val()) {
		user_data.profile.user_pic = $('#user_pic_src').val();

	}


	if (this_congress.congress_information.congress_user_fields && this_congress.congress_information.congress_user_fields.length > 0) {

		if (!user_data.profile.user_fields) {
			user_data.profile.user_fields = {};
		}
		$.each(this_congress.congress_information.congress_user_fields, function(index, this_user_field_id) {
			var this_user_field = this_congress.user_fields_information['' + this_user_field_id];
			if (this_user_field.readonly == "0") {
				if ($('#user_field_' + this_user_field_id) && $('#user_field_' + this_user_field_id).val()) {
					user_data.profile.user_fields['' + this_user_field_id] = $('#user_field_' + this_user_field_id).val();
				}
			}
		});

	}
	var params = {
		f: 'saveUserProfile',
		user_data: user_data,
		event_info: {
			id: this_congress.congress_information.congress_id,
			lang: this_congress.congress_information.congress_lang
		}
	};
	if (breaking_changes.user_pic_file) { params.user_pic_file = true; }
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: { params: params },
		dataType: 'json',
		success: function profileSaved(response) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(response));
			if (response.success) {

				if (response.object) {
					if (response.object.user_pic) {
						if (breaking_changes.user_pic_file) {
							user_data.profile.user_pic = response.object.user_pic_file;
							console.log('saved ' + user_data.profile.user_pic);
						} else {
							user_data.profile.user_pic = response.object.user_pic;
						}
					}
				}

				saveUserDataToStorage();
				if (!quiet) {
					showToastrAlert('success', trd('success-profile-data-saved'));
				}

				loadMyProfile(true);
			} else {
				showToastrAlert('error', trd('error-could-not-save-profile'));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(xhr));
		}
	});
}

function postRequest(url, object, function_call) {
	showLoadingOverlay();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: object,
		dataType: 'json',
		success: function(response) {
			hideLoadingOverlay();
			console.log('got response:' + JSON.stringify(response));
			if (response.success) {
				eval(function_call);
			} else {
				showToastrAlert('error', trd(response.message));
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got error: ' + JSON.stringify(xhr));
		}
	});
}


var meetings = {
	url: services_home + 'services.php',
	list: [],
	getLocationTitle: function(l_id) {
		return this_congress.locations_information['' + l_id].location_name;
	},
	getMyAgendaList: function() {
		var object = { params: { f: 'getMeetings', congress_id: this_congress.congress_information.congress_id, user_id: user_data.profile.user_id } };
		postRequest(this.url, object, "meetings.list=response.object.meetings;generateMeetingListHtml();");
	},
	getParticipantList: function(user_id) {
		var object = { params: { f: 'getMeetings', congress_id: this_congress.congress_information.congress_id, user_id: user_data.profile.user_id } };
		postRequest(this.url, object, "meetings.list=response.object.meetings;loadMeetWithParticipantList(false," + user_id + ");");
	},
	refreshDetail: function(meeting_id) {
		var object = { params: { f: 'getMeetings', congress_id: this_congress.congress_information.congress_id, user_id: user_data.profile.user_id } };
		postRequest(this.url, object, "meetings.list=response.object.meetings;loadMeetingDetail(" + meeting_id + ",false);");
	},
	addMeeting: function(title, start_time, end_time, location) {

		this.list.push({ 'id': 1, 'title': title, 'start_time': start_time, 'end_time': end_time, 'location': location });
	},
	getMeetingById: function(id) {
		return this.list.filter(function(m) {
			return id == m.id;
		})[0];
	},
	getList: function() {
		return this.list;
	},
	isInMeeting: function(user_id, meeting_id) {
		var this_meeting = this.getMeetingById(meeting_id);
		return this_meeting.participants.filter(function(p) {
			return p.user_id == user_id
		}).length > 0;
	},
	getParticipantStatus: function(user_id, meeting_id) {
		var this_meeting = this.getMeetingById(meeting_id);
		return this_meeting.participants.filter(function(p) {
			return p.user_id == user_id
		})[0].status;
	},
	addParticipantFromList: function(meeting_id, user_id) {
		var object = { params: { f: 'addParticipant', meeting_id: meeting_id, user_id: user_id } };
		postRequest(this.url, object, "goBack();meetings.refreshDetail(" + meeting_id + ");");
		this.sendMeetingNotification(meeting_id, user_id, 'meetinginvite_' + meeting_id, trd('meeting-notification-invited') + ' ' + user_data.profile.user_name);
	},
	addParticipant: function(meeting_id, user_id) {
		var object = { params: { f: 'addParticipant', meeting_id: meeting_id, user_id: user_id } };
		postRequest(this.url, object, "goBack();showToastrAlert('success',trd('meeting-invitation-sent'));");
		this.sendMeetingNotification(meeting_id, user_id, 'meetinginvite_' + meeting_id, trd('meeting-notification-invited') + ' ' + user_data.profile.user_name);
	},
	updateParticipantStatus: function(meeting_id, user_id, status) {
		this_meeting = this.getMeetingById(meeting_id);
		if (status == 'declined')
			cancel_local_notification('meetingreminder', meeting_id);
		if (status == 'attending') {
			var now = new Date();
			if (stringToDate(this_meeting.start_time).getTime() < now.getTime()) {
				schedule_local_notification('meetingreminder', meeting_id, trd('meeting-reminder-title'), trd('meeting-reminder-message') + ': ' + this_meeting.title, this_meeting.start_time, 10);
			} else {
				showToastrAlert('error', trd('error-meeting-past'));
			}
		}


		var object = { params: { f: 'updateParticipantStatus', meeting_id: meeting_id, user_id: user_id, status: status } };
		postRequest(this.url, object, "goBack();meetings.getMyAgendaList();");

		this.sendMeetingNotification(meeting_id, this.getMeetingById(meeting_id).user_id, 'meetingstatus_' + meeting_id, user_data.profile.user_name + ' ' + trd('meeting-notification-status-update') + ' ' + status);
	},
	sendMeetingNotification: function(meeting_id, user_id, message_type, message) {
		var object = { params: { f: 'sendNotificationToUser', user_id: user_id, event_id: this_congress.congress_information.congress_id, message: message, message_type: message_type } };
		postRequest(this.url, object, "console.log(\'Notification sent\')");
	}
};

function generateMeetingListHtml() {
	var myAgendaHtml = '';
	if (meetings.getList().length == 0) {
		myAgendaHtml += '<div class="info_div font_color_gray_1">' + trd('myagenda-no-meetings') + '</div>';
	} else {
		var section_exists = false;
		var tempHtml = '';
		$.each(meetings.getList(), function(index, this_meeting) {
			if (this_meeting.user_id == user_data.profile.user_id) {

				section_exists = true;
				tempHtml += '<div class="session_info_element border_bottom_color_dark" id="meeting_element_' + this_meeting.id + '">';
				tempHtml += '<div class="sessionInfo" id="session_button_' + this_meeting.id + '" onclick="loadMeetingDetail(' + this_meeting.id + ')">';
				tempHtml += '<span class="session_list_header_session_time font_color_gray_1">' + this_meeting.start_time.substr(0, 16) + ' - ' + this_meeting.end_time.substr(11, 5) + '</span>';
				tempHtml += '<div class="session_name font_bold font_color_dark">' + this_meeting.title + '</div>';
				tempHtml += '<span class="session_header_sala font_color_gray_1">' + (this_meeting.location || meetings.getLocationTitle(this_meeting.location_id)) + '</span>';
				tempHtml += '<div class="gotodetail_button" id="gotodetail_button_meeting_' + this_meeting.id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
				tempHtml += '</div>';
				tempHtml += '</div>';
			}
		});
		if (section_exists) {
			myAgendaHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="margin-bottom:5px">MY MEETINGS</div>';
			myAgendaHtml += tempHtml;
			section_exists = false;

		}
		tempHtml = '';
		$.each(meetings.getList(), function(index, this_meeting) {
			if ((this_meeting.status == 'attending') && (this_meeting.user_id != user_data.profile.user_id)) {
				section_exists = true;
				tempHtml += '<div class="session_info_element border_bottom_color_dark" id="meeting_element_' + this_meeting.id + '">';
				tempHtml += '<div class="sessionInfo" id="session_button_' + this_meeting.id + '" onclick="loadMeetingDetail(' + this_meeting.id + ')">';
				tempHtml += '<span class="session_list_header_session_time font_color_gray_1">' + this_meeting.start_time.substr(0, 16) + ' - ' + this_meeting.end_time.substr(11, 5) + '</span>';
				tempHtml += '<div class="session_name font_bold font_color_dark">' + this_meeting.title + '</div>';
				tempHtml += '<span class="session_header_sala font_color_gray_1">' + (this_meeting.location || meetings.getLocationTitle(this_meeting.location_id)) + '</span>';
				tempHtml += '<div class="gotodetail_button" id="gotodetail_button_meeting_' + this_meeting.id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
				tempHtml += '</div>';
				tempHtml += '</div>';
			}
		});
		if (section_exists) {
			myAgendaHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="margin-bottom:5px">ATTENDING</div>';
			myAgendaHtml += tempHtml;
			section_exists = false;

		}
		tempHtml = '';
		$.each(meetings.getList(), function(index, this_meeting) {
			if (this_meeting.status == 'invited') {
				section_exists = true;
				tempHtml += '<div class="session_info_element border_bottom_color_dark" id="meeting_element_' + this_meeting.id + '">';
				tempHtml += '<div class="sessionInfo" id="session_button_' + this_meeting.id + '" onclick="loadMeetingDetail(' + this_meeting.id + ')">';
				tempHtml += '<span class="session_list_header_session_time font_color_gray_1">' + this_meeting.start_time.substr(0, 16) + ' - ' + this_meeting.end_time.substr(11, 5) + '</span>';
				tempHtml += '<div class="session_name font_bold font_color_dark">' + this_meeting.title + '</div>';
				tempHtml += '<span class="session_header_sala font_color_gray_1">' + (this_meeting.location || meetings.getLocationTitle(this_meeting.location_id)) + '</span>';
				tempHtml += '<div class="gotodetail_button" id="gotodetail_button_meeting_' + this_meeting.id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
				tempHtml += '</div>';
				tempHtml += '</div>';
			}
		});
		if (section_exists) {
			myAgendaHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="margin-bottom:5px">INVITED</div>';
			myAgendaHtml += tempHtml;
			section_exists = false;
		}

		tempHtml = '';
		$.each(meetings.getList(), function(index, this_meeting) {
			if (this_meeting.status == 'declined') {
				section_exists = true;
				tempHtml += '<div class="session_info_element border_bottom_color_dark" id="meeting_element_' + this_meeting.id + '">';
				tempHtml += '<div class="sessionInfo" id="session_button_' + this_meeting.id + '" onclick="loadMeetingDetail(' + this_meeting.id + ')">';
				tempHtml += '<span class="session_list_header_session_time font_color_gray_1">' + this_meeting.start_time.substr(0, 16) + ' - ' + this_meeting.end_time.substr(11, 5) + '</span>';
				tempHtml += '<div class="session_name font_bold font_color_dark">' + this_meeting.title + '</div>';
				tempHtml += '<span class="session_header_sala font_color_gray_1">' + (this_meeting.location || meetings.getLocationTitle(this_meeting.location_id)) + '</span>';
				tempHtml += '<div class="gotodetail_button" id="gotodetail_button_meeting_' + this_meeting.id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
				tempHtml += '</div>';
				tempHtml += '</div>';
			}
		});
		if (section_exists) {
			myAgendaHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="margin-bottom:5px">DECLINED</div>';
			myAgendaHtml += tempHtml;
			section_exists = false;
		}
	}
	$('#myAgenda_meeting_list').html(myAgendaHtml);
}

function loadMeetWithParticipantList(fromHistory, user_id) {
	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage(false);
		return;
	}

	var isCurrent = ($('#meeting_list.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var MeetingListHtml = '';

	MeetingListHtml += '<div id="meeting_list" class="normal_page ' + initialPosition + '">';
	MeetingListHtml += '<div class="list_page_header ">';
	MeetingListHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('meeting-select') + '</div></div>';
	MeetingListHtml += '</div>';
	MeetingListHtml += '<div class="list_page scroll">';
	MeetingListHtml += '<div class="scroll_lock" style="padding-bottom:60px;">';

	MeetingListHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="margin-bottom:5px">' + trd('NEW') + '</div>';
	MeetingListHtml += '<div class="session_info_element border_bottom_color_dark" id="meeting_element_new">';
	MeetingListHtml += '<div class="sessionInfo" id="session_button_new" onclick="showEditMeetingModal(false,' + user_id + ')">';
	MeetingListHtml += '<span class="session_list_header_session_time font_color_gray_1">' + trd('create-new-meeting') + '</span>';
	MeetingListHtml += '<div class="session_name font_bold font_color_dark">' + trd('create-new-meeting-description') + '</div>';

	MeetingListHtml += '<span class="session_header_sala font_color_gray_1">' + trd('meeting-new-location') + '</span>';
	MeetingListHtml += '</div>';
	MeetingListHtml += '</div>';

	if (meetings.getList().length > 0) {
		MeetingListHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="margin-bottom:5px">' + trd('EXISTING') + '</div>';
		$.each(meetings.getList(), function(index, this_meeting) {

			if (this_meeting.user_id == user_data.profile.user_id) {
				MeetingListHtml += '<div class="session_info_element border_bottom_color_dark" id="meeting_element_' + this_meeting.id + '">';
				if (meetings.isInMeeting(user_id, this_meeting.id))
					MeetingListHtml += '<div class="sessionInfo" id="session_button_' + this_meeting.id + '" onclick="showToastrAlert(\'warning\',\'User already in meeting\')">';
				else
					MeetingListHtml += '<div class="sessionInfo" id="session_button_' + this_meeting.id + '" onclick="meetings.addParticipant(' + this_meeting.id + ',' + user_id + ')">';
				if (meetings.isInMeeting(user_id, this_meeting.id))
					MeetingListHtml += '<div class="session_list_header_session_time font_color_gray_1">' + trd('meeting-status-' + meetings.getParticipantStatus(user_id, this_meeting.id)) + '</div>';
				else
					MeetingListHtml += '<div class="session_list_header_session_time font_color_gray_1">' + trd('meeting-status-not-invited') + '</div>';

				MeetingListHtml += '<span class="session_list_header_session_time font_color_gray_1">' + this_meeting.start_time.substr(0, 16) + ' - ' + this_meeting.end_time.substr(11, 5) + '</span>';
				MeetingListHtml += '<div class="session_name font_bold font_color_dark">' + this_meeting.title + '</div>';
				MeetingListHtml += '<span class="session_header_sala font_color_gray_1">' + (this_meeting.location || meetings.getLocationTitle(this_meeting.location_id)) + '</span>';
				MeetingListHtml += '</div>';
				MeetingListHtml += '</div>';
			}
		});
	}


	MeetingListHtml += '</div>';
	MeetingListHtml += '</div>';

	$('#meeting_list').remove();
	$('.mainDiv').append(MeetingListHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('meeting_list');", 1);
		} else {
			setTimeout("bringforward('meeting_list');", 1);
		}
	} else {
		onPageChanged();
	}

}

function loadMeetingDetail(meeting_id, fromHistory) {
	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage(false);
		return;
	}
	//  if(!this_congress.meetings_information){ refreshUsermeetings('loadMeetingDetail('+meeting_id+','+fromHistory+')'); return; }

	console.log('loading meeting');
	var isCurrent = ($('#meeting_detail_' + meeting_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}
	var this_meeting = meetings.getMeetingById(meeting_id);
	console.log(this_meeting);
	var MeetingDetailHtml = '';

	MeetingDetailHtml += '<div id="meeting_detail_' + meeting_id + '" class="normal_page ' + initialPosition + '">';
	MeetingDetailHtml += '<div class="list_page_header ">';
	var meeting_header = this_meeting.status == 'attending' ? trd('meeting-header-attending') : trd('meeting-header-invited');
	MeetingDetailHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + meeting_header + '</div></div>';
	MeetingDetailHtml += '</div>';
	MeetingDetailHtml += '<div class="list_page scroll">';
	MeetingDetailHtml += '<div class="scroll_lock" style="padding-bottom:60px;">';
	MeetingDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="margin-bottom:5px">' + this_meeting.start_time.substr(0, 16) + ' - ' + this_meeting.end_time.substr(11, 5) + '</div>';
	MeetingDetailHtml += '<div style="padding-left:10px;"><div class="session_name font_bold font_color_dark">' + this_meeting.title + '</div>';
	MeetingDetailHtml += '<span class="session_header_sala font_color_gray_1">' + (this_meeting.location || meetings.getLocationTitle(this_meeting.location_id)) + '</span>';

	MeetingDetailHtml += '</div><div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('meeting-organizer') + '</div>';
	$.each(this_meeting.participants, function(index, this_participant) {
		if (this_participant.user_id == this_meeting.user_id) {
			MeetingDetailHtml += '<div class="session_info_element border_bottom_color_dark" id="participant_element_' + this_participant.user_id + '">';
			MeetingDetailHtml += '<div class="sessionInfo" id="participant_button_' + this_participant.userid + '" onclick="loadProfileDetail(' + this_participant.user_id + ');">';
			MeetingDetailHtml += '<div class="session_name font_bold font_color_dark">' + this_participant.user_name + '</div>';
			MeetingDetailHtml += '<span class="session_header_sala font_color_gray_1">' + trd('participant-organizer') + '</span>';
			MeetingDetailHtml += '<div class="gotodetail_button" id="gotodetail_button_meeting_' + this_participant.user_id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
			MeetingDetailHtml += '</div>';

		}

	});


	MeetingDetailHtml += '</div><div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('meeting-participants') + '</div>';
	if (this_meeting.participants.length == 1 && this_meeting.participants[0].user_id == user_data.profile.user_id)
		MeetingDetailHtml += '<div class="info_div font_color_gray_1">' + trd('meeting-no-participants') + '</div>';
	else {
		$.each(this_meeting.participants, function(index, this_participant) {
			if (this_participant.user_id != this_meeting.user_id) {
				MeetingDetailHtml += '<div class="session_info_element border_bottom_color_dark" id="participant_element_' + this_participant.user_id + '">';
				MeetingDetailHtml += '<div class="sessionInfo" id="participant_button_' + this_participant.userid + '" onclick="loadProfileDetail(' + this_participant.user_id + ');">';
				MeetingDetailHtml += '<div class="session_name font_bold font_color_dark">' + this_participant.user_name + '</div>';
				MeetingDetailHtml += '<span class="session_header_sala font_color_gray_1">' + trd('meeting-status-' + this_participant.status) + '</span>';
				MeetingDetailHtml += '<div class="gotodetail_button" id="gotodetail_button_meeting_' + this_participant.user_id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
				MeetingDetailHtml += '</div></div>';

			}

		});
	}
	//MeetingDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';
	MeetingDetailHtml += '</div>';
	MeetingDetailHtml += '</div>';
	if (this_meeting.user_id == user_data.profile.user_id) {
		MeetingDetailHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom_right" onclick="showEditMeetingModal(' + this_meeting.id + ')">' + trd('button-meeting-edit') + '</div>';
		MeetingDetailHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom_left" onclick="loadProfilesIndex(false,' + this_meeting.id + ')">' + trd('button-meeting-add') + '</div>';
	} else if (this_meeting.status == 'invited') {
		MeetingDetailHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom_right" onclick="meetings.updateParticipantStatus(' + this_meeting.id + ',user_data.profile.user_id,\'attending\')">' + trd('button-meeting-accept') + '</div>';
		MeetingDetailHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom_left" onclick="meetings.updateParticipantStatus(' + this_meeting.id + ',user_data.profile.user_id,\'declined\')">' + trd('button-meeting-decline') + '</div>';
	} else if (this_meeting.status == 'attending') {
		MeetingDetailHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom" onclick="navigator.notification.confirm(trd(\'meeting-cancel-confirm\'),function(button) { if(button==1) meetings.updateParticipantStatus(' + this_meeting.id + ',user_data.profile.user_id,\'declined\'); })">' + trd('button-meeting-cancel-presence') + '</div>';
	} else if (this_meeting.status == 'declined') {
		MeetingDetailHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom" onclick="navigator.notification.confirm(trd(\'meeting-rejoin-confirm\'),function(button) { if(button==1) meetings.updateParticipantStatus(' + this_meeting.id + ',user_data.profile.user_id,\'attending\'); })">' + trd('button-meeting-rejoin') + '</div>';
	}



	$('#meeting_detail_' + meeting_id).remove();
	$('.mainDiv').append(MeetingDetailHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('meeting_detail_" + meeting_id + "');", 1);
		} else {
			setTimeout("bringforward('meeting_detail_" + meeting_id + "');", 1);
		}
	} else {
		onPageChanged();
	}
}


function showEditMeetingModal(meeting_id, user_id) {

	var this_meeting = {};
	if (!meeting_id) {
		var st = new Date();
		var et = new Date();
		this_meeting = {
			title: '',
			start_time: '',
			end_time: '',
			location: ''
		};
	} else {
		this_meeting = meetings.getMeetingById(meeting_id);
		var st = stringToDate(this_meeting.start_time);
		var et = stringToDate(this_meeting.end_time);
	}
	var modalHtml = '<div class="session_question normal_page scroll">';
	modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('meeting-description') + '</div>';
	modalHtml += '<input type="text" placeholder="' + trd('meeting-description-placeholder') + '" value="' + this_meeting.title + '" id="meeting_title" class="block_text_visible font_color_gray_1" value="" style="border:0px solid #404040;text-align:center;margin:auto;width:100%;height:50px;background-color:white">';

	modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('meeting-time') + '</div>';
	modalHtml += '<div style="height:50px;line-height:50px;text-align:center">';
	modalHtml += '<input type="text" onclick="datePicker.show({ date: stringToDate(\'2000-11-11 \'+document.getElementById(\'meeting_start_time\').value+\':00\'), is24Hour: true,  mode: \'time\'},';
	modalHtml += 'function(time) {document.getElementById(\'meeting_start_time\').value=time.toString().split(\' \')[4].substr(0,5); if(parseInt(document.getElementById(\'meeting_end_time\').value.replace(\':\',\'\'))<parseInt(time.toString().split(\' \')[4].substr(0,5).replace(\':\',\'\'))) document.getElementById(\'meeting_end_time\').value=time.toString().split(\' \')[4].substr(0,5); }, \'\');" value="' + st.toString().substr(16, 5) + '"  id="meeting_start_time" class="font_color_gray_1" value="" style="border:1px solid #404040;text-align:center;width:60px;height:30px;background-color:white"></input>';
	modalHtml += ' to <input type="text" onclick="datePicker.show({ date: stringToDate(\'2000-11-11 \'+document.getElementById(\'meeting_end_time\').value+\':00\'), is24Hour: true, mode: \'time\'},';
	modalHtml += 'function(time) {document.getElementById(\'meeting_end_time\').value=time.toString().split(\' \')[4].substr(0,5);  if(parseInt(document.getElementById(\'meeting_start_time\').value.replace(\':\',\'\'))>parseInt(time.toString().split(\' \')[4].substr(0,5).replace(\':\',\'\'))) document.getElementById(\'meeting_start_time\').value=time.toString().split(\' \')[4].substr(0,5); }, \'\');" value="' + et.toString().substr(16, 5) + '"  id="meeting_end_time" class="font_color_gray_1" value="" style="border:1px solid #404040;text-align:center;width:60px;height:30px;background-color:white"></input>';

	modalHtml += ' <select id="meeting_day" style="width:130px;height:32px;margin-left:5px;vertical-align:middle">';

	$.each(this_congress.congress_information.congress_days, function(index, this_day_id) {
		var this_day = this_congress.day_information['' + this_day_id];
		var day = st.getFullYear() + '-' + ("00" + (st.getMonth() + 1)).slice(-2) + '-' + ("00" + st.getDate()).slice(-2);
		var sel_mod = this_day.day_time == day ? "selected" : "";
		modalHtml += '<option ' + sel_mod + ' value=' + this_day.day_time + '>' + this_day.day_name + '</option>';

	});
	modalHtml += '</select></div>';
	modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('meeting-location') + '</div>';

	modalHtml += '<div style="width:100%;height:50px;line-height:50px;text-align:center">';
	modalHtml += ' <select id="meeting_location_select" onchange="if(this.value==\'other\')document.getElementById(\'meeting_location\').style.visibility=\'visible\'; else document.getElementById(\'meeting_location\').style.visibility=\'hidden\';" style="width:150px;height:32px;text-align:center;vertical-align:middle">';
	var sel_mod = !this_meeting.location_id ? "selected" : "";
	modalHtml += '<option ' + sel_mod + ' value="other">' + trd('meeting-location-other') + '</option>';
	$.each(this_congress.congress_information.congress_locations, function(index, location_id) {
		var this_location = this_congress.locations_information['' + location_id];
		sel_mod = this_location.location_id == this_meeting.location_id ? "selected" : "";
		if (this_location.has_meeting == '1')
			modalHtml += '<option ' + sel_mod + ' value=' + this_location.location_id + '>' + this_location.location_name + '</option>';
	});
	modalHtml += '</select></div>';

	var input_visibility = 'hidden';
	if (!this_meeting.location_id)
		input_visibility = 'visible';
	modalHtml += '<input type="text" placeholder="' + trd('meeting-location-placeholder') + '" value="' + this_meeting.location + '"" id="meeting_location" class="block_text_visible font_color_gray_1" value="" style="visibility:' + input_visibility + ';border:1px solid #404040;text-align:center;margin:auto;width:100%;height:50px;background-color:white">';

	modalHtml += '</div>';
	modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom_right" onclick="closeModal()">' + trd('button-edit-meeting-cancel') + '</div>';

	modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom_left" onclick="saveMeeting(' + meeting_id + ',' + user_id + ')">' + trd('button-edit-meeting-save') + '</div>';

	$('.modal_page').html(modalHtml);
	$('.modal_page').addClass('show');
}


function saveMeeting(id, user_id) {
	console.log(user_id);
	var title = $('#meeting_title').val();
	var location = $('#meeting_location').val();
	var location_id = $('#meeting_location_select').val();
	var start_time = $('#meeting_day').val() + ' ' + $('#meeting_start_time').val() + ':00';
	var end_time = $('#meeting_day').val() + ' ' + $('#meeting_end_time').val() + ':00';

	var now = new Date();

	var valid = true;

	if (stringToDate(start_time).getTime < now.getTime()) {
		showToastrAlert('error', trd('error-meeting-past'));
		valid = false;
	}


	if (title == '') {
		showToastrAlert('error', trd('description-missing'));
		valid = false;
	}

	if (location == '' && location_id == 'other') {
		showToastrAlert('error', trd('location-missing'));
		valid = false;
	}

	if (!valid)
		return;

	if (location_id == 'other') {
		location_id = '';
	} else {
		location = '';
	}


	var url = services_home + 'services.php';
	if (!id) {
		var object = { params: { f: 'addMeeting', congress_id: this_congress.congress_information.congress_id, title: title, location: location, location_id: location_id, user_id: user_data.profile.user_id, start_time: start_time, end_time: end_time } };
		if (!user_id)
			postRequest(url, object, "meetings.getMyAgendaList();closeModal();");
		else
			postRequest(url, object, "closeModal();meetings.addParticipant(response.object.meeting_id," + user_id + ")");
	} else {
		var object = { params: { f: 'updateMeeting', id: id, congress_id: this_congress.congress_information.congress_id, title: title, location: location, location_id: location_id, user_id: user_data.profile.user_id, start_time: start_time, end_time: end_time } };
		postRequest(url, object, "meetings.refreshDetail(" + id + ");closeModal();");
	}
}

function takePhoto() {
	navigator.camera.getPicture(onPhotoSuccess, onPhotoFail, {
		quality: 100,
		allowEdit: true,
		targetWidth: 300,
		targetHeight: 300,
		destinationType: Camera.DestinationType.DATA_URL
	});
}

function takePhotoForFeed() {
	if (this_congress.congress_information.has_image_frame == '1') {
		navigator.camera.getPicture(onPhotoForFeedSuccess, onPhotoForFeedFail, {
			quality: 50,
			allowEdit: true,
			targetWidth: 1000,
			targetHeight: 1000,
			correctOrientation: true,
			destinationType: Camera.DestinationType.DATA_URL
		});
	} else {
		navigator.camera.getPicture(onPhotoForFeedSuccess, onPhotoForFeedFail, {
			quality: 50,
			allowEdit: false,
			correctOrientation: true,
			destinationType: Camera.DestinationType.DATA_URL
		});
	}
}

function takePhotoForFeed2() {
	navigator.camera.getPicture(onPhotoForFeedSuccess, onPhotoForFeedFail, {
		quality: 50,
		allowEdit: true,
		targetWidth: 600,
		targetHeight: 600,
		destinationType: Camera.DestinationType.DATA_URL
	});
}

function choosePhoto() {
	navigator.camera.getPicture(onPhotoSuccess, onPhotoFail, {
		quality: 100,
		allowEdit: true,
		targetWidth: 300,
		targetHeight: 300,
		destinationType: Camera.DestinationType.DATA_URL,
		sourceType: Camera.PictureSourceType.PHOTOLIBRARY
	});
}

function choosePhotoForFeed() {
	if (this_congress.congress_information.has_image_frame == '1') {
		navigator.camera.getPicture(onPhotoForFeedSuccess, onPhotoForFeedFail, {
			quality: 50,
			allowEdit: true,
			targetWidth: 1000,
			targetHeight: 1000,
			destinationType: Camera.DestinationType.DATA_URL,
			sourceType: Camera.PictureSourceType.PHOTOLIBRARY
		});
	} else {
		navigator.camera.getPicture(onPhotoForFeedSuccess, onPhotoForFeedFail, {
			quality: 50,
			allowEdit: false,
			destinationType: Camera.DestinationType.DATA_URL,
			sourceType: Camera.PictureSourceType.PHOTOLIBRARY
		});
	}
}


function onPhotoForFeedSuccess(imageData) {
	if (context_action_sheet_action == 'register_user') {
		$('#register_user_photo').css('background-image', "url('data:image/jpeg;base64," + imageData + "')");
		$('#user_img_src').val(imageData);
		$('#user_photo_explain').html(trd('register-fill-remaining'));
		context_action_sheet_action = false;
	} else {
		$('#post_temp_img').css('background-image', "url('data:image/jpeg;base64," + imageData + "')");
		$('.post_temp_img_placeholder').hide();
		$('#post_img_src').val(imageData);
		$('#post_img_url').val('');
		if (this_congress.congress_information.has_image_frame == '1') {
			$('#frame_image_interface').show();
			$('#unframe_post_image').hide();
		}
	}

}

function onPhotoSuccess(imageData) {
	$('#user_profile_pic_div').css('background-image', "url('data:image/jpeg;base64," + imageData + "')");
	$('#delete_pic_bt').css('display', 'inline-block');
	$('#user_pic_src').val(imageData);
}

function onPhotoFail(message) {
	console.log('Failed because: ' + message);
}

function onPhotoForFeedFail(message) {
	console.log('Failed because: ' + message);
	showToastrAlert('error', trd('could-not-take-picture'));
}

function framePostImage() {
	var url = $('#post_img_url').val();
	var imageData = 'data:image/jpeg;base64,' + $('#post_img_src').val();
	if (url) {
		$('#post_temp_img').css('background-image', "url(" + url + ")");
		$('#frame_post_image').hide();
		$('#unframe_post_image').show();
	} else if (imageData) {
		showLoadingOverlay();
		$.ajax({
			type: 'POST',
			url: services_home + 'services.php',
			cache: false,
			data: {
				params: {
					f: 'frameImage',
					congress_id: this_congress.congress_information.congress_id,
					base64: imageData
				}
			},
			dataType: 'json',
			success: function(response) {
				hideLoadingOverlay();
				console.log('got' + JSON.stringify(response));
				if (response.success && response.object) {
					console.log(response.object);
					url = response.object.url;
					$('#post_img_url').val(url);
					$('#post_temp_img').css('background-image', "url(" + url + ")");
					$('#frame_post_image').hide();
					$('#unframe_post_image').show();
				} else {
					showToastrAlert('error', trd('error-invalid-image'))
				}
			},
			error: function(xhr, ajaxOptions, thrownError) {
				hideLoadingOverlay();
				showToastrAlert('error', trd('no-connection'));
				console.log('got' + JSON.stringify(xhr));
			}
		});
	}
}

function unframePostImage() {
	var imageData = $('#post_img_src').val();
	if (imageData) {
		$('#post_temp_img').css('background-image', "url('data:image/jpeg;base64," + imageData + "')");
		$('#frame_post_image').show();
		$('#unframe_post_image').hide();
	}
}

function deletePhoto() {
	$('#delete_pic_bt').hide();
	$('#user_profile_pic_div').css('background-image', "url('img/defaults/img_user.png')");
	$('#user_pic_src').val('');
	user_data.profile.user_pic = '';
}

function loadConversationDetail(fromHistory, with_user_id) {
	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage(false);
		return;
	}

	setSelectedMenuArea('profile');

	console.log('loading profile edition');
	var isCurrent = ($('#conversation_detail_' + with_user_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var user_pic_src = 'url(\'img/defaults/img_user.png\');';
	var user_pic_base_64 = '';
	var close_display = 'none';
	if (user_data.profile && user_data.profile.user_pic && user_data.profile.user_pic != '') {
		if (breaking_changes.user_pic_file) {
			user_pic_src = 'url(\'' + user_pic_home + user_data.profile.user_pic + '\')';
		} else {
			user_pic_src = 'url(\'data:image/jpeg;base64,' + user_data.profile.user_pic + '\')';
			user_pic_base_64 = user_data.profile.user_pic;
		}
		close_display = 'inline-block';
	}

	var conversationDetailHtml = '';
	conversationDetailHtml += '<div id="conversation_detail_' + with_user_id + '" class="normal_page ' + initialPosition + '">';

	conversationDetailHtml += '<div class="list_page_header">';
	conversationDetailHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold"><span id="to_user_name"></span></div></div>';
	conversationDetailHtml += '<div class="header_more_button cg-icon cg-icon-user cg-icon-size-14 font_color_gray_1 selected_font_color_white" onclick="loadProfileDetail(' + with_user_id + ');"></div>';
	conversationDetailHtml += '<div class="header_more_button cg-icon cg-icon-user cg-icon-size-14 font_color_gray_1 selected_font_color_white" onclick="loadProfileDetail(' + with_user_id + ');"></div>';

	conversationDetailHtml += '</div>';


	conversationDetailHtml += '<div class="list_page with_bottom_input scroll" style="background-color:white">';

	conversationDetailHtml += '<div class="scroll_lock">';

	conversationDetailHtml += '<div id="conversation_messages"></div>';

	conversationDetailHtml += '</div>';
	conversationDetailHtml += '</div>';

	conversationDetailHtml += '<div class="bottom_input"><div class="wrap_textarea"><textarea id="message_text" maxlength="300"></textarea></div><div class="send_button" onclick="sendMessageToUser(' + with_user_id + ')">' + trd('bt-send') + '</div></div>';

	conversationDetailHtml += '</div>';

	$('#conversation_detail_' + with_user_id).remove();
	$('.mainDiv').append(conversationDetailHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('conversation_detail_" + with_user_id + "');", 1);
		} else {
			setTimeout("bringforward('conversation_detail_" + with_user_id + "');", 1);
		}

	} else {
		onPageChanged();
	}
	getConversationWithUser(with_user_id);
}

function loadEditProfile(fromHistory, first_time) {
	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage(false);
		return;
	}

	setSelectedMenuArea('profile');

	console.log('loading profile edition');
	var isCurrent = ($('#editprofile.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var user_pic_src = 'url(\'img/defaults/img_user.png\');';
	var user_pic_base_64 = '';
	var close_display = 'none';
	if (user_data.profile && user_data.profile.user_pic && user_data.profile.user_pic != '') {
		if (breaking_changes.user_pic_file) {
			user_pic_src = 'url(\'' + user_pic_home + user_data.profile.user_pic + '\')';
		} else {
			user_pic_src = 'url(\'data:image/jpeg;base64,' + user_data.profile.user_pic + '\')';
		}
		user_pic_base_64 = user_data.profile.user_pic;
		close_display = 'inline-block';
	}

	var editProfileHtml = '';
	editProfileHtml += '<div id="editprofile" class="normal_page ' + initialPosition + '">';

	editProfileHtml += '<div class="list_page_header ">';
	editProfileHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('header-my-profile') + '</div></div>';
	editProfileHtml += '<div class="edit_button cg-icon cg-icon-check cg-icon-size-14 font_color_gray_1 selected_font_color_white" onclick="saveUserProfile(' + first_time + ');"></div>';
	editProfileHtml += '</div>';


	editProfileHtml += '<div class="list_page with_bottom_input scroll">';

	editProfileHtml += '<div class="scroll_lock">';

	editProfileHtml += '<div class="profile_header">';
	editProfileHtml += '<table><tr><td>';
	editProfileHtml += '<div class="user_profile_pic_div" id="user_profile_pic_div" style="background-image:' + user_pic_src + '"></div>';
	editProfileHtml += '<input type="hidden" value="' + user_pic_base_64 + '" id="user_pic_src" />';
	editProfileHtml += '</td>';
	editProfileHtml += '<td style="text-align:center">';
	editProfileHtml += '<div class="cg-icon cg-icon-close font_color_dark cg-icon-size-20" id="delete_pic_bt" style="margin-left:15px;margin-right:15px;display:' + close_display + '" onclick="deletePhoto();"></div>';
	editProfileHtml += '<div class="cg-icon cg-icon-bt-gallery color_icon_clickable cg-icon-size-20" onclick="choosePhoto();" style="margin-left:15px;margin-right:10px;"></div>';
	editProfileHtml += '<div class="cg-icon cg-icon-bt-photo color_icon_clickable cg-icon-size-20" onclick="takePhoto();"></div>';
	editProfileHtml += '</td></tr></table>';
	editProfileHtml += '</div>';


	/*editProfileHtml += '<div class="division_bottom bg_color_gray_3"></div>';
	editProfileHtml += '<div class="block_text_holder"><input type="text" placeholder="'+trd('ph-name')+'" id="edit_user_name" class="block_text font_color_gray_1" style="text-transform:capitalize" value="'+user_data.profile.user_name+'" /><span class="cg-icon cg-icon-user font_color_dark text_icon"></span></div>';
	editProfileHtml += '<div class="division_bottom bg_color_gray_3"></div>';
	editProfileHtml += '<div class="block_text_holder"><input type="text" placeholder="'+trd('ph-subtitle')+'" id="edit_user_subtitle" class="block_text font_color_gray_1" value="'+(user_data.profile.user_subtitle?user_data.profile.user_subtitle:'')+'" /><span class="cg-icon cg-icon-user-subtitle font_color_dark text_icon"></span></div>';
	editProfileHtml += '<div class="division_bottom bg_color_gray_3"></div>';
	editProfileHtml += '<div class="block_text_holder"><input type="text" placeholder="'+trd('ph-phone')+'" id="edit_user_phone" class="block_text font_color_gray_1" value="'+(user_data.profile.user_phone?user_data.profile.user_phone:'')+'" /><span class="cg-icon cg-icon-phone font_color_dark text_icon"></span></div>';
	editProfileHtml += '<div class="division_bottom bg_color_gray_3"></div>';
	editProfileHtml += '<div class="block_text_holder"><input type="text" placeholder="'+trd('ph-website')+'" id="edit_user_website" value="'+(user_data.profile.user_website?user_data.profile.user_website:'')+'" class="block_text font_color_gray_1" style="text-transform:lowercase" /><span class="cg-icon cg-icon-link font_color_dark text_icon" style="font-size:10pt"></span></div>';
	editProfileHtml += '<div class="division_bottom bg_color_gray_3"></div>';
	editProfileHtml += '<div class="block_text_holder"><input type="text" placeholder="'+trd('ph-email')+'" id="edit_user_email" class="block_text font_color_gray_1" style="text-transform:lowercase" value="'+(user_data.profile.user_email?user_data.profile.user_email:'')+'" /><span class="cg-icon cg-icon-email font_color_dark text_icon"  style="font-size:12pt"></span></div>';
	editProfileHtml += '<div class="division_bottom bg_color_gray_3"></div>';
	editProfileHtml += '<div class="block_text_holder"><textarea type="text" placeholder="'+trd('ph-bio')+'" id="edit_user_bio" class="block_text font_color_gray_1">'+(user_data.profile.user_bio?user_data.profile.user_bio:'')+'</textarea><span class="cg-icon cg-icon-user-bio font_color_dark text_icon"  style="font-size:10pt"></span></div>';
	editProfileHtml += '<div class="division_bottom bg_color_gray_1"></div>';*/

	if (this_congress.congress_information.congress_user_fields && this_congress.congress_information.congress_user_fields.length > 0) {

		$.each(this_congress.congress_information.congress_user_fields, function(index, this_user_field_id) {
			var this_user_field = this_congress.user_fields_information['' + this_user_field_id];

			editProfileHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_user_field.label + '</div>';

			if (this_user_field.type == 'choose_one') {

				var user_choice = '';
				if (user_data.profile.user_fields && user_data.profile.user_fields[this_user_field_id] && user_data.profile.user_fields[this_user_field_id] != '' && user_data.profile.user_fields[this_user_field_id] != null) {
					user_choice = user_data.profile.user_fields[this_user_field_id];
				}



				editProfileHtml += '<select class="user_field_choose_one" id="user_field_' + this_user_field_id + '">';
				editProfileHtml += '<option value="">' + trd('user-field-option-choose-one-empty') + '</option>';
				var selectedModifier = '';
				$.each(this_user_field.options, function(index_option, this_option_id) {
					if (this_option_id == user_choice) {
						selectedModifier = ' selected '
					} else {
						selectedModifier = '';
					}
					var this_option = this_congress.user_field_options_information['' + this_option_id];
					editProfileHtml += '<option value="' + this_option_id + '" ' + selectedModifier + ' >' + this_option.option_value + '</option>';
				});

				editProfileHtml += '</select>';
			}

			if (this_user_field.type == 'choose_many') {

				var user_choice = '';
				if (user_data.profile.user_fields && user_data.profile.user_fields[this_user_field_id] && user_data.profile.user_fields[this_user_field_id] != '' && user_data.profile.user_fields[this_user_field_id] != null) {
					user_choice = user_data.profile.user_fields[this_user_field_id];
				}

				editProfileHtml += '<select multiple class="user_field_choose_many" id="user_field_' + this_user_field_id + '">';
				var selectedModifier = '';
				$.each(this_user_field.options, function(index_option, this_option_id) {
					if (user_choice.indexOf(this_option_id) >= 0) {
						selectedModifier = ' selected '
					} else {
						selectedModifier = '';
					}
					var this_option = this_congress.user_field_options_information['' + this_option_id];
					editProfileHtml += '<option value="' + this_option_id + '" ' + selectedModifier + ' >' + this_option.option_value + '</option>';
				});

				editProfileHtml += '</select>';
			}

			if (this_user_field.type == 'write' && this_user_field.readonly == "0") {

				if (user_data.profile.user_fields && user_data.profile.user_fields[this_user_field_id] && user_data.profile.user_fields[this_user_field_id] != '' && user_data.profile.user_fields[this_user_field_id] != null) {
					var user_choice = user_data.profile.user_fields[this_user_field_id];
					editProfileHtml += '<div class="block_text_holder"><textarea type="text" placeholder="' + trd('ph-user-field-write') + '" id="user_field_' + this_user_field_id + '" class="user_field_write">' + user_choice + '</textarea></div>';
				} else {
					editProfileHtml += '<div class="block_text_holder"><textarea type="text" placeholder="' + trd('ph-bio') + '" id="user_field_' + this_user_field_id + '" class="user_field_write"></textarea></div>';

				}
			}
			if (this_user_field.type == 'write' && this_user_field.readonly == "1") {
				var user_choice = user_data.profile.user_fields[this_user_field_id];
				editProfileHtml += '<div class="user_field_read font_color_gray_1" style="padding:15px;">' + user_choice + '</div>';
			}


		});

	}


	editProfileHtml += '</div>';
	editProfileHtml += '</div>';

	editProfileHtml += '<div class="modal_button_bottom font_color_white color_bg_division_1" onclick="saveUserProfile(' + first_time + ');">' + trd('bt-save-profile-changes') + '</div>';

	editProfileHtml += '</div>';

	$('#editprofile').remove();
	$('.mainDiv').append(editProfileHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('editprofile');", 1);
		} else {
			setTimeout("bringforward('editprofile');", 1);
		}

	} else {
		onPageChanged();
	}

}

function loadMyProfile(fromHistory) {
	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage();
		console.log('not logged in');
		return;
	} else if (this_congress.congress_information.has_networking && this_congress.congress_information.has_networking == "1") {

	} else {
		loadMyAgenda(MY_AGENDA_FILTER_SESSIONS, false);
		return;
	}
	getUserProfile('refresh', '', false, fromHistory);
}

function renderMyProfile(fromHistory) {

	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage();
		console.log('not logged in');
		return;
	} else if (this_congress.congress_information.has_networking && this_congress.congress_information.has_networking == "1") {

	} else {
		loadMyAgenda(MY_AGENDA_FILTER_SESSIONS, false);
		return;
	}

	setSelectedMenuArea('profile');

	console.log('loading my agenda');
	var isCurrent = ($('#myprofile.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var user_pic_src = 'url(\'img/defaults/img_user.png\');';
	if (user_data.profile && user_data.profile.user_pic && user_data.profile.user_pic != '') {
		if (breaking_changes.user_pic_file) {
			user_pic_src = 'url(\'' + user_pic_home + user_data.profile.user_pic + '\')';
		} else {
			user_pic_src = 'url(\'data:image/jpeg;base64,' + user_data.profile.user_pic + '\')';
		}
	}

	var myProfileHtml = '';
	myProfileHtml += '<div id="myprofile" class="normal_page ' + initialPosition + '">';

	myProfileHtml += '<div class="list_page_header ">';
	myProfileHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('header-my-profile') + '</div></div>';
	myProfileHtml += '<div class="edit_button cg-icon cg-icon-edit cg-icon-size-14 color_icon_second_menu selected_font_color_white" onclick="loadEditProfile(false,false);"></div><div onclick="loadEditProfile(false,false);" class="filter_label right color_icon_second_menu">' + trd('label-edit-profile') + '</div>';
	myProfileHtml += '<div class="logout_button cg-icon cg-icon-logout cg-icon-size-14 color_icon_second_menu selected_font_color_white" onclick="do_logout();"></div><div  onclick="do_logout();" class="filter_label left color_icon_second_menu">' + trd('label-logout') + '</div>';
	myProfileHtml += '</div>';


	myProfileHtml += '<div class="list_page scroll">';

	myProfileHtml += '<div class="scroll_lock">';

	myProfileHtml += '<div class="profile_header">';
	myProfileHtml += '<table><tr><td>';
	myProfileHtml += '<div class="user_profile_pic_div" style="background-image:' + user_pic_src + '"></div>';
	myProfileHtml += '</td>';
	myProfileHtml += '<td>';
	myProfileHtml += '<div class="profile_details">';

	myProfileHtml += '<div class="profile_name font_size_big font_color_dark">' + user_data.profile.user_name + '</div>';

	myProfileHtml += '<div class="profile_subtitle font_color_gray_1">' + (user_data.profile.user_subtitle ? user_data.profile.user_subtitle : (trd('user-subtitle-undefined'))) + '</div>';
	myProfileHtml += '</div>';
	myProfileHtml += '<div class="clearfix"></div>';
	myProfileHtml += '</td></tr></table>';
	if (this_congress && this_congress.congress_information && this_congress.congress_information.has_linkedin == '1') {
		if (!user_data.profile.user_linkedin_url || user_data.profile.user_linkedin_url == '' || user_data.profile.user_linkedin_url == 'null') {
			myProfileHtml += '<div class="block_button option_button linkedin btn_link_with_linkedin color_bg_division_2 font_color_white" style="margin-top:15px;font-size:12px" onclick="getProfileFromLinkedIn()">' + trd('bt-link-with-linkedin') + '</div>';
		}
	}
	if (this_congress && this_congress.congress_information && this_congress.congress_information.has_myqrcode == '1') {
		myProfileHtml += '<div class="block_button option_button qrcode color_bg_division_2 font_color_white" style="margin-top:15px;font-size:12px" onclick="createQRCodePage(\'' + user_data.profile.user_code + '\')">' + trd('bt-show-my-qr-code') + '</div>';
	}
	myProfileHtml += '<div class="block_button font_color_white color_bg_division_1" style="margin-top:15px;font-size:12px" onclick="loadEditProfile(false,false);">' + trd('button-edit-profile') + '</div>';
	myProfileHtml += '</div>';

	myProfileHtml += '<div class="division_bottom color_bg_division_1"></div>';
	myProfileHtml += '<div class="my_profile_contacts">';
	/*myProfileHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">'+trd('profile-phone-title')+'</div>';
	myProfileHtml += '<div class="my_profile_contact_phone profile_attribute font_color_dark font_size_normal">'+(user_data.profile.user_phone?user_data.profile.user_phone:(trd('user-phone-undefined')))+'</div>';
	myProfileHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">'+trd('profile-email-title')+'</div>';
	myProfileHtml += '<div class="my_profile_contact_email profile_attribute font_color_dark font_size_normal">'+(user_data.profile.user_email?user_data.profile.user_email:(trd('user-email-undefined')))+'</div>';*/
	//myProfileHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">'+trd('profile-website-title')+'</div>';

	//myProfileHtml += '<div class="my_profile_contact_website profile_attribute font_color_dark font_size_normal">'+(user_data.profile.user_website?user_data.profile.user_website:(trd('user-website-undefined')))+'</div>';
	if (this_congress.congress_information.congress_user_fields && this_congress.congress_information.congress_user_fields.length > 0) {

		$.each(this_congress.congress_information.congress_user_fields, function(index, this_user_field_id) {
			var this_user_field = this_congress.user_fields_information['' + this_user_field_id];

			myProfileHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_user_field.label + '</div>';

			if (this_user_field.type == 'choose_one') {
				if (user_data.profile.user_fields && user_data.profile.user_fields[this_user_field_id] && user_data.profile.user_fields[this_user_field_id] != '' && user_data.profile.user_fields[this_user_field_id] != null) {
					var user_choice = user_data.profile.user_fields[this_user_field_id];

					var this_user_field_option = this_congress.user_field_options_information['' + user_choice];
                    console.log(index + ' >>> '  + user_choice);
					myProfileHtml += '<div class="user_field_text font_color_dark profile_attribute">' + this_user_field_option.option_value + '</div>';
				} else {
					myProfileHtml += '<div class="user_field_text font_color_dark profile_attribute ">' + trd('user-field-option-choose-one-empty-label') + '</div>';
				}
			}
			if (this_user_field.type == 'choose_many') {
				if (user_data.profile.user_fields && user_data.profile.user_fields[this_user_field_id] && user_data.profile.user_fields[this_user_field_id] != '' && user_data.profile.user_fields[this_user_field_id] != null) {
					var user_choice = user_data.profile.user_fields[this_user_field_id];
					console.log(user_choice);
					var choose_many_text = '';
					user_choice.forEach(function(choice) {
						choose_many_text += this_congress.user_field_options_information['' + choice].option_value + ', ';
					});
					myProfileHtml += '<div class="user_field_text font_color_dark profile_attribute">' + choose_many_text.substr(0, choose_many_text.length - 2) + '</div>';

				} else {

				}
			}
			if (this_user_field.type == 'write' && this_user_field.readonly == "0") {

				if (user_data.profile.user_fields && user_data.profile.user_fields[this_user_field_id] && user_data.profile.user_fields[this_user_field_id] != '' && user_data.profile.user_fields[this_user_field_id] != null) {
					var user_choice = user_data.profile.user_fields[this_user_field_id];
					myProfileHtml += '<div class="user_field_text font_color_dark profile_attribute">' + user_choice + '</div>';
				} else {
					myProfileHtml += '<div class="user_field_text font_color_dark profile_attribute ">' + trd('user-field-option-write-empty') + '</div>';
				}
			}

			if (this_user_field.type == 'write' && this_user_field.readonly == "1") {
				var user_choice = user_data.profile.user_fields[this_user_field_id];
				myProfileHtml += '<div class="user_field_read font_color_gray_1" style="padding:15px;">' + user_choice + '</div>';
			}

		});

	}
	myProfileHtml += '</div>';
	//myProfileHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">'+trd('profile-bio-title')+'</div>';

	//myProfileHtml += '<div class="my_profile_bio profile_attribute font_size_normal font_color_dark">'+(user_data.profile.user_bio?user_data.profile.user_bio:(trd('user-bio-undefined')))+'</div>';

	/*if (!user_data.profile.user_fb_id || user_data.profile.user_fb_id==''){
	  myProfileHtml += '<div class="block_button bg_color_facebook font_color_white"style="margin-bottom:15px;" onclick="linkWithFB();">'+trd('bt-link-with-facebook')+'</div>';
	}*/

	myProfileHtml += '</div>';
	myProfileHtml += '</div>';
	myProfileHtml += '</div>';

	$('#myprofile').remove();
	$('.mainDiv').append(myProfileHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('myprofile');", 1);
		} else {
			setTimeout("bringforward('myprofile');", 1);
		}

	} else {
		onPageChanged();
	}


}

function loadProfileDetail(profile_id, fromHistory) {
	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage(false);
		return;
	}
	if (!this_congress.profiles_information) {
		refreshUserProfiles('loadProfileDetail(' + profile_id + ',' + fromHistory + ')');
		return;
	}
	if (profile_id == user_data.profile.user_id) {
		console.log('user_id equals user_data.profile.user_id');
		loadMyProfile(fromHistory);
	}
	setSelectedMenuArea('participants');

	console.log('loading user profile');
	var isCurrent = ($('#profile_detail_' + profile_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var this_profile = this_congress.profiles_information['' + profile_id];

	var user_pic_src = 'url(\'img/defaults/img_user.png\');';
	if (this_profile.user_pic && this_profile.user_pic != '') {
		if (breaking_changes.user_pic_file) {
			user_pic_src = 'url(\'' + user_pic_home + this_profile.user_pic + '\')';
		} else {
			user_pic_src = 'url(\'data:image/jpeg;base64,' + this_profile.user_pic + '\')';
		}
	}

	var profileDetailHtml = '';
	profileDetailHtml += '<div id="profile_detail_' + profile_id + '" class="normal_page ' + initialPosition + '">';

	profileDetailHtml += '<div class="list_page_header ">';
	profileDetailHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + this_profile.user_name + '</div></div>';
	profileDetailHtml += '</div>';

	profileDetailHtml += '<div class="list_page scroll">';

	profileDetailHtml += '<div class="scroll_lock" style="padding-bottom:60px;">';

	profileDetailHtml += '<div class="profile_header">';
	profileDetailHtml += '<table><tr><td>';
	profileDetailHtml += '<div class="user_profile_pic_div" style="background-image:' + user_pic_src + '"></div>';
	profileDetailHtml += '</td>';
	profileDetailHtml += '<td>';
	profileDetailHtml += '<div class="profile_details">';

	profileDetailHtml += '<div class="profile_name font_size_big font_color_dark">' + this_profile.user_name + '</div>';

	profileDetailHtml += '<div class="profile_subtitle font_color_gray_1">' + this_profile.user_subtitle + '</div>';
	profileDetailHtml += '</div>';
	profileDetailHtml += '<div class="clearfix"></div>';
	profileDetailHtml += '</td></tr></table>';
	if (this_profile.user_linkedin_url && this_profile.user_linkedin_url.indexOf('http') > -1) {
		profileDetailHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-top:15px;font-size:12px" onclick="openLink(\'' + this_profile.user_linkedin_url + '\')">' + trd('profile-open-linkedin-profile') + '</div>';
	}
	var inMyAgendaModifier = false;
	if (array_contains(user_data.profile.agenda["profiles"], this_profile.user_id)) {
		inMyAgendaModifier = true;
	}
	if (this_congress.congress_information.has_myagenda == "1") {
		profileDetailHtml += '<div class="block_button ' + ((inMyAgendaModifier) ? 'selected' : '') + ' add_profile_to_fav_btn color_bg_division_2 font_color_white" style="margin-top:15px;font-size:12px" onclick="add_profile_to_my_agenda(' + this_profile.user_id + ');">' + ((!inMyAgendaModifier) ? trd('profile-add-to-favourites') : trd('profile-remove-from-favourites')) + '</div>';
	}
	if (this_congress.congress_information.has_meetings == "1" && profile_id != user_data.profile.user_id) {
		profileDetailHtml += '<div class="block_button add_to_meeting_btn color_bg_division_2 font_color_white" style="margin-top:15px;font-size:12px" onclick="meetings.getParticipantList(' + this_profile.user_id + ');">' + trd('profile-schedule-meeting') + '</div>';
	}

	profileDetailHtml += '</div>';

	profileDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';


	if (this_congress.congress_information.congress_user_fields && this_congress.congress_information.congress_user_fields.length > 0) {

		$.each(this_congress.congress_information.congress_user_fields, function(index, this_user_field_id) {
			var this_user_field = this_congress.user_fields_information['' + this_user_field_id];

			if (this_user_field.is_private && this_user_field.is_private == "1") {
				return true;
			}

			profileDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_user_field.label + '</div>';

			if (this_user_field.type == 'choose_one') {
				if (this_profile.user_fields && this_profile.user_fields[this_user_field_id] && this_profile.user_fields[this_user_field_id] != '' && this_profile.user_fields[this_user_field_id] != null) {
					var user_choice = this_profile.user_fields[this_user_field_id];

					var this_user_field_option = this_congress.user_field_options_information['' + user_choice];
					profileDetailHtml += '<div class="user_field_text font_color_dark profile_attribute">' + this_user_field_option.option_value + '</div>';
				} else {
					profileDetailHtml += '<div class="user_field_text font_color_dark profile_attribute ">' + trd('user-field-option-choose-one-empty-label') + '</div>';
				}
			}

			if (this_user_field.type == 'choose_many') {
				if (this_profile.user_fields && this_profile.user_fields[this_user_field_id] && this_profile.user_fields[this_user_field_id] != '' && this_profile.user_fields[this_user_field_id] != null) {
					var user_choice = this_profile.user_fields[this_user_field_id];
					var choose_many_text = '';
					user_choice.forEach(function(choice) {
						choose_many_text += this_congress.user_field_options_information['' + choice].option_value + ', ';
					});
					profileDetailHtml += '<div class="user_field_text font_color_dark profile_attribute">' + choose_many_text.substr(0, choose_many_text.length - 2) + '</div>';

				} else {

				}
			}

			if (this_user_field.type == 'write' && this_user_field.readonly == "0") {

				if (this_profile.user_fields && this_profile.user_fields[this_user_field_id] && this_profile.user_fields[this_user_field_id] != '' && this_profile.user_fields[this_user_field_id] != null) {
					var user_choice = this_profile.user_fields[this_user_field_id];
					profileDetailHtml += '<div class="user_field_text font_color_dark profile_attribute">' + user_choice + '</div>';
				} else {
					profileDetailHtml += '<div class="user_field_text font_color_dark profile_attribute ">' + trd('user-field-option-write-empty') + '</div>';
				}
			}

			if (this_user_field.type == 'write' && this_user_field.readonly == "1") {
				var user_choice = this_profile.user_fields[this_user_field_id];
				profileDetailHtml += '<div class="user_field_read font_color_gray_1" style="padding:15px;">' + user_choice + '</div>';
			}

		});

	}


	profileDetailHtml += '</div>';

	profileDetailHtml += '</div>';
	if (this_congress.congress_information.has_chat && this_congress.congress_information.has_chat == "1") {
		profileDetailHtml += '<div class="modal_button_bottom color_bg_division_1" onclick="loadConversationDetail(false,' + this_profile.user_id + ')">' + trd('button-send-message') + '</div>';
	}

	profileDetailHtml += '</div>';

	$('#profile_detail_' + profile_id).remove();
	$('.mainDiv').append(profileDetailHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('profile_detail_" + profile_id + "');", 1);
		} else {
			setTimeout("bringforward('profile_detail_" + profile_id + "');", 1);
		}

	} else {
		onPageChanged();
	}
}

function loadCongressForUser(that_congress_id) {
	if (!user_data || user_data.profile.anonymous == "1") {
		showToastrAlert('error', trd('restricted-area-authenticate-first'));
		loadAuthPage(false);
		return;
	} else if (!array_contains(user_data.profile.user_events, that_congress_id)) {
		showToastrAlert('error', trd('user-does-not-have-access-to-event'));
		return;
	} else {
		loadCongressData(that_congress_id, 'en', true);
	}
}

function sendMessageToUser(to_user_id) {
	if (!this_congress) {
		return;
	}
	var message_text = $('#message_text').val();
	if (message_text == '') {
		showToastrAlert('error', trd('no-message-to-send'));
		return;
	}


	var url = services_home + 'services.php';
	showLoadingOverlay();
	user_data.profile.lang = this_congress.congress_information.congress_lang;

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'sendMessageToUser',
				user_data: user_data,
				event_info: {
					id: this_congress.congress_information.congress_id,
					lang: this_congress.congress_information.congress_lang
				},
				to_user_id: to_user_id,
				message_text: message_text
			}
		},
		dataType: 'json',
		success: function conversationRetrieved(response) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(response));
			var messagesHtml = '';

			if (response.success && response.object && response.object.new_message) {
				var this_message = response.object.new_message;
				var messageHtml = '';
				var direction = '';
				if (this_message.from_user_id == user_data.profile.user_id) {
					direction = 'FROM';
				} else {
					direction = 'TO';
				}
				messageHtml += '<div class="chat_message_timestamp">' + this_message.message_timestamp + '</div>';
				messageHtml += '<div class="chat_message ' + direction + '" id="list_element_' + this_message.message_id + '">' + convertLineBreaks(this_message.message_text) + '<div class="perninha"></div></div>';
				$('#conversation_messages').append(messageHtml);
				$('#message_text').val('');
				$('.empty_list_message').remove();
			} else {
				showToastrAlert('error', trd('no-message-sent'))
			}

			$(".current .scroll")[0].scrollTop = $(".current .scroll")[0].scrollHeight;


		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			showToastrAlert('error', trd('error-message-not-sent'));
			console.log('got' + JSON.stringify(xhr));
		}
	});
}

function getConversationWithUser(with_user_id) {
	if (!this_congress) {
		return;
	}

	var url = services_home + 'services.php';

	showLoadingOverlay();

	user_data.profile.lang = this_congress.congress_information.congress_lang;

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'getConversationWithUser',
				user_data: user_data,
				event_info: {
					id: this_congress.congress_information.congress_id,
					lang: this_congress.congress_information.congress_lang
				},
				with_user_id: with_user_id
			}
		},
		dataType: 'json',
		success: function conversationRetrieved(response) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(response));
			var messagesHtml = '';

			if (response.object && response.object.messages && response.object.messages.length > 0) {
				$.each(response.object.messages, function(index, this_message) {

					var direction = '';
					if (this_message.from_user_id == user_data.profile.user_id) {
						direction = 'FROM';
					} else {
						direction = 'TO';
					}

					messagesHtml += '<div class="chat_message_timestamp" style="color:grey;">' + this_message.message_timestamp + '</div>';
					messagesHtml += '<div class="chat_message ' + direction + '" id="list_element_' + this_message.message_id + '">' + convertLineBreaks(this_message.message_text) + '<div class="perninha"></div></div>';
				});
			} else {
				messagesHtml += '<div class="empty_list_message font_color_gray_1">' + trd('no-messages-from-user') + '</div>';
			}
			$('#conversation_messages').html(messagesHtml);

			$('#to_user_name').html(response.object.with_user_profile.user_name);

			$(".current .scroll")[0].scrollTop = $(".current .scroll")[0].scrollHeight;


		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(xhr));
		}
	});
}

function convertLineBreaks(str) {
	if (str == '' || str == undefined) {
		return '';
	}

	if (!str) return;
	return str.replace(/(?:\r\n|\r|\n)/g, '<br />');
}


function do_logout() {
	user_data.profile = emptyProfile();

	if (requires_full_profile && user_data.profile.anonymous == "1") {
		loadModalAuthPage();
		showModal();
		if (this_congress && this_congress.congress_information && this_congress.congress_information.has_user_location == '1') {
			after_login_action = 'user_location';
		}
	} else {
		loadAuthPage(true);
	}
	saveUserDataToStorage();
	updateProfile();
}

function clean_user_data() {
	if (user_data.profile) {
		if (!user_data.profile.user_phone || user_data.profile.user_phone == null) {
			user_data.profile.user_phone = '';
		}
		if (!user_data.profile.user_website || user_data.profile.user_website == null) {
			user_data.profile.user_website = '';
		}
		if (!user_data.profile.user_subtitle || user_data.profile.user_subtitle == null) {
			user_data.profile.user_subtitle = '';
		}
		if (!user_data.profile.user_bio || user_data.profile.user_bio == null) {
			user_data.profile.user_bio = '';
		}
	}
}

function loadLoginPage() {

	var loginPageHtml = '';
	loginPageHtml += '<div id="loginpage" class="normal_page">';

	loginPageHtml += '<table class="just_valign"><tr><td>';

	loginPageHtml += '<div style="margin:30px;">';

	loginPageHtml += '<div style="text-align:center;"><img src="config/login_icon.png" height="80" style="margin:auto;margin-bottom:0px;" /></div>';
	loginPageHtml += '<div><input type="text" placeholder="' + trd('login-ph-email') + '" id="login_user_email" class="block_text" style="margin-top:30px;margin-bottom:5px;height:50px;font-size:18px" /></div>';

	loginPageHtml += '<input type="text"  placeholder="' + trd('login-ph-pincode') + '" id="login_user_pincode" class="block_text" style="margin-bottom:10px;height:50px;font-size:18px" />';

	loginPageHtml += '<div class="block_button" style="margin-bottom:15px;margin-left:0;margin-right:0;background-color:#0460a9;color:white;" onclick="doLogin()">' + trd('bt-do-login') + '</div>';
	loginPageHtml += '<div style="text-decoration:underline;color:#0460a9;" onclick="openLink(\'' + app_config.request_email_url + '\')">' + trd('bt-login-forgot-password') + '</div>';

	loginPageHtml += '</td></tr></table>';

	loginPageHtml += '</div>';

	loginPageHtml += '</div>';
	loginPageHtml += '</div>';
	$('#loginpage').remove();
	$('#loginDiv').append(loginPageHtml);
	$('#headerOverlay').remove();
	FastClick.attach(document.body);
}

function doLogout() {

	clearMainDivs();
	showLoginDiv();
	user_data.access_data = null;
	saveUserDataToStorage();
}

function doLogin() {
	var email = $('#login_user_email').val();
	var pin = $('#login_user_pincode').val();

	var url = services_home + 'services.php';
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'getUserAccess',
				email: email,
				pin: pin
			}
		},
		dataType: 'json',
		success: function gotAccess(response) {
			if (response.success) {
				if (response.object && response.object.access_id) {
					access_data = response.object;
					user_data.access_data = access_data;
					saveUserDataToStorage();
					loadCongressList();
				}
			} else {
				showToastrAlert('error', trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			showToastrAlert('error', trd('connection-error'));
			console.log('error' + JSON.stringify(xhr));
		}
	});
}

function loadAuthPage(fromHistory) {

	setSelectedMenuArea('profile');

	console.log('loading login page');
	var isCurrent = ($('#authpage.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var loginPageHtml = '';

	loginPageHtml += '<div id="authpage" class="authpage normal_page ' + initialPosition + '">';

	loginPageHtml += '<div class="list_page_header">';
	loginPageHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('header-auth-page') + '</div></div>';
	loginPageHtml += '</div>';


	loginPageHtml += '<div class="list_page scroll">';

	loginPageHtml += '<div class="scroll_lock">';

	if (auth_scan_code) {
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-scan') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-explain-text') + '</div>';
		loginPageHtml += '<div class="scan_badge_button color_bg_division_2 font_color_white" onclick="scanUserBadge()">' + trd('auth-button-label') + '</div>';
	}
	if (auth_by_code) {
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-code') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-insert-code-label') + '</div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-code') + '" id="auth_code" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-bottom:20px" onclick="getUserProfile(\'code\');">OK</div>';
	}

	if (auth_by_email) {
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-email') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-insert-email-label') + '</div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-email') + '" id="auth_email" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-bottom:20px" onclick="getUserProfile(\'email\');">OK</div>';
	}

	if (auth_by_email_or_code) {
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-code') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-insert-email-or-code-label') + '</div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-email-or-code') + '" id="auth_by_email_or_code" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-bottom:30px" onclick="getUserProfile(\'profile_email_or_code\');">OK</div>';
	}

	if (auth_by_email_and_code) {
		var send_code_url = 'http://cms.cloudguideapp.com/services/tools/sendMail/code.php?congress_id=' + this_congress.congress_information.congress_id + '&lang=' + this_congress.congress_information.congress_lang;
		loginPageHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-title-auth-code') + '</div>';
		loginPageHtml += '<div class="auth_explain_text font_color_dark">' + trd('auth-insert-email-and-code-label') + '</div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-email') + '" id="auth_email" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('auth-insert-code') + '" id="auth_code" class="block_text_visible font_color_dark" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
		loginPageHtml += '<div class="block_button color_bg_division_2 font_color_white" style="margin-bottom:80px" onclick="getUserProfile(\'profile_email_and_code\');">OK</div>';
		loginPageHtml += '<div class="block_button font_color_white" style="margin-bottom:30px; background-color:grey; text-transform:none;" onclick="openLink(\'' + send_code_url + '\');">' + trd('request-a-code') + '</div>';
	}

	if (free_registration) {
		loginPageHtml += '<div class="block_button color_bg_division_1" onclick="loadModalRegisterPage(true);showModal();" style="margin-top:30px;font-size:12px">' + trd('auth-register-modal') + '</div>';
	}


	loginPageHtml += '</div>';
	loginPageHtml += '</div>';
	loginPageHtml += '</div>';

	$('#authpage').remove();
	$('.mainDiv').append(loginPageHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('authpage');", 1);
		} else {
			setTimeout("bringforward('authpage');", 1);
		}

	} else {
		onPageChanged();
	}
}

function updateDevice() {

	var url = services_home + 'services.php';

	if (isMobile) {
		user_data.device.uuid = device.uuid;
		user_data.device.os = (isIOS ? "ios" : "android");
	} else {
		user_data.device.uuid = 'WEB';
		user_data.device.os = 'web';
	}

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'updateDevice',
				user_data: user_data
			}
		},
		dataType: 'json',
		success: function userDataSubmitted(response) {
			console.log('got' + JSON.stringify(response));
			if (response.success) {
				if (response.object && response.object.new_device_id) {
					user_data.device.device_id = response.object.new_device_id;
					saveUserDataToStorage();
				}
			} else {
				//cgAlert(trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('error' + JSON.stringify(xhr));
		}
	});
}

function validateUser() {
	if (!user_data.profile.user_id) {
		return;
	}
	var url = services_home + 'services.php';

	user_data.profile.lang = this_congress.congress_information.congress_lang;

	console.log('updating profile ' + JSON.stringify(user_data));

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'validateUser',
				user_data: user_data,
				event_info: {
					id: this_congress.congress_information.congress_id,
					lang: this_congress.congress_information.congress_lang
				}
			}
		},
		dataType: 'json',
		success: function uservalidated(response) {
			console.log('got' + JSON.stringify(response));
			if (response.success) {
				console.log('user valid');
			} else {
				if (response.object) {
					if (response.object.fwd_link) {
						showToastrAlert('error', trd(response.message));
						openLink(fwd_link);
					}
				} else {
					showToastrAlert('error', trd(response.message));
				}
				console.log('user not valid:' + JSON.stringify(response));
				do_logout();
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('got' + JSON.stringify(xhr));
		}
	});
}

function updateProfile() {
	if (!this_congress) {
		return;
	}

	var url = services_home + 'services.php';

	user_data.profile.lang = this_congress.congress_information.congress_lang;

	console.log('updating profile ' + JSON.stringify(user_data));

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'updateProfile',
				user_data: user_data,
				event_info: {
					id: this_congress.congress_information.congress_id,
					lang: this_congress.congress_information.congress_lang
				}
			}
		},
		dataType: 'json',
		success: function profileUpdated(response) {
			console.log('got' + JSON.stringify(response));
			if (response.success) {
				if (response.object) {

					if (response.object.new_profile_id) {
						user_data.profile.user_id = response.object.new_profile_id;
					}
					if (response.object.new_device_id) {
						user_data.device.device_id = response.object.new_device_id;
					}

					saveUserDataToStorage();
				}
			} else {
				console.log('error' + JSON.stringify(response));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('got' + JSON.stringify(xhr));
		}
	});
}

function getEventWithCode(event_code) {

	showLoadingPage(trd('loading-check-code'));

	var url = services_home + 'check_event_code.php?event_code=' + event_code;


	$.ajax({
		type: 'GET',
		url: url,
		cache: false,
		dataType: 'json',
		success: function userDataSubmitted(response) {
			if (response.success && response.object) {
				loadCongressData(response.object.id, '', true);
			} else {
				showToastrAlert('error', trd(response.message));
				setTimeout("hideLoadingPage();", 1000);
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {

			showToastrAlert('error', trd("no-connection"));
			setTimeout("hideLoadingPage();", 1000);

		}
	});
}

function loadSponsorsIndex(fromHistory) {
	if (page_moving) {
		console.log('cant start, page is moving');
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('sponsors');
	console.log('showing sponsors index');

	var sponsorsIndexHtml = '';

	var isCurrent = ($('#sponsors_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	sponsorsIndexHtml += '<div class="normal_page ' + initialPosition + '" id="sponsors_index">';


	sponsorsIndexHtml += '<div class="list_page_header ">';
	sponsorsIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('sponsors') + '</div></div>';
	sponsorsIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">' + trd('filter-label') + '</div></div>';

	sponsorsIndexHtml += '<div class="list_page scroll">';

	sponsorsIndexHtml += '<div class="scroll_lock">';



	if (this_congress.congress_information.congress_sponsors.length == 0) {
		sponsorsIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-sponsors') + '</div>';
	}

	$.each(this_congress.congress_information.congress_sponsor_types, function(index, this_sponsor_level_id) {
		if (SPONSOR_FILTER_TYPE != -1 && SPONSOR_FILTER_TYPE != this_sponsor_level_id) {
			return true;
		}

		var this_sponsor_level = this_congress.sponsor_types_information['' + this_sponsor_level_id];
		sponsorsIndexHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_sponsor_level.sponsor_type_name + '</div>';

		var sponsorIndex = 0;


		$.each(this_sponsor_level.sponsors, function(index, this_sponsor_id) {


			var this_sponsor = this_congress.sponsors_information[this_sponsor_id];


			sponsorsIndexHtml += getHtmlForSponsorInfo(this_sponsor_id);

		});



	});

	sponsorsIndexHtml += '</div>';
	sponsorsIndexHtml += '</div>';
	$('#sponsors_index').remove();
	$('.mainDiv').append(sponsorsIndexHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('sponsors_index');", 1);
		} else {
			setTimeout("bringforward('sponsors_index');", 1);
		}
	} else {
		onPageChanged();
	}

}


function refreshNextSessions() {

	var next_sessions = nextSessions();

	var nextSessionsHtml = '';

	nextSessionsHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('next-sessions') + '</div>';

	if (next_sessions.length > 0) {


		nextSessionsHtml += '<div class="dashboard_block clearfix">';

		$.each(next_sessions, function(index, this_session_id) {
			nextSessionsHtml += getHtmlForMiniSessionInfo(this_session_id);
		});


		nextSessionsHtml += '</div>';
	} else {
		nextSessionsHtml += '<div class="info_div font_color_gray_1">' + trd('no-next-sessions') + '</div>';
	}

	$('#next_sessions').html(nextSessionsHtml);
}

function loadPhotoFeed(fromHistory, search_text) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	showLoadingOverlay();

	var isCurrent = ($('#photo_feed.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var mainDivWidth = $('.mainDiv').width();

	var this_post = {

	}

	var photoFeedHtml = '';

	photoFeedHtml += '<div class="normal_page with_bottom_input ' + initialPosition + '" id="photo_feed">';
	photoFeedHtml += '<div class="scroll" style="position:absolute;top:0;left:0;bottom:0;right:0;">';
	photoFeedHtml += '<div class="scroll_lock">';

	photoFeedHtml += '<div id="posts_feed_div"></div>';

	photoFeedHtml += '</div>';
	photoFeedHtml += '</div>';


    if(search_text){ var new_post_search_text = "'" + search_text + "'"; }
    else{ var new_post_search_text = ""; }
	photoFeedHtml += '<div class="photo_feed_actions color_bg_division_2" style="color:white;padding:10px;text-align:center;position:absolute;bottom:0;left:0;right:0;z-index:99" onclick="showNewPostModal(' + new_post_search_text + ');">' + trd('post-a-picture-to-feed') + '</div>';
	photoFeedHtml += '</div>';

	$('#photo_feed').remove();
	$('.mainDiv').append(photoFeedHtml);

	refreshFeed(search_text);
	if (search_text && search_text != '') {
		showToastrAlert('custom', { message: search_text, title: trd('feed-filtered-by') });
	}

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('photo_feed');", 1);
		} else {
			setTimeout("bringforward('photo_feed');", 1);
		}
	} else {
		onPageChanged();
	}
}

function postFriendlyDate(this_date) {
	var t = this_date.split(/[- :]/);
	var date = new Date(Date.UTC(t[0], t[1] - 1, t[2], t[3], t[4], t[5]));

	var minUnit = (1000 * 60);
	var hourUnit = (1000 * 60 * 60);
	var dayUnit = (1000 * 60 * 60 * 24);


	var now = new Date();
	var diff = now.getTime() - date.getTime();
	if (diff < minUnit) {
		return 'just now';
	} else if (diff < hourUnit) {
		return Math.ceil(diff / minUnit) + ' minutes ago';
	} else if (diff < dayUnit) {
		return Math.ceil(diff / hourUnit) + ' hours ago';
	} else if (diff < (2 * dayUnit)) {
		return 'Yesterday,  at ' + addZero(date.getHours()) + ':' + addZero(date.getMinutes());
	} else {
		return 'On ' + date.getDate() + '/' + (date.getMonth() + 1) + ', at ' + addZero(date.getHours()) + ':' + addZero(date.getMinutes());
	}
	//return date.toString('dd/MM/yyyy HH:mm');
}

function addZero(i) {
	if (i < 10) {
		i = "0" + i;
	}
	return i;
}

function togglePostLike(post_id) {
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();

	$('#post_container_' + post_id + ' .post_like_button').toggleClass('on');

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'togglePostLike',
				user_data: user_data,
				event_info: {
					id: this_congress.congress_information.congress_id,
					lang: this_congress.congress_information.congress_lang
				},
				post_id: post_id
			},
		},
		dataType: 'json',
		success: function postLikeToggled(response) {
			console.log('got response:' + JSON.stringify(response));
			if (response.success) {
				updatePostStatus(response.object);
				//cgAlert(trd('success-image-posted-to-feed'));
			} else {
				showToastrAlert('error', trd('error-could-not-perform-action'));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('got error: ' + JSON.stringify(xhr));
		}
	});
}


function deletePost(post_id) {
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	showLoadingOverlay();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'deletePost',
				user_data: user_data,
				event_info: {
					id: this_congress.congress_information.congress_id,
					lang: this_congress.congress_information.congress_lang
				},
				post_id: post_id
			},
		},
		dataType: 'json',
		success: function postLikeToggled(response) {
			hideLoadingOverlay();
			console.log('got response:' + JSON.stringify(response));
			if (response.success) {
				refreshFeed();
				showToastrAlert('success', trd('success-post-deleted'));
			} else {
				showToastrAlert('error', trd('error-could-not-delete-post'));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got error: ' + JSON.stringify(xhr));
		}
	});
}

function updatePostStatus(this_post_status) {
	if ($('#post_container_' + this_post_status.post_id).length > 0) {
		if (this_post_status.liked == "1") {
			$('#post_container_' + this_post_status.post_id + ' .post_like_button').addClass('on');
		} else {
			$('#post_container_' + this_post_status.post_id + ' .post_like_button').removeClass('on');
		}

		if (this_post_status.likes == "1") {
			$('#post_container_' + this_post_status.post_id + ' .post_like_counter').html(this_post_status.likes + ' like');
		} else {
			$('#post_container_' + this_post_status.post_id + ' .post_like_counter').html(this_post_status.likes + ' likes');
		}


	}
}

function refreshFeed(search_text) {
	showLoadingOverlay();
	var params = {
		f: 'getPosts',
		user_data: user_data,
		event_info: {
			id: this_congress.congress_information.congress_id,
			lang: this_congress.congress_information.congress_lang
		}
	};
	if (breaking_changes.user_pic_file) { params.user_pic_file = true; }
	if (search_text && search_text != '') { params.search_text = search_text; }
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function feedRetrieved(response) {

			console.log('response: ' + JSON.stringify(response));
			if (response.success) {
				var posts = response.object.posts;
				if (posts.length > 0) {
					lazyload.posts.page = 1;
					lazyload.posts.object = posts;
					var postsHtml = generateHtmlFromPosts();
					$('#posts_feed_div').html(postsHtml);
					$('#photo_feed .scroll').scroll(function(event) {
						onPostsScroll();
					});
					// $('.post_image').on('doubleTap', function() {
					//     var post_id = $(this).parent().attr('id').split('_')[2];
					//     togglePostLike(post_id);
					// });
				} else {
					showToastrAlert('success', trd('feed-empty-please-post'));
				}
				hideLoadingOverlay();
			} else {
				hideLoadingOverlay();
				showToastrAlert('error', trd(response.message));
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('ERROR:' + JSON.stringify(xhr));
			showToastrAlert('error', trd('error-feed-not-retrieved'));
			loadHome();
		}
	});
}

function onPostsScroll() {
	var scroll_element = $('#photo_feed .scroll');
	var scroll_height = scroll_element[0].scrollHeight;
	pastScrollPosts = scroll_element[0].scrollTop;
	if (pastScrollPosts / scroll_height > lazyload.posts.ratio && lazyload.posts.object.length > lazyload.posts.sizeTimesPages()) {
		lazyload.posts.page++;
		var more_posts_html = generateHtmlFromPosts();
		console.log('adding page ' + lazyload.posts.page + 'at the end of');
		console.log($('#endofposts_page' + lazyload.posts.page));
		$('#endofposts_page' + (lazyload.posts.page - 1)).append(more_posts_html);
		$('.post_image').off();
		// $('.post_image').on('doubleTap', function() {
		//     var post_id = $(this).parent().attr('id').split('_')[2];
		//     togglePostLike(post_id);
		// });
	}
}

function generateHtmlFromPosts(fromHistory) {
	var posts = lazyload.posts.object;
	postsHtml = '';
	var rendered_posts = 0;
	$.each(posts, function(index, this_post) {
		if (lazyload.posts.page == 1 || fromHistory || (lazyload.posts.page > 1 && index > lazyload.posts.size * (lazyload.posts.page - 1))) {
			postsHtml += getHtmlForPost(this_post);
		}
		if (index < lazyload.posts.sizeTimesPages()) {
			rendered_posts = index + 1;
			return true;
		} else {
			return false;
		}
	});
	console.log('rendered ' + rendered_posts + ' posts in total');
	postsHtml += '<div id="endofposts_page' + lazyload.posts.page + '"></div>';
	return postsHtml;
}


function getHtmlForPost_old(this_post) {
	var postHtml = '';

	var mainDivWidth = $('.mainDiv').width();

	var user_liked = '';
	if (this_post.user_liked == "1") {
		user_liked = 'on'
	}

	var post_likes = '';
	if (this_post.post_likes == "1") {
		post_likes = this_post.post_likes + ' like';
	} else {
		post_likes = this_post.post_likes + ' likes';
	}

	postHtml += '<div class="post_container font_color_gray_1" id="post_container_' + this_post.post_id + '">';
	postHtml += '<div class="post_user_info">';
	postHtml += '<div class="post_like_button ' + user_liked + '" onclick="togglePostLike(' + this_post.post_id + ')"></div>';
	if (user_data.profile && user_data.profile.user_id && user_data.profile.user_id == this_post.post_user_id) {
		postHtml += '<div class="post_options_button" onclick="choosePostActions(' + this_post.post_id + ');"></div>';
	}
	postHtml += '<div class="post_like_counter">' + post_likes + '</div>';
	if (breaking_changes.user_pic_file) {
		postHtml += '<div class="post_user_avatar" style="background-image:url(' + user_pic_home + this_post.user_pic + ')"></div>';
	} else {
		postHtml += '<div class="post_user_avatar" style="background-image:url(data:image/jpeg;base64,' + this_post.user_pic + ')"></div>';
	}
	postHtml += '<div class="post_user_content" style="width:' + (mainDivWidth - 110) + 'px;">';
	postHtml += '<div class="post_date">' + postFriendlyDate(this_post.post_time) + '</div>';
	postHtml += '<div class="post_user_name font_bold">' + this_post.user_name + '</div>';
	if (this_post.user_subtitle && this_post.user_subtitle != null) {
		postHtml += '<div class="post_user_subtitle">' + this_post.user_subtitle + '</div>';
	}
	if (this_post.post_image) {


		postHtml += '<div class="post_user_text">' + this_post.post_text + '</div>';

	}
	postHtml += '</div>';

	postHtml += '<div class="clearfix"></div>';
	postHtml += '</div>';
	postHtml += '<div class="clearfix"></div>';
	if (this_post.post_image) {
		var link = "";
		if (this_post.post_link) {
			postHtml += '<div onclick="openLink(\'' + this_post.post_link + '\')" style="position:relative;height:' + mainDivWidth / 3 + 'px;line-height:' + mainDivWidth / 3 + 'px;text-align:center;"><div class="post_image" style="width:100%;height:100%;background-image:url(\'' + post_images_home + this_post.post_image + '\');background-position:center;"></div>';
			postHtml += '<div style="position:absolute;left:0;right:0;top:0;bottom:0;background-color:rgba(0,0,0,.3);"><img style="display:inline-block;height:40px;width:40px;vertical-align:middle;opacity:.5" src="img/link_white.png"></div>';
			postHtml += '</div>'
		} else {
			postHtml += '<div class="post_image" ' + link + ' style="height:' + mainDivWidth + 'px;background-color:gray;background-image:url(\'' + post_images_home + this_post.post_image + '\');"></div>';
		}
	} else {
		postHtml += '<div style="width:calc(100% - 40px);padding:20px;padding-top:5px;padding-bottom:25px;font-size:14px">' + this_post.post_text + '</div>'

	}
	postHtml += '</div>';

	return postHtml;
}

function getHtmlForPost(this_post) {
	var postHtml = '';
	var mainDivWidth = $('.mainDiv').width();

	var user_liked = '';
	if (this_post.user_liked == "1") {
		user_liked = 'on'
	}

	var post_likes = '';
	if (this_post.post_likes == "1") {
		post_likes = this_post.post_likes + ' like';
	} else {
		post_likes = this_post.post_likes + ' likes';
	}

	postHtml += '<div class="post_container font_color_gray_1" id="post_container_' + this_post.post_id + '">';
	postHtml += '<div class="post_user_info">';
	postHtml += '<div class="post_like_button ' + user_liked + '" onclick="togglePostLike(' + this_post.post_id + ')"></div>';
	if (user_data.profile && user_data.profile.user_id && (user_data.profile.user_id == this_post.post_user_id || user_data.profile.is_admin == '1')) {
		postHtml += '<div class="post_options_button" onclick="choosePostActions(' + this_post.post_id + ');"></div>';
	}
	postHtml += '<div class="post_like_counter">' + post_likes + '</div>';
	//if (user_data.profile.user_id != this_post.post_user_id) {
	var click_profile = 'onclick="loadProfileDetail(' + this_post.post_user_id + ');"';
	//} else {
	//var click_profile = '';
	//}
	if (breaking_changes.user_pic_file) {
		postHtml += '<div class="post_user_avatar" ' + click_profile + ' style="background-image:url(' + user_pic_home + this_post.user_pic + ')"></div>';
	} else {
		if (this_post.user_pic && this_post.user_pic != '' && this_post.user_pic != 'undefined') {
			postHtml += '<div class="post_user_avatar" ' + click_profile + ' style="background-image:url(data:image/jpeg;base64,' + this_post.user_pic + ')"></div>';
		} else {
			postHtml += '<div class="post_user_avatar" ' + click_profile + ' style="background-color:white;background-image:url(img/defaults/img_user.png)"></div>';
		}

	}
	postHtml += '<div class="post_user_content" style="width:calc(100% - 110px);">';
	postHtml += '<div class="post_date">' + postFriendlyDate(this_post.post_time) + '</div>';
	postHtml += '<div class="post_user_name font_bold">' + this_post.user_name + '</div>';
	if (this_post.user_subtitle && this_post.user_subtitle != null) {
		postHtml += '<div class="post_user_subtitle">' + this_post.user_subtitle + '</div>';
	}
	if (this_post.post_image) {


		postHtml += '<div class="post_user_text">' + this_post.post_text + '</div>';

	}
	postHtml += '</div>';

	postHtml += '<div class="clearfix"></div>';
	postHtml += '</div>';
	postHtml += '<div class="clearfix"></div>';
	if (this_post.post_image) {
		var link = "";
		if (this_post.post_link) {
			postHtml += '<div onclick="openLink(\'' + this_post.post_link + '\')" style="position:relative;height:' + mainDivWidth / 3 + 'px;line-height:' + mainDivWidth / 3 + 'px;text-align:center;"><div class="post_image" style="width:100%;height:100%;background-image:url(\'' + post_images_home + this_post.post_image + '\');background-position:center;"></div>';
			postHtml += '<div style="position:absolute;left:0;right:0;top:0;bottom:0;background-color:rgba(0,0,0,.3);"><img style="display:inline-block;height:40px;width:40px;vertical-align:middle;opacity:.5" src="img/link_white.png"></div>';
			postHtml += '</div>'
		} else {
			postHtml += '<div onclick="event.stopPropagation();" class="post_image" ' + link + ' style="position:relative;overflow:hidden;max-height:' + (mainDivWidth - 20) + 'px;);"><div onclick="event.stopPropagation();doZoomOnImage2(\'' + post_images_home + this_post.post_image + '\')" style="position:absolute;top:8px;right:8px;height:30px;width:30px;z-index:5;border-radius:3px;background-color:rgba(0,0,0,.3);background-image:url(\'img/fullscreen.png\');background-repeat:no-repeat;background-position:center;background-size:30px;"></div><div style="max-height:inherit;transform: translateY(50%);"><img src="' + post_images_home + this_post.post_image + '" style="display:block; width:100%;transform: translateY(-50%);"></div></div>';
		}
	} else {
		postHtml += '<div style="width:calc(100% - 40px);padding:20px;padding-top:5px;padding-bottom:25px;font-size:14px">' + this_post.post_text + '</div>'

	}
	postHtml += '<div class="post_footer_comments" style="position:relative;">';
    if(this_post.post_image){
        postHtml += '<img onclick="photo_share.imageLink(\'' + post_images_home + this_post.post_image + '\')" src="img/share_photo.png" style="width:50px;opacity:0.6;margin-left:10px;">';
    }
	postHtml += '<div class="post_comment_button" onclick="postComments.showModal(' + this_post.post_id + ')"></div>';
	postHtml += '<div class="post_comment_counter" onclick="postComments.showModal(' + this_post.post_id + ')">' + this_post.num_comments + ' comments</div>';
	if (this_post.last_comment_text && this_post.last_comment_text != null)
		postHtml += '<div class="last_comment" style="margin-left:5px;line-height:12px "><span class="comment_user">' + (this_post.last_comment_user == null ? trd('user-anonymous') : this_post.last_comment_user) + '</span><span class="post_date"> ' + postFriendlyDate(this_post.last_comment_timestamp) + '</span><br><span class="comment_text">' + this_post.last_comment_text + '</span></div>';

	postHtml += '</div>';
	postHtml += '</div>';

	return postHtml;
}

var postComments = {
	url: services_home + 'services.php?rand=' + (new Date()).getTime(),
	showModal: function(post_id) {
		showLoadingOverlay();
		var params = {
			f: 'getPostDetail',
			post_id: post_id,
			user_id: user_data.profile.user_id,
			event_id: this_congress.congress_information.congress_id,
			locale: this_congress.congress_information.congress_lang
		};

		console.log('showPostCommentsModal calling ' + url);
		var url = this.url;
		$.ajax({
			type: 'POST',
			url: url,
			cache: false,
			dataType: 'json',
			data: { params: params },
			success: function postRetrieved(response) {
				hideLoadingOverlay();
				if (response.success) {
					postComments.postRetreived(response.object.post);
				} else {
					postComments.postFail();
				}

			},
			error: function(xhr, ajaxOptions, thrownError) {
				postComments.postFail();
				hideLoadingOverlay();
			}
		});
	},

	postRetreived: function(post) {
		var modalHtml = '<div class="post_modal normal_page scroll" onclick="event.stopPropagation();">';
		modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-post') + '</div>';
		modalHtml += getHtmlForPost(post);
		modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-comments') + '</div>';
		modalHtml += '<div class="post_comments" id="post_comments_' + post.post_id + '">';
		modalHtml += postComments.generateCommentsListHtml(post.comments);
		modalHtml += '</div>';
		modalHtml += '</div>';
		modalHtml += '<div class="post_comments_input_container">';
		modalHtml += '<input class="post_comments_input" type="text" maxlength="300" placeholder="' + trd('post-comment-placeholder') + '"/>';
		modalHtml += '<div class="post_comments_input_button" ' + clickAttribute + '="postComments.addCommentToPost(' + post.post_id + ')"></div>';
		modalHtml += '</div>';
		modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom" onclick="closeModal()">' + trd('post-close-button') + '</div>';
		modalHtml += '<script> $(".post_comments_input").on("focus", function(){ setTimeout(function() { $(".post_modal")[0].scrollTop=$(\'.post_comments\').offset().top; },500); }); $(".post_comments_input").on("keyup", function(){ if($(this).val()=="") $(\'.post_comments_input_button\').css(\'opacity\',\'0\'); else $(\'.post_comments_input_button\').css(\'opacity\',\'.5\'); }); </script>';

		$('.modal_page').html(modalHtml);
		$('.modal_page').addClass('show');
	},

	addCommentToPost: function(post_id) {
		var comment_text = $('.post_comments_input').val();
		if (!comment_text.length || comment_text.length < 1) {
			showToastrAlert('error', trd('text-too-short'));
			return;
		}
		var url = this.url;
		showLoadingOverlay();
		var params = {
			f: 'addPostComment',
			post_id: post_id,
			comment_text: comment_text,
			user_id: user_data.profile.user_id,
			event_id: this_congress.congress_information.congress_id
		}
		$.ajax({
			type: 'POST',
			url: url,
			cache: false,
			dataType: 'json',
			data: { params: params },
			success: function commentAdded(response) {
				hideLoadingOverlay();
				if (response.success) {
					postComments.refreshComments(post_id);
				} else {

				}
				$('.post_comments_input').val('');
				$('.post_comments_input').blur();
				$('.post_comments_input_button').css('opacity', '0');
			},
			error: function(xhr, ajaxOptions, thrownError) {
				hideLoadingOverlay();
				$('.post_comments_input').blur();
			}
		});
	},

	postFail: function() {
		showToastrAlert('error', trd('post-not-retrieved'));
	},

	refreshComments: function(post_id) {
		var url = this.url;
		var params = {
			f: 'getPostComments',
			post_id: post_id,
			event_id: this_congress.congress_information.congress_id,
		}
		$.ajax({
			type: 'POST',
			url: url,
			cache: false,
			dataType: 'json',
			data: { params: params },
			success: function commentsRetrieved(response) {
				hideLoadingOverlay();
				if (response.success) {
					$('#post_comments_' + post_id).html(postComments.generateCommentsListHtml(response.object.comments));
				} else {

				}

			},
			error: function(xhr, ajaxOptions, thrownError) {
				hideLoadingOverlay();
			}
		});
	},

	generateCommentsListHtml: function(comments) {
		var commentsHtml = '<div class="comment_no_comments">' + trd('comment-no-comments') + '</div>';
		comments.forEach(function(comment) {
			commentsHtml += '<div id="comment_container_' + comment.post_id + '" class="comment_card font_color_dark">';
			commentsHtml += '<div class="comment_card_top"><span class="comment_user">' + (comment.user_name == null ? trd('user-anonymous') : comment.user_name) + ' </span><span class="post_date"> ' + postFriendlyDate(comment.comment_timestamp) + '</span></div>';
			commentsHtml += '<div class="comment_text">' + comment.comment_text + '</div>';
			commentsHtml += '</div>';
		});
		return commentsHtml;
	}
};


function loadDashboard(fromHistory) {

	checkMandatory();

	if (this_congress && this_congress.congress_information.homescreen_script) {
		eval(this_congress.congress_information.homescreen_script);
		return;
	}

	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	clearHistory();

	setSelectedMenuArea('dashboard');

	var dashboard_type = this_congress.congress_information.dashboard_type;
    shortcut_line_count = this_congress.congress_information.shortcut_line_count;

	var dashboardHtml = '';

	var isCurrent = ($('#dashboard.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {

		initialPosition = 'past';
	} else if ($('.current').length == 0) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	dashboardHtml += '<div class="normal_page ' + initialPosition + '" id="dashboard">';

	dashboardHtml += '<div class="scroll" style="position:absolute;top:0;left:0;right:0;bottom:0;">';


	var congress_logo;
	if (this_congress.media_information['event-logo'] && this_congress.media_information['event-logo']['' + this_congress.congress_information.congress_id]) {
		congress_logo = this_congress.media_information['event-logo']['' + this_congress.congress_information.congress_id];
		var congressLogoUrl;

		if (congress_logo.offline) {
			congressLogoUrl = wwwRoot + '/' + congress_logo.name;
		} else {
			congressLogoUrl = congress_logo.imgURL_original;
		}

	} else {
		congressLogoUrl = false;
	}

	if (congressLogoUrl) {
		dashboardHtml += '<div class="congress_logo_image"><img src="' + congressLogoUrl + '" /></div>';
	}

	if (this_congress.congress_information.show_last_notification && this_congress.congress_information.show_last_notification == "1") {
		dashboardHtml += '<div class="dashboard_news" onclick="loadNewsIndex(false);">';
		var news_info = trd('no-news-dashboard');
		var news_info_ts = '';
		if (this_congress.congress_information.congress_news.length > 0) {
			news_info = this_congress.news_information[this_congress.congress_information.congress_news[0]].news_title;
			news_info_ts = this_congress.news_information[this_congress.congress_information.congress_news[0]].news_timestamp;
		}
		dashboardHtml += '<div class="last_news_timestamp">' + news_info_ts.substr(0, 16) + '</div>'
		dashboardHtml += '<div class="last_news font_bold">' + news_info + '</div>';

		dashboardHtml += '</div>';
	}

	if (true) {

		if (dashboard_type == 'grid_icon') {
			dashboardHtml += '<div class="dashboard_shortcuts"><table class="shortcuts_table" style="text-align:center;" width="100%"><tr>';
		}
		if (dashboard_type == 'list_icon') {
			dashboardHtml += '<div class="dashboard_list">';
		}
		if (dashboard_type == 'grid_image') {
			dashboardHtml += '<div class="dashboard_list_image" style="display:flex;flex-direction:row;flex-wrap:wrap;" style="width:100%">';
		}


		var shortcut_count = 0;

		$.each(shortcuts, function(index, shortcut_id) {



			var clickBehaviour = '';
			var area_title = '';
			var iconHtml = '';
			var icon_class = '';
			var this_shortcut = this_congress.shortcuts_information[shortcut_id];

			var area_type_split = this_shortcut.area_type.split('_');
			if (area_type_split.length > 1) { this_shortcut.area_target = this_shortcut.area_type.replace(area_type_split[0] + '_', ''); }
			this_shortcut.area_type = area_type_split[0];

			if (this_shortcut.area_type == 'division') {
				shortcut_count = 0;

				if (dashboard_type == 'list_icon') {
					dashboardHtml += '</div>';
				}
				if (dashboard_type == 'grid_image') {
					dashboardHtml += '</div>';
				}

				if (dashboard_type == 'grid_icon') {
					dashboardHtml += '</table></tr></div>';
				}

				dashboard_type = this_shortcut.layout_type;
				shortcut_line_count = this_shortcut.grid_break;
				console.log('for division ' + this_shortcut.shortcut_id + ' break is ' + this_shortcut.grid_break);

				if (dashboard_type == 'grid_icon') {
					dashboardHtml += '<div class="dashboard_shortcuts"><table class="shortcuts_table" style="text-align:center;" width="100%"><tr>';
				}
				if (dashboard_type == 'list_icon') {
					dashboardHtml += '<div class="dashboard_list">';
				}
				if (dashboard_type == 'grid_image') {
					dashboardHtml += '<div class="dashboard_list_image" style="display:flex;flex-direction:row;flex-wrap:wrap;" style="width:100%">';
				}

				return true;
			} else if (this_shortcut.area_available == '0') {
				clickBehaviour = 'availableSoon(\'' + stringEscape(htmlEntities(this_shortcut.area_title)) + '\');';
			} else if (this_shortcut.available_when && moment(last_server_time).isBefore(this_shortcut.available_when)) {
				clickBehaviour = 'availableSoon(\'' + stringEscape(htmlEntities(this_shortcut.area_title)) + '\');';
			} else if (this_shortcut.area_type == 'program') {
				if (this_shortcut.area_target) { clickBehaviour = 'loadSessionDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'SESSION_FILTER_SESSION_TYPE=-1;clearHistory();loadSessionIndex(false);'; }
			} else if (this_shortcut.area_type == 'speakers') {
				if (this_shortcut.area_target) { clickBehaviour = 'loadSpeakerDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadSpeakersIndex();'; }
			} else if (this_shortcut.area_type == 'exhibitors') {
				if (this_shortcut.area_target) { clickBehaviour = 'loadExhibitorDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadExhibitorsIndex(false);'; }
			} else if (this_shortcut.area_type == 'spaces') {
				if (this_shortcut.area_target) { clickBehaviour = 'loadFloorplan(' + this_shortcut.area_target + ',-1,false);'; } else { clickBehaviour = 'clearHistory();loadFloorplan(-1,-1,false);'; }
			} else if (this_shortcut.area_type == 'posters') {
				if (this_shortcut.area_target) { clickBehaviour = 'loadPosterDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadPostersIndex();'; }
			} else if (this_shortcut.area_type == 'sponsors') {
				if (this_shortcut.area_target) { clickBehaviour = 'loadSponsorDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadSponsorsIndex();'; }
			} else if (this_shortcut.area_type == 'points-of-interest') {
				if (this_shortcut.area_target) { clickBehaviour = 'loadPOIDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadPOIIndex();'; }
			} else if (this_shortcut.area_type == 'resources') {
				clickBehaviour = 'clearHistory();loadResourcesIndex();';
			} else if (this_shortcut.area_type == 'feedback') {
				if (this_shortcut.area_target) { clickBehaviour = 'loadFeedbackDetail(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadFeedbackIndex();'; }
			} else if (this_shortcut.area_type == 'other') {
				clickBehaviour = 'clearHistory();loadCustomArea(' + this_area_id + ',false);';
			} else if (this_shortcut.area_type == 'myagenda') {
				//clickBehaviour = 'clearHistory();loadMyAgenda('+MY_AGENDA_NO_FILTER+',false);';
				clickBehaviour = 'loadMyAgendaIndex(false);'
			} else if (this_shortcut.area_type == 'link') {
				clickBehaviour = clickBehaviour = 'clearHistory();openLink(\'' + this_shortcut.area_target + '\');';
			} else if (this_shortcut.area_type == 'pdf') {
				clickBehaviour = clickBehaviour = 'clearHistory();openPDF(\'' + this_shortcut.area_target + '\');';
			} else if (this_shortcut.area_type == 'search') {
				clickBehaviour = clickBehaviour = 'clearHistory();loadSearch(false);';
			} else if (this_shortcut.area_type == 'notification') {
				clickBehaviour = clickBehaviour = 'clearHistory();loadNewsIndex(false);';
			} else if (this_shortcut.area_type == 'nextsessions') {
				clickBehaviour = 'clearHistory();loadNextSessions(false);';
			} else if (this_shortcut.area_type == 'participants') {
				clickBehaviour = 'clearHistory();loadProfilesIndex(false);';
			} else if (this_shortcut.area_type == 'userconversations') {
				clickBehaviour = 'clearHistory();loadConversationsIndex(false);';
			} else if (this_shortcut.area_type == 'chatrooms') {
				clickBehaviour = 'clearHistory();chat_rooms.lobby.page();';
			} else if (this_shortcut.area_type == 'userprofile') {
				clickBehaviour = 'clearHistory();loadMyProfile(false);';
			} else if (this_shortcut.area_type == 'photofeed') {
				clickBehaviour = 'clearHistory();loadPhotoFeed();';
			} else if (this_shortcut.area_type == 'pollingsessions') {
				if (this_shortcut.area_target) { clickBehaviour = 'showPollingModal(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadPollingSessions(false);'; }
			} else if (this_shortcut.area_type == 'moderationsessions') {
				if (this_shortcut.area_target) { clickBehaviour = 'showSessionQuestionModal(' + this_shortcut.area_target + ');'; } else { clickBehaviour = 'clearHistory();loadModerationSessions(false);'; }
			} else if (this_shortcut.area_type.indexOf('customarea') > -1) {
				//var string_divide = this_shortcut.area_type.split("_");
				//var area_id = string_divide[string_divide.length - 1];
				//var this_area = this_congress.areas_information['' + area_id];
				clickBehaviour = 'clearHistory();loadCustomArea(' + this_shortcut.area_target + ',false);';
			} else if (this_shortcut.area_type.indexOf('javascript') > -1) {
				//var string_divide = this_shortcut.area_type.split("_");
				//var javascript = string_divide[string_divide.length - 1];
				//var javascript = this_shortcut.area_type.replace('javascript_', '');
				clickBehaviour = this_shortcut.area_target;
			} else if (this_shortcut.area_type.indexOf('trackschedule') > -1) {
				//var string_divide = this_shortcut.area_type.split("_");
				//var session_type_id = string_divide[string_divide.length - 1];
				//var this_session_type = this_congress.session_types_information['' + session_type_id];
				if (this_shortcut.area_target) { clickBehaviour = 'SESSION_FILTER_SESSION_TYPE=' + this_shortcut.area_target + ';SESSION_FILTER_DAY=-1;clearHistory();loadSessionIndex(false);'; } else { clickBehaviour = 'SESSION_FILTER_SESSION_TYPE=-1;clearHistory();loadSessionIndex(false);'; }
			} else if (this_shortcut.area_type.indexOf('linkgroup_') > -1) {
				//var string_divide = this_shortcut.area_type.split("_");
				//var link_group_id = string_divide[string_divide.length - 1];
				clickBehaviour = 'clearHistory();loadLinksIndex(' + this_shortcut.area_target + ');';
			} else {
				console.log('code not recognized:' + this_shortcut.area_type);
				return true;
			}

			area_title = this_shortcut.area_title;

			if (this_congress.media_information['shortcut'] && this_congress.media_information['shortcut']['' + this_shortcut.shortcut_id]) {
				var this_media = this_congress.media_information['shortcut']['' + this_shortcut.shortcut_id];
				var customIconUrl = '';
				if (this_media.offline) {
					customIconUrl = wwwRoot + '/' + this_media.name;
				} else {
					customIconUrl = this_media.imgURL_original;
				}
				iconHtml = '<span class="shortcut_icon"><img src="' + customIconUrl + '" width="50" /></span>';
			} else {
				icon_class = 'cg-icon-' + this_shortcut.area_type;
				iconHtml = '<span class="shortcut_icon cg-icon ' + icon_class + '" style="font-size:26pt;" ></span>';
			}

			if (this_shortcut.area_type == 'division') {
				// do nothing john snow
			} else if (dashboard_type == 'list_icon') {
				dashboardHtml += '<div class="dashboard_list_shortcut color_bg_shortcut_icon" onclick="' + clickBehaviour + '"><div class="list_shortcut_icon " style="background-image:url(\'' + customIconUrl + '\')"></div><div class="list_shortcut_title color_shortcut_icon"><div class="placeholder"></div><div class="shortcut_list_area_title">' + area_title + '</div></div><div class="list_shortcut_gotodetail"><div class="placeholder"></div><span class="cg-icon cg-icon-size-10 cg-icon-fwd font_color_shortcut"></span></div></div>';
			} else if (dashboard_type == 'grid_image') {
				dashboardHtml += '<div class="dashboard_grid_image_shortcut" style="width:' + (100 / shortcut_line_count) + '%" onclick="' + clickBehaviour + '"><img src="' + customIconUrl + '" style="width:100%;display:block" /></div>';
			} else if (dashboard_type == 'grid_icon') {
				dashboardHtml += '<td><div class="dashboard_area_shortcut" onclick="' + clickBehaviour + '">' + iconHtml + '<div class="font_semibold subtitle" style="color:black;font-size:8px;"><table class="just_valign"><tr><td>' + area_title + '</td></tr></table></div></div></td>';
				shortcut_count++;
				console.log(area_title + ' :  ' + shortcut_count);

				if ((shortcut_count) != 0 && (shortcut_count) % shortcut_line_count == 0) {
					console.log('breaking');
					dashboardHtml += '</tr><tr>';
				}
			}

		});
		if (dashboard_type == 'list_icon') {
			dashboardHtml += '</div>';
		}
		if (dashboard_type == 'grid_image') {
			dashboardHtml += '</div>';
		}

		if (dashboard_type == 'grid_icon') {
			dashboardHtml += '</table></tr></div>';
		}


	}

	if (this_congress.congress_information.home_linkgroup && this_congress.congress_information.home_linkgroup != "0")
		var this_link_group = this_congress.link_groups_information['' + this_congress.congress_information.home_linkgroup];
	if (this_link_group) {
		$.each(this_link_group.links, function(index, this_link_id) {
			dashboardHtml += getHtmlForLinkInfo(this_link_id);
		});
	}


	var limit = 3;

	if (this_congress.congress_information.show_next_sessions && this_congress.congress_information.show_next_sessions != 0) {
		var next_sessions = nextSessions();

		dashboardHtml += '<div id="next_sessions">';

		dashboardHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('next-sessions') + '</div>';

		if (next_sessions.length > 0) {


			dashboardHtml += '<div class="dashboard_block clearfix">';

			$.each(next_sessions, function(index, this_session_id) {
				dashboardHtml += getHtmlForMiniSessionInfo(this_session_id);
			});


			dashboardHtml += '</div>';
		} else {
			dashboardHtml += '<div class="info_div font_color_gray_1">' + trd('no-next-sessions') + '</div>';
		}

		dashboardHtml += '</div>';
	}

	dashboardHtml += '</div>';

	var hasFeaturedContent = (this_congress.congress_information.congress_highlights.length > 0);

	if (hasFeaturedContent) {
		dashboardHtml += '<div id="featuredIndexSwipe" style="max-width:100%;" class="swipe">';
		dashboardHtml += '<div class="swipe-wrap">';

		var clickBehaviour = '';

		$.each(this_congress.congress_information.congress_highlights, function(index, this_highlight_id) {

			var this_highlight = this_congress.highlights_information['' + this_highlight_id];

			if (this_highlight.highlight_type == 'sponsor') {
				clickBehaviour = 'loadSponsorDetail(' + this_highlight.highlight_value + ');';
			} else if (this_highlight.highlight_type == 'exhibitor') {
				clickBehaviour = 'loadExhibitorDetail(' + this_highlight.highlight_value + ');';
			} else if (this_highlight.highlight_type == 'session') {
				clickBehaviour = 'loadSessionDetail(' + this_highlight.highlight_value + ');';
			} else if (this_highlight.highlight_type == 'external') {
				clickBehaviour = 'openLink(\'' + this_highlight.highlight_value + '\');';
			} else if (this_highlight.highlight_type == 'javascript') {
				clickBehaviour = this_highlight.highlight_value;
			}

			dashboardHtml += '<div class="page_swipe" onclick="' + clickBehaviour + '">';

			if (this_congress.media_information && this_congress.media_information['highlight'] && this_congress.media_information['highlight']['' + this_highlight_id]) {

				this_media = this_congress.media_information['highlight']['' + this_highlight_id];
				var banner_url = '';
				if (this_media.offline) {
					banner_url = wwwRoot + '/' + this_media.name;
				} else {
					banner_url = this_media.imgURL_original;
				}

				dashboardHtml += '<div class="sponsor-banner"><img src="' + banner_url + '" style="display:block;margin:0;padding:0" width="100%"></div>';
			} else {
				if (this_highlight.highlight_type == 'sponsor') {
					dashboardHtml += getHtmlForFeaturedSponsor(this_highlight.highlight_value);
				} else if (this_highlight.highlight_type == 'exhibitor') {
					dashboardHtml += getHtmlForFeaturedExhibitor(this_highlight.highlight_value);
				} else if (this_highlight.highlight_type == 'session') {
					dashboardHtml += getHtmlForFeaturedSession(this_highlight.highlight_value);
				} else if (this_highlight.highlight_type == 'external') {
					//dashboardHtml += 'external link';
				} else if (this_highlight.highlight_type == 'javascript') {
					clickBehaviour = this_highlight.highlight_value;
				}
			}


			dashboardHtml += '</div>';
		});
		dashboardHtml += '</div>';
		dashboardHtml += '</div>';
	}

	dashboardHtml += '</div>';
	$('#dashboard').remove();
	$('.mainDiv').append(dashboardHtml);

	var elem = document.getElementById('featuredIndexSwipe');
	window.featuredSwipe = Swipe(elem, {
		lockDirection: false,
		auto: 3000,
		speed: 600,
		continuous: true,
		stopPropagation: false
	});

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('dashboard');", 1);
		} else {
			setTimeout("bringforward('dashboard');", 1);
		}
	} else {
		onPageChanged();
	}

	setTimeout("resetFeaturedSwipe();", 1500);
	if (this_congress.congress_information.show_tips == "1") {
		tip.show();
	}
}

var tip = {
	show: function() {
		var have_tip = false;
		var conflicting_sessions = conflictingSessions();
		var next_sessions = nextSessions();
		if (conflicting_sessions) {
			next_sessions = next_sessions.filter(function(n) { //that are in the user agenda
				return user_data.profile.agenda.sessions.indexOf(Number(n)) !== -1;
			});
		}
		if (next_sessions.length > 0) {
			var tip_session = this_congress.sessions_information[next_sessions[0]];
			if (tip_session.has_detail != "0") {
				have_tip = {
					message: '(' + tip_session.session_start_time + ') ' + tip_session.session_title,
					button_title: trd('find-out-more'),
					button_javascript: 'loadSessionDetail(' + next_sessions[0] + ')',
					title: trd('next-session')
				};
			}
		}
		if (!have_tip) {
			var previous_sessions = previousSessions();
			previous_sessions = previous_sessions.filter(function(p) { //that are not yet rated
				return user_data.profile.rating.sessions[Number(p)] === undefined;
			});
			if (conflicting_sessions) {
				previous_sessions = previous_sessions.filter(function(n) { //that are in the user agenda
					return user_data.profile.agenda.sessions.indexOf(Number(n)) !== -1;
				});
			}
			if (previous_sessions.length > 0) {
				var tip_session = this_congress.sessions_information[previous_sessions[0]];
				if (tip_session.has_detail != "0" && this_congress.sessions_information[previous_sessions[0]].has_rating == "1") {
					have_tip = {
						message: this_congress.sessions_information[previous_sessions[0]].session_title,
						button_title: trd('rate-now'),
						button_javascript: 'loadSessionDetail(' + previous_sessions[0] + ')',
						title: trd('please-rate-this-session')
					};
				}
			}
		}
		if (!have_tip) {
			if (conflicting_sessions && user_data.profile.agenda.sessions && user_data.profile.agenda.sessions.length == 0 &&
				this_congress.congress_information.has_myagenda == "1") {
				have_tip = {
					message: trd('tip-add-sessions-to-agenda'),
					button_title: trd('browse-program'),
					button_javascript: 'loadSessionIndex()',
					title: trd('did-you-know-that')
				};
			}
		}
		if (have_tip && window.localStorage['saved_history'] && window.localStorage['saved_history'].length > 20) {
			var identifier = have_tip.title + '>' + have_tip.message;
			console.log('tip: ' + identifier);
			if (!array_contains(tip.tips_shown, identifier)) {
				setTimeout(function() {
					if ($('#dashboard.current').length > 0) {
						showToastrAlert('custom', have_tip);
						tip.tips_shown.push(identifier);
					}
				}, 2000);
			}
		}
	},
	tips_shown: []
}

var tip = {
	show: function() {
		var have_tip = false;
		var conflicting_sessions = conflictingSessions();
		var next_sessions = nextSessions();
		if (conflicting_sessions) {
			next_sessions = next_sessions.filter(function(n) { //that are in the user agenda
				return user_data.profile.agenda.sessions.indexOf(Number(n)) !== -1;
			});
		}
		if (next_sessions.length > 0) {
			var tip_session = this_congress.sessions_information[next_sessions[0]];
			if (tip_session.has_detail != "0") {
				have_tip = {
					message: '(' + tip_session.session_start_time + ') ' + tip_session.session_title,
					button_title: trd('find-out-more'),
					button_javascript: 'loadSessionDetail(' + next_sessions[0] + ')',
					title: trd('next-session')
				};
			}
		}
		if (!have_tip) {
			var previous_sessions = previousSessions();
			previous_sessions = previous_sessions.filter(function(p) { //that are not yet rated
				return user_data.profile.rating.sessions[Number(p)] === undefined;
			});
			if (conflicting_sessions && user_data.profile.agenda.sessions) {
				previous_sessions = previous_sessions.filter(function(n) { //that are in the user agenda
					return user_data.profile.agenda.sessions.indexOf(Number(n)) !== -1;
				});
			}
			if (previous_sessions.length > 0) {
				var tip_session = this_congress.sessions_information[previous_sessions[0]];
				if (tip_session.has_detail != "0" && this_congress.sessions_information[previous_sessions[0]].has_rating == "1") {
					have_tip = {
						message: this_congress.sessions_information[previous_sessions[0]].session_title,
						button_title: trd('rate-now'),
						button_javascript: 'loadSessionDetail(' + previous_sessions[0] + ')',
						title: trd('please-rate-this-session')
					};
				}
			}
		}
		if (!have_tip) {
			if (conflicting_sessions && user_data.profile.agenda.sessions && user_data.profile.agenda.sessions.length == 0 && this_congress.congress_information.has_myagenda == "1") {
				have_tip = {
					message: trd('tip-add-sessions-to-agenda'),
					button_title: trd('browse-program'),
					button_javascript: 'loadSessionIndex()',
					title: trd('did-you-know-that')
				};
			}
		}
		if (have_tip && window.localStorage['saved_history'] && window.localStorage['saved_history'].length > 20) {
			var identifier = have_tip.title + '>' + have_tip.message;
			console.log('tip: ' + identifier);
			if (!array_contains(tip.tips_shown, identifier)) {
				setTimeout(function() {
					if ($('#dashboard.current').length > 0) {
						showToastrAlert('custom', have_tip);
						tip.tips_shown.push(identifier);
					}
				}, 2000);
			}
		}
	},
	tips_shown: []
}

function getHtmlForResourceInfo(resource_id) {

	var this_resource = this_congress.resources_information['' + resource_id];

	var resource_media = '';
	var resource_url = '';
	if (this_congress.media_information['resource'] && this_congress.media_information['resource']['' + resource_id]) {
		resource_media = this_congress.media_information['resource']['' + resource_id];
		if (resource_media.offline && isIOS) {
			resource_url = fsRoot + '/' + resource_media.name;
		} else {
			resource_url = media_home + 'resource/' + resource_media.media_value + '/original/' + resource_media.name;
		}
	}

	console.log('resource url is ' + resource_url);


	var resourceInfoHtml = '';
	resourceInfoHtml += '<div onclick="openPDF(\'' + resource_url + '\');">';
	resourceInfoHtml += '<div class="resource_button border_top_color_dark"><span class="resource_name kinda_title_color font_bold font_color_dark" >' + this_resource.resource_title + '</span>';

	if (this_resource.resource_subtitle) {
		resourceInfoHtml += '<br><span class="resource_format font_color_gray_1">' + this_resource.resource_subtitle + '</span>';
	}

	if (this_resource.resource_type) {
		var this_resource_type = resource_types_information['' + this_resource.resource_type];
		resourceInfoHtml += '<br><span class="resource_format font_color_gray_1">' + this_resource_type.resource_type_name + '</span>';
	}

	resourceInfoHtml += '<div class="download_button" id="download_button_' + this_resource.resource_id + '" ><span class="cg-icon font_color_dark cg-icon-bt-zoom-in"></span></div></div>';

	resourceInfoHtml += '</div>';




	return resourceInfoHtml;
}


function shuffle_array(a) {
	var j, x, i;
	for (i = a.length; i; i -= 1) {
		j = Math.floor(Math.random() * i);
		x = a[i - 1];
		a[i - 1] = a[j];
		a[j] = x;
	}
}

function loadResourcesIndex(fromHistory) {
	if (page_moving) {
		console.log('cant start, page is moving');
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('resources');
	console.log('showing resources index');


	var isCurrent = ($('#resources_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var resourcesIndexHtml = '';

	resourcesIndexHtml += '<div class="normal_page ' + initialPosition + '" id="resources_index">';

	resourcesIndexHtml += '<div class="list_page_header ">';
	resourcesIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('resources') + '</div></div>';
	resourcesIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div></div>';

	resourcesIndexHtml += '<div class="list_page scroll">';
	resourcesIndexHtml += '<div class="scroll_lock">';

	if (this_congress.congress_information.congress_resources.length == 0) {
		resourcesIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-resources') + '</div>';
	}

	$.each(this_congress.congress_information.congress_resources, function(index, this_resource_id) {


		console.log('evaluating resource ' + this_resource_id);
		var this_resource = this_congress.resources_information['' + this_resource_id];

		if (!this_resource.resource_featured || this_resource.resource_featured == 0) {
			console.log('resource not featured, skipping');
			return true;
		}

		if (RESOURCE_FILTER_TYPE != -1 && RESOURCE_FILTER_TYPE != this_resource.resource_type) {
			return true;
		}

		console.log('showing resource');


		resourcesIndexHtml += getHtmlForResourceInfo(this_resource_id);
	});

	resourcesIndexHtml += '</div>';
	resourcesIndexHtml += '</div>';
	resourcesIndexHtml += '</div>';

	$('#resources_index').remove();
	$('.mainDiv').append(resourcesIndexHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('resources_index');", 1);
		} else {
			setTimeout("bringforward('resources_index');", 1);
		}
	} else {
		onPageChanged();
	}

}

function cgAlert(message) {

	if (isMobile) {
		navigator.notification.alert(message, cgAlertCallback, trd('alert-title'), trd('alert-ok'));
	} else {
		alert(message);
	}
}

function cgAlertCallback() {

}

function resizeHandler() {
	var el = $('.scroll');
	el.css({ webkitOverflowScrolling: 'auto', overflow: 'hidden' });
	setTimeout(setOverflow, 10);
}

function setOverflow() {
	var el = $('.scroll');
	el.css({ webkitOverflowScrolling: 'touch', overflow: 'auto' });
}

function cgConfirmOpenGuide(congress_id, event_code) {
	context_congress_id = congress_id;
	console.log('confirming update')

	if (event_code && event_code != '' && event_code != 'null' && event_code != 'undefined') {
		if (isMobile) {
			navigator.notification.prompt(
				trd('prompt-code-required-message'),
				function(results) {
					if (results.buttonIndex == 2 && results.input1 == event_code) {
						loadCongressData(context_congress_id, app_default_lang, true);
					} else {
						showToastrAlert('error', trd('event-code-not-recognized'));
					}
				}, trd('prompt-code-required-title'), trd('confirm-openguide-cancel') + ',' + trd('confirm-openguide-submit'));
		} else {
			var this_event_code = prompt(trd('prompt-code-required-message'), trd('prompt-code-required-title'));
			if (this_event_code == event_code) {
				loadCongressData(context_congress_id, app_default_lang, true);
			}
		}
	} else {
		if (isMobile) {
			navigator.notification.confirm(trd('confirm-openguide-message'), cgConfirmOpenGuideCallback, trd('confirm-openguide-title'), trd('confirm-openguide-no') + ',' + trd('confirm-openguide-yes'));
		} else {
			if (confirm(trd('confirm-openguide-message'))) {
				loadCongressData(context_congress_id, app_default_lang, true);
			}
		}
	}
}



function cgConfirmOpenGuideCallback(button) {
	console.log('button is ' + button);
	if (button == 2) {
		loadCongressData(context_congress_id, app_default_lang, true);
	} else {

	}
}

function cgConfirm(message) {

	navigator.notification.alert(message, function() {
		loadCongressData(this_congress.congress_information.congress_id, this_congress.congress_information.congress_lang, true);
		showToastrAlert('warning', trd('automatic-update-please-wait'));
	}, trd('alert-update-title'), trd('alert-update-ok'));
	return;

	//if (isMobile) {
	//console.log('confirming update')
	//this_congress.congress_information.user_warned = true;
	//navigator.notification.confirm(message, cgConfirmCallback, trd('confirm-title'), trd('skip-update') + ',' + trd('confirm-update'));
	//} else {
	//if (confirm(trd('confirm-title'))) {
	//loadCongressData(this_congress.congress_information.congress_id, this_congress.congress_information.congress_lang, true);
	//this_congress.congress_information.user_warned = false;
	//} else {
	//this_congress.congress_information.user_warned = true;
	//setTimeout(function() {
	//this_congress.congress_information.user_warned = false;
	//}, 120 * 60 * 1000);
	//}
	//}
}

function cgConfirmCallback(button) {
	console.log('button is ' + button);
	if (button == 2) {
		loadCongressData(this_congress.congress_information.congress_id, this_congress.congress_information.congress_lang, true);
		this_congress.congress_information.user_warned = false;
	} else {
		this_congress.congress_information.user_warned = true;
		setTimeout(function() {
			this_congress.congress_information.user_warned = false;
		}, 120 * 60 * 1000);
	}
}

function openPDF(target) {
	console.log('opening target ' + target);
	if (isIOS) {
		window.open(target, '_blank', 'enableViewportScale=yes,location=no');
	} else {
		window.open(target, '_system', 'enableViewportScale=yes,location=no');
		//navigator.app.loadUrl(target, { openExternal:true } );
		/*window.resolveLocalFileSystemURL(target,
     function (fileEntry) {
       console.log('the PDF IS THERE!!');
       window.plugins.fileOpener.open(fileEntry.fullPath);
     },
     function () { console.log('the PDF IS NOT THERE!!');
   }
   );*/
	}
}

function loadSocialFeed(fromHistory) {
	setSelectedMenuArea('socialfeed');
	console.log('loading id socialfeed');

	var isCurrent = ($('#socialfeed.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}
	var socialfeedHTML = '';
	socialfeedHTML += '<div id="socialfeed" class="normal_page ' + initialPosition + '">';
	socialfeedHTML += '     <div class="list_page_header ">';
	socialfeedHTML += '         <div class="list_page_header_content color_font_second_menu">';
	socialfeedHTML += '             <div class="list_page_header_title font_bold">' + trd('socialfeed-title') + '</div>';
	socialfeedHTML += '         </div>';
	socialfeedHTML += '     </div>';
	socialfeedHTML += '     <div class="list_page scroll">';
	socialfeedHTML += '               <div id="socialfeed_cards"></div>';
	socialfeedHTML += '     </div>';
	socialfeedHTML += '</div>';

	$('#socialfeed').remove();
	$('.mainDiv').append(socialfeedHTML);

	refreshSocialFeed();

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('socialfeed');", 1);
		} else {
			setTimeout("bringforward('socialfeed');", 1);
		}

	} else {
		onPageChanged();
	}
}

function refreshSocialFeed() {
	showLoadingOverlay();
	var congress_id = this_congress.congress_information.congress_id;
	var url = services_home + 'integrations/socialfeed.php?rand=' + (new Date()).getTime() + '&congress_id=' + congress_id;
	console.log('calling ' + url);
	$.ajax({
		type: 'GET',
		url: url,
		cache: false,
		dataType: 'json',
		success: function(response) {
			hideLoadingOverlay();
			if (response.success) {
				var cardsHTML = '';
				$.each(response.socialfeed, function(index, object) {
					cardsHTML += socialFeedCardsHTML(object);
				});
				$('#socialfeed_cards').append(cardsHTML);
			} else {
				showToastrAlert('error', trd(response.message));
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('ERROR:' + JSON.stringify(xhr));
			showToastrAlert('error', trd('error-socialfeed-not-retrieved'));
		}
	});
}

function socialFeedCardsHTML(obj) {
	switch (obj.source_type) {
		case 'facebook':
			if (!obj.message) { obj.message = obj.name; }
			var html = [
				'<div style="margin: 15px;border: 1px solid transparent;border-radius:5px;box-shadow: 1px 1px 2px gray; background-color: #f2f2f2; font-size: 12px;">',
				'<img src="img/facebook.png" width="30px" style="float:left;opacity:0.4;margin:5px">',
				'<div style="color: grey; float:right; font-size:16px;margin:5px">' + obj.source_label + '</div>',
				'<div style="clear:both"></div>',
				'<div style="color: #3b5998; font-weight: bold; margin: 15px 15px 5px 15px; font-size: 16px; font-family: sans-serif;">' + obj.created_time + '</div>'
			].join("\n");
			if (obj.picture) {
				html += '<div style="text-align: center;"><img src="' + obj.picture + '" style="text-align:center;margin-top:5px;border-radius:5px" width="260"></div>';
			}
			html += [
				'<div style="color:#424242; margin: 0px 15px 0px 15px;font-family:sans-serif; font-size: 14px;">' + obj.message + '</div>',
				'<div onclick="openLink(\'' + obj.source_url + '\')" ',
				'style="color:white;background-color:#3b5998;font-size:16px;margin:15px;text-align:center;padding:10px;border-radius:5px">',
				trd('socialfeed-open-in-facebook') + '</div>',
				'</div>'
			].join("\n");
			break;
		case 'twitter':
			var html = [
				'<div style="margin:15px;border: 1px solid transparent;border-radius:5px;box-shadow: 1px 1px 2px grey; background-color: #f2f2f2; font-size: 12px;">',
				'<img src="img/twitter.png" width="30px" style="float:left;opacity:0.4;margin:5px">',
				'<div style="color: grey; float:right; font-size:16px;margin:5px">' + obj.source_label + '</div>',
				'<div style="clear:both"></div>',
				'<img width="50px" style="float:left; margin: 15px 5px 5px 15px; border: 1px solid grey; border-radius:5px"',
				'src="' + obj.avatar + '">',
				'<div style="color: #424242; font-weight: bold; margin: 15px 15px 5px 15px; font-size: 16px; font-family: sans-serif;">' + obj.name + '<br>',
				'<span style="color:#0084b4">' + obj.created_time + '</span></div>',
				'<div style="clear:both"></div>',
				'<div style="color:#424242; margin: 0px 15px 0px 15px;font-family:sans-serif; font-size: 14px;">' + obj.message + '</div>'
			].join("\n");
			if (obj.picture) {
				html += '<div style="text-align: center;"><img src="' + obj.picture + '" style="text-align:center;margin-top:5px;border-radius:5px" width="260"></div>';
			}
			html += [
				'<div onclick="openLink(\'' + obj.source_url + '\')" ',
				'style="color:white;background-color:#0084b4;font-size:16px;margin:15px;text-align:center;padding:10px;border-radius:5px">',
				trd('socialfeed-open-in-twitter') + '</div>',
				'</div>'
			].join("\n");
			break;
		case 'instagram':
			var html = [
				'<div style="margin:15px; border:1px solid transparent;border-radius: 5px;box-shadow: 1px 1px 2px grey; background-color: #f2f2f2; font-size: 12px;">',
				'<img src="img/instagram.png" width="30px" style="float:left;opacity:0.4;margin:5px">',
				'<div style="color: grey; float:right; font-size:16px;margin:5px">' + obj.source_label + '</div>',
				'<div style="clear:both"></div>',
				'<div style="color:#cd486b; font-weight: bold; margin: 5px 15px 5px 15px; font-size: 16px; font-family: sans-serif;">' + obj.created_time + '</div>',
				'<div style="text-align: center;"><img src="' + obj.picture + '" style="text-align: center; margin-top: 5px;border-radius: 5px" width="260"></div>',
				'<div onclick="openLink(\'' + obj.source_url + '\')" ',
				'style="color:white;background-color:#cd486b;font-size:16px;margin:15px;text-align:center;padding:10px;border-radius:5px">',
				trd('socialfeed-open-in-instagram') + '</div>',
				'</div>'
			].join("\n");
			break;
	}
	return html;
}


function openLink(target, get_params) {
	saveActionInHistory("openLink(" + target + ")");
	if (get_params) {
		var params = "user_id=" + user_data.profile.user_id + "&lang=" + this_congress.congress_information.congress_lang + "&congress_id=" + this_congress.congress_information.congress_id;
		if (target.indexOf('?') < 0) { target += "?" + params; } else { target += "&" + params; }
	}
	if (target.indexOf('http:') < 0 && target.indexOf('https:') < 0) {
		target = 'http://' + target;
	}
	console.log('opening link: ' + target);
	if (isIOS || !isMobile) {
		window.open(target, '_blank', 'enableViewportScale=yes,location=no,scrollbars=yes');
	} else {
		cordova.InAppBrowser.open(target, '_blank', 'location=yes');
		//navigator.app.loadUrl(target, { openExternal:true } );
	}
}

function loadSearch(fromHistory) {
	if (page_moving) {
		console.log('cant start, page is moving');
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('search');
	console.log('loading search');

	var isCurrent = ($('#searchDiv.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var searchDivHtml = '';

	searchDivHtml += '<div class="normal_page ' + initialPosition + '" id="searchDiv">';

	searchDivHtml += '<div class="list_page_header ">';
	searchDivHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold search">' + trd('search-header') + '</div></div>';
	searchDivHtml += '</div>';

	searchDivHtml += '<div class="list_page scroll">';

	searchDivHtml += '<div class="search_text_div">';
	searchDivHtml += '<div class="block_text_holder"><input type="text" placeholder="' + trd('search-placeholder') + '"  id="search_input_text" class="block_text_visible font_color_gray_1" value="" style="border:1px solid #404040;text-align:center;margin:auto;width:calc(100% - 30px);bottom:10px;background-color:white" /></div>';
	searchDivHtml += '<div class="block_button color_bg_division_2" style="font-size:12px" onclick="doSearch();">' + trd('button-do-search') + '</div>';
	searchDivHtml += '<div class="search_results_div clearfix">';

	searchDivHtml += '<div class="search_searching_div" id="search_searching_div">';
	searchDivHtml += '<div class="result_title kinda_title font_color_dark">' + trd('search-not-started') + '</div>';
	searchDivHtml += '</div>';

	searchDivHtml += '<div id="actual_results">';
	searchDivHtml += '</div>';

	searchDivHtml += '</div>';
	searchDivHtml += '</div>';
	searchDivHtml += '</div>';

	$('#searchDiv').remove();

	$('.mainDiv').append(searchDivHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('searchDiv');", 1);
		} else {
			setTimeout("bringforward('searchDiv');", 1);
		}
	} else {
		onPageChanged();
	}

	if (SEARCH_STRING && SEARCH_STRING != '') {
		$('#search_input_text').val(SEARCH_STRING);
		doSearch();
	}
}

function highlightWord(full_text, target) {
	var start = 0;
	var end = 0;
	if (!full_text || full_text == '') {
		return '';
	}
	if (removeDiacritics(full_text.toLowerCase()).indexOf(target.toLowerCase()) > -1) {
		start = removeDiacritics(full_text.toLowerCase()).indexOf(target.toLowerCase());
		var real_word = full_text.substr(start, target.length);
		full_text = full_text.replace(real_word, '<span class="highlight_span">' + real_word + '</span>');
		return full_text;
	} else {
		return full_text;
	}
}

function doSearch() {

	$('#search_searching_div').html('<img src="img/cg_loading_gray.gif" width="30" /><div class="result_title kinda_title font_color_dark">' + trd('searching-results') + '</div>');


	var searchString = removeDiacritics($('#search_input_text').val());
	if (searchString == '') {
		return;
	}

	var resultHtml = '';
	var resultsFound = 0;
	$('#actual_results').html('');
	console.log('Search String: ' + searchString);

	// SEARCH SPEAKERS
	$.each(this_congress.congress_information.congress_speakers, function(index, this_speaker_id) {
		var this_speaker = this_congress.speakers_information['' + this_speaker_id];
		var strippedDescription = strip(this_speaker.speaker_description);
		var inDescription = false;

		console.log('Evaluating speaker: ' + this_speaker.speaker_first_name + 'with id ' + this_speaker.speaker_id);
		var matchesSearch = false;
		if (removeDiacritics(this_speaker.speaker_first_name).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		} else if (removeDiacritics(this_speaker.speaker_last_name).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		} else if (this_speaker.speaker_subtitle && removeDiacritics(this_speaker.speaker_subtitle).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		} else if (this_speaker.speaker_description && removeDiacritics(this_speaker.speaker_description).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			inDescription = true;
			resultsFound++;
		}

		if (matchesSearch) {

			var speaker_full_name = this_speaker.speaker_first_name + ' ' + this_speaker.speaker_last_name;
			speaker_full_name = highlightWord(speaker_full_name, searchString);
			var speaker_subtitle = highlightWord(this_speaker.speaker_subtitle, searchString);

			if (inDescription) {
				selectedDesc = strip(strippedDescription);
				selectedDesc = excerpt(selectedDesc, searchString);
				selectedDesc = highlightWord(selectedDesc, searchString);
			}

			resultHtml += '<div class="search_result_element_div clearfix" onclick="loadSpeakerDetail(' + this_speaker.speaker_id + ',false);">';
			resultHtml += '<div class="icon_result_type"><span class="cg-icon font_color_dark cg-icon-speakers"></span></div>';
			resultHtml += '<div class="result_content">';
			resultHtml += '<div class="result_title kinda_title_color font_bold font_color_dark">' + speaker_full_name + '</div>';
			resultHtml += '<div class="result_subtitle kinda_subtitle font_color_gray_1">' + speaker_subtitle + '</div>';
			if (inDescription) {
				resultHtml += '<div class="result_subtitle kinda_subtitle font_color_gray_1">' + selectedDesc + '</div>';
			}
			resultHtml += '</div>';
			resultHtml += '</div>';
		}
	});


	// EXHIBITORS

	$.each(this_congress.congress_information.congress_exhibitors, function(index, this_exhibitor_id) {

		var this_exhibitor = this_congress.exhibitors_information['' + this_exhibitor_id];

		var this_exhibitor_type;

		if (this_exhibitor.exhibitor_type) {
			this_exhibitor_type = exhibitor_types_information['' + this_exhibitor.exhibitor_type];
		}

		console.log('Evaluating speaker: ' + this_exhibitor.exhibitor_name);
		var matchesSearch = false;
		if (removeDiacritics(this_exhibitor.exhibitor_name).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		} else if (this_exhibitor_type && removeDiacritics(this_exhibitor_type.exhibitor_type_name).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		} else if (this_exhibitor.exhibitor_description && removeDiacritics(this_exhibitor.exhibitor_description).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		} else if (this_exhibitor.exhibitor_subtitle && removeDiacritics(this_exhibitor.exhibitor_subtitle).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		}

		if (matchesSearch) {

			var exhibitor_name = highlightWord(this_exhibitor.exhibitor_name, searchString);
			var exhibitor_subtitle = highlightWord(this_exhibitor.exhibitor_subtitle, searchString);

			resultHtml += '<div class="search_result_element_div clearfix" onclick="loadExhibitorDetail(' + this_exhibitor.exhibitor_id + ',false);">';
			resultHtml += '<div class="icon_result_type"><span class="cg-icon font_color_dark cg-icon-exhibitors"></span></div>';
			resultHtml += '<div class="result_content">';
			resultHtml += '<div class="result_title kinda_title_color font_bold font_color_dark">' + exhibitor_name + '</div>';

			if (this_exhibitor.exhibitor_subtitle) {
				resultHtml += '<div class="result_subtitle kinda_subtitle font_color_gray_1">' + exhibitor_subtitle + '</div>';
			}
			resultHtml += '</div>';
			resultHtml += '</div>';
		}
	});


	// SEARCH POSTERS

	$.each(this_congress.congress_information.congress_posters, function(index, this_poster_id) {
		var inDescription = false;
		var this_poster = this_congress.posters_information['' + this_poster_id];
		console.log('Evaluating poster: ' + this_poster.poster_title);
		var matchesSearch = false;
		if (this_poster.poster_title && removeDiacritics(this_poster.poster_title).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		}
		if (this_poster.poster_description && removeDiacritics(this_poster.poster_description).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			inDescription = true;
			resultsFound++;
		}

		if (matchesSearch) {

			var poster_title = highlightWord(this_poster.poster_title, searchString);
			var selectedDesc = '';
			if (inDescription) {
				selectedDesc = strip(this_poster.poster_description);
				selectedDesc = excerpt(selectedDesc, searchString);
				selectedDesc = highlightWord(selectedDesc, searchString);
			}

			resultHtml += '<div class="search_result_element_div clearfix" onclick="loadPosterDetail(' + this_poster.poster_id + ',false);">';
			resultHtml += '<div class="icon_result_type"><span class="cg-icon font_color_dark cg-icon-posters"></span></div>';
			resultHtml += '<div class="result_content">';
			resultHtml += '<div class="result_title kinda_title_color font_bold font_color_dark">' + poster_title + '</div>';
			if (inDescription) {
				resultHtml += '<div class="result_subtitle kinda_subtitle font_color_gray_1">' + selectedDesc + '</div>';
			}
			resultHtml += '</div>';
			resultHtml += '</div>';
		}
	});

	// SEARCH SESSIONS

	$.each(this_congress.sessions_information, function(index, this_session) {

		var inDescription = false;
		var strippedDescription = strip(this_session.session_description);

		if (!this_session || !this_session.session_title) {
			return true;
		}
		console.log('Evaluating session: ' + this_session.session_title);
		var matchesSearch = false;
		if (this_session.session_title && removeDiacritics(this_session.session_title).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		} else if (this_session.session_description && removeDiacritics(strippedDescription).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			inDescription = true;
			resultsFound++;
		} else if (removeDiacritics(this_session.session_subtitle).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		}

		if (matchesSearch) {

			var session_title = highlightWord(this_session.session_title, searchString);
			var session_subtitle = highlightWord(this_session.session_subtitle, searchString);
			var selectedDesc = '';
			if (inDescription) {
				selectedDesc = strippedDescription;
				selectedDesc = excerpt(selectedDesc, searchString);
				selectedDesc = highlightWord(selectedDesc, searchString);
			}

			resultHtml += '<div class="search_result_element_div clearfix" onclick="loadSessionDetail(' + this_session.session_id + ',false);">';
			resultHtml += '<div class="icon_result_type "><span class="cg-icon font_color_dark cg-icon-program"></span></div>';
			resultHtml += '<div class="result_content">';
			resultHtml += '<div class="result_title kinda_title_color font_bold font_bold font_color_dark">' + session_title + '</div>';
			resultHtml += '<div class="result_subtitle kinda_subtitle font_color_gray_1">' + session_subtitle + '</div>';
			if (inDescription) {
				resultHtml += '<div class="result_subtitle kinda_subtitle font_color_gray_1">' + selectedDesc + '</div>';
			}
			resultHtml += '</div>';
			resultHtml += '</div>';
		}
	});

	// SEARCH POI

	$.each(this_congress.congress_information.congress_poi, function(index, this_poi_id) {

		var this_poi = this_congress.poi_information['' + this_poi_id];
		var poi_name = highlightWord(this_poi.poi_name, searchString);


		console.log('Evaluating session: ' + this_poi.poi_name);
		var matchesSearch = false;
		if (this_poi.poi_name && this_poi.poi_name.toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		}

		if (matchesSearch) {


			resultHtml += '<div class="search_result_element_div clearfix" onclick="loadPOIDetail(' + this_poi.poi_id + ',false);">';
			resultHtml += '<div class="icon_result_type"><span class="cg-icon font_color_dark cg-icon-points-of-interest"></span></div>';
			resultHtml += '<div class="result_content">';
			resultHtml += '<div class="result_title kinda_title_color font_bold font_color_dark">' + poi_name + '</div>';
			resultHtml += '</div>';
			resultHtml += '</div>';
		}
	});


	// SEARCH SPONSORS

	$.each(this_congress.sponsors_information, function(index, this_sponsor) {

		console.log('Evaluating session: ' + this_sponsor.sponsor_name);
		var matchesSearch = false;
		if (this_sponsor.sponsor_name && this_sponsor.sponsor_name.toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		} else if (this_sponsor.sponsor_description && this_sponsor.sponsor_description.toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		}

		if (matchesSearch) {
			resultHtml += '<div class="search_result_element_div clearfix" onclick="loadSponsorDetail(' + this_sponsor.sponsor_id + ',false);">';
			resultHtml += '<div class="icon_result_type"><span class="cg-icon font_color_dark cg-icon-sponsors"></span></div>';
			resultHtml += '<div class="result_content">';
			resultHtml += '<div class="result_title kinda_title_color font_bold font_color_dark">' + this_sponsor.sponsor_name + '</div>';
			resultHtml += '</div>';
			resultHtml += '</div>';
		}
	});

	// SEARCH AREAS

	$.each(this_congress.areas_information, function(index, this_area) {
		var inDescription = false;
		var strippedDescription = strip(this_area.area_description);

		console.log('Evaluating area: ' + this_area.area_title);
		var matchesSearch = false;
		if (this_area.area_title && removeDiacritics(this_area.area_title).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			resultsFound++;
		}
		if (this_area.area_description && removeDiacritics(strippedDescription).toLowerCase().indexOf(searchString.toLowerCase()) > -1) {
			matchesSearch = true;
			inDescription = true;
			resultsFound++;
		}

		if (matchesSearch) {

			var area_title = highlightWord(this_area.area_title, searchString);
			var selectedDesc = '';
			if (inDescription) {
				selectedDesc = strippedDescription;
				selectedDesc = excerpt(selectedDesc, searchString);
				selectedDesc = highlightWord(selectedDesc, searchString);
			}

			resultHtml += '<div class="search_result_element_div clearfix" onclick="loadCustomArea(' + this_area.area_id + ',false);">';
			resultHtml += '<div class="icon_result_type"><span class="cg-icon font_color_dark cg-icon-circle"></span></div>';
			resultHtml += '<div class="result_content">';
			resultHtml += '<div class="result_title kinda_title_color font_bold font_color_dark">' + area_title + '</div>';
			if (inDescription) {
				resultHtml += '<div class="result_subtitle kinda_subtitle font_color_gray_1">' + selectedDesc + '</div>';
			}
			resultHtml += '</div>';
			resultHtml += '</div>';
		}
	});


	$('#actual_results').html(resultHtml);
	$('#search_searching_div').hide();
	$('#search_input_text').blur();
	SEARCH_STRING = searchString;


	$('#search_searching_div').html('');
}

function excerpt(selectedDesc, searchString) {
	var size = 100;
	var excerpt_start = 0;
	var excerpt_size = searchString.length;

	var start = removeDiacritics(selectedDesc).toLowerCase().indexOf(removeDiacritics(searchString).toLowerCase());
	if ((start - size) > 0) {
		excerpt_start = start - size;
		excerpt_size += size;
	}

	var excerpt_end = start + searchString.length;

	if ((excerpt_start + size) < selectedDesc.length) {
		excerpt_end = excerpt_start + size;
		excerpt_size += size;
	} else {
		excerpt_size = (selectedDesc.length - excerpt_start - searchString.length);
	}

	return "... " + selectedDesc.substr(excerpt_start, excerpt_size) + " ...";
}

function strip(html) {
	var tmp = document.createElement("DIV");
	tmp.innerHTML = html;
	return tmp.textContent || tmp.innerText || "";
}

function loadHighlightsIndex(fromHistory) {
	console.log('loading posters index');

	var isCurrent = ($('#highlightsIndex.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var highlightsIndexHtml = '';

	highlightsIndexHtml += '<div class="normal_page scroll ' + initialPosition + '" id="highlightsIndex">';
	highlightsIndexHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">Produtos em Destaque</div>';
	highlightsIndexHtml += '<div id="highlightsIndexSwipe" style="max-width:100%;margin:0 auto" class="swipe">';
	highlightsIndexHtml += '<div class="swipe-wrap">';

	console.log('iterating posters');
	$.each(this_congress.congress_information.congress_posters, function(index_poster, poster_id) {
		console.log('');
		var this_poster = this_congress.posters_information['' + poster_id];



		console.log('poster image...');
		highlightsIndexHtml += '<div class="page_swipe">';
		highlightsIndexHtml += '<div onclick="doZoomOnImage(\'' + this_poster.poster_image + '\')" class="poster_image_div">';
		highlightsIndexHtml += '<img src="' + fsRoot + '/' + this_poster.poster_image + '" />';
		highlightsIndexHtml += '</div>';
		console.log('poster title...');
		highlightsIndexHtml += '<div class="gradient_background_gray">';
		highlightsIndexHtml += '<div class="division_gray_double_line"></div>';
		highlightsIndexHtml += '<div class="poster_title font_bold">' + this_poster.poster_title + '</div>';
		console.log('poster author...');
		var this_author = this_congress.speakers_information['' + this_poster.poster_author_id];
		highlightsIndexHtml += '<div class="poster_author_name">Autores: ' + this_author.speaker_last_name + ' , ' + this_author.speaker_first_name + '</div>';

		highlightsIndexHtml += '<div style="clear:both;"></div>';
		highlightsIndexHtml += '<div class="division_gray"></div>';
		highlightsIndexHtml += '<div class="poster_description description">' + this_poster.poster_description + '</div>';
		highlightsIndexHtml += '</div>';

		highlightsIndexHtml += '</div>';




	});

	highlightsIndexHtml += '</div>';
	highlightsIndexHtml += '</div>';
	highlightsIndexHtml += '</div>';

	$('#highlightsIndex').remove();

	$('.mainDiv').append(highlightsIndexHtml);

	var elem = document.getElementById('highlightsIndexSwipe');
	window.highlightsSwipe = Swipe(elem, {
		lockDirection: false
	});

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('highlightsIndex');", 1);
		} else {
			setTimeout("bringforward('highlightsIndex');", 1);
		}
	} else {
		onPageChanged();
	}
}

function closeModal() {
	$('.modal_page').removeClass('show');
	closeSockets();
	setTimeout(function() {
		checkMandatory();
	}, 300);

}

function closeSockets() {
	if (polling_socket) {
		polling_socket.disconnect();
	}
	if (moderation_socket) {
		if(mixer){ mixer.destroy(); }
		moderation_socket.disconnect();
	}
	if (chat_rooms.room.socket) {
		chat_rooms.room.socket.disconnect();
	}
}

function getSessionQuestionnaires(session_id) {
	var params = {
		f: 'getSessionQuestionnaires',
		session_id: session_id,
		user_id: user_data.profile.user_id,
		event_id: this_congress.congress_information.congress_id,
		locale: this_congress.congress_information.congress_lang
	};

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('getSessionQuestionnaires calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function questionnairesRetrieved(response) {
			console.log('response: ' + JSON.stringify(response));

			var questionnaires = response.object;
			var questionnairesHtml = '';

			if (questionnaires) {

				if (questionnaires.length > 0) {
					questionnairesHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-session-questionnaires') + '</div>';

				}
				$.each(questionnaires, function(index, this_questionnaire) {
					var checkedModifier = '';

					var feedback_object = {};
					feedback_object.feedback_id = this_questionnaire.feedback_id;
					feedback_object.feedback_title = this_questionnaire.feedback_title;
					feedback_object.session_id = this_questionnaire.session_id;
					feedback_object.questions = [];
					$.each(this_questionnaire.questions, function(index, this_question) {
						var question_object = {};
						question_object.question_text = this_question.question_text;
						question_object.question_id = this_question.question_id;
						question_object.feedback_id = this_question.feedback_id;
						feedback_object.questions.push(this_question.question_id);
						question_object.options = [];
						$.each(this_question.options, function(index, this_option) {
							var option_object = {};
							option_object.option_id = this_option.option_id;
							option_object.option_text = this_option.option_text;
							question_object.options.push(this_option.option_id);
							this_congress.options_information['' + this_option.option_id] = option_object;
						});
						this_congress.questions_information['' + this_question.question_id] = question_object;
					});

					this_congress.feedback_information['' + this_questionnaire.feedback_id] = feedback_object;

					if (user_data.profile.feedback['' + this_questionnaire.feedback_id]) {
						checkedModifier = 'selected';
					}

					questionnairesHtml += '<div id="feedback_element_' + this_questionnaire.feedback_id + '" class="border_top_color_dark feedback_element feedbackInfo list_element ' + checkedModifier + '" onclick="loadFeedbackDetail(' + this_questionnaire.feedback_id + ');">';

					questionnairesHtml += '<td><div class="feedback_name kinda_title_color font_bold font_color_dark">' + this_questionnaire.feedback_title + '</div>';
					questionnairesHtml += '<div class="feedback_short_description kinda_subtitle font_color_gray_1">' + this_questionnaire.questions.length + ' ' + trd('questions') + '</div></td></tr></table>';
					questionnairesHtml += '<div class="add_session_to_favourites"><span class="cg-icon cg-icon-check font_color_dark cg-icon-size-16"></span></div>';
					questionnairesHtml += '</div>';
				});

				$('#session_questionnaires').html(questionnairesHtml);
			} else {
				questionnairesHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-session-questionnaires') + '</div>';
				questionnairesHtml += '<div class="no_questions font_color_dark">' + trd('no-open-questionnaires') + '</div>';

				$('#session_questionnaires').html(questionnairesHtml);
			}
			var hasOpenQuestion = false;
			$.each(questionnaires, function(index, this_feedback) {
				if (this_feedback.open_poll == "1") {
					refreshOpenQuestion(this_feedback.questions[0]);
					hasOpenQuestion = true;
					return false;
				}
			});

			if (!hasOpenQuestion) {
				$('.polling_no_questions').show();
				$('.polling_answered_question').hide();
				$('.question_polling_detail').remove();
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('ERROR xhr:' + JSON.stringify(xhr));
			console.log('ERROR ajaxOptions:' + JSON.stringify(ajaxOptions));
			console.log('ERROR thrownError:' + JSON.stringify(thrownError));
		}
	});

}

function refreshOpenQuestion(this_question) {
	var questionDetailHtml = '';
	var feedback_id = this_question.feedback_id;

	if (user_data.profile.feedback['' + this_question.feedback_id] && user_data.profile.feedback['' + this_question.feedback_id]['' + this_question.question_id]) {
		$('#question_detail_' + this_question.question_id).remove();
		$('.polling_answered_question').show();
		$('.polling_no_questions').hide();
		console.log('TODO THANKS FOR RESPONSE!');
		return;
	} else if ($('#question_detail_' + this_question.question_id).length > 0) {
		console.log('already showing question ' + this_question.question_id);
		return;
	} else {
		questionDetailHtml += '<div class="question_polling_detail" id="question_detail_' + this_question.question_id + '">';
		questionDetailHtml += '<div class="question_text font_color_dark">' + this_question.question_text + '</div>';

		questionDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';

		$.each(this_question.options, function(index, this_option) {

			var selectedMod = '';
			if (user_data.profile.feedback['' + feedback_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] == this_option.option_id) {
				selectedMod = 'selected';
			}

			questionDetailHtml += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element ' + selectedMod + '" id="option_element_' + this_option.option_id + '" onclick="confirmOption(\'' + this_option.option_text + '\',' + this_question.feedback_id + ',' + this_question.question_id + ',' + this_option.option_id + ', true);"><table><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
		});
		questionDetailHtml += '</div>';
	}


	$('#session_questionnaires_modal').html(questionDetailHtml);
	$('.polling_no_questions').hide();
}

function stringEscape(s) {
	return s ? s.replace(/\\/g, '\\\\').replace(/\n/g, '\\n').replace(/\t/g, '\\t').replace(/\v/g, '\\v').replace(/'/g, "\\'").replace(/"/g, '\\"').replace(/[\x00-\x1F\x80-\x9F]/g, hex) : s;

	function hex(c) {
		var v = '0' + c.charCodeAt(0).toString(16);
		return '\\x' + v.substr(v.length - 2);
	}
}

function confirmOption(option_text, feedback_id, question_id, option_id, is_polling, session_id) {
	if (isMobile) {
		navigator.notification.confirm(
			option_text,
			function(button) {
				if (button == 2) {
					selectOption(feedback_id, question_id, option_id, is_polling, session_id);
				}
			},
			trd('confirm-option-title'), [trd('confirm-option-cancel'), trd('confirm-option-confirm')]);
	} else {
		if (confirm(trd('confirm-option-title') + ' ' + option_text)) {
			selectOption(feedback_id, question_id, option_id, is_polling, session_id);
		}
	}
}

var session_questions = [];
var moderation_socket = null;
var container;
var mixer;

function showSessionQuestionModal(session_id) {
	var this_session = this_congress.sessions_information['' + session_id];
	var modalHtml = '<div class="session_question normal_page scroll">';
	modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-write-question') + '</div>';
	// modalHtml += '<div class="explanation font_color_dark">' + trd('explain-write-question') + '</div>';
	modalHtml += '<div class="input_question_container border_color_dark"><textarea id="session_question_text" class="input_question" maxlength="500" placeholder="' + trd('explain-write-question') + '"></textarea></div>';
	modalHtml += '<div class="button_send_question font_color_white color_bg_division_2" onclick="sendSessionQuestion(' + this_session.session_id + ');">' + trd('send-question') + '</div>';
	if (this_session.has_moderation == '1') {
		modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-user-questions') + '</div>';
		modalHtml += '<div id="user_questions"></div>';
	}
	if (this_session.has_moderation == '2') {
		modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-all-questions') + '</div>';
		modalHtml += '<div id="all_questions"><div class="mod_no_questions font_color_gray_4" style="display:none; margin-top:60px;text-align:center;width100%;">' + trd('no-questions') + '</div></div>';
	}
	modalHtml += '</div>';
	modalHtml += '<div id="socket_connection_status" class="off"></div>';
	modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom keyboard_hides" onclick="closeModal()">' + trd('close-questions') + '</div>';

	$('.modal_page').html(modalHtml);
	$('.modal_page').addClass('show');


	if (this_session.has_moderation && this_session.has_moderation == "2") {
		container = document.querySelector('#all_questions');
		mixer = mixitup(container, {
			data: {
				uidKey: 'question_id',
				dirtyCheck: true
			},
			render: {
				target: render
			},
			selectors: {
				target: '.mixer_container'
			}
		});
	}

	openModerationSocket(session_id);
}

function sendSessionQuestion(session_id) {
	var question_text = $('#session_question_text').val();

	if (!question_text || question_text == '' || question_text.length < 5) {
		showToastrAlert('error', trd('question-too-short'));
		return;
	}
	var question = {
		user_id: user_data.profile.user_id,
		congress_id: this_congress.congress_information.congress_id,
		session_id: session_id,
		question_text: question_text
	}

	moderation_socket.emit('new_question', question);
	$('#session_question_text').val('');
}


function toggleQuestionLike(session_id, question_id) {
	var likes = $('#question_container_' + question_id + ' .question_likes');

	if ($('#question_like_button_' + question_id).hasClass('on')) {
		$('#question_like_button_' + question_id).removeClass('on')
		likes.html(parseInt(likes.html()) - 1);
	} else {
		$('#question_like_button_' + question_id).addClass('on')
		likes.html(parseInt(likes.html()) + 1);
	}
	var vote = {
		user_id: user_data.profile.user_id,
		session_id: session_id,
		question_id: question_id
	}
	moderation_socket.emit('vote', vote);
}


function openModerationSocket(session_id) {
	moderation_socket = io.connect('http://94.46.160.248:3001');

	moderation_socket.on('connect', function() {
		$('#socket_connection_status').removeClass('off');
		moderation_socket.emit('client', session_id);
	});

	moderation_socket.on('get_list', function(question_list) {
		this_session = this_congress.sessions_information['' + session_id];
		question_list = question_list.filter(function(question) {
			return !(question.was_dismissed == "1" && question.user_id != user_data.profile.user_id);
		});
		if (this_session.has_moderation == "1") {
			userQuestionsHtml = '';
			if (question_list && question_list.length > 0) {
				$.each(question_list, function(index, question) {
					if (question.user_id == user_data.profile.user_id) {
						userQuestionsHtml += '<div class="user_question border_bottom_color_dark font_color_dark">';
						userQuestionsHtml += question.question_text;
						userQuestionsHtml += '</div>';
					}
				});
			}
			if (userQuestionsHtml == '') {
				userQuestionsHtml = '<div class="no_questions font_color_dark">' + trd('no-user-questions') + '</div>';
			}
			$('#user_questions').html(userQuestionsHtml);
		} else if (this_session.has_moderation == "2") {
			question_list.sort(function(a, b) {
				var wda = parseInt(a.was_dismissed);
				var wdb = parseInt(b.was_dismissed);
				if (wda - wdb)
					return wda - wdb;
				var va = parseInt(a.likes)
				var vb = parseInt(b.likes)
				if (vb - va)
					return vb - va;
				var da = new Date(stringToDate(a.question_timestamp)).getTime();
				var db = new Date(stringToDate(b.question_timestamp)).getTime();
				return db - da;
			});
			mixer.dataset(question_list)
			//$('.mod_no_questions').remove();
			if (question_list.length == 0) {
				$('.mod_no_questions').show();
				//$('#all_questions').html('<div class="mod_no_questions font_color_gray_4" style="margin-top:60px;text-align:center;width100%;">' + trd('no-questions') + '</div>');
			} else
				$('.mod_no_questions').hide();

		}
	});

	moderation_socket.on('question_add', function(question) {
		showToastrAlert('success', trd('moderation-question-submitted'));
	});

	moderation_socket.on('disconnect', function() {
		$('#socket_connection_status').addClass('off');
	});
}

function getSessionQuestionById(question_id) {
	var output = null;
	session_questions.forEach(function(question) {
		if (question.question_id == question_id) {
			output = question;
		}
	});
	return output;
}


function render(question) {
	var user_liked = (question.users.indexOf('' + user_data.profile.user_id) > -1 ? 'on' : '');
	var user_submited = '';
	if (question.user_id == user_data.profile.user_id) {
		user_submited = '<span style="font-size: 12px;line-height: 12px;vertical-align: middle;"> (' + trd('question-submitted');
		if (question.was_dismissed)
			user_submited += ', ' + trd('question-discarded') + ')'
		else
			user_submited += ')</span>';
	}
	var questionsHtml = '';
	questionsHtml += '<div class="mixer_container">';
	questionsHtml += '<div id="question_container_' + question.question_id + '" class="question_card font_color_dark" style="' + (question.was_dismissed == '1' ? 'opacity:.6' : '') + '">';
	questionsHtml += '<div class="question_card_top" >' + question.question_text + '</div>';
	questionsHtml += '<div class="question_card_bottom"><div class="question_timestamp">' + question.question_timestamp.split(" ")[1] + user_submited + '</div>';
	questionsHtml += '<div onclick="toggleQuestionLike(' + question.session_id + ',' + question.question_id + ')" style="display:inline-block;float:right;"><div class="question_likes">' + question.likes + '</div>';
	questionsHtml += '<div id="question_like_button_' + question.question_id + '" class="question_like_button ' + user_liked + '"></div></div>';
	questionsHtml += '</div>';
	questionsHtml += '</div>';
	questionsHtml += '</div>';
	return questionsHtml;
};

function getInstantFeedback(feedback_id) {
	var params = {
		f: 'getFeedbacks',
		event_info: {
			id: this_congress.congress_information.congress_id,
			lang: this_congress.congress_information.congress_lang
		},
		feedback_id: feedback_id
	};

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);
	showLoadingOverlay();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function feedbackRetrieved(response) {
			hideLoadingOverlay();
			if (response.success) {
				var feedbacks = response.object;
				$.each(feedbacks.feedback_information, function(index, this_feedback) {
					this_congress.feedback_information['' + this_feedback.feedback_id] = this_feedback;
					if (!array_contains(this_congress.congress_information.congress_feedback, this_feedback.feedback_id)) {
						this_congress.congress_information.congress_feedback.push(this_feedback.feedback_id);
					}
				});
				$.each(feedbacks.questions_information, function(index, this_question) {
					this_congress.questions_information['' + this_question.question_id] = this_question;
				});
				$.each(feedbacks.options_information, function(index, this_option) {
					this_congress.options_information['' + this_option.option_id] = this_option;
				});

				var this_feedback = this_congress.feedback_information['' + feedback_id];
				if (this_feedback.questions.length >= 2 || true) {
					showFeedbackModal(feedback_id, false);
				} else {
					showInstantFeedback(feedback_id);
				}
			} else {
				//cgAlert(trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
		}
	});
}

function showInstantFeedback(feedback_id) {
	var this_feedback = this_congress.feedback_information['' + feedback_id];
	var this_question = this_congress.questions_information['' + this_feedback.questions[0]];

	var modalHtml = '';

	var mainDivWidth = $('.mainDiv').width();
	modalHtml += '<div id="session_questionnaires_modal"></div>';
	if (this_question.question_type != 'write') {
		var onclick_close = 'closeModal()';
	} else {
		var onclick_close = 'finishedFeedback(' + feedback_id + ', true)';
	}
	//modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom" onclick="'+onclick_close+'">' + trd('bt-close-window') + '</div>';

	//$('.modal_page').html(modalHtml);
	//$('.modal_page').addClass('show');
	//

	showModalHtml(true, modalHtml, true);


	var questionDetailHtml = '';
	questionDetailHtml += '<div class="question_polling_detail" id="question_detail_' + this_question.question_id + '">';
	questionDetailHtml += '<div class="question_text font_color_dark">' + this_question.question_text + '</div>';

	questionDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';

	if (this_question.question_type == 'select_one') {
		$.each(this_question.options, function(index, this_option_id) {
			var this_option = this_congress.options_information['' + this_option_id];
			questionDetailHtml += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element" id="option_element_' + this_option.option_id + '" onclick="selectInstantOption(' + this_question.question_id + ',' + this_option.option_id + ',\'select_one\')"><table><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
		});
	} else if (this_question.question_type == 'select_many') {
		$.each(this_question.options, function(index, this_option_id) {
			var this_option = this_congress.options_information['' + this_option_id];
			questionDetailHtml += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element" id="option_element_' + this_option.option_id + '" onclick="this.classList.toggle(\'selected\')"><table><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
		});
		questionDetailHtml += '<div class="btn-done font_bold color_bg_division_2" onclick="selectInstantOption(' + this_question.question_id + ',0,\'select_many\');">' + trd('finish-questionnaire') + '</div>';

	} else {
		var mainDivWidth = $('.mainDiv').width();
		questionDetailHtml += '<textarea maxlength="300" placeholder="' + trd('answer-text-placeholder') + '" class="answer_text" id="answer_text_' + this_question.question_id + '" style="width:' + (mainDivWidth - 10) + 'px;height:200px;margin:auto;border:0;background-color:transparent;padding: 20px;"></textarea>';
		questionDetailHtml += '<div class="btn-done font_bold color_bg_division_2" onclick="selectInstantOption(' + this_question.question_id + ',0,\'write\');">' + trd('finish-questionnaire') + '</div>';

	}

	questionDetailHtml += '</div>';

	$('#session_questionnaires_modal').html(questionDetailHtml);

}

function showFeedbackModal(feedback_id, dismissable) {
	var this_feedback = this_congress.feedback_information['' + feedback_id];

	var modalHtml = '';

	var mainDivWidth = $('.mainDiv').width();
	modalHtml += '<div id="feedback_modal" style="position:absolute;top:0;left:0;bottom:42px;right:0;overflow:hidden;-webkit-overflow-scrolling: touch;overflow-y: scroll;"></div>';

	modalHtml += '<div class="button_cancel next_question_button_modal font_color_white color_bg_division_2 modal_button_bottom" style="display:none" onclick="">' + trd('bt-modal-next-question') + '</div>';
	modalHtml += '<div class="button_cancel finish_feedback_button_modal font_color_white color_bg_division_2 modal_button_bottom" style="display:none" onclick="finishedFeedback(' + feedback_id + ',true)">' + trd('bt-modal-finish-feedback') + '</div>';


	$('.modal_page').html(modalHtml);
	$('.modal_page').addClass('show');

	loadQuestionDetailModal(this_feedback.questions[0]);
}

function nextQuestionModal(feedback_id, this_question_index) {
	var this_feedback = this_congress.feedback_information['' + feedback_id];
	var this_question_id = this_feedback.questions[this_question_index];
	var this_question = this_congress.questions_information['' + this_question_id];

	if (this_question.mandatory && this_question.mandatory == '1') {
		if ($('.option_element').length > 0 && $('.option_element.selected').length == 0) {
			showToastrAlert('warning', trd('must-answer-question') + '');
			return;
		} else if ($('.answer_text').length > 0 && $('.answer_text').val() == '') {
			showToastrAlert('warning', trd('must-answer-question') + '');
			return;
		}
	}
	var next_question_id = this_feedback.questions[(this_question_index + 1)];
	loadQuestionDetailModal(next_question_id, false);
}

function loadQuestionDetailModal(question_id) {

	var this_question = this_congress.questions_information['' + question_id];
	var this_feedback = this_congress.feedback_information['' + this_question.feedback_id];
	var feedback_id = this_question.feedback_id;

	var this_question = this_congress.questions_information['' + question_id];


	var questionDetailHtml = '';
	questionDetailHtml += '<div class="question_polling_detail" id="question_detail_' + this_question.question_id + '">';
	questionDetailHtml += '<div class="question_text font_color_dark">' + this_question.question_text + '</div>';

	questionDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';

	if (this_question.question_type == 'select_one') {
		$.each(this_question.options, function(index, this_option_id) {
			var this_option = this_congress.options_information['' + this_option_id];
			questionDetailHtml += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element" id="option_element_' + this_option.option_id + '" onclick="selectOption(' + this_question.feedback_id + ',' + this_question.question_id + ',' + this_option.option_id + ');"><table><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
		});
	} else if (this_question.question_type == 'select_many') {
		$.each(this_question.options, function(index, this_option_id) {
			var this_option = this_congress.options_information['' + this_option_id];
			questionDetailHtml += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element" id="option_element_' + this_option.option_id + '" onclick="selectOptionMultiple(' + this_question.feedback_id + ',' + this_question.question_id + ',' + this_option.option_id + ');"><table><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
		});
	} else {
		var mainDivWidth = $('.mainDiv').width();
		questionDetailHtml += '<textarea maxlength="300" placeholder="' + trd('answer-text-placeholder') + '" class="answer_text" id="answer_text_' + this_question.question_id + '" onkeyup="saveAnswerText(' + this_question.feedback_id + ',' + this_question.question_id + ')" style="width:' + (mainDivWidth - 10) + 'px;height:200px;margin:auto;border:0;background-color:transparent;padding: 20px;"></textarea>';
	}
	questionDetailHtml += '</div>';


	var this_question_index = this_feedback.questions.indexOf('' + question_id);
	if (this_question_index == this_feedback.questions.length - 1) {
		//questionDetailHtml += '<div class="btn-done font_bold color_bg_division_2" onclick="finishedFeedback(' + this_feedback.feedback_id + ');">' + trd('finish-questionnaire') + '</div>';
		$('.finish_feedback_button_modal').show();
		$('.next_question_button_modal').hide();
	} else {
		var next_question_id = this_feedback.questions[(this_question_index + 1)];
		//questionDetailHtml += '<div class="btn-done color_bg_division_2" onclick="nextQuestion(' + this_feedback.feedback_id + ',' + this_question_index + ');">' + trd('next-question') + '</div>';
		$('.finish_feedback_button_modal').hide();

		$('.next_question_button_modal').attr('onclick', 'nextQuestionModal(' + feedback_id + ',' + (this_question_index) + ');');
		$('.next_question_button_modal').show();
	}

	console.log(questionDetailHtml);
	$('#feedback_modal').html(questionDetailHtml);
}


function selectInstantOption(question_id, option_id, type) {
	console.log(question_id, option_id, type);
	var text = '';
	if (option_id && type == "select_one") {
		$('#option_element_' + option_id).addClass('selected');
	} else if (type == 'select_many') {
		text = '';
		$('#question_detail_' + question_id + ' .option_element.selected').each(function(i, el) {
			console.log(el);
			if (i > 0) {
				text += ',';
			}
			text += el.id.replace('option_element_', '');
		});

	} else if (type == 'write') {
		text = $('#answer_text_' + question_id).val();
	}
	if (!text && !option_id) {
		showToastrAlert('warning', trd('must-answer-question') + '');
		return;
	}

	var params = {
		f: 'answerPollNew',
		e: 'polls',
		params: {
			question_id: question_id,
			option_id: option_id,
			text: text,
			type: type,
			user_id: user_data.profile.user_id
		}
	};

	var url = services_home + 'backend/services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: params,
		success: function answered(response) {
			if (response.success) {
				setTimeout(function() {
					closeModal();
					showToastrAlert('success', trd('success-instant-question-answered'));
				}, 300);
			} else {
				setTimeout(function() {
					closeModal();
					showToastrAlert('error', trd('error-instant-question-already-answered'));
				}, 300);
			}
		},
		error: function(xhr, ajaxOptions, thrownError) {
			showToastrAlert('error', trd('quiz-response-error'));
		}
	});
}


function showEventQuestionModal() {
	var modalHtml = '<div class="session_question normal_page scroll">';
	modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-write-event-question') + '</div>';
	modalHtml += '<div class="explanation font_color_dark">' + trd('explain-write-event-question') + '</div>';
	modalHtml += '<div class="input_question_container border_color_dark"><textarea id="session_question_text" maxlength="140" class="input_question" placeholder="' + trd('placeholder-write-event-question') + '"></textarea></div>';
	modalHtml += '<div class="button_send_question font_color_white color_bg_division_2" onclick="sendSessionQuestion(0);">' + trd('send-question') + '</div>';
	modalHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-user-questions') + '</div>';
	modalHtml += '<div id="user_questions"></div>';
	modalHtml += '</div>';
	modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom keyboard_hides" onclick="closeModal()">' + trd('close-questions') + '</div>';
	$('.modal_page').html(modalHtml);
	$('.modal_page').addClass('show');
	getSessionQuestions(0);
}

function showPollingModal(session_id) {
	var modalHtml = '';
	var mainDivWidth = $('.mainDiv').width();
	modalHtml += '<div class="polling_modal" style="position:absolute;top:0;bottom:50px;left:0;right:0;overflow-y:auto" id="polling_modal_' + session_id + '">';
	modalHtml += '<div class="polling_no_questions"><table class="just_valign" style="text-align:center"><tr><td>' + trd('polling-no-open-questions') + '</td></tr></table></div>'
	modalHtml += '<div class="polling_answered_question" style="display:none;"><table class="just_valign" style="text-align:center"><tr><td>' + trd('polling-already-answered') + '</td></tr></table></div>'
	modalHtml += '<div id="session_questionnaires_modal"></div>';
	modalHtml += '</div>';
	modalHtml += '<div id="socket_connection_status" class="off"></div>';
	modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom" onclick="closeModal()">' + trd('bt-close-window') + '</div>';
	$('.modal_page').html(modalHtml);
	$('.modal_page').addClass('show');
	openPollingSocket(session_id);
}
var polling_socket = null;

function openPollingSocket(session_id) {
	polling_socket = io.connect('http://94.46.160.248:3002');
	polling_socket.on('connect', function() {
		polling_socket.emit('socket_connect', { session_id: session_id, type: 'client' });
		$('#socket_connection_status').removeClass('off');
	});
	polling_socket.on('vote_received', function(response) {
		if ($('#question_detail_' + response.question_id).length > 0) {
			$('#question_detail_' + response.question_id).hide();
			$('.polling_answered_question').show();
		}
		if (response.status) {
			showToastrAlert('success', trd('vote-received'));
		} else {
			showToastrAlert('error', trd('vote-error'));
		}
	});
	polling_socket.on('disconnect', function() {
		$('#socket_connection_status').addClass('off');
	});
	polling_socket.on('status', function(data) {
		console.log(data);
		updatePollingModal(data, session_id);
	});
}

function hexToRgbA(hex, op) {
	var c;
	if (/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)) {
		c = hex.substring(1).split('');
		if (c.length == 3) {
			c = [c[0], c[0], c[1], c[1], c[2], c[2]];
		}
		c = '0x' + c.join('');
		return 'rgba(' + [(c >> 16) & 255, (c >> 8) & 255, c & 255].join(',') + ',' + op + ')';
	}
	throw new Error('Bad Hex');
}

function updatePollingModal(data, session_id) {
	var this_question = data.question;
	var questionDetailHtml = '';
	$('.polling_answered_question').hide();
	$('.polling_no_questions').hide();

	if (!this_question.feedback_id || data.open_poll == false) {
		$('#session_questionnaires_modal').html(questionDetailHtml);
		$('.polling_no_questions').show();
		return;
	}
	var feedback_id = this_question.feedback_id;
	if (user_data.profile.feedback['' + this_question.feedback_id] && user_data.profile.feedback['' + this_question.feedback_id]['' + this_question.question_id]) {
		$('#question_detail_' + this_question.question_id).remove();
		$('.polling_answered_question').show();
		console.log('TODO THANKS FOR RESPONSE!');
		return;
	} else if ($('#question_detail_' + this_question.question_id).length > 0) {
		console.log('already showing question ' + this_question.question_id);
		return;
	} else {
		var colors = ['#4F6D7A', '#EADC96', '#C1B2AB', '#006992', '#60BFBF', '#F58276', '#5B504D', '#936E41', '#8C5383', '#725A51', '#CF4142', '#D4643A', '#E8BC34', '#ACD27B', '#5F9F78', '#606262', '#27162E', '#BF1F1B', '#C29855', '#6E6E1F', '#E3B53A', '#CE4B1C', '#B23C0D', '#18141D', '#343F26', '#1F6E67', '#5E9B2C', '#B5DB28', '#E3E561', '#2F3341', '#F65FAE', '#DFAA26', '#B8CD98', '#098BDE', '#99B31A', '#193D40', '#6C8E81', '#94B7C8', '#DADCDC', '#03AD64', '#5F9D88', '#9655B1', '#E9D9B0', '#D28D45', '#7A4F37', '#B8E2CB', '#E57467', '#FAE2A3', '#C9A979', '#606156'].map(function(color) {
			return hexToRgbA(color, .5);
		});
		questionDetailHtml += '<div class="question_polling_detail" id="question_detail_' + this_question.question_id + '">';
		questionDetailHtml += '<div class="question_text font_color_dark">' + this_question.question_text + '</div>';
		questionDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';
		$.each(this_question.options, function(index, this_option) {
			var selectedMod = '';
			if (user_data.profile.feedback['' + feedback_id] && user_data.profile.feedback['' + feedback_id]['' + this_question.question_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] == this_option.option_id) {
				selectedMod = 'selected';
			}
			questionDetailHtml += '<div class=" font_color_gray_1 option_element ' + selectedMod + '" id="option_element_' + this_option.option_id + '" onclick="confirmOption(\'' + stringEscape(htmlEntities(this_option.option_text)) + '\',' + this_question.feedback_id + ',' + this_question.question_id + ',' + this_option.option_id + ', true,' + session_id + ');"><table><tr><td><div class="option_letter" style="background-color: ' + colors[index] + '">' + String.fromCharCode(65 + index) + '</div></td><td style="padding:5px"><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
		});
		questionDetailHtml += '</div>';
	}
	$('#session_questionnaires_modal').html(questionDetailHtml);
}

function htmlEntities(str) {
	return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
}

function stringEscape(s) {
	return s ? s.replace(/\\/g, '\\\\').replace(/\n/g, '\\n').replace(/\t/g, '\\t').replace(/\v/g, '\\v').replace(/'/g, "\\'").replace(/"/g, '\\"').replace(/[\x00-\x1F\x80-\x9F]/g, hex) : s;

	function hex(c) { var v = '0' + c.charCodeAt(0).toString(16); return '\\x' + v.substr(v.length - 2); }
}


function showNoteModal(target_type, target_id) {
	var modalHtml = '';

	var mainDivWidth = $('.mainDiv').width();
	modalHtml += '<textarea maxlength="1000" placeholder="' + trd('note-content-placehoder') + '" id="note_text" style="width:' + (mainDivWidth - 10) + 'px;position:absolute;top:0;left:0;right:0;bottom:50px;padding:10px;margin:0;border:0;background-color:transparent;"></textarea>';

	modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom_right" onclick="saveNote(\'' + target_type + '\',' + target_id + ')">' + trd('button-save-note') + '</div>';
	modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom_left" onclick="closeModal()">' + trd('button-cancel-note') + '</div>';


	$('.modal_page').html(modalHtml);
	$('.modal_page').addClass('show');

	if (user_data.profile.notes[target_type]['' + target_id]) {
		$('#note_text').val(user_data.profile.notes[target_type]['' + target_id]);
	}

}

function saveNote(target_type, target_id) {
	var note_value = $('#note_text').val();
	console.log('PROFILE IS: ' + JSON.stringify(user_data.profile));
	if (!user_data.profile.notes[target_type]) {
		user_data.profile.notes[target_type] = {};
	}

	if (!note_value || note_value == '') {
		delete user_data.profile.notes[target_type]['' + target_id];
	} else {
		user_data.profile.notes[target_type]['' + target_id] = note_value;
	}
	saveUserDataToStorage();
	updateProfile();
	showToastrAlert("success", trd('note-saved'));
	closeModal();

	if ($('#myagenda.current').length > 0) {
		loadMyAgenda(MY_AGENDA_FILTER_NOTES);
	}
}

function showNewPostModal(search_text) {

	if (!user_data || user_data.profile.anonymous == "1") {
		after_login_action = 'new_post';
		loadAuthPage(false);
		return;
	}


	var modalHtml = '';

	var mainDivWidth = $('.mainDiv').width();
	modalHtml += '<div class="color_bg_division_1" style="color:white;padding:8px;font-size:10px;">';
	modalHtml += '<table style="width:100%;text-align:center;"><tr>';
	modalHtml += '<td onclick="takePhotoForFeed()">' + trd('option-post-take-a-photo') + '</td>';
	modalHtml += '<td onclick="choosePhotoForFeed();">' + trd('option-post-choose-photo') + '</td>';
	modalHtml += '<td onclick="closeModal();">' + trd('option-post-cancel') + '</td>';
	modalHtml += '</tr></table>';
	modalHtml += '</div>';
	modalHtml += '<div class="keyboard_hides" id="post_temp_img" onclick="choosePhotoMethod()" style="height:' + mainDivWidth + 'px;background-size:cover;background-color:gray;position:relative;"><div class="post_temp_img_placeholder"></div></div>';

	modalHtml += '<div class="keyboard_hides" id="frame_image_interface">';
	modalHtml += '<div id="frame_post_image" onclick="framePostImage()" class="font_color_white color_bg_division_1" style="width: 200px; height: 20px; margin-top: -30px; padding: 5px; text-align: center; position: absolute; right: 0; border-top: 1px solid white; border-left: 1px solid white; font-size: 14px; text-transform: uppercase;">' + trd('apply-frame') + '</div>';
	modalHtml += '<div id="unframe_post_image" onclick="unframePostImage()" class="font_color_white color_bg_division_1" style="width: 200px; height: 20px; margin-top: -30px; padding: 5px; text-align: center; position: absolute; right: 0; border-top: 1px solid white; border-left: 1px solid white; font-size: 14px; text-transform: uppercase;">' + trd('unapply-frame') + '</div>';
	modalHtml += '</div>';
	modalHtml += '<input type="hidden" id="post_img_src" value="" />';
	modalHtml += '<input type="hidden" id="post_img_url" value="" />';
	modalHtml += '<textarea maxlength="140" placeholder="' + trd('post-content-placehoder') + '" id="post_text" style="width:' + (mainDivWidth - 10) + 'px;height:120px;margin:auto;border:0;background-color:transparent;"></textarea>';

    if(search_text){ var new_post_search_text = "'" + search_text + "'"; }
    else{ var new_post_search_text = ""; }
	modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom" onclick="submitPhotoPostData(' + new_post_search_text + ')">' + trd('confirm-post-button') + '</div>';


	$('.modal_page').html(modalHtml);
	$('.modal_page').addClass('show');
	$('#frame_image_interface').hide();
}

function submitPhotoPostData(search_text) {
	// if ($('#post_img_src').val() == '') {
	//     showToastrAlert('error', trd('invalid-post-no-image'));
	//     return;
	// }

	/*if ($('#post_text').val() == ''){
	  cgAlert(trd('invalid-post-no-text'));
	  return;
	}*/

	var this_post = {
		text: $('#post_text').val()
	}
	if (search_text && search_text != '' && search_text.indexOf('#') > -1) { this_post.text += ' ' + search_text; } //adds hashtag 
	if ($('#post_img_src').val()) { this_post.image = $('#post_img_src').val(); }

	if ($('#frame_post_image').css('display') == 'none') { this_post.image = $('#post_img_url').val(); }


	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	showLoadingOverlay();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				f: 'postToFeed2',
				user_data: user_data,
				event_info: {
					id: this_congress.congress_information.congress_id,
					lang: this_congress.congress_information.congress_lang
				},
				post_data: this_post
			},

		},
		dataType: 'json',
		success: function photoPosted(response) {
			hideLoadingOverlay();
			console.log('got response:' + JSON.stringify(response));
			if (response.success) {
				closeModal();
				refreshFeed(search_text);
				showToastrAlert('success', trd('success-image-posted-to-feed'));
			} else {
				showToastrAlert('error', trd('error-could-not-save-profile'));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got error: ' + JSON.stringify(xhr));
		}
	});

}

function loadSessionDetail(session_id, fromHistory) {
	if (page_moving) {
		console.log('cant start, page is moving');
		return;
	} else {
		page_moving = true;
	}



	setSelectedMenuArea('program');
	console.log('loading session detail for session ' + session_id);


	var this_session = this_congress.sessions_information['' + session_id];

	var isCurrent = ($('#session_detail_' + session_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var sessionDetailHtml = '';

	sessionDetailHtml += '<div class="normal_page session_detail ' + initialPosition + '" id="session_detail_' + session_id + '">';
	if (this_session.show_actions && this_session.show_actions == "2") {
		sessionDetailHtml += '<div class="scroll" style="position:absolute;left:0;bottom:0;top:0;right:0;padding-bottom:80px;">';
	} else {
		sessionDetailHtml += '<div class="scroll" style="position:absolute;left:0;bottom:0;top:0;right:0;">';
	}
	sessionDetailHtml += '<div class="scroll_lock">';
	var sessionImageUrl = '';
	if (this_congress.media_information['session'] && this_congress.media_information['session']['' + this_session.session_id]) {
		var session_media = this_congress.media_information['session']['' + session_id];

		if (session_media.offline) {
			sessionImageUrl = fsRoot + '/' + session_media.name;
		} else {
			sessionImageUrl = session_media.imgURL_original;
		}
		sessionDetailHtml += '<div class="session_banner"><img src="' + sessionImageUrl + '" style="width:100%;display:block" /></div>';

	}
	sessionDetailHtml += '<div class="detailDiv session">';
	sessionDetailHtml += '<div class="session_detail_header clearfix">';
	sessionDetailHtml += '<div class="session_name font_bold color_font_second_menu">' + this_session.session_title + '</div>';
	sessionDetailHtml += '<div class="session_attributes font_color_gray_1">';

	var session_time_string = '';
	if (this_session.session_start_time && this_session.session_start_time != null && this_session.session_start_time != '00:00') {
		session_time_string += this_session.session_start_time;
	}
	if (this_session.session_end_time && this_session.session_end_time != null && this_session.session_end_time != '00:00') {
		session_time_string += ' - ' + this_session.session_end_time;
	}
	var this_session_day = this_congress.day_information['' + this_session.session_day_id];
	var this_session_location = this_congress.locations_information['' + this_session.session_location_id];


	//###################################################


	//if(this_session.show_actions != "2") {
	sessionDetailHtml += '<span class="session_day">' + this_session_day.day_name + '</span>';
	if (session_time_string != '') {
		sessionDetailHtml += '<br><span class="session_time">' + session_time_string + '</span>';
	}
	if (this_session_location) {
		sessionDetailHtml += '<br><span class="session_room">' + this_session_location.location_name + '</span>';
	}
	//}

	if (this_session.session_session_type) {
		var this_session_type = this_congress.session_types_information['' + this_session.session_session_type];

		sessionDetailHtml += '<br><div class="session_type">' + this_session_type.session_type_name + '</div>';
	}

	var last_tag;

	var count_alternatives = 0;

	if (this_session.session_tags && this_session.session_tags.length > 0) {
		$.each(this_session.session_tags, function(index, this_tag_alternative) {
			var this_tag_alternative = this_congress.session_tag_alternatives_information['' + this_tag_alternative];


			if (!last_tag || last_tag != this_tag_alternative.tag_id) {

				if (count_alternatives > 0) {
					sessionDetailHtml += '</div>';
				}
				count_alternatives = 0;
				last_tag = this_tag_alternative.tag_id;
				var this_tag = this_congress.session_tags_information['' + this_tag_alternative.tag_id];
				sessionDetailHtml += '<div class="session_tag font_color_dark">' + this_tag.tag_name + '</div>';
				sessionDetailHtml += '<div class="tag_alternatives font_color_gray_1">';
			}

			count_alternatives++;

			sessionDetailHtml += '<br><span class="session_room">' + this_tag_alternative.alternative_name + '</span>';

		});

		if (count_alternatives > 0) {
			sessionDetailHtml += '</div>';
		}
	}


	var inMyAgendaModifier = '';
	var inMyAgenda = false;
	if (array_contains(user_data.profile.agenda["sessions"], session_id)) {
		inMyAgendaModifier = 'selected';
		inMyAgenda = true;
	}

	sessionDetailHtml += '</div>';

	var count_actions = 0;

	if (this_session.show_actions && this_session.show_actions == "2") {
		sessionDetailHtml += '<div class="actions_div" style="text-align:left">';

		if (this_congress.congress_information.has_myagenda == '1' && this_session.max_registrations == 0) {
			sessionDetailHtml += '<div class="top_action color_bg_division_1" style="margin-right:10px" onclick="add_to_my_agenda(' + session_id + ');">';
			sessionDetailHtml += '<div class="top_action_icon" style="position:relative"><span class="cg-icon cg-icon-myagenda' + (inMyAgenda ? ' in_agenda' : '') + ' font_color_white cg-icon-size-18" style="height:40px;line-height:35px;width:35px"><div class="my-agenda-color"></div></span></div>';
			//sessionDetailHtml += '<div class="top_action_text"><span class="session_day">' + this_session_day.day_name + '<br>'+session_time_string+'</span></div>';

			sessionDetailHtml += '<div class="top_action_action agenda_text"><span>' + (inMyAgenda ? trd('remove-from-agenda') : trd('add-to-agenda')) + '</span></div>';


			//sessionDetailHtml += '<div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('bt-add-to-agenda') + '</div>';
			sessionDetailHtml += '</div>';
		}

		if (this_session.session_location_id) {
			if (this_session_location && this_session_location.location_map) {
				sessionDetailHtml += '<div class="top_action color_bg_division_1" onclick="loadFloorplan(-1,' + this_session.session_location_id + ',false);">';
				sessionDetailHtml += '<div class="top_action_icon">';
				sessionDetailHtml += '<span class="cg-icon icon-pinpoint font_color_white cg-icon-size-18" style="height:40px;line-height:35px;width:35px"></span></div>';
				sessionDetailHtml += '<div class="top_action_action">Go to Location</div>';

				//sessionDetailHtml += '<div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('label-go-to-location') + '</div>';
				sessionDetailHtml += '</div>';
			}
		}
		sessionDetailHtml += '<div class="clearfix"></div>';
		sessionDetailHtml += '</div>';
	}

	if (this_session.show_actions && this_session.show_actions == "1") {
		sessionDetailHtml += '<div class="actions_div">';

		if (this_session.has_moderation && (this_session.has_moderation == "1" || this_session.has_moderation == "2")) {
			count_actions++;
			sessionDetailHtml += '<div class="action" onclick="showSessionQuestionModal(' + session_id + ');"><div class="action_icon add_to_favs ' + inMyAgendaModifier + '"><span class="cg-icon cg-icon-moderation color_icon_clickable cg-icon-size-20"></span><div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('bt-ask-question') + '</div></div></div>';
		}

		if (this_session.has_polling && this_session.has_polling == "1") {
			count_actions++;
			sessionDetailHtml += '<div class="action" onclick="showPollingModal(' + session_id + ');"><div class="action_icon add_to_favs"><span class="cg-icon cg-icon-polling color_icon_clickable cg-icon-size-20"></span><div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('bt-polling') + '</div></div></div>';
		}

		// MY AGENDA ACTION
		if (this_congress.congress_information.has_myagenda == '1' && this_session.max_registrations == 0) {
			count_actions++;
			sessionDetailHtml += '<div class="action" onclick="add_to_my_agenda(' + session_id + ');">';
			sessionDetailHtml += '<div class="action_icon add_to_favs ' + inMyAgendaModifier + '">';
			sessionDetailHtml += '<span class="cg-icon cg-icon-myagenda color_icon_clickable cg-icon-size-20"></span>';
			sessionDetailHtml += '<div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('bt-add-to-agenda') + '</div>';
			sessionDetailHtml += '<div class="add_badge" style=""></div>';
			sessionDetailHtml += '</div>';
			sessionDetailHtml += '</div>';
		}

		if (this_session.session_location_id) {
			count_actions++;
			var this_location = this_congress.locations_information['' + this_session.session_location_id];
			if (this_location && this_location.location_map) {
				sessionDetailHtml += '<div class="action" onclick="loadFloorplan(-1,' + this_session.session_location_id + ',false);"><div class="action_icon"><span class="cg-icon icon-pinpoint color_icon_clickable cg-icon-size-20"></span><div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('label-go-to-location') + '</div></div></div>';
			}
		}

		if (this_congress.congress_information.has_session_notes && this_congress.congress_information.has_session_notes == "1") {
			count_actions++;
			sessionDetailHtml += '<div class="action" onclick="showNoteModal(\'session\',' + session_id + ');">';
			sessionDetailHtml += '<div class="action_icon">';
			sessionDetailHtml += '<span class="cg-icon cg-icon-notes color_icon_clickable cg-icon-size-20"></span>';
			sessionDetailHtml += '<div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('bt-take-a-note') + '</div>';
			sessionDetailHtml += '</div>';
			sessionDetailHtml += '</div>';
		}
		sessionDetailHtml += '<div class="clearfix"></div>';
		sessionDetailHtml += '</div>';

	}

	if (this_session.show_actions && this_session.show_actions == "3") {

		if (this_session.session_location_id) {
			var this_location = this_congress.locations_information['' + this_session.session_location_id];
			if (this_location && this_location.location_map) {
				sessionDetailHtml += '<div class="action_list_item border_top_color_dark" onclick="loadFloorplan(-1,' + this_session.session_location_id + ',false);">';
				sessionDetailHtml += '<span class="cg-icon cg-icon-bt-location color_icon_clickable cg-icon-size-20"></span>';
				sessionDetailHtml += '<span class="action_list_title font_color_dark">' + trd('label-go-to-location') + '</span>';
				sessionDetailHtml += '</div>';
			}
		}

		// IF SESSION HAS MODERATION
		if (this_session.has_moderation && (this_session.has_moderation == "1" || this_session.has_moderation == "2")) {
			sessionDetailHtml += '<div class="action_list_item border_top_color_dark" onclick="showSessionQuestionModal(' + session_id + ');">';
			sessionDetailHtml += '<span class="cg-icon cg-icon-messages color_icon_clickable cg-icon-size-20"></span>';
			sessionDetailHtml += '<span class="action_list_title font_color_dark">' + trd('bt-ask-question') + '</span>';
			sessionDetailHtml += '</div>';
		}

		// IF SESSION HAS POLLING
		if (this_session.has_polling && this_session.has_polling == "1") {
			sessionDetailHtml += '<div class="action_list_item border_top_color_dark" onclick="showPollingModal(' + session_id + ');">';
			sessionDetailHtml += '<span class="cg-icon cg-icon-polling color_icon_clickable cg-icon-size-20"></span>';
			sessionDetailHtml += '<span class="action_list_title font_color_dark">' + trd('bt-polling') + '</span>';
			sessionDetailHtml += '</div>';
		}

		sessionDetailHtml += '<div class="action_list_item add_to_favs border_top_color_dark" style="margin-bottom:20px;" onclick="add_to_my_agenda(' + session_id + ');">';
		sessionDetailHtml += '<span class="cg-icon cg-icon-bt-fav color_icon_clickable cg-icon-size-20"></span>';
		sessionDetailHtml += '<span class="action_list_title font_color_dark">' + trd('bt-add-to-agenda') + '</span>';
		sessionDetailHtml += '</div>';

		sessionDetailHtml += '<div class="action_list_item border_bottom_color_dark border_top_color_dark" style="margin-bottom:20px;" onclick="showNoteModal(\'session\',' + session_id + ')">';
		sessionDetailHtml += '<span class="cg-icon cg-icon-edit color_icon_clickable cg-icon-size-20"></span>';
		sessionDetailHtml += '<span class="action_list_title font_color_dark">' + trd('bt-take-a-note') + '</span>';
		sessionDetailHtml += '</div>';



	}




	sessionDetailHtml += '</div>';


	if (this_session.session_sponsor) {
		sessionDetailHtml += '<div class="session_sponsorhip_title font_color_dark border_bottom_color_dark border_top_color_dark">' + trd('session-sponsored-by') + '</div>';
		sessionDetailHtml += '<div class="session_sponsorship" onclick="loadSponsorDetail(' + this_session.session_sponsor + ')">';

		sessionDetailHtml += getHtmlForFeaturedSponsor(this_session.session_sponsor);
		sessionDetailHtml += '<div class="clearfix"></div>';
		sessionDetailHtml += '</div>';
	}

	if (this_session.show_questions && this_session.show_questions == "1") {
		sessionDetailHtml += '<div id="session_questionnaires"></div>';
	}



	if (this_session.has_rating && this_session.has_rating == "1") {
		sessionDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="">' + trd('rate-this-session') + '</div>';
		sessionDetailHtml += '<div class="session_rating">';
		sessionDetailHtml += '<div class="rate_session font_bold"><div class="stars_container"><div class="face1" id="rate_session_' + session_id + 'star_1" onclick="do_rate_session(' + session_id + ',1);"></div><div class="face2" id="rate_session_' + session_id + 'star_2" onclick="do_rate_session(' + session_id + ',2);"></div><div class="face3" id="rate_session_' + session_id + 'star_3" onclick="do_rate_session(' + session_id + ',3);"></div><div class="face4" id="rate_session_' + session_id + 'star_4" onclick="do_rate_session(' + session_id + ',4);"></div><div class="face5" id="rate_session_' + session_id + 'star_5" onclick="do_rate_session(' + session_id + ',5);"></div></div></div>';
		sessionDetailHtml += '</div>';
	}

	if (this_session.max_registrations && this_session.max_registrations != "0") {
		sessionDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="">' + trd('register-in-this-session') + '</div>';
		sessionDetailHtml += '<div id="session_registration_div">';

		sessionDetailHtml += '</div>';
	}


	if (this_session.session_description) {
		//sessionDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="">'+trd('section-about-session')+'</div>';
	}
	sessionDetailHtml += '<div class="session_description description">';
	if (!this_session.session_description) {
		if (this_session.session_posters.length == 0) {
			sessionDetailHtml += '<div class="info_div font_color_gray_1 border_top_color_dark">' + trd('no-session-description') + '</div>';
		}
	} else {
		sessionDetailHtml += this_session.session_description;
	}
	sessionDetailHtml += '</div>';

	if (this_session.session_posters.length > 0) {
		sessionDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white" style="margin-top:20px;">' + trd('section-session-posters') + '</div>';
		sessionDetailHtml += '<div class="session_description description">';
		this_session.session_posters.map(function(poster_id) {
			sessionDetailHtml += '<h3>' + this_congress.posters_information['' + poster_id].poster_title + '</h3>';
			sessionDetailHtml += this_congress.posters_information['' + poster_id].poster_description;
			sessionDetailHtml += '<hr>';
		});
		sessionDetailHtml += '</div>';
	}



	var lastParticipation = '';

	if (this_session.show_speakers && this_session.show_speakers == "1") {
		if (this_session.session_participations && this_session.session_participations.length > 0) {
			$.each(this_session.session_participations, function(index, this_session_participation) {
				$.each(this_session_participation, function(index, this_participation) {
					var this_speaker_type = this_congress.speaker_types_information['' + this_participation.alternative_type];
					if (lastParticipation != this_participation.alternative_type) {
						sessionDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_speaker_type.speaker_type_name + '</div>';
						lastParticipation = this_participation.alternative_type;
					}
					sessionDetailHtml += getHtmlForSpeakerInfo(this_participation.speaker_id);
				});
			});
		}
	}

	if (this_session.resources && this_session.resources.length > 0) {
		sessionDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('associated-resources') + '</div>';

		first = true;
		$.each(this_session.resources, function(index, this_resource_id) {
			if (first) {
				first = false;
			} else {
				sessionDetailHtml += '<div class="division_bottom color_bg_division_1">&nb    sp;</div>';
			}
			sessionDetailHtml += getHtmlForResourceInfo(this_resource_id);
		});
	}

	sessionDetailHtml += '</div>';

	sessionDetailHtml += '</div>';

	sessionDetailHtml += '</div>';

	if (this_session.show_actions && this_session.show_actions == "2") {
		sessionDetailHtml += '<div class="session_bottom_actions color_bg_division_1 font_color_white">';
		sessionDetailHtml += '<table class="menu_align"><tr>';

		// IF SESSION HAS MODERATION
		if (this_session.has_moderation && (this_session.has_moderation == "1" || this_session.has_moderation == "2")) {
			sessionDetailHtml += '<td onclick="showSessionQuestionModal(' + session_id + ');" class="action_td"><span class="cg-icon cg-icon-moderation cg-icon-size-16" style="font-size:26pt"></span><span class="bottom_action_title">' + trd('bt-ask-question') + '</span></td>';
		}

		// IF SESSION HAS POLLING
		if (this_session.has_polling && this_session.has_polling == "1") {
			sessionDetailHtml += '<td onclick="showPollingModal(' + session_id + ');" class="action_td"><span class="cg-icon cg-icon-polling cg-icon-size-16" style="font-size:26pt"></span><span class="bottom_action_title">' + trd('bt-polling') + '</span></td>';
		}

		/*if (this_congress.congress_information && this_congress.congress_information.has_myagenda == "1"){
		  sessionDetailHtml += '<td onclick="add_to_my_agenda('+session_id+');" class="add_to_favs action_td '+inMyAgendaModifier+'"><span class="cg-icon cg-icon-myagenda cg-icon-size-16"></span><span class="bottom_action_title">'+trd('bt-add-to-agenda')+'</span></td>';
		}*/

		if (this_congress.congress_information && this_congress.congress_information.has_session_notes == "1") {
			sessionDetailHtml += '<td onclick="showNoteModal(\'session\',' + session_id + ');" class="action_td"><span class="cg-icon cg-icon-notes cg-icon-size-16" style="font-size:26pt"></span><span class="bottom_action_title">' + trd('bt-take-a-note') + '</span></td>';
		}

		if (this_session.max_registrations && this_session.max_registrations != "0") {
			sessionDetailHtml += '<td><span  style="font-size:26pt" class="cg-icon cg-icon-check cg-icon-size-16"></span><span class="bottom_action_title">' + trd('bt-session-register') + '</span></td>';
		}
		sessionDetailHtml += '</tr></table>';
		sessionDetailHtml += '</div>';
	}

	sessionDetailHtml += '</div>';

	$('#session_detail_' + session_id).remove();


	$('.mainDiv').append(sessionDetailHtml);
	$('.actions_div').addClass('actions' + count_actions);

	if (user_data.profile.rating.sessions['' + session_id]) {
		do_rate_session(session_id, user_data.profile.rating.sessions['' + session_id], true);
	}

	if (this_session.show_questions && this_session.show_questions == "1") {
		getSessionQuestionnaires(session_id);
	}

	if (this_session.max_registrations && this_session.max_registrations != "0") {
		//registration_interval = setInterval("checkSessionRegistrations('" + session_id + "');", 10000);
		checkSessionRegistrations(session_id);
	}


	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('session_detail_" + session_id + "');", 1);
		} else {
			setTimeout("bringforward('session_detail_" + session_id + "');", 1);
		}
	} else {
		onPageChanged();
	}

}

function checkSessionRegistrations(session_id) {

	var params = {
		f: 'getSessionRegistrations',
		session_id: session_id,
		user_id: user_data.profile.user_id
	};

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function registrtionsRetrieved(response) {
			console.log('response: ' + JSON.stringify(response));
			if (response.success && response.object && response.object.registrations) {
				var max_registrations = response.object.registrations.max_registrations;
				var registrations = response.object.registrations.registrations;
				var user_registered = response.object.registrations.user_registered;
				var registrationsHtml = '';
				if (user_registered && user_registered == "1") {
					console.log('already registered');
					// already registered
					registrationsHtml += '<div class="session_registration_explain font_color_gray_1" style="text-align:center;padding:20px">' + trd('register-already-registered-in-session') + '</div>';
					registrationsHtml += '<div onclick="unregisterUserFromSession(' + session_id + ')" class="block_button color_bg_division_2 font_color_white" style="font-size:12px;margin-bottom:15px">' + trd('button-unregister-in-session') + '</div>';
				} else if (parseInt(max_registrations) <= parseInt(registrations)) {
					console.log('no slots');
					// no more slots
					registrationsHtml += '<div class="session_registration_explain font_color_gray_1" style="text-align:center;padding:20px">' + trd('register-user-in-session-no-more-slots') + '</div>';
				} else {
					console.log('slots available ');
					// slots available
					registrationsHtml += '<div class="session_registration_explain font_color_gray_1" style="text-align:center;padding:20px">' + trd('register-user-in-session-explain') + '</div>';
					registrationsHtml += '<div onclick="registerUserIntoSession(' + session_id + ')" class="block_button color_bg_division_2 font_color_white" style="font-size:12px;margin-bottom:15px">' + trd('button-register-in-session') + '</div>';
					registrationsHtml += '<div class="session_registration_explain font_color_gray_1" style="text-align:center; font-weight:bold;">' + registrations + '/' + max_registrations + ' ' + trd('register-user-in-session-slots-available') + '</div>';
				}

				$('#session_registration_div').html(registrationsHtml);
			}


		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('ERROR:' + JSON.stringify(xhr));
			//cgAlert(trd('error-connection-unstable'));
		}
	});
}

function loadFloorplan(floorplan_id, zoom_location_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('spaces');

	var isCurrent = ($('#mapDiv.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}






	var this_floorplan;

	if (zoom_location_id && zoom_location_id != -1 && zoom_location_id != "-1") {
		var location_to_zoom = this_congress.locations_information['' + zoom_location_id];
		FLOORPLAN_FILTER_FLOORPLAN = location_to_zoom.location_map;
	}


	if (floorplan_id == -1 || floorplan_id == "-1") {
		if (FLOORPLAN_FILTER_FLOORPLAN == -1) {
			FLOORPLAN_FILTER_FLOORPLAN = this_congress.congress_information.congress_floorplans[0];
			this_floorplan = this_congress.floorplans_information['' + FLOORPLAN_FILTER_FLOORPLAN];
		} else {
			this_floorplan = this_congress.floorplans_information['' + FLOORPLAN_FILTER_FLOORPLAN];
		}
	} else {
		FLOORPLAN_FILTER_FLOORPLAN = floorplan_id;
		this_floorplan = this_congress.floorplans_information['' + floorplan_id];
	}

	var floorplan_media = this_congress.media_information['map']['' + this_floorplan.map_id];

	var floorplan_image_url = '';

	if (floorplan_media.offline) {
		floorplan_image_url = fsRoot + '/' + floorplan_media.name;
	} else {
		floorplan_image_url = floorplan_media.imgURL_original;
	}
	var mapDivHtml = '';



	mapDivHtml += '<div id="mapDiv" class="normal_page ' + initialPosition + '" style="top:0px;bottom:0;">';

	mapDivHtml += '<div class="list_page_header ">';
	mapDivHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + this_floorplan.map_name + '</div></div>';
	mapDivHtml += '<div class="filter_button cg-icon cg-icon-floors cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div style="bottom:-2px;" onclick="toggleFilter();" class="filter_label right font_color_dark"><table class="just_valign"><tr><td>' + trd('see-all-floors') + '</td></tr></table></div></div>';

	mapDivHtml += '<div id="mapZoomImg"><div id="mapScrollPane"><img id="zoomableImage" src="' + floorplan_image_url + '" /></div></div><div id="mapInfoDiv"></div></div>';

	$('#mapDiv').remove();

	$('.mainDiv').append(mapDivHtml);

	if (mapScroll) {
		mapScroll.destroy();
		mapScroll = null;
	}


	$('#zoomableImage').on('load', function startiscroll() {

		var mapwidth = $('#zoomableImage').width();
		var mapheight = $('#zoomableImage').height();

		var windowwidth = $('.mainDiv').width();
		var windowheight = $('.mainDiv').height();

		var yscale = (windowheight - 80) / mapheight;
		var xscale = (windowwidth) / mapwidth;

		var minscale = 1;
		if (yscale > 1 || xscale > 1) {
			minscale = 1;
		} else if (mapwidth > mapheight) {
			minscale = yscale;
		} else {
			minscale = xscale;
		}

		if (!mapScroll) {
			mapScroll = new iScroll('mapZoomImg', {
				zoom: true,
				fadeScrollbar: true,
				hideScrollbar: true,
				zoomMin: minscale,
				zoomMax: 1.3,
				onScrollStart: function() {
					clearOverlays();
					$('#mapZoomImg').css('bottom', '0px');
				},
				onScrollEnd: function() { resizePinpoints(); }

			});

		}


		attachPinpoint();


		if (zoom_location_id && zoom_location_id != -1 && zoom_location_id != "-1") {

			mapScroll.zoom(0, 0, 1);
			setTimeout(function() {
				mapScroll.refresh();
				mapScroll.zoom(0, 0, minscale);
				zoomToLocation(zoom_location_id);


			}, 100);
		} else {

			mapScroll.zoom(0, 0, 1);
			setTimeout(function() {
				mapScroll.zoom(0, 0, minscale);
				mapScroll.refresh();
			}, 100);
		}
		FastClick.attach(document.body);
		mapScroll.refresh();
	});



	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('mapDiv');", 1);
		} else {
			setTimeout("bringforward('mapDiv');", 1);
		}
	} else {
		page_moving = false;
		onPageChanged();
	}

}

function resizePinpoints() {
	$('.pinpoint').each(function(index) {
		$(this).css('background-size', DEFAULT_PINPOINT_SIZE * (1 / mapScroll.scale) + 'px');

		if ($(this).hasClass('selected')) {
			$(this).css('font-size', '' + DEFAULT_PINPOINT_FONT_SIZE * (1 / mapScroll.scale) + 'pt');
			$(this).css('width', DEFAULT_PINPOINT_SIZE * (1 / mapScroll.scale) + 'px');
			$(this).css('height', DEFAULT_PINPOINT_SIZE * (1 / mapScroll.scale) + 'px');
			$(this).css('margin-top', '-' + DEFAULT_PINPOINT_SIZE * 0.7 * (1 / mapScroll.scale) + 'px');
			$(this).css('margin-left', '-' + DEFAULT_PINPOINT_SIZE * 0.5 * (1 / mapScroll.scale) + 'px');
		} else {
			$(this).css('font-size', '' + DEFAULT_PINPOINT_FONT_SIZE / 2 * (1 / mapScroll.scale) + 'pt');
			$(this).css('width', DEFAULT_PINPOINT_SIZE / 2 * (1 / mapScroll.scale) + 'px');
			$(this).css('height', DEFAULT_PINPOINT_SIZE / 2 * (1 / mapScroll.scale) + 'px');
			$(this).css('margin-top', '-' + DEFAULT_PINPOINT_SIZE / 2 * 0.6 * (1 / mapScroll.scale) + 'px');
			$(this).css('margin-left', '-' + DEFAULT_PINPOINT_SIZE / 2 * 0.5 * (1 / mapScroll.scale) + 'px');
		}

	});
}

function search_exhibitors() {

	var searchString = $('#search_exhibitors').val();

	$.each(this_congress.congress_information.congress_exhibitors, function(index, this_exhibitor_id) {

		var this_exhibitor = this_congress.exhibitors_information['' + this_exhibitor_id];


		if (this_exhibitor.exhibitor_name.toLowerCase().indexOf(searchString.toLowerCase()) > -1 || searchString.length < 3) {
			$('#exhibitor_element_' + this_exhibitor.exhibitor_id).show();
		} else {
			$('#exhibitor_element_' + this_exhibitor.exhibitor_id).hide();
		}

	});
}

function search_poi() {

	var searchString = $('#search_poi').val();

	$.each(this_congress.congress_information.congress_poi, function(index, this_poi_id) {

		var this_poi = this_congress.poi_information['' + this_poi_id];

		if (this_poi.poi_name.toLowerCase().indexOf(searchString.toLowerCase()) > -1 || searchString.length < 3) {
			$('#poi_button_' + this_poi.poi_id).show();
		} else {
			$('#poi_button_' + this_poi.poi_id).hide();
		}

	});
}

function search_participants(search_value) {
	if (search_value) {
		if (search_value == ' ') { search_value = ''; } //used to clear the search
		var searchString = search_value;
		$('#search_participants').val(searchString);
	} else {
		var searchString = $('#search_participants').val();
	}
	if (lazyload.profiles.search) {
		var last_search = lazyload.profiles.search;
	} else {
		var last_search = '';
	}
	lazyload.profiles.search = searchString;
	if (searchString.length < 3 && last_search.length <= searchString.length) {
		return;
	}
	var search_count = 0;
	var found_profiles = [];
	$.each(this_congress.congress_information.congress_profiles, function(index, this_participant_id) {
		var this_participant = this_congress.profiles_information['' + this_participant_id];
		if ((this_participant.user_name && this_participant.user_name.toLowerCase().indexOf(searchString.toLowerCase()) > -1) || (this_participant.user_subtitle && this_participant.user_subtitle.toLowerCase().indexOf(searchString.toLowerCase()) > -1) || (searchString.length < 3 && last_search.length <= searchString.length)) {
			found_profiles.push(this_participant_id);
			search_count++;
		}
	});
	console.log('finished and search count is ' + search_count);
	$('#profiles_list').html(generateHtmlFromProfiles(true, found_profiles));
	if (search_count == 0) {
		$('#empty_list_participants').show();
		$('#empty_list_participants').html(trd('no-search-results'));
	} else {
		$('#empty_list_participants').hide();
	}
}

function search_speakers() {

	var searchString = removeDiacritics($('#search_speakers').val());

	if (searchString.length < 3) {
		$('.speaker_button').show();
		return;
	}

	$.each(this_congress.congress_information.congress_speakers, function(index, this_speaker_id) {

		var this_speaker = this_congress.speakers_information['' + this_speaker_id];

		if (removeDiacritics(this_speaker.speaker_first_name).toLowerCase().indexOf(searchString.toLowerCase()) > -1 || removeDiacritics(this_speaker.speaker_last_name).toLowerCase().indexOf(searchString.toLowerCase()) > -1 || removeDiacritics(this_speaker.speaker_subtitle).toLowerCase().indexOf(searchString.toLowerCase()) > -1 || searchString.length < 3) {
			$('#speaker_button_' + this_speaker.speaker_id).show();
		} else {
			$('#speaker_button_' + this_speaker.speaker_id).hide();
		}

	});
}

var posters_timeout;

function search_posters() {
	clearTimeout(posters_timeout);
	posters_timeout = setTimeout("do_search_posters();", 2000);

}


function do_search_posters() {
	var searchString = $('#search_posters').val();


	$.each(this_congress.congress_information.congress_posters, function(index, this_poster_id) {

		var this_poster = this_congress.posters_information['' + this_poster_id];
		var this_poster_title_nd = '';
		this_poster_title_nd = this_poster.poster_title.toLowerCase();
		if (this_poster_title_nd.indexOf(searchString.toLowerCase()) > -1 || searchString.length < 3) {
			$('#poster_element_' + this_poster.poster_id).show();
			$('#day_container_' + this_poster.poster_type).addClass('open');
			$('#day_container_' + this_poster.poster_type).removeClass('closed');
		} else {
			$('#poster_element_' + this_poster.poster_id).hide();
		}

	});
}

function unicodeToChar(text) {
	return text.replace(/\\u[\dABCDEFabcdef][\dABCDEFabcdef][\dABCDEFabcdef][\dABCDEFabcdef]/g,
		function(match) {
			return String.fromCharCode(parseInt(match.replace(/\\u/g, ''), 16));
		});
}

function search_sessions() {
	var searchString = $('#search_sessions').val();

	if (searchString.length < 3) {
		return;
	}

	$('.day_container').removeClass('closed');
	$('.day_container').addClass('open');
	$('.panel_container').hide();
	$('.day_container').hide();

	$('.panel_container').removeClass('closed');
	$('.panel_container').addClass('open');
	$('.panel_container').hide();

	$.each(this_congress.congress_information.congress_days, function(index, this_day_id) {

		var this_day = this_congress.day_information['' + this_day_id];

		$.each(this_day.sessions, function(index, this_session_id) {



			var this_session = this_congress.sessions_information['' + this_session_id];

			if (this_session.session_title.toLowerCase().indexOf(searchString.toLowerCase()) > -1 || searchString.length < 1) {
				$('#session_element_' + this_session_id).show();
				if (this_session.session_group) {
					$('.session_group_' + this_session.session_group).show();
					$('.session_group_' + this_session.session_group).removeClass('closed');
					$('.session_group_' + this_session.session_group).addClass('open');
				}
				$('#day_container_' + this_session.session_day_id).show();
				$('.panel_container' + this_session.session_day_id).show();

			} else {
				$('#session_element_' + this_session_id).hide();
			}

		});
	});
}



function loadExhibitorsIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('exhibitors');

	var isCurrent = ($('#exhibitors_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var exhibitorsIndexHtml = '';
	exhibitorsIndexHtml += '<div class="normal_page  ' + initialPosition + '" id="exhibitors_index">';

	exhibitorsIndexHtml += '<div class="list_page_header ">';
	exhibitorsIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('exhibitors') + '</div></div>';
	exhibitorsIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu" id="filter_button" onclick="toggleFilter();"></div><div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">' + trd('filter-label') + '</div></div>';

	exhibitorsIndexHtml += '<div class="exhibitorsIndexHeader searchHeader">';
	exhibitorsIndexHtml += '<input type="text" id="search_exhibitors" class="index_search_text" placeholder="' + trd('search-exhibitors') + '" onkeyup="search_exhibitors();" />';
	exhibitorsIndexHtml += '<span class="cg-icon-character cg-icon-search-close search_close font_color_gray_1" onclick="toggleSearch();"></span>';
	exhibitorsIndexHtml += '</div>';


	exhibitorsIndexHtml += '<div class="list_page scroll">';
	exhibitorsIndexHtml += '<div class="scroll_lock">';


	if (this_congress.congress_information.congress_exhibitors.length == 0) {
		exhibitorsIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-exhibitors') + '</div>';
	}

	$.each(this_congress.congress_information.congress_exhibitors, function(index, this_exhibitor_id) {

		var this_exhibitor = this_congress.exhibitors_information['' + this_exhibitor_id];

		if (EXHIBITOR_FILTER_TYPE != -1 && EXHIBITOR_FILTER_TYPE != this_exhibitor.exhibitor_type) {
			return true;
		}


		exhibitorsIndexHtml += getHtmlForExhibitorInfo(this_exhibitor_id);

	});

	exhibitorsIndexHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';

	exhibitorsIndexHtml += '</div>';
	exhibitorsIndexHtml += '</div>';
	exhibitorsIndexHtml += '</div>';

	$('#exhibitors_index').remove();

	$('.mainDiv').append(exhibitorsIndexHtml);
	document.getElementById('mainDiv').scrollTop = 40;

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('exhibitors_index');", 1);
		} else {
			setTimeout("bringforward('exhibitors_index');", 1);
		}

	} else {
		onPageChanged();
	}
}

function loadLinksIndex(link_group_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	var isCurrent = ($('#link_group_index_' + link_group_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var this_link_group = this_congress.link_groups_information['' + link_group_id];

	var linkIndexHtml = '';
	linkIndexHtml += '<div class="normal_page  ' + initialPosition + '" id="link_group_index_' + link_group_id + '">';

	linkIndexHtml += '<div class="list_page_header ">';
	linkIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + this_link_group.link_group_name + '</div></div>';
	//linkIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu" id="filter_button" onclick="toggleFilter();"></div>';
	//<div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">'+trd('filter-label')+'</div>
	//<div class="search_button cg-icon cg-icon-search cg-icon-size-14 color_icon_second_menu" id="search_button" onclick="toggleSearch();"></div>
	//<div  onclick="toggleSearch();" class="filter_label left color_icon_second_menu">'+trd('filter-search')+'</div>
	linkIndexHtml += '</div>';


	linkIndexHtml += '<div class="list_page scroll">';
	linkIndexHtml += '<div class="scroll_lock">';


	if (this_link_group.links.length == 0) {
		linkIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-links') + '</div>';
	}

	$.each(this_link_group.links, function(index, this_link_id) {

		linkIndexHtml += getHtmlForLinkInfo(this_link_id);

	});

	linkIndexHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';

	linkIndexHtml += '</div>';
	linkIndexHtml += '</div>';
	linkIndexHtml += '</div>';

	$('#link_group_index_' + link_group_id).remove();

	$('.mainDiv').append(linkIndexHtml);
	document.getElementById('mainDiv').scrollTop = 40;

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('link_group_index_" + link_group_id + "');", 1);
		} else {
			setTimeout("bringforward('link_group_index_" + link_group_id + "');", 1);
		}

	} else {
		onPageChanged();
	}
}


function loadFeedbackIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('feedback');

	var isCurrent = ($('#feedback_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}



	var feedbackIndexHtml = '';

	feedbackIndexHtml += '<div class="normal_page ' + initialPosition + '" id="feedback_index">';

	feedbackIndexHtml += '<div class="list_page_header ">';
	feedbackIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('feedback') + '</div></div>';
	feedbackIndexHtml += '</div>';

	feedbackIndexHtml += '<div class="list_page scroll">';
	feedbackIndexHtml += '<div class="scroll_lock">';
	feedbackIndexHtml += '<div id="feedback_list">';
	if (this_congress.congress_information.congress_feedback.length == 0) {
		feedbackIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-feedback') + '</div>';
	}

	$.each(this_congress.congress_information.congress_feedback, function(index, this_feedback_id) {

		var this_feedback = this_congress.feedback_information['' + this_feedback_id];



		feedbackIndexHtml += getHtmlForFeedbackInfo(this_feedback_id);

	});

	feedbackIndexHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';

	feedbackIndexHtml += '</div>';
	feedbackIndexHtml += '</div>';
	feedbackIndexHtml += '</div>';
	feedbackIndexHtml += '</div>';

	$('#feedback_index').remove();

	$('.mainDiv').append(feedbackIndexHtml);
	refreshFeedbackIndex();
	document.getElementById('mainDiv').scrollTop = 40;

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('feedback_index');", 1);
		} else {
			setTimeout("bringforward('feedback_index');", 1);
		}

	} else {
		onPageChanged();
	}
}

function loadScoredFeedbackIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	if (!user_data || user_data.profile.anonymous == "1") {
		after_login_action = 'scored_feedback';
		page_moving = false;
		//loadModalAuthPage();
		//loadModalRegisterPage(true);
		//showModal();
		confirmMustRegister(trd('must-register-to-quiz'));
		return;
	}

	setSelectedMenuArea('feedback');

	var isCurrent = ($('#feedback_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}



	var feedbackIndexHtml = '';

	feedbackIndexHtml += '<div class="normal_page ' + initialPosition + '" id="feedback_index">';

	feedbackIndexHtml += '<div class="list_page_header ">';
	feedbackIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('header-scored-feedback-index') + '</div></div>';
	feedbackIndexHtml += '</div>';

	feedbackIndexHtml += '<div class="list_page scroll">';
	feedbackIndexHtml += '<div class="scroll_lock">';
	feedbackIndexHtml += '<div id="feedback_list">';
	if (this_congress.congress_information.congress_feedback.length == 0) {
		feedbackIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-scored-feedback') + '</div>';
	}

	$.each(this_congress.congress_information.congress_feedback, function(index, this_feedback_id) {
		var this_feedback = this_congress.feedback_information['' + this_feedback_id];
		feedbackIndexHtml += getHtmlForFeedbackInfo(this_feedback_id);
	});

	feedbackIndexHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';

	feedbackIndexHtml += '</div>';
	feedbackIndexHtml += '</div>';
	feedbackIndexHtml += '</div>';
	feedbackIndexHtml += '</div>';

	$('#feedback_index').remove();

	$('.mainDiv').append(feedbackIndexHtml);
	refreshScoredFeedbackIndex();
	document.getElementById('mainDiv').scrollTop = 40;

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('feedback_index');", 1);
		} else {
			setTimeout("bringforward('feedback_index');", 1);
		}

	} else {
		onPageChanged();
	}
}

function refreshFeedbackIndex() {
	var params = {
		f: 'getFeedbacks',
		event_info: {
			id: this_congress.congress_information.congress_id,
			lang: this_congress.congress_information.congress_lang
		}
	};

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);
	showLoadingOverlay();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function conversationsRetrieved(response) {
			hideLoadingOverlay();
			if (response.success) {
				var feedbacks = response.object;
				this_congress.feedback_information = feedbacks.feedback_information;
				this_congress.options_information = feedbacks.options_information;
				this_congress.questions_information = feedbacks.questions_information;
				this_congress.congress_information.congress_feedback = feedbacks.congress_feedback;
				var feedbacksHtml = '';
				var countFeedbacks = 0;
				$.each(this_congress.congress_information.congress_feedback, function(index, this_feedback_id) {
					var this_feedback = this_congress.feedback_information['' + this_feedback_id];
					if (this_feedback && this_feedback.feedback_public && this_feedback.feedback_public == "1") {
						feedbacksHtml += getHtmlForFeedbackInfo(this_feedback_id);
						countFeedbacks++;
					}

				});
				if (countFeedbacks == 0) {
					feedbacksHtml = '<div class="empty_list_message font_color_gray_1" id="empty_list_participants">' + trd('no-feedbacks-to-show') + '</div>';
				}
				$('#feedback_list').html(feedbacksHtml);
			} else {
				//cgAlert(trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			//alert('ERROR:' + JSON.stringify(xhr));
			//cgAlert(trd('error-profile-not-retrieved'));
		}
	});
}

function refreshScoredFeedbackIndex() {
	var params = {
		f: 'getFeedbacks',
		event_info: {
			id: this_congress.congress_information.congress_id,
			lang: this_congress.congress_information.congress_lang
		}
	};

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);
	showLoadingOverlay();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function conversationsRetrieved(response) {
			hideLoadingOverlay();
			if (response.success) {
				var feedbacks = response.object;
				this_congress.feedback_information = feedbacks.feedback_information;
				this_congress.options_information = feedbacks.options_information;
				this_congress.questions_information = feedbacks.questions_information;
				this_congress.congress_information.congress_feedback = feedbacks.congress_feedback;
				var feedbacksHtml = '';
				var countFeedbacks = 0;
				$.each(this_congress.congress_information.congress_feedback, function(index, this_feedback_id) {
					var this_feedback = this_congress.feedback_information['' + this_feedback_id];
					var scored = isFeedbackScored(this_feedback_id);
					if (!scored) {
						return true;
					}
					if (this_feedback && this_feedback.feedback_public && this_feedback.feedback_public == "1") {
						feedbacksHtml += getHtmlForFeedbackInfo(this_feedback_id);
						countFeedbacks++;
					}
				});
				if (countFeedbacks == 0) {
					feedbacksHtml = '<div class="empty_list_message font_color_gray_1" id="empty_list_participants">' + trd('no-feedbacks-to-show') + '</div>';
				}
				$('#feedback_list').html(feedbacksHtml);
			} else {
				//cgAlert(trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			showToastrAlert('error', trd('error-scored-feedback-not-retrieved'));
			loadHome();
		}
	});
}

function isFeedbackScored(this_feedback_id) {
	var this_feedback = this_congress.feedback_information['' + this_feedback_id];
	var scored = false;
	$.each(this_feedback.questions, function(index, question_id) {
		var this_question = this_congress.questions_information['' + question_id];
		$.each(this_question.options, function(index_option, option_id) {
			var this_option = this_congress.options_information['' + option_id];
			if (this_option.score && this_option.score == "1") {
				scored = true;
				return false;
			}
		});
		return false;
	});

	return scored;
}

function loadFeedbackIndexForSession(session_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('feedback');

	var isCurrent = ($('#feedback_index_for_session_' + session_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}



	var feedbackIndexHtml = '';

	feedbackIndexHtml += '<div class="normal_page ' + initialPosition + ' feedback_index_for_session" id="feedback_index_for_session_' + session_id + '">';

	feedbackIndexHtml += '<div class="list_page_header ">';
	feedbackIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('feedback') + '</div></div>';
	feedbackIndexHtml += '</div>';

	feedbackIndexHtml += '<div class="list_page scroll">';
	feedbackIndexHtml += '<div class="scroll_lock">';

	feedbackIndexHtml += '<div id="session_questionnaires"></div>';






	feedbackIndexHtml += '</div>';
	feedbackIndexHtml += '</div>';
	feedbackIndexHtml += '</div>';

	$('#feedback_index_for_session_' + session_id).remove();

	$('.mainDiv').append(feedbackIndexHtml);
	document.getElementById('mainDiv').scrollTop = 40;

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('feedback_index_for_session_" + session_id + "');", 1);
		} else {
			setTimeout("bringforward('feedback_index_for_session_" + session_id + "');", 1);
		}

	} else {
		onPageChanged();
	}

	getSessionQuestionnaires(session_id);
}


function loadPostersIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('posters');

	var isCurrent = ($('#posters_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}



	var postersIndexHtml = '';
	postersIndexHtml += '<div class="normal_page ' + initialPosition + '" id="posters_index">';

	postersIndexHtml += '<div class="list_page_header ">';
	postersIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('posters') + '</div></div>';
	postersIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">' + trd('filter-label') + '</div></div>';

	postersIndexHtml += '<div class="postersIndexHeader searchHeader">';
	postersIndexHtml += '<input type="text" id="search_posters" class="index_search_text" placeholder="' + trd('search-posters') + '" onkeyup="search_posters();" />';
	postersIndexHtml += '<span class="cg-icon-character cg-icon-search-close search_close font_color_gray_1" onclick="toggleSearch();"></span>';
	postersIndexHtml += '</div>';

	postersIndexHtml += '<div class="list_page scroll">';
	postersIndexHtml += '<div class="scroll_lock">';




	if (this_congress.congress_information.congress_posters.length == 0) {
		postersIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-posters') + '</div>';
	}


	if (this_congress.congress_information.congress_poster_types && this_congress.congress_information.congress_poster_types.length > 0) {

		$.each(this_congress.congress_information.congress_poster_types, function(index, this_poster_type_id) {


			if (POSTER_FILTER_TYPE != -1 && POSTER_FILTER_TYPE != this_poster_type_id) {
				return true;
			}

			if (POSTER_FILTER_TYPE == -1) {
				closedModifier = 'closed';
			} else {
				closedModifier = 'open';
			}

			var this_poster_type = this_congress.poster_types_information['' + this_poster_type_id];

			postersIndexHtml += '<div id="day_container_' + this_poster_type_id + '" class="day_container font_size_normal ' + closedModifier + '">';

			postersIndexHtml += '<div class="session_index_day_header font_bold font_color_white color_bg_division_1 " onclick="toggle_day_container(' + this_poster_type_id + ');"><div class="day_name font_size_normal"><span class="cg-icon-character cg-icon-posters font_color_white cg-icon-size-14"></span> | ' + this_poster_type.poster_type_name + '&nbsp;&nbsp;<span class="cg-icon-character cg-icon-arrow-toggle cg-icon-size-6 font_color_white"></span></div></div>';

			$.each(this_poster_type.posters, function(index, this_poster_id) {

				var this_poster = this_congress.posters_information['' + this_poster_id];




				if (POSTER_FILTER_TYPE != -1 && POSTER_FILTER_TYPE != this_poster.poster_type) {
					return true;
				}

				postersIndexHtml += getHtmlForPosterInfo(this_poster_id);

			});
			postersIndexHtml += '</div>';
		});

	} else {
		// DOES NOT HAVE POSTER TYPES
		$.each(this_congress.congress_information.congress_posters, function(index, this_poster_id) {

			var this_poster = this_congress.posters_information['' + this_poster_id];

			if (POSTER_FILTER_TYPE != -1 && POSTER_FILTER_TYPE != this_poster.poster_type) {
				return true;
			}

			postersIndexHtml += getHtmlForPosterInfo(this_poster_id);

		});



	}







	postersIndexHtml += '</div>';
	postersIndexHtml += '</div>';
	postersIndexHtml += '</div>';

	$('#posters_index').remove();

	$('.mainDiv').append(postersIndexHtml);
	document.getElementById('mainDiv').scrollTop = 40;

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('posters_index');", 1);
		} else {
			setTimeout("bringforward('posters_index');", 1);
		}

	} else {
		onPageChanged();
	}
}



function loadPOIIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('points-of-interest');

	var isCurrent = ($('#poi_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var poiIndexHtml = '';

	poiIndexHtml += '<div class="normal_page ' + initialPosition + '" id="poi_index">';

	poiIndexHtml += '<div class="list_page_header ">';
	poiIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('points-of-interest') + '</div></div>';
	poiIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">' + trd('filter-label') + '</div></div>';

	poiIndexHtml += '<div class="poiIndexHeader searchHeader">';
	poiIndexHtml += '<input type="text" id="search_poi" class="index_search_text" placeholder="' + trd('search-pois') + '" onkeyup="search_poi();" />';
	poiIndexHtml += '<span class="cg-icon-character cg-icon-search-close search_close font_color_gray_1" onclick="toggleSearch();"></span>';
	poiIndexHtml += '</div>';

	poiIndexHtml += '<div class="list_page scroll">';
	poiIndexHtml += '<div class="scroll_lock">';



	if (this_congress.congress_information.congress_poi.length == 0) {
		poiIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-poi') + '</div>';
	}


	if (this_congress.congress_information.congress_poi_types.length > 0) {
		$.each(this_congress.congress_information.congress_poi_types, function(index, this_poi_type_id) {

			var this_poi_type = this_congress.poi_types_information['' + this_poi_type_id];

			if (POI_FILTER_TYPE != -1 && POI_FILTER_TYPE != this_poi_type_id) {
				// DO NOTHING
			} else {

				if (this_poi_type.pois && this_poi_type.pois.length > 0) {

					poiIndexHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_poi_type.poi_type_name + '</div>';

					$.each(this_poi_type.pois, function(index, this_poi_id) {
						poiIndexHtml += getHtmlForPOIInfo(this_poi_id);
					});

				}

			}
		});
	} else {

		$.each(this_congress.congress_information.congress_poi, function(index, this_poi_id) {

			var this_poi = this_congress.poi_information['' + this_poi_id];



			poiIndexHtml += getHtmlForPOIInfo(this_poi_id);

		});
	}

	poiIndexHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';

	poiIndexHtml += '</div>';
	poiIndexHtml += '</div>';
	poiIndexHtml += '</div>';

	$('#poi_index').remove();

	$('.mainDiv').append(poiIndexHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('poi_index');", 1);
		} else {
			setTimeout("bringforward('poi_index');", 1);
		}

	} else {
		onPageChanged();
	}
}

function loadSpeakersIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('speakers');

	var isCurrent = ($('#speakers_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var speakersIndexHtml = '';

	speakersIndexHtml += '<div class="normal_page ' + initialPosition + '" id="speakers_index">';

	speakersIndexHtml += '<div class="list_page_header  ">';
	speakersIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('speakers') + '</div></div>';
	speakersIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">' + trd('filter-label') + '</div></div>';

	speakersIndexHtml += '<div class="speakersIndexHeader searchHeader">';
	speakersIndexHtml += '<input type="text" id="search_speakers" class="index_search_text" placeholder="' + trd('search-speakers') + '" onkeyup="search_speakers();" />';
	speakersIndexHtml += '<span class="cg-icon-character cg-icon-search-close search_close font_color_gray_1" onclick="toggleSearch();"></span>';

	speakersIndexHtml += '</div>';

	speakersIndexHtml += '<div class="list_page scroll">';
	speakersIndexHtml += '<div class="scroll_lock">';


	if (this_congress.congress_information.congress_speakers.length == 0) {
		speakersIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-speakers') + '</div>';
	}


	var first = true;
	$.each(this_congress.congress_information.congress_speakers, function(index, this_speaker_id) {

		var this_speaker = this_congress.speakers_information['' + this_speaker_id];

		if (SPEAKER_FILTER_TYPE != -1 && SPEAKER_FILTER_TYPE != this_speaker.speaker_type) {
			return true;
		}

		speakersIndexHtml += getHtmlForSpeakerInfo(this_speaker_id);

	});
	speakersIndexHtml += '</div>';
	speakersIndexHtml += '</div>';
	speakersIndexHtml += '</div>';

	$('#speakers_index').remove();

	$('.mainDiv').append(speakersIndexHtml);

	$('#speakers_index .scroll')[0].scrollTop = pastScrollSpeakers;

	$('#speakers_index .scroll').scroll(function(event) {
		pastScrollSpeakers = $('#speakers_index .scroll')[0].scrollTop;
	});

	//PullToRefresh.init({
	//mainElement: '.scroll_lock', // above which element?
	//onRefresh: function (done) {
	//setTimeout(function () {
	//done(); // end pull to refresh
	//showToastrAlert('success','Refreshed, mothafucka!');
	//}, 1500);
	//}
	//});

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('speakers_index');", 1);
		} else {
			setTimeout("bringforward('speakers_index');", 1);
		}

	} else {
		onPageChanged();
	}

}

function loadSpeakersIndexForSession(session_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	var isCurrent = ($('#speakers_index_for_session_' + session_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var this_session = this_congress.sessions_information['' + session_id];

	var speakersIndexHtml = '';

	speakersIndexHtml += '<div class="normal_page ' + initialPosition + '" id="speakers_index_for_session_' + session_id + '">';

	speakersIndexHtml += '<div class="list_page_header">';
	speakersIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('header-session-speakers') + '</div></div>';
	speakersIndexHtml += '</div>';

	speakersIndexHtml += '<div class="list_page scroll">';
	speakersIndexHtml += '<div class="scroll_lock">';


	if (this_session.session_participations.length == 0) {
		speakersIndexHtml += '<div class="info_div font_color_gray_1">' + trd('no-speakers') + '</div>';
	}

	var lastParticipation = '';

	$.each(this_session.session_participations, function(index, this_session_participation) {
		$.each(this_session_participation, function(index, this_participation) {
			var this_speaker_type = this_congress.speaker_types_information['' + this_participation.alternative_type];
			if (lastParticipation != this_participation.alternative_type) {
				speakersIndexHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + this_speaker_type.speaker_type_name + '</div>';
				lastParticipation = this_participation.alternative_type;
			}


			speakersIndexHtml += getHtmlForSpeakerInfo(this_participation.speaker_id);

		});
	});


	speakersIndexHtml += '</div>';
	speakersIndexHtml += '</div>';
	speakersIndexHtml += '</div>';

	$('#speakers_index_for_session_' + session_id).remove();

	$('.mainDiv').append(speakersIndexHtml);

	if ($('#speakers_index_for_session_' + session_id + ' .scroll').length > 0) {
		$('#speakers_index_for_session_' + session_id + ' .scroll')[0].scrollTop = pastScrollSpeakers;
		$('#speakers_index_for_session_' + session_id + ' .scroll').scroll(function(event) {
			pastScrollSpeakers = $('#speakers_index_for_session_' + session_id + ' .scroll')[0].scrollTop;
		});
	}


	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('speakers_index_for_session_" + session_id + "');", 1);
		} else {
			setTimeout("bringforward('speakers_index_for_session_" + session_id + "');", 1);
		}

	} else {
		onPageChanged();
	}

}


function loadProfilesIndex(fromHistory, fromMeetings) {

	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage(false);
		return;
	}

	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('participants');

	var isCurrent = ($('#profiles_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	profilesIndexHtml = '';
	profilesIndexHtml += '<div class="normal_page ' + initialPosition + '" id="profiles_index">';

	profilesIndexHtml += '<div class="list_page_header">';
	profilesIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('list-header-participants') + '</div></div>';
	profilesIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">' + trd('filter-label') + '</div><div class="search_button cg-icon cg-icon-search cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="search_button" onclick="toggleSearch(\'search_participants(lazyload.profiles.search)\');"></div><div  onclick="toggleSearch();" class="filter_label left color_icon_second_menu">' + trd('filter-search') + '</div></div>';

	profilesIndexHtml += '<div class="speakersIndexHeader searchHeader">';
	profilesIndexHtml += '<input type="text" id="search_participants" class="index_search_text" placeholder="' + trd('search-participants') + '" onkeyup="search_participants();" />';
	profilesIndexHtml += '<span class="cg-icon-character cg-icon-search-close search_close font_color_gray_1" onclick="search_participants(\' \');"></span>';

	profilesIndexHtml += '</div>';

	profilesIndexHtml += '<div class="list_page scroll">';
	profilesIndexHtml += '<div class="scroll_lock">';
	profilesIndexHtml += '<div class="empty_list_message font_color_gray_1" id="empty_list_participants">' + trd('no-profiles-to-show') + '</div>';


	profilesIndexHtml += '<div id="profiles_list"></div>';

	profilesIndexHtml += '</div>';
	profilesIndexHtml += '</div>';
	profilesIndexHtml += '</div>';

	$('#profiles_index').remove();
	$('.mainDiv').append(profilesIndexHtml);

	if (fromHistory && this_congress.congress_information.congress_profiles.length > 0) {
		showLoadingOverlay();
		console.log(fromMeetings);
		var list_html = generateHtmlFromProfiles(fromHistory, false, fromMeetings);
		$('#profiles_list').html(list_html);
		$('#empty_list_participants').hide();

		$('#profiles_index .scroll')[0].scrollTop = pastScrollProfiles;
		$('#profiles_index .scroll').scroll(function(event) {
			onProfilesScroll();
		});
		if (lazyload.profiles.search != '') {
			if (lazyload.profiles.search.length < 3) { toggleSearch(); }
			search_participants(lazyload.profiles.search);
		}
		hideLoadingOverlay();
	}

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('profiles_index');", 1);
		} else {
			setTimeout("bringforward('profiles_index');", 1);
		}

	} else {
		onPageChanged();
	}

	if (!fromHistory) {
		refreshUserProfiles('', fromMeetings);
	}
}

function onProfilesScroll() {
	var scroll_element = $('#profiles_index .scroll');
	var scroll_height = scroll_element[0].scrollHeight;
	pastScrollProfiles = scroll_element[0].scrollTop;
	if (pastScrollProfiles / scroll_height > lazyload.profiles.ratio && this_congress.congress_information.congress_profiles.length > lazyload.profiles.sizeTimesPages() && !lazyload.profiles.search) {
		lazyload.profiles.page++;
		var more_profiles_html = generateHtmlFromProfiles();
		console.log('adding page ' + lazyload.profiles.page + 'at the end of');
		console.log($('#endofprofiles_page' + lazyload.profiles.page));
		$('#endofprofiles_page' + (lazyload.profiles.page - 1)).append(more_profiles_html);
	}
}

function loadProfilesIndexForSession(session_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('participants');

	var isCurrent = ($('#profiles_index_for_session_' + session_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var profilesIndexHtml = '';

	profilesIndexHtml += '<div class="normal_page ' + initialPosition + '" id="profiles_index_for_session_' + session_id + '">';

	profilesIndexHtml += '<div class="list_page_header">';
	profilesIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('list-header-participants') + '</div></div>';
	profilesIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div></div>';

	profilesIndexHtml += '<div class="list_page scroll">';
	profilesIndexHtml += '<div class="scroll_lock">';
	profilesIndexHtml += '<div class="empty_list_message font_color_gray_1" id="empty_list_participants">' + trd('no-profiles-to-show') + '</div>';


	profilesIndexHtml += '<div id="profiles_list"></div>';

	profilesIndexHtml += '</div>';
	profilesIndexHtml += '</div>';
	profilesIndexHtml += '</div>';

	$('#profiles_index').remove();

	$('.mainDiv').append(profilesIndexHtml);

	if ($('#profiles_index_for_session_' + session_id + ' .scroll').length > 0) {
		$('#profiles_index_for_session_' + session_id + ' .scroll')[0].scrollTop = pastScrollProfiles;
		$('#profiles_index_for_session_' + session_id + ' .scroll').scroll(function(event) {
			pastScrollProfiles = $('#profiles_index .scroll')[0].scrollTop;
		});
	}

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('profiles_index_for_session_" + session_id + "');", 1);
		} else {
			setTimeout("bringforward('profiles_index_for_session_" + session_id + "');", 1);
		}

	} else {
		onPageChanged();
	}

	refreshUserProfilesForSession(session_id);
}

function loadConversationsIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage(false);
		return;
	}

	setSelectedMenuArea('conversations');

	var isCurrent = ($('#conversations_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var profilesIndexHtml = '';

	profilesIndexHtml += '<div class="normal_page ' + initialPosition + '" id="conversations_index">';

	profilesIndexHtml += '<div class="list_page_header">';
	profilesIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('list-header-conversations') + '</div></div>';
	profilesIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div  onclick="toggleFilter();" class="filter_label right color_icon_second_menu">' + trd('filter-label') + '</div></div>';

	profilesIndexHtml += '<div class="speakersIndexHeader searchHeader">';
	profilesIndexHtml += '<input type="text" id="search_participants" class="index_search_text" placeholder="' + trd('search-participants') + '" onkeyup="search_participants();" />';
	//profilesIndexHtml += '<span class="cg-icon-character cg-icon-search-close search_close font_color_gray_1" onclick="toggleSearch();"></span>';

	profilesIndexHtml += '</div>';

	profilesIndexHtml += '<div class="list_page scroll">';
	profilesIndexHtml += '<div class="scroll_lock">';

	profilesIndexHtml += '<div id="conversations_list">' + trd('no-conversations-to-show') + '</div>';

	profilesIndexHtml += '</div>';
	profilesIndexHtml += '</div>';
	profilesIndexHtml += '</div>';

	$('#conversations_index').remove();

	$('.mainDiv').append(profilesIndexHtml);

	$('#conversations_index .scroll')[0].scrollTop = pastScrollConversations;

	$('#conversations_index .scroll').scroll(function(event) {
		pastScrollConversations = $('#conversations_index .scroll')[0].scrollTop;
	});

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('conversations_index');", 1);
		} else {
			setTimeout("bringforward('conversations_index');", 1);
		}

	} else {
		onPageChanged();
	}

	refreshConversations();

}

function refreshConversations() {
	var params = {
		f: 'getUserConversations',
		user_id: user_data.profile.user_id,
		event_id: this_congress.congress_information.congress_id
	};
	if (breaking_changes.user_pic_file) { params.user_pic_file = true; }
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);
	showLoadingOverlay();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function conversationsRetrieved(response) {
			hideLoadingOverlay();
			console.log('response: ' + JSON.stringify(response));
			if (response.success) {
				var conversations = response.object;
				var conversationsHtml = '';

				$.each(conversations, function(index, this_conversation) {
					var this_profile_pic = 'img/defaults/img_user.png';
					if (this_conversation.profile.user_pic) {
						if (breaking_changes.user_pic_file) {
							this_profile_pic = user_pic_home + this_conversation.profile.user_pic;
						} else {
							this_profile_pic = 'data:image/jpeg;base64,' + this_conversation.profile.user_pic;
						}
					}
					conversationsHtml += '<div class="speaker_button border_bottom_color_dark" id="conversation_button_' + this_conversation.profile.user_id + '" onclick="loadConversationDetail(false,' + this_conversation.profile.user_id + ');">';
					conversationsHtml += '<table><tr><td><div class="small_pic"><img src="' + this_profile_pic + '" /></td>';
					conversationsHtml += '<td><div class="speaker_name font_bold font_color_dark">' + this_conversation.profile.user_name + '</div>';
					conversationsHtml += '<div class="speaker_short_description">' + this_conversation.last_message.message_text + '</div></td></tr></table>';
					conversationsHtml += '<div class="gotodetail_button" id="gotodetail_button_speaker_' + this_conversation.profile.user_id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
					conversationsHtml += '</div>';
				});

				$('#conversations_list').html(conversationsHtml);
			} else {
				//showToastrAlert('error',trd(response.message));

				var conversationsHtml = '<div class="font_color_gray_1" style="font-size:10pt;text-align:center;padding:20px">' + trd(response.message) + '</div>';
				$('#conversations_list').html(conversationsHtml);
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('ERROR:' + JSON.stringify(xhr));
			showToastrAlert('error', trd('error-profile-not-retrieved'));
		}
	});
}


function refreshUserProfilesForSession(session_id) {
	var params = {
		f: 'getUserProfilesForSession',
		user_id: user_data.profile.user_id,
		event_id: this_congress.congress_information.congress_id,
		session_id: session_id
	};
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function profilesRetrieved(response) {
			console.log('response: ' + JSON.stringify(response));
			if (response.success) {
				var profiles = response.object;
				var profilesHtml = '';

				this_congress.profiles_information = {};
				this_congress.congress_information.congress_profiles = [];

				$.each(profiles, function(index, this_profile) {
					this_congress.profiles_information['' + this_profile.user_id] = this_profile;
					this_congress.congress_information.congress_profiles.push(this_profile.user_id);
					var this_profile_pic = 'img/defaults/img_user.png';
					if (this_profile.user_pic) {
						this_profile_pic = 'data:image/jpeg;base64,' + this_profile.user_pic
					}
					profilesHtml += '<div class="speaker_button border_bottom_color_dark" id="participant_button_' + this_profile.user_id + '" onclick="loadProfileDetail(' + this_profile.user_id + ');">';
					profilesHtml += '<table><tr><td><div class="small_pic"><img src="' + this_profile_pic + '" /></td>';
					profilesHtml += '<td><div class="speaker_name font_bold font_color_dark">' + this_profile.user_name + '</div>';
					profilesHtml += '<div class="speaker_short_description">' + (this_profile.user_subtitle ? this_profile.user_subtitle : (trd('user-subtitle-undefined'))) + '</div></td></tr></table>';
					profilesHtml += '<div class="gotodetail_button" id="gotodetail_button_speaker_' + this_profile.user_id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
					profilesHtml += '</div>';
				});

				$('#profiles_list').html(profilesHtml);
				if (profiles.length > 0) {
					$('#empty_list_participants').hide();
				}
			} else {
				showToastrAlert('error', trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('ERROR:' + JSON.stringify(xhr));
			showToastrAlert('error', trd('error-profile-not-retrieved'));
		}
	});

}

function refreshUserProfiles(function_call, fromMeetings) {
	var params = {
		f: 'getUserProfiles',
		user_id: user_data.profile.user_id,
		event_id: this_congress.congress_information.congress_id
	};
	if (breaking_changes.user_pic_file) { params.user_pic_file = true; }
	showLoadingOverlay();
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function profilesRetrieved(response) {
			hideLoadingOverlay();
			//console.log('response: ' + JSON.stringify(response));
			if (response.success) {
				var profiles = response.object;
				var profilesHtml = '';
				console.log(profiles.length + ' profiles');
				this_congress.profiles_information = {};
				this_congress.congress_information.congress_profiles = [];

				$.each(profiles, function(index, this_profile) {
					this_congress.profiles_information['' + this_profile.user_id] = this_profile;
					if (!this_profile.test_user || this_profile.test_user == '0') {
						this_congress.congress_information.congress_profiles.push(this_profile.user_id);
					}
				});

				if ($('#profiles_list').length > 0) {
					lazyload.profiles.page = 1;
					profilesHtml = generateHtmlFromProfiles(false, false, fromMeetings);
					$('#profiles_list').html(profilesHtml);

					//$('#profiles_index .scroll')[0].scrollTop = pastScrollProfiles;
					$('#profiles_index .scroll').scroll(function(event) {
						onProfilesScroll();
					});

					if (profiles.length > 0) {
						$('#empty_list_participants').hide();
					}
				} else if (function_call) { eval(function_call); }

				//toggleSearch();
			} else {
				hideLoadingOverlay();
				showToastrAlert('error', trd(response.message));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('ERROR:' + JSON.stringify(xhr));
			showToastrAlert('error', trd('error-profile-not-retrieved'));
		}
	});

}

function generateHtmlFromProfiles(fromHistory, fromSearch, fromMeetings) {
	profilesHtml = '';
	var profiles = this_congress.congress_information.congress_profiles;
	if (fromSearch) {
		lazyload.profiles.page = 1;
		profiles = profiles.filter(function(p) {
			return array_contains(fromSearch, p);
		});
	}
	var rendered_profiles = 0;
	$.each(profiles, function(index, this_profile_id) {
		if (lazyload.profiles.page == 1 || fromHistory || (lazyload.profiles.page > 1 && index > lazyload.profiles.size * (lazyload.profiles.page - 1))) {
			var this_profile = this_congress.profiles_information['' + this_profile_id];
			var this_profile_pic = 'img/defaults/img_user.png';
			//console.log(this_profile.user_name + ' ' + this_profile_id );
			if (this_profile.user_pic) {
				if (breaking_changes.user_pic_file) {
					this_profile_pic = user_pic_home + this_profile.user_pic;
				} else {
					this_profile_pic = 'data:image/jpeg;base64,' + this_profile.user_pic;
				}
			}
			console.log(fromMeetings);
			if (fromMeetings)
				clickBehaviour = '"if(meetings.isInMeeting(' + this_profile.user_id + ',' + fromMeetings + ')) showToastrAlert(\'warning\',\'User already in meeting\'); else navigator.notification.confirm(trd(\'meeting-participant-confirm\'),function(button) {console.log(button); if (button==1) meetings.addParticipantFromList(' + fromMeetings + ',' + this_profile.user_id + ');})"';
			else
				clickBehaviour = '"loadProfileDetail(' + this_profile.user_id + ');"';

			profilesHtml += '<div class="speaker_button border_bottom_color_dark" id="participant_button_' + this_profile.user_id + '" onclick=' + clickBehaviour + '>';
			profilesHtml += '<table><tr><td><div class="small_pic" style="background-image:url(' + this_profile_pic + ');background-size:cover"></td>';
			profilesHtml += '<td><div class="speaker_name font_bold font_color_dark">' + this_profile.user_name + '</div>';
			profilesHtml += '<div class="speaker_short_description">' + (this_profile.user_subtitle ? this_profile.user_subtitle : (trd('user-subtitle-undefined'))) + '</div></td></tr></table>';
			profilesHtml += '<div class="gotodetail_button" id="gotodetail_button_speaker_' + this_profile.user_id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
			profilesHtml += '</div>';
		}
		if (index < lazyload.profiles.sizeTimesPages()) {
			rendered_profiles = index + 1;
			return true;
		} else {
			return false;
		}
	});
	console.log('rendered ' + rendered_profiles + ' profiles in total');
	profilesHtml += '<div id="endofprofiles_page' + lazyload.profiles.page + '"></div>';
	return profilesHtml;
}

function loadExhibitorDetail(exhibitor_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('exhibitors');

	var this_exhibitor = this_congress.exhibitors_information['' + exhibitor_id];

	var isCurrent = ($('#exhibitor_detail_' + exhibitor_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var exhibitorImageUrl = '';


	if (this_congress.media_information['exhibitor'] && this_congress.media_information['exhibitor']['' + exhibitor_id]) {

		exhibitor_media = this_congress.media_information['exhibitor']['' + exhibitor_id];

		if (exhibitor_media.offline) {
			exhibitorImageUrl = fsRoot + '/' + exhibitor_media.name;
		} else {
			exhibitorImageUrl = exhibitor_media.imgURL_small;
		}
	} else {
		exhibitorImageUrl = 'img/defaults/Img_exhibitor.png';
	}

	var exhibitorDetailHtml = '';
	exhibitorDetailHtml += '<div class="normal_page scroll ' + initialPosition + '" id="exhibitor_detail_' + exhibitor_id + '">';
	exhibitorDetailHtml += '<div class="scroll_lock">';
	exhibitorDetailHtml += '<div class="detailDiv exhibitor">';
	exhibitorDetailHtml += '<div class="exhibitorHeader">';
	exhibitorDetailHtml += '<table><tr><td>';
	exhibitorDetailHtml += '<div class="big_pic"><img src="' + exhibitorImageUrl + '" /></div>';
	exhibitorDetailHtml += '</td><td>';
	exhibitorDetailHtml += '<div class="exhibitor_name font_bold kinda_title font_color_dark">' + this_exhibitor.exhibitor_name + '</div>';

	if (this_exhibitor.exhibitor_type) {
		var this_exhibitor_type = this_congress.exhibitor_types_information['' + this_exhibitor.exhibitor_type];
		if (this_exhibitor_type) {
			exhibitorDetailHtml += '<div class="exhibitor_short_description kinda_subtitle font_color_gray_1">' + this_exhibitor_type.exhibitor_type_name + '</div>';
		}
	}


	if (this_exhibitor.exhibitor_location) {
		var this_location = this_congress.locations_information['' + this_exhibitor.exhibitor_location];
		if (this_location) {
			exhibitorDetailHtml += '<div class="exhibitor_short_description kinda_subtitle font_color_gray_1">' + this_location.location_name + '</div>';
		}
	}

	exhibitorDetailHtml += '</td></tr></table>';
	exhibitorDetailHtml += '</div>';


	var inMyAgendaModifier = '';
	if (array_contains(user_data.profile.agenda["exhibitors"], exhibitor_id)) {
		inMyAgendaModifier = 'selected';
	}

	var count_actions = 0;
	exhibitorDetailHtml += '<div class="actions_div clearfix">';

	// MY AGENDA ACTION
    if(this_congress.congress_information.has_myagenda == '1'){
        count_actions++;
        exhibitorDetailHtml += '<div class="action" onclick="add_exhibitor_to_my_agenda(' + exhibitor_id + ');">';
        exhibitorDetailHtml += '<div class="action_icon add_to_favs ' + inMyAgendaModifier + '">';
        exhibitorDetailHtml += '<span class="cg-icon cg-icon-myagenda color_icon_clickable cg-icon-size-20"></span>';
        exhibitorDetailHtml += '<div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('bt-add-to-agenda') + '</div>';
        exhibitorDetailHtml += '<div class="add_badge" style=""></div>';
        exhibitorDetailHtml += '</div>';
        exhibitorDetailHtml += '</div>';
    }

	//exhibitorDetailHtml += '<div class="action" onclick="add_exhibitor_to_my_agenda('+exhibitor_id+');"><div class="action_icon add_to_favs '+inMyAgendaModifier+'"><span class="cg-icon cg-icon-bt-fav color_icon_clickable cg-icon-size-20"></span><div class="clickable_label font_color_gray_1 action_title font_bold">'+trd('label-add-to-my-agenda')+'</div></div></div>';

	if (this_exhibitor.exhibitor_location) {
		count_actions++;
		exhibitorDetailHtml += '<div class="action"><div class="action_icon" onclick="loadFloorplan(-1,' + this_exhibitor.exhibitor_location + ',false);"><span class="cg-icon cg-icon-bt-location color_icon_clickable cg-icon-size-20"></span><div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('label-go-to-location') + '</div></div></div>';
	}

	if (this_exhibitor.exhibitor_website) {
		count_actions++;
		exhibitorDetailHtml += '<div class="action"><div class="action_icon" onclick="openLink(\'' + this_exhibitor.exhibitor_website + '\');"><span class="cg-icon cg-icon-bt-link color_icon_clickable cg-icon-size-20"></span><div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('label-show-website') + '</div></div></div>';
	}

	exhibitorDetailHtml += '<div class="clearfix"></div>';

	exhibitorDetailHtml += '</div>';

	/*exhibitorDetailHtml += '<div class="exhibitor_contacts">';
	  exhibitorDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">'+trd('title-contacts')+'</div>';
	  exhibitorDetailHtml += '<div class="exhibitor_contact_details">';
	  if (this_exhibitor.exhibitor_contact_phone){
	    exhibitorDetailHtml += '<div class="exhibitor_contact_detail font_color_dark"><a href="tel:'+this_exhibitor.exhibitor_contact_phone+'" class="silent safelink"><span class="cg-icon-character cg-icon-bt-phone color_icon_clickable cg-icon-size-20"></span></a>&nbsp;&nbsp;'+this_exhibitor.exhibitor_contact_phone+'</div>';
	  }
	  if (this_exhibitor.exhibitor_contact_address){

	    var mapsLink = '';
	    if (isIOS){
	      mapsLink = 'http://maps.apple.com/?daddr=' + encodeURIComponent(this_exhibitor.exhibitor_contact_address);
	    }
	    else{
	     mapsLink = 'http://maps.google.com/maps?q=' + encodeURIComponent(this_exhibitor.exhibitor_contact_address);
	   }

	   exhibitorDetailHtml += '<div class="exhibitor_contact_detail font_color_dark"><span class="cg-icon-character cg-icon-bt-location color_icon_clickable cg-icon-size-20"></span>&nbsp;&nbsp;'+this_exhibitor.exhibitor_contact_address+'</div>';
	 }
	 if (this_exhibitor.exhibitor_contact_email){
	  exhibitorDetailHtml += '<div class="exhibitor_contact_detail font_color_dark"><a class="silent" href="mailto:'+this_exhibitor.exhibitor_contact_email+'"><span class="cg-icon-character cg-icon-bt-email color_icon_clickable cg-icon-size-20"></span></a>&nbsp;&nbsp;'+this_exhibitor.exhibitor_contact_email+'</div>';
	}
	if (this_exhibitor.exhibitor_website){
	  exhibitorDetailHtml += '<div class="exhibitor_contact_detail font_color_dark"><span class="cg-icon-character cg-icon-bt-website color_icon_clickable cg-icon-size-20" onclick="openLink(\''+this_exhibitor.exhibitor_website+'\');"></span>&nbsp;&nbsp;'+this_exhibitor.exhibitor_website+'</div>';
	}
	exhibitorDetailHtml += '</div>';
	exhibitorDetailHtml += '</div>';

	exhibitorDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';*/




	exhibitorDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('rate-this-exhibitor') + '</div>';

	exhibitorDetailHtml += '<div class="stars_container clearfix">';

	exhibitorDetailHtml += '<div class="face1" id="rate_exhibitor_' + exhibitor_id + 'star_1" onclick="do_rate_exhibitor(' + exhibitor_id + ',1);"></div>';
	exhibitorDetailHtml += '<div class="face2" id="rate_exhibitor_' + exhibitor_id + 'star_2" onclick="do_rate_exhibitor(' + exhibitor_id + ',2);"></div>';
	exhibitorDetailHtml += '<div class="face3" id="rate_exhibitor_' + exhibitor_id + 'star_3" onclick="do_rate_exhibitor(' + exhibitor_id + ',3);"></div>';
	exhibitorDetailHtml += '<div class="face4" id="rate_exhibitor_' + exhibitor_id + 'star_4" onclick="do_rate_exhibitor(' + exhibitor_id + ',4);"></div>';
	exhibitorDetailHtml += '<div class="face5" id="rate_exhibitor_' + exhibitor_id + 'star_5" onclick="do_rate_exhibitor(' + exhibitor_id + ',5);"></div>';

	exhibitorDetailHtml += '</div>';


	//exhibitorDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">'+trd('section-about-exhibitor')+'</div>';

	if (this_exhibitor.exhibitor_description && this_exhibitor.exhibitor_description == '') {
		//exhibitorDetailHtml += '<div class="info_div font_color_gray_1">'+trd('no-exhibitor-description')+'</div>';
	} else {
		exhibitorDetailHtml += '<div class="exhibitor_description description" style="padding-top:20px">' + this_exhibitor.exhibitor_description + '</div>';
	}


	if (this_exhibitor.resources.length > 0) {
		exhibitorDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white"><span class="cg-icon-character cg-icon-resources font_color_white cg-icon-size-14"></span>&nbsp;&nbsp;' + trd('associated-resources') + '</div>';

		first = true;
		$.each(this_exhibitor.resources, function(index, this_resource_id) {
			if (first) {
				first = false;
			} else {
				exhibitorDetailHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';
			}
			exhibitorDetailHtml += getHtmlForResourceInfo(this_resource_id);
		});
	}


	exhibitorDetailHtml += '</div>';

	exhibitorDetailHtml += '</div>';

	exhibitorDetailHtml += '</div>';

	$('#exhibitor_detail_' + exhibitor_id).remove();
	$('.mainDiv').append(exhibitorDetailHtml);
	$('.actions_div').addClass('actions' + count_actions);

	if (user_data.profile.rating.exhibitors['' + exhibitor_id]) {
		do_rate_exhibitor(exhibitor_id, user_data.profile.rating.exhibitors['' + exhibitor_id], true);
	}

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('exhibitor_detail_" + exhibitor_id + "');", 1);
		} else {
			setTimeout("bringforward('exhibitor_detail_" + exhibitor_id + "');", 1);
		}
	} else {
		onPageChanged();
	}

}


function toggleContacts() {
	$('.exhibitor_contacts').toggleClass('visible');
}


function mainDivOverlay() {
	if ($('body').hasClass('widescreen')) {
		return;
	}
	var overlayHtml = '';
	overlayHtml = '<div id="mainDivOverlay" onclick="clickedMainOverlay();"></div>';
	$('#mainDivOverlay').remove();
	$('#mainDiv').append(overlayHtml);
}

function clearMainDivOverlay() {
	$('#mainDivOverlay').remove();
}



function loadPosterDetail(poster_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('posters');

	var this_poster = this_congress.posters_information['' + poster_id];

	var isCurrent = ($('#poster_detail_' + poster_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var posterImageUrl = '';


	if (this_congress.media_information['poster'] && this_congress.media_information['poster']['' + poster_id]) {

		poster_media = this_congress.media_information['poster']['' + poster_id];

		if (poster_media.offline) {
			posterImageUrl = fsRoot + '/' + poster_media.name;
		} else {
			posterImageUrl = poster_media.imgURL_original;
		}
	}

	var posterDetailHtml = '';
	posterDetailHtml += '<div class="normal_page scroll ' + initialPosition + '" id="poster_detail_' + poster_id + '">';
	posterDetailHtml += '<div class="scroll_lock">';
	posterDetailHtml += '<div class="detailDiv poster">';
	posterDetailHtml += '<div class="posterHeader clearfix">';
	posterDetailHtml += '<div class="page_title font_bold font_color_dark kinda_title_color">' + this_poster.poster_title + '</div>';
	posterDetailHtml += '<div class="poster_short_description font_color_gray_1"></div>';

	/*posterDetailHtml += '<div class="color_bg_division_1"  style="color:white;text-align:center;">';
	posterDetailHtml += '<table class="just_valign"><tr>';
	posterDetailHtml += '<td><div onclick="add_poster_to_my_agenda('+poster_id+');"><div class="'+inMyAgendaModifier+'"><span class="cg-icon cg-icon-myagenda cg-icon-size-20"></span></div><div style="color:white;font-size:9px;text-align:center;"><span style="max-width:60px">'+trd('bt-add-to-agenda')+'</span></div></div></td>';

	posterDetailHtml += '</tr></table>';
	posterDetailHtml += '</div>';*/

	posterDetailHtml += '<div class="actions_div">';

	var inMyAgendaModifier = '';
	if (array_contains(user_data.profile.agenda["posters"], poster_id)) {
		inMyAgendaModifier = 'selected';
	}

	// posterDetailHtml += '<div class="action" onclick="add_poster_to_my_agenda(' + poster_id + ');"><div class="action_icon add_to_favs ' + inMyAgendaModifier + '"><span class="cg-icon cg-icon-bt-fav color_icon_clickable cg-icon-size-20"></span></div><div class="action_title font_color_gray_1">' + trd('bt-add-to-agenda') + '</div></div>';


	if (this_congress.congress_information.has_myagenda == '1') {
		posterDetailHtml += '<div style="width: 60px;margin-top: 5px;" class="action" onclick="add_poster_to_my_agenda(' + poster_id + ');">';
		posterDetailHtml += '<div class="action_icon add_to_favs ' + inMyAgendaModifier + '">';
		posterDetailHtml += '<span class="cg-icon cg-icon-myagenda color_icon_clickable cg-icon-size-20"></span>';
		posterDetailHtml += '<div class="clickable_label font_color_gray_1 action_title font_bold">' + trd('bt-add-to-agenda') + '</div>';
		posterDetailHtml += '<div class="add_badge" style=""></div>';
		posterDetailHtml += '</div>';
		posterDetailHtml += '</div>';
	}


	if (posterImageUrl && posterImageUrl != '') {
		posterDetailHtml += '<div class="action" onclick="doZoomOnImage(\'' + posterImageUrl + '\')"><div class="action_icon"><span class="cg-icon cg-icon-bt-zoom-in cg-icon-size-20 color_icon_clickable"></span></div><div class="clickable_label font_color_gray_1">' + trd('bt-zoom') + '</div></div>';
	}


	posterDetailHtml += '</div>';
	posterDetailHtml += '</div>';

	posterDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('rate-this-poster') + '</div>';

	posterDetailHtml += '<div class="stars_container clearfix">';

	posterDetailHtml += '<div class="face1" id="rate_poster_' + poster_id + 'star_1" onclick="do_rate_poster(' + poster_id + ',1);"></div>';
	posterDetailHtml += '<div class="face2" id="rate_poster_' + poster_id + 'star_2" onclick="do_rate_poster(' + poster_id + ',2);"></div>';
	posterDetailHtml += '<div class="face3" id="rate_poster_' + poster_id + 'star_3" onclick="do_rate_poster(' + poster_id + ',3);"></div>';
	posterDetailHtml += '<div class="face4" id="rate_poster_' + poster_id + 'star_4" onclick="do_rate_poster(' + poster_id + ',4);"></div>';
	posterDetailHtml += '<div class="face5" id="rate_poster_' + poster_id + 'star_5" onclick="do_rate_poster(' + poster_id + ',5);"></div>';

	posterDetailHtml += '</div>';


	posterDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-about-poster') + '</div>';

	if (this_poster.poster_description && this_poster.poster_description == '') {
		posterDetailHtml += '<div class="info_div font_color_gray_1">' + trd('no-poster-description') + '</div>';

	} else {
		posterDetailHtml += '<div class="poster_description description">' + this_poster.poster_description + '</div>';

	}



	if (this_poster.resources.length > 0) {
		posterDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('associated-resources') + '</div>';

		first = true;
		$.each(this_poster.resources, function(index, this_resource_id) {
			if (first) {
				first = false;
			} else {
				posterDetailHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';
			}
			posterDetailHtml += getHtmlForResourceInfo(this_resource_id);
		});
	}


	posterDetailHtml += '</div>';

	posterDetailHtml += '</div>';

	posterDetailHtml += '</div>';

	$('#poster_detail_' + poster_id).remove();
	$('.mainDiv').append(posterDetailHtml);

	if (user_data.profile.rating.posters['' + poster_id]) {
		do_rate_poster(poster_id, user_data.profile.rating.posters['' + poster_id], true);
	}

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('poster_detail_" + poster_id + "');", 1);
		} else {
			setTimeout("bringforward('poster_detail_" + poster_id + "');", 1);
		}
	} else {
		onPageChanged();
	}

}

function loadPOIDetail(poi_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('points-of-interest');

	var this_poi = this_congress.poi_information['' + poi_id];

	var isCurrent = ($('#poi_detail_' + poi_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var poi_image_url = '';
	if (this_congress.media_information['poi'] && this_congress.media_information['poi']['' + poi_id]) {
		var poi_media = this_congress.media_information['poi']['' + poi_id];

		if (poi_media.offline) {
			poi_image_url = fsRoot + '/' + poi_media.name;
		} else {
			pois_image_url = poi_media.imgURL_small;
		}
	} else {
		poi_image_url = 'img/defaults/Img_poi.png';
	}


	var poiDetailHtml = '';
	poiDetailHtml += '<div class="normal_page scroll ' + initialPosition + '" id="poi_detail_' + poi_id + '">';
	poiDetailHtml += '<div class="scroll_lock">';
	poiDetailHtml += '<div class="detailDiv poi">';
	poiDetailHtml += '<div class="poiHeader">';
	poiDetailHtml += '<table><tr><td>';
	poiDetailHtml += '<div class="big_pic"><img src="' + poi_image_url + '" /></div>';
	poiDetailHtml += '</td><td>';
	poiDetailHtml += '<div class="poi_name font_color_dark kinda_title_color font_bold">' + this_poi.poi_name + '</div>';
	if (this_poi.poi_type) {
		var this_poi_type = this_congress.poi_types_information['' + this_poi.poi_type];
		poiDetailHtml += '<div class="description font_color_gray_1">' + this_poi_type.poi_type_name + '</div>';
	}

	poiDetailHtml += '</td></tr></table>';
	poiDetailHtml += '</div>';
	poiDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-about-poi') + '</div>';

	if (this_poi.poi_description && this_poi.poi_description == '') {
		poiDetailHtml += '<div class="info_div font_color_gray_1">' + trd('no-poi-description') + '</div>';

	} else {
		poiDetailHtml += '<div class="poi_description description">' + this_poi.poi_description + '</div>';
	}

	if (this_poi.resources.length > 0) {
		poiDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('associated-resources') + '</div>';

		first = true;
		$.each(this_poi.resources, function(index, this_resource_id) {
			poiDetailHtml += getHtmlForResourceInfo(this_resource_id);
		});
	}


	poiDetailHtml += '</div>';

	poiDetailHtml += '</div>';

	poiDetailHtml += '</div>';

	$('#poi_detail_' + poi_id).remove();
	$('.mainDiv').append(poiDetailHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('poi_detail_" + poi_id + "');", 1);
		} else {
			setTimeout("bringforward('poi_detail_" + poi_id + "');", 1);
		}
	} else {
		onPageChanged();
	}

}

function loadFeedbackDetail(feedback_id) {
	var this_feedback = this_congress.feedback_information['' + feedback_id];

	var scored = isFeedbackScored(feedback_id);
	if (scored) {
		if (user_data && user_data.profile.feedback && user_data.profile.feedback['' + feedback_id]) {
			showToastrAlert('info', trd('quiz-already-answered'));
			return;
		}
	}

	if (!this_feedback.questions || this_feedback.questions.length < 1) {
		return;
	}

	loadQuestionDetail(this_feedback.questions[0]);
}

function loadQuestionDetail(question_id, fromHistory) {
	setSelectedMenuArea('feedback');
	var this_question = this_congress.questions_information['' + question_id];
	var this_feedback = this_congress.feedback_information['' + this_question.feedback_id];
	var feedback_id = this_question.feedback_id;

	var this_question = this_congress.questions_information['' + question_id];

	var isCurrent = ($('#question_detail_' + question_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var questionDetailHtml = '';



	questionDetailHtml += '<div class="normal_page ' + initialPosition + '" id="question_detail_' + question_id + '">';

	questionDetailHtml += '<div class="list_page_header ">';
	questionDetailHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('feedback') + '</div></div>';
	questionDetailHtml += '</div>';

	questionDetailHtml += '<div class="list_page scroll">';



	questionDetailHtml += '<div class="question_text font_color_dark">' + this_question.question_text + '<div class="question_counter font_color_gray_1">' + (this_feedback.questions.indexOf('' + this_question.question_id) + 1) + '/' + this_feedback.questions.length + '</div></div>';

	questionDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';

	if (this_question.question_type == 'select_one') {
		$.each(this_question.options, function(index, this_option_id) {
			var this_option = this_congress.options_information['' + this_option_id];
			var selectedMod = '';
			if (user_data.profile.feedback['' + feedback_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] == this_option_id) {
				selectedMod = 'selected';
			}
			questionDetailHtml += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element ' + selectedMod + '" id="option_element_' + this_option.option_id + '" onclick="selectOption(' + this_question.feedback_id + ',' + this_question.question_id + ',' + this_option.option_id + ');"><table><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
		});
	} else if (this_question.question_type == 'select_many') {
		$.each(this_question.options, function(index, this_option_id) {
			var this_option = this_congress.options_information['' + this_option_id];
			var selectedMod = '';
			if (user_data.profile.feedback['' + feedback_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] && user_data.profile.feedback['' + feedback_id]['' + question_id].indexOf(this_option_id) >= 0) {
				selectedMod = 'selected';
			}
			questionDetailHtml += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element ' + selectedMod + '" id="option_element_' + this_option.option_id + '" onclick="selectOptionMultiple(' + this_question.feedback_id + ',' + this_question.question_id + ',' + this_option.option_id + ');"><table><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
		});

	} else { //write an answer
		var mainDivWidth = $('.mainDiv').width();
		questionDetailHtml += '<textarea maxlength="300" placeholder="' + trd('answer-text-placeholder') + '" class="answer_text" id="answer_text_' + this_question.question_id + '" onkeyup="saveAnswerText(' + this_question.feedback_id + ',' + this_question.question_id + ')" style="width:' + (mainDivWidth - 10) + 'px;height:200px;margin:auto;border:0;background-color:transparent;padding: 20px;"></textarea>';
	}

	var this_question_index = this_feedback.questions.indexOf('' + question_id);

	if (this_question_index == this_feedback.questions.length - 1) {
		questionDetailHtml += '<div class="btn-done font_bold color_bg_division_2" onclick="finishedFeedback(' + this_feedback.feedback_id + ');">' + trd('finish-questionnaire') + '</div>';
	} else {
		var next_question_id = this_feedback.questions[(this_question_index + 1)];
		questionDetailHtml += '<div class="btn-done color_bg_division_2" onclick="nextQuestion(' + this_feedback.feedback_id + ',' + this_question_index + ');">' + trd('next-question') + '</div>';
	}

	questionDetailHtml += '</div>';
	questionDetailHtml += '</div>';

	$('#question_detail_' + question_id).remove();
	$('.mainDiv').append(questionDetailHtml);

	if (user_data.profile.feedback['' + feedback_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] && this_question.question_type == 'write') {
		$('#answer_text_' + this_question.question_id).val(user_data.profile.feedback['' + feedback_id]['' + question_id]);
	}

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('question_detail_" + question_id + "');", 1);
		} else {
			setTimeout("bringforward('question_detail_" + question_id + "');", 1);
		}
	} else {
		onPageChanged();
	}

}

function getHtmlForQuestion(question_id) {
	var this_question = this_congress.questions_information['' + question_id];
	var feedback_id = this_question.feedback_id;

	var questionDetailHtml = '';

	questionDetailHtml += '<div class="question_text font_color_dark">' + this_question.question_text + '<div class="question_counter font_color_gray_1">' + (this_feedback.questions.indexOf('' + this_question.question_id) + 1) + '/' + this_feedback.questions.length + '</div></div>';

	questionDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';

	$.each(this_question.options, function(index, this_option_id) {

		var this_option = this_congress.options_information['' + this_option_id];


		var selectedMod = '';
		if (user_data.profile.feedback['' + feedback_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] && user_data.profile.feedback['' + feedback_id]['' + question_id] == this_option_id) {
			selectedMod = 'selected';
		}

		questionDetailHtml += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element ' + selectedMod + '" id="option_element_' + this_option.option_id + '" onclick="selectOption(' + this_question.feedback_id + ',' + this_question.question_id + ',' + this_option.option_id + ');"><table><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + this_option.option_text + '</span></td></tr></table></div>';
	});

	var this_question_index = this_feedback.questions.indexOf('' + question_id);

	if (this_question_index == this_feedback.questions.length - 1) {
		questionDetailHtml += '<div class="btn-done font_bold color_bg_division_2" onclick="finishedFeedback(' + this_feedback.feedback_id + ');">' + trd('finish-questionnaire') + '</div>';
	} else {

		var next_question_id = this_feedback.questions[(this_question_index + 1)];
		questionDetailHtml += '<div class="btn-done color_bg_division_2" onclick="nextQuestion(' + this_feedback.feedback_id + ',' + this_question_index + ');">' + trd('next-question') + '</div>';
	}
}

function nextQuestion(this_feedback_id, this_question_index) {
	var this_feedback = this_congress.feedback_information['' + this_feedback_id];
	var this_question_id = this_feedback.questions[this_question_index];
	var this_question = this_congress.questions_information['' + this_question_id];

	if (this_question.mandatory && this_question.mandatory == '1') {
		if ($('.option_element').length > 0 && $('.option_element.selected').length == 0) {
			showToastrAlert('warning', trd('must-answer-question') + '');
			return;
		} else if ($('.answer_text').length > 0 && $('.answer_text').val() == '') {
			showToastrAlert('warning', trd('must-answer-question') + '');
			return;
		}
	}
	var this_feedback = this_congress.feedback_information['' + this_feedback_id];
	var next_question_id = this_feedback.questions[(this_question_index + 1)];
	loadQuestionDetail(next_question_id, false);

}

function finishedFeedback(feedback_id, from_instant_feedback) {


	var this_feedback = this_congress.feedback_information['' + feedback_id];
	var this_question_id = this_feedback.questions[this_feedback.questions.length - 1];
	var this_question = this_congress.questions_information['' + this_question_id];

	if (this_question.mandatory && this_question.mandatory == '1') {
		if ($('.option_element').length > 0 && $('.option_element.selected').length == 0) {
			showToastrAlert('warning', trd('must-answer-question') + '');
			return;
		} else if ($('.answer_text').length > 0 && $('.answer_text').val() == '') {
			showToastrAlert('warning', trd('must-answer-question') + '');
			return;
		}
	}

	var scored = isFeedbackScored(feedback_id);
	if (from_instant_feedback) { //used for instant feedback of type write
		showToastrAlert('success', trd('message-finished-quiz'));
		closeModal();
	} else {
		if (scored) {
			showToastrAlert('success', trd('message-finished-quiz'));
		} else {
			showToastrAlert('success', trd('message-finished-questionnaire') + '');
		}
		if (this_feedback.session_id) {
			loadSessionDetail(this_feedback.session_id, true);
		} else {
			if (scored) {
				loadScoredFeedbackIndex(true);
			} else {
				loadFeedbackIndex(true);
			}

		}
	}
	saveUserDataToStorage();
	updateProfile();
}


function selectOption(feedback_id, question_id, option_id, is_polling, session_id) {
	$('.option_element').removeClass('selected');
	$('#option_element_' + option_id).addClass('selected');
	if (!user_data.profile.feedback) {
		user_data.profile.feedback = {};
	}
	if (!user_data.profile.feedback['' + feedback_id]) {
		user_data.profile.feedback['' + feedback_id] = {};
	}
	user_data.profile.feedback['' + feedback_id]['' + question_id] = option_id;
	if (is_polling) {
		//answerPoll(option_id,question_id);
		answerPollSocket(feedback_id, question_id, option_id, session_id);
		saveUserDataToStorage();
		updateProfile();
	}
}

function selectOptionMultiple(feedback_id, question_id, option_id, is_polling, session_id) {
	$('#option_element_' + option_id).toggleClass('selected');
	if (!user_data.profile.feedback) {
		user_data.profile.feedback = {};
	}
	if (!user_data.profile.feedback['' + feedback_id]) {
		user_data.profile.feedback['' + feedback_id] = {};
	}
	if (!user_data.profile.feedback['' + feedback_id]['' + question_id]) {
		user_data.profile.feedback['' + feedback_id]['' + question_id] = '';
	}
	if (user_data.profile.feedback['' + feedback_id]['' + question_id].toString().indexOf('' + option_id) > -1) {
		var options = user_data.profile.feedback['' + feedback_id]['' + question_id].split(',');
		var index = options.indexOf('' + option_id);
		options.splice(index, 1);
		user_data.profile.feedback['' + feedback_id]['' + question_id] = options.join(',');
	} else {
		if (!user_data.profile.feedback['' + feedback_id]['' + question_id]) {
			user_data.profile.feedback['' + feedback_id]['' + question_id] = ('' + option_id);
		} else {
			user_data.profile.feedback['' + feedback_id]['' + question_id] += (',' + option_id);
		}
	}
}

function saveAnswerText(feedback_id, question_id) {
	var answer_text = $('#answer_text_' + question_id).val();
	console.log(answer_text);
	if (answer_text) {
		if (!user_data.profile.feedback) {
			user_data.profile.feedback = {};
		}
		if (!user_data.profile.feedback['' + feedback_id]) {
			user_data.profile.feedback['' + feedback_id] = {};
		}
		user_data.profile.feedback['' + feedback_id]['' + question_id] = answer_text;
	}
}

function answerPoll(option_id) {
	var params = {
		f: 'answerPoll',
		e: 'polls',
		params: {
			option_id: option_id,
			user_id: user_data.profile.user_id
		}
	};

	var url = services_home + 'backend/services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: params,
		success: function answered(response) {
			//alert(JSON.stringify(response));
		},
		error: function(xhr, ajaxOptions, thrownError) {
			//alert(JSON.stringify(xhr));
		}
	});
}

function answerPollSocket(feedback_id, question_id, option_id, session_id) {
	if (polling_socket) {
		var vote = {
			session_id: session_id,
			congress_id: this_congress.congress_information.congress_id,
			user_id: user_data.profile.user_id,
			feedback_id: feedback_id,
			question_id: question_id,
			option_id: option_id
		}
		polling_socket.emit('vote', vote);
		setTimeout(function() {
			if ($('#question_detail_' + question_id).length > 0) {
				$('#question_detail_' + question_id).hide();
				$('.polling_answered_question').show();
			}
		}, 1000);
	}
}

function loadSponsorDetail(sponsor_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	var this_sponsor = this_congress.sponsors_information['' + sponsor_id];

	var isCurrent = ($('#sponsor_detail_' + sponsor_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var sponsorImageUrl = '';

	if (this_congress.media_information['sponsor'] && this_congress.media_information['sponsor']['' + sponsor_id]) {
		this_sponsor_image = this_congress.media_information['sponsor']['' + sponsor_id];
		if (this_sponsor_image.offline) {
			this_sponsor.sponsor_image = fsRoot + '/' + this_sponsor_image.name;
		} else {
			this_sponsor.sponsor_image = this_sponsor_image.imgURL_small;
		}
	} else {
		this_sponsor.sponsor_image = 'img/defaults/Img_sponsor.png';
	}

	var sponsorDetailHtml = '';
	sponsorDetailHtml += '<div class="normal_page scroll ' + initialPosition + '" id="sponsor_detail_' + sponsor_id + '">';
	sponsorDetailHtml += '<div class="scroll_lock">';
	sponsorDetailHtml += '<div class="detailDiv sponsor">';
	sponsorDetailHtml += '<table><tr><td>';
	sponsorDetailHtml += '<div class="big_pic"><img src="' + this_sponsor.sponsor_image + '" /></div>';
	sponsorDetailHtml += '</td><td>';
	sponsorDetailHtml += '<div class="sponsor_name font_color_dark kinda_title_color font_bold">' + this_sponsor.sponsor_name + '</div>';

	if (this_sponsor.sponsor_subtitle) {

		sponsorDetailHtml += '<div class="sponsor_short_description font_color_gray_1">' + this_sponsor.sponsor_subtitle + '</div>';

	}
	sponsorDetailHtml += '</td></tr></table>';


	sponsorDetailHtml += '<div class="actions_div">';

	if (this_sponsor.sponsor_website) {

		sponsorDetailHtml += '<div class="action" onclick="openLink(\'' + this_sponsor.sponsor_website + '\');""><div class="action_icon add_to_favs"><span class="cg-icon cg-icon-bt-link color_icon_clickable cg-icon-size-20"></span><div class="clickable_label font_color_gray_1">' + trd('bt-sponsor-website') + '</div></div><div class="action_title font_bold">' + trd('bt-sponsor-website') + '</div></div>';
	}


	sponsorDetailHtml += '<div class="clearfix"></div>';
	sponsorDetailHtml += '</div>';

	sponsorDetailHtml += '</div>';

	sponsorDetailHtml += '<div class="division_bottom color_bg_division_1"></div>';


	sponsorDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-about-sponsor') + '</div>';

	if (this_sponsor.sponsor_description && this_sponsor.sponsor_description == '') {
		sponsorDetailHtml += '<div class="info_div  font_color_gray_1">' + trd('no-sponsor-description') + '</div>';
	} else {

		sponsorDetailHtml += '<div class="sponsor_description description font_color_gray_1">' + this_sponsor.sponsor_description + '</div>';

	}

	if (this_sponsor.resources.length > 0) {
		sponsorDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('associated-resources') + '</div>';

		first = true;
		$.each(this_sponsor.resources, function(index, this_resource_id) {
			if (first) {
				first = false;
			} else {
				sponsorDetailHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';
			}
			sponsorDetailHtml += getHtmlForResourceInfo(this_resource_id);
		});
	}

	if (this_sponsor.sponsor_exhibitor) {
		sponsorDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('sponsor-associated-exhibitor') + '</div>';

		sponsorDetailHtml += getHtmlForExhibitorInfo(this_sponsor.sponsor_exhibitor);
	}

	sponsorDetailHtml += '</div>';

	sponsorDetailHtml += '</div>';

	sponsorDetailHtml += '</div>';

	$('#sponsor_detail_' + sponsor_id).remove();
	$('.mainDiv').append(sponsorDetailHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('sponsor_detail_" + sponsor_id + "');", 1);
		} else {
			setTimeout("bringforward('sponsor_detail_" + sponsor_id + "');", 1);
		}
	} else {
		onPageChanged();
	}
}

function loadCustomArea(area_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('area_' + area_id);

	var this_area = this_congress.areas_information['' + area_id];

	var isCurrent = ($('#area_detail_' + area_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var customAreaHtml = '';
	customAreaHtml += '<div class="normal_page scroll ' + initialPosition + '" id="custom_area_' + area_id + '">';
	customAreaHtml += '<div class="detailDiv description custom font_color_gray_1" id="area_description">';
	customAreaHtml += replaceEmbededVariables(blocks.replaceSources(this_area.area_description));
	customAreaHtml += '</div>';
	customAreaHtml += '</div>';

	$('#custom_area_' + area_id).remove();
	$('.mainDiv').append(customAreaHtml);

	$('.custom h2').addClass('section_title');
	$('.custom h2').addClass('bg_color_dark');
	$('.custom h2').addClass('font_color_white');

	getAreaDescription(area_id);


	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('custom_area_" + area_id + "');", 1);
		} else {
			setTimeout("bringforward('custom_area_" + area_id + "');", 1);
		}
	} else {
		onPageChanged();
	}
}

function replaceEmbededVariables(html) { //replaces ººkey/variableºº with 
	var embeds = html.match(/ºº\S+ºº/g);
	if (!embeds) { return html; }
	embeds.map(function(e) {
		var embed = e.replace(/ºº/g, '');
		console.log(e);
		console.log(embed);
		if (this_congress && this_congress.translations && this_congress.translations[embed]) {
			html = html.replace(e, this_congress.translations[embed]);
		} else {
			var embed_split = embed.split('.');
			console.log(embed_split);
			var variable = window;
			var valid = true;
			embed_split.map(function(s) {
				if (valid && variable[s]) { variable = variable[s]; } else { valid = false; }
			});
			if (valid) { html = html.replace(e, variable); } else { html = html.replace(e, ''); }
		}
	});
	console.log(12701);
	console.log(html);
	return html;
}

function getAreaDescription(area_id) {
	var params = {
		f: 'getAreaDescription',
		area_id: area_id,
		lang: this_congress.congress_information.congress_lang,
		link_get: {
			user_id: user_data.profile.user_id,
			lang: this_congress.congress_information.congress_lang,
			congress_id: this_congress.congress_information.congress_id
		}
	};

	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function areaDescriptionLoaded(response) {
			console.log('response: ' + JSON.stringify(response));
			if (response.success && response.object) {
				if (response.object.area_description == '') {
					$('#area_description').html('<div class="font_color_gray_1" style="font-size:14pt;text-align:center;padding:20px">' + trd('area-description-empty') + '</div>');

				} else {
					$('#area_description').html(replaceEmbededVariables(blocks.replaceSources(response.object.area_description)));
					$('.custom h2').addClass('section_title');
					$('.custom h2').addClass('bg_color_dark');
					$('.custom h2').addClass('font_color_white');
					replaceLinks();
				}

			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('ERROR:' + JSON.stringify(xhr));
			//cgAlert(trd('error-connection-unstable'));
		}
	});
}

function registerUserIntoSession(session_id) {
	if (conflictingSessions(session_id).length > 0) {
		showToastrAlert('error', trd('conflicting-sessions-found'));
		return;
	}
	var params = {
		f: 'registerUserIntoSession',
		session_id: session_id,
		user_id: user_data.profile.user_id
	};
	showLoadingOverlay();
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function userRegisteredIntoSession(response) {
			hideLoadingOverlay();
			console.log('response: ' + JSON.stringify(response));
			if (response.success) {
				if (!array_contains(user_data.profile.agenda["sessions"], session_id))
					add_to_my_agenda(session_id, true);
				showToastrAlert('success', trd('user-registered'));
			} else {
				showToastrAlert('error', response.message);
			}
			checkSessionRegistrations(session_id);

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('ERROR:' + JSON.stringify(xhr));
			//cgAlert(trd('error-connection-unstable'));
		}
	});
}

function unregisterUserFromSession(session_id) {
	var params = {
		f: 'unregisterUserFromSession',
		session_id: session_id,
		user_id: user_data.profile.user_id
	};
	showLoadingOverlay();
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	console.log('calling ' + url);
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		dataType: 'json',
		data: { params: params },
		success: function userUnregisteredFromSession(response) {
			hideLoadingOverlay();
			console.log('response: ' + JSON.stringify(response));
			if (response.success) {
				if (array_contains(user_data.profile.agenda["sessions"], session_id))
					add_to_my_agenda(session_id, true);
				showToastrAlert('success', trd('user-unregistered'));
			} else {
				showToastrAlert('error', response.message);
			}
			checkSessionRegistrations(session_id);
		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('ERROR:' + JSON.stringify(xhr));
			//cgAlert(trd('error-connection-unstable'));
		}
	});
}


function loadSpeakerDetail(speaker_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('speakers');

	var this_speaker = this_congress.speakers_information['' + speaker_id];

	var isCurrent = ($('#speaker_detail_' + speaker_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

    this_speaker.speaker_image = getImageForSpeaker(speaker_id);

	var speakerDetailHtml = '';
	speakerDetailHtml += '<div class="normal_page scroll ' + initialPosition + '" id="speaker_detail_' + speaker_id + '">';
	speakerDetailHtml += '<div class="scroll_lock">';
	speakerDetailHtml += '<div class="detailDiv speaker">';
	speakerDetailHtml += '<div class="speakerHeader">';
	speakerDetailHtml += '<table><tr><td>';
	speakerDetailHtml += '<div class="big_pic"><img src="' + this_speaker.speaker_image + '" /></div>';
	speakerDetailHtml += '</td><td>';
	speakerDetailHtml += '<div class="speaker_name font_bold kinda_title font_color_dark">' + this_speaker.speaker_first_name + ' ' + this_speaker.speaker_last_name + '</div>';
	speakerDetailHtml += '<div class="speaker_short_description">' + this_speaker.speaker_subtitle + '</div>';
    if(this_speaker.user_id){
        speakerDetailHtml += '<div onclick="loadProfileDetail(' + this_speaker.user_id + ')" class="speaker_short_description color_icon_top_menu"><span >' + trd('participant-profile') + '</span><span class="cg-icon cg-icon-fwd cg-icon-size-10" style="width: 20px; "></span></div>';
    }
	speakerDetailHtml += '</td></tr></table>';
	speakerDetailHtml += '</div>';


    if(this_congress.congress_information.has_rate_speakers == '1'){
	speakerDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('rate-this-speaker') + '</div>';
	speakerDetailHtml += '<div class="rate_speaker">';
	speakerDetailHtml += '<div class="stars_container clearfix">';
	speakerDetailHtml += '<div class="face1" id="rate_speaker_' + speaker_id + 'star_1" onclick="do_rate_speaker(' + speaker_id + ',1);"></div>';
	speakerDetailHtml += '<div class="face2" id="rate_speaker_' + speaker_id + 'star_2" onclick="do_rate_speaker(' + speaker_id + ',2);"></div>';
	speakerDetailHtml += '<div class="face3" id="rate_speaker_' + speaker_id + 'star_3" onclick="do_rate_speaker(' + speaker_id + ',3);"></div>';
	speakerDetailHtml += '<div class="face4" id="rate_speaker_' + speaker_id + 'star_4" onclick="do_rate_speaker(' + speaker_id + ',4);"></div>';
	speakerDetailHtml += '<div class="face5" id="rate_speaker_' + speaker_id + 'star_5" onclick="do_rate_speaker(' + speaker_id + ',5);"></div>';
	speakerDetailHtml += '</div>';
	speakerDetailHtml += '</div>';
    }

	if (this_speaker.speaker_profile_id) {
		speakerDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('title-speaker-participant-profile') + '</div>';
		speakerDetailHtml += '<div class="block_button color_bg_division_2" style="font-size:10px;margin:15px" onclick="loadProfileDetail(' + this_speaker.speaker_profile_id + ')">' + trd('bt-speaker-participant-profile') + '</div>';
		//speakerDetailHtml += getHtmlForProfileInfo(this_speaker.speaker_profile_id);
	}

	speakerDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('section-about-speaker') + '</div>';
	if (!this_speaker.speaker_description) {
		speakerDetailHtml += '<div class="info_div  font_color_gray_1">' + trd('no-speaker-description') + '</div>';
	} else {
		speakerDetailHtml += '<div class="speaker_description description">' + this_speaker.speaker_description + '</div>';
	}



	if (this_speaker.speaker_sessions.length > 0) {
		speakerDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('associated-sessions') + '</div>';

		$.each(this_speaker.speaker_sessions, function(index, this_session_id) {
			speakerDetailHtml += getHtmlForMiniSessionInfo(this_session_id);
		});

	}

	if (this_speaker.resources.length > 0) {
		speakerDetailHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('associated-resources') + '</div>';

		first = true;
		$.each(this_speaker.resources, function(index, this_resource_id) {
			if (first) {
				first = false;
			} else {
				speakerDetailHtml += '<div class="division_bottom color_bg_division_1">&nbsp;</div>';
			}
			speakerDetailHtml += getHtmlForResourceInfo(this_resource_id);
		});
	}

	speakerDetailHtml += '</div>';

	speakerDetailHtml += '</div>';
	speakerDetailHtml += '</div>';

	$('#speaker_detail_' + speaker_id).remove();
	$('.mainDiv').append(speakerDetailHtml);

	if (user_data.profile["rating"]["speakers"]['' + speaker_id]) {
		do_rate_speaker(speaker_id, user_data.profile["rating"]["speakers"]['' + speaker_id], true);
	}

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('speaker_detail_" + speaker_id + "');", 1);
		} else {
			setTimeout("bringforward('speaker_detail_" + speaker_id + "');", 1);
		}
	} else {
		onPageChanged();
	}

}

function loadNextSessions(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('program');

	var isCurrent = ($('#next_sessions_page.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var nextSessionsHtml = '';
	nextSessionsHtml += '<div class="normal_page scroll ' + initialPosition + '" id="next_sessions_page">';
	nextSessionsHtml += '<div class="scroll_lock">';

	var next_sessions_list = nextSessions();
	nextSessionsHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('next-sessions') + '</div>';
	if (next_sessions_list.length > 0) {
		$.each(next_sessions_list, function(index, this_session_id) {
			nextSessionsHtml += getHtmlForSessionInfo(this_session_id);
		});
	} else {
		nextSessionsHtml += '<div class="info_div font_color_gray_1">' + trd('no-next-sessions') + '</div>';
	}


	nextSessionsHtml += '</div>';
	nextSessionsHtml += '</div>';

	$('#next_sessions_page').remove();
	$('.mainDiv').append(nextSessionsHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('next_sessions_page');", 1);
		} else {
			setTimeout("bringforward('next_sessions_page');", 1);
		}
	} else {
		onPageChanged();
	}

}

function loadPollingSessions(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('program');

	var isCurrent = ($('#polling_sessions_page.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var pollingSessionsHtml = '';
	pollingSessionsHtml += '<div class="normal_page scroll ' + initialPosition + '" id="polling_sessions_page">';
	pollingSessionsHtml += '<div class="scroll_lock">';

	var polling_sessions_list = pollingSessions();
	pollingSessionsHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('polling-sessions-list') + '</div>';
	if (polling_sessions_list.length > 0) {
		$.each(polling_sessions_list, function(index, this_session_id) {
			pollingSessionsHtml += getHtmlForMiniSessionInfo(this_session_id, 'showPollingModal(' + this_session_id + ');');
		});
	} else {
		pollingSessionsHtml += '<div class="info_div font_color_gray_1">' + trd('no-polling-sessions') + '</div>';
	}


	pollingSessionsHtml += '</div>';
	pollingSessionsHtml += '</div>';

	$('#polling_sessions_page').remove();
	$('.mainDiv').append(pollingSessionsHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('polling_sessions_page');", 1);
		} else {
			setTimeout("bringforward('polling_sessions_page');", 1);
		}
	} else {
		onPageChanged();
	}

}

function loadModerationSessions(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('program');

	var isCurrent = ($('#moderation_sessions_page.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var moderationSessionsHtml = '';
	moderationSessionsHtml += '<div class="normal_page scroll ' + initialPosition + '" id="moderation_sessions_page">';
	moderationSessionsHtml += '<div class="scroll_lock">';

	var moderation_sessions_list = moderationSessions();
	moderationSessionsHtml += '<div class="section_title font_bold color_bg_division_1 font_color_white">' + trd('moderation-sessions-list') + '</div>';
	if (moderation_sessions_list.length > 0) {
		$.each(moderation_sessions_list, function(index, this_session_id) {
			moderationSessionsHtml += getHtmlForMiniSessionInfo(this_session_id, 'showSessionQuestionModal(' + this_session_id + ');');
		});
	} else {
		moderationSessionsHtml += '<div class="info_div font_color_gray_1">' + trd('no-moderation-sessions') + '</div>';
	}


	moderationSessionsHtml += '</div>';
	moderationSessionsHtml += '</div>';

	$('#moderation_sessions_page').remove();
	$('.mainDiv').append(moderationSessionsHtml);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('moderation_sessions_page');", 1);
		} else {
			setTimeout("bringforward('moderation_sessions_page');", 1);
		}
	} else {
		onPageChanged();
	}

}



function bringforward(pageid) {
	var options = {
		"direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
		"duration": 200, // in milliseconds (ms), default 400
		"slowdownfactor": 4, // overlap views (higher number is more) or no overlap (1). -1 doesn't slide at all. Default 4
		//"slidePixels"      :   100, // optional, works nice with slowdownfactor -1 to create a 'material design'-like effect. Default not set so it slides the entire page.
		"iosdelay": 60, // ms to wait for the iOS webview to update before animation kicks in, default 60
		"androiddelay": 70, // same as above but for Android, default 70
		"winphonedelay": 250, // same as above but for Windows Phone, default 200,
		"fixedPixelsTop": 0, // the number of pixels of your fixed header, default 0 (iOS and Android)
		"fixedPixelsBottom": 0 // the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
	};
	if ($('.smallscreen').length > 0 && $('.loading_page').length == 0 && isMobile && !isIOS) {
		window.plugins.nativepagetransitions.slide(options);
		hideMenu();
	}

	$('#' + pageid).removeClass('future');
	if ($('.current').length > 0) {
		page_moving = true;
		$('.current').addClass('past');
		var currentId = $('.current').attr('id');
		$('.current').removeClass('current');
		if (currentId) {
			if (isIOS) {
				setTimeout("$('#" + currentId + "').remove();", 200);
			} else {
				$('#' + currentId).remove();
			}

		}

		makeHistory(currentId);

		document.getElementById('mainDiv').scrollTop = 0;
	}


	$('#' + pageid).addClass('current');

	onPageChanged();
}

function clearOverlays() {
	clearMainDivOverlay();
	$('#headerOverlay').remove();
	dismissZoom();
	$('.pinpoint.selected').removeClass('selected');
	resizePinpoints();
	$('.exhibitor_popover').remove();

	$('#mapInfoDiv').css('max-height', '0');
	$('#mapInfoDiv_content').css('max-height', '0');


}

function clickedMainOverlay() {
	clearOverlays();
	hideBothMenus();
}

function onPageChanged() {

	clearOverlays();

	saveActionInHistory($('.current').attr('id'));
	$('#back_button').show();

	clearInterval(update_timer_session_info);
	clearInterval(registration_interval);

	hideFilter();

	$('.filter_button').hide();

	if ($('.current').length == 0) {
		return;
	}

	if ($('.current').attr('id') == 'speakers_index') {
		$('.filter_button').hide();
		$('.filter_label.right').hide();
	}
	if ($('.current').attr('id') == 'conversations_index') {
		$('.filter_button').hide();
		$('.filter_label.right').hide();
	}

	if ($('.current').attr('id') == 'profiles_index') {
		$('.filter_button').hide();
		$('.filter_label.right').hide();
	}

	if ($('.current').attr('id') == 'resources_index' && this_congress.congress_information.congress_resources_types.length > 0) {
		$('.filter_button').show();
		$('.filter_label.right').show();
		loadResourcesFilters();
	}

	if ($('.current').attr('id') == 'session_index') {
		$('.filter_button').show();
		$('.filter_label.right').show();
		loadSessionFilters();
	}

	if ($('.current').attr('id') == 'posters_index') {
		if (this_congress.congress_information.congress_poster_types.length > 0) {
			$('.filter_button').show();
			$('.filter_label.right').show();
		} else {
			$('.filter_button').hide();
			$('.filter_label.right').hide();
		}

		loadPosterFilters();
	}

	if ($('.current').attr('id') == 'poi_index' && this_congress.congress_information.congress_poi_types.length > 0) {
		$('.filter_button').show();
		$('.filter_label.right').show();
		loadPOIFilters();
	}

	if ($('.current').attr('id') == 'sponsors_index' && this_congress.congress_information.congress_sponsor_types.length > 0) {
		$('.filter_button').show();
		$('.filter_label.right').show();
		loadSponsorsFilters();
	}

	if ($('.current').attr('id') == 'exhibitors_index' && this_congress.congress_information.congress_exhibitor_types.length > 0) {
		$('.filter_button').show();
		$('.filter_label.right').show();
		loadExhibitorsFilters();
	}


	if ($('.current').attr('id') == 'mapDiv') {
		$('.filter_button').show();
		$('.filter_label.right').show();
		loadFloorplanFilters();
	}

	if ($('.current').attr('id') == 'myagenda') {
		$('.filter_button').show();
		$('.filter_label.right').show();
		loadMyAgendaFilters();
	}

	/*if ($('.current').attr('id').indexOf('session_detail') > -1){
	  update_timer_session_info = setInterval("checkSessionUpdate();",1000);
	}
	else if ($('#session_questionnaires_modal').length > 0){
	  update_timer_session_info = setInterval("checkSessionUpdate();",1000);
	}
	else if ($('.current').attr('id').indexOf('feedback_index_for_session_') > -1){
	  update_timer_session_info = setInterval("checkSessionUpdate();",1000);
	}*/

	if (clearhistorybool) {
		my_history = [];
		clearhistorybool = false;
	}

	if (this_congress && this_congress.congress_information.homescreen_id) {
		if ($('.current').attr('id').indexOf(this_congress.congress_information.homescreen_id)) {
			$('#nav_header').show();
			$('#dash_header').hide();
		} else {
			$('#nav_header').hide();
			$('#dash_header').show();

		}
	} else {
		if ($('.current').attr('id').indexOf('dashboard')) {
			$('#nav_header').show();
			$('#dash_header').hide();
		} else {
			$('#nav_header').hide();
			$('#dash_header').show();

		}
	}

	if ($('.smallscreen').length > 0) {
		hideMenu();
	}

	replaceLinks();

	closeSockets();

	setTimeout("page_moving=false;", 220);

	FastClick.attach(document.body);
}

function replaceLinks() {
	$('a').click(function(event) {
		if ($(this).attr('href').indexOf('mailto') > -1) {
			return true;
		}
		if ($(this).hasClass('safelink')) {
			return true;
		}


		event.stopPropagation();
		event.preventDefault();

		if ($(this).attr('href').indexOf('http://') > -1 || $(this).attr('href').indexOf('https://') > -1) {
			openLink($(this).attr('href'));
		} else {
			console.log('cant open ' + $(this).attr('href'));
		}

	});
}

function hideBothMenus() {
	hideFilter();
	hideMenu();
}

function loadSessionFilters() {
	var filtersHtml = '';
	var selectedModifier = '';

	selectedModifier = '';
	if (SESSION_FILTER_DAY == -1) {
		selectedModifier = 'selected';
	}

	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white"><span class="area_title font_semibold">' + trd('filter-by-day') + '</span></div>';

	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="SESSION_FILTER_DAY=-1;loadSessionIndex(false);loadSessionFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';

	$.each(this_congress.congress_information.congress_days, function(index, this_day_id) {

		var this_day = this_congress.day_information['' + this_day_id];

		selectedModifier = '';
		if (SESSION_FILTER_DAY == this_day.day_id) {
			selectedModifier = 'selected';
		}

		filtersHtml += '<div class="side_menu_item  ' + selectedModifier + '" onclick="SESSION_FILTER_DAY=' + this_day.day_id + ';loadSessionIndex(false);loadSessionFilters();hideBothMenus();"><span class="area_title  font_semibold">' + this_day.day_name + '</span></div>';
	});

	selectedModifier = '';
	if (SESSION_FILTER_SESSION_TYPE == -1) {
		selectedModifier = 'selected';
	}


	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white"><span class="area_title  font_semibold">' + trd('filter-session-type') + '</span></div>';

	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="SESSION_FILTER_SESSION_TYPE=-1;loadSessionIndex(false);loadSessionFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';

	$.each(this_congress.congress_information.congress_session_types, function(index, this_session_type_id) {

		var this_session_type = this_congress.session_types_information['' + this_session_type_id];


		selectedModifier = '';
		if (SESSION_FILTER_SESSION_TYPE == this_session_type_id) {
			selectedModifier = 'selected';
		}

		filtersHtml += '<div class="side_menu_item  ' + selectedModifier + '" onclick="SESSION_FILTER_SESSION_TYPE=' + this_session_type_id + ';loadSessionIndex(false);loadSessionFilters();hideBothMenus();"><span class="area_title font_semibold">' + this_session_type.session_type_name + '</span><div class="session_type_color_indicator" style="background-color:' + this_session_type.session_type_color + '"></div></div>';
	});

	// SESSION TAGS

	$.each(this_congress.congress_information.congress_tags, function(index, this_session_tag_id) {

		var this_session_tag = this_congress.session_tags_information['' + this_session_tag_id];

		filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white"><span class="area_title font_semibold">' + this_session_tag.tag_name + '</span></div>';


		$.each(this_session_tag.alternatives, function(index_alternative, this_session_tag_alternative_id) {

			var this_alternative = this_congress.session_tag_alternatives_information['' + this_session_tag_alternative_id];

			selectedModifier = '';
			if (array_contains(SESSION_FILTER_TAGS, this_session_tag_alternative_id)) {
				selectedModifier = 'selected';
			}

			filtersHtml += '<div class="side_menu_item  ' + selectedModifier + '" onclick="filterSessionTag(' + this_session_tag_alternative_id + ');loadSessionIndex(false);loadSessionFilters();hideBothMenus();"><span class="area_title font_semibold">' + this_alternative.alternative_name + '</span></div>';

		});



	});

	// SESSION LOCATION



	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white"><span class="area_title font_semibold">' + trd('filter-location') + '</span></div>';

	selectedModifier = '';
	if (SESSION_FILTER_LOCATION == -1) {
		selectedModifier = 'selected';
	}


	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="SESSION_FILTER_LOCATION=-1;loadSessionIndex(false);loadSessionFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';

	$.each(this_congress.locations_information, function(index, this_location) {

		if (!this_location.sessions || this_location.sessions.length < 1) {
			return true;
		}

		selectedModifier = '';
		if (SESSION_FILTER_LOCATION == this_location.location_id) {
			selectedModifier = 'selected';
		}

		filtersHtml += '<div class="side_menu_item  font_color_white ' + selectedModifier + '" onclick="SESSION_FILTER_LOCATION=' + this_location.location_id + ';loadSessionIndex(false);loadSessionFilters();hideBothMenus();"><span class="area_title font_semibold font_color_gray_1">' + this_location.location_name + '</span></div>';
	});



	$('.side_menu_filter_container').html(filtersHtml);
}


function loadSessionIndexFilters(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('program');

	var isCurrent = ($('#session_index_filters.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var html = '';

	html += '<div class="normal_page scroll ' + initialPosition + '" id="session_index_filters">';
	html += '<div class="scroll_div scroll short">';


	var selectedFilterDescription = '';
	var selectedModifier = '';
	if (SESSION_FILTER_DAY && SESSION_FILTER_DAY != -1) {
		var this_day = this_congress.day_information['' + SESSION_FILTER_DAY];
		selectedFilterDescription = '<span class="selected_filter_indicator font_color_dark"><br>' + this_day.day_name + '</span>';
		selectedModifier = 'selected';
	}

	html += '<div class="filter_type_option font_color_gray_1 list_element ' + selectedModifier + '" onclick="loadChooseDayFilter();">' + trd('option-filter-by-day') + selectedFilterDescription + '<div class="arrow_next"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div></div>';

	selectedFilterDescription = '';
	selectedModifier = '';
	if (SESSION_FILTER_LOCATION && SESSION_FILTER_LOCATION != -1) {
		var this_location = this_congress.locations_information['' + SESSION_FILTER_LOCATION];
		selectedFilterDescription = '<span class="selected_filter_indicator font_color_dark"><br>' + this_location.location_name + '</span>';
		selectedModifier = 'selected';
	}

	html += '<div class="filter_type_option font_color_gray_1 list_element ' + selectedModifier + '" onclick="loadChooseLocationFilter();">' + trd('option-filter-by-room') + selectedFilterDescription + '<div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';


	selectedFilterDescription = '';
	selectedModifier = '';
	if (SESSION_FILTER_SESSION_TYPE && SESSION_FILTER_SESSION_TYPE != -1) {
		var this_session_type = this_congress.session_types_information['' + SESSION_FILTER_SESSION_TYPE];
		selectedFilterDescription = '<span class="selected_filter_indicator font_color_dark"><br>' + this_session_type.session_type_name + '</span>';
		selectedModifier = 'selected';
	}

	if (this_congress.congress_information.congress_session_types.length > 0) {
		html += '<div class="filter_type_option font_color_gray_1 list_element ' + selectedModifier + '" onclick="loadChooseSessionTypeFilter();">' + trd('option-filter-by-session-type') + selectedFilterDescription + '<div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';
	}


	$.each(this_congress.congress_information.congress_tags, function(index, this_session_tag_id) {
		selectedFilterDescription = '';
		selectedModifier = '';
		var this_session_tag = this_congress.session_tags_information['' + this_session_tag_id];

		$.each(SESSION_FILTER_TAGS, function(index_tag, this_alternative_id) {
			var this_alternative = this_congress.session_tag_alternatives_information['' + this_alternative_id];
			if (this_alternative.tag_id == this_session_tag_id) {
				if (selectedFilterDescription != '') {
					selectedFilterDescription += ' , '
				}

				selectedFilterDescription += this_alternative.alternative_name;
			}
		});

		html += '<div class="filter_type_option font_color_gray_1 list_element" onclick="loadChooseSessionTagFilter(' + this_session_tag_id + ')">' + trd('filter-by-') + ' ' + this_session_tag.tag_name + '<span class="selected_filter_indicator font_color_dark"><br>' + selectedFilterDescription + '</span><div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';
	});




	html += '</div>';
	html += '<div class="bottom_actions"><table><tr><td><div class="bottom_button color_bg_division_1" onclick="loadSessionIndex(true);">' + trd('button-apply-filters') + '</div></td><td><div class="bottom_button color_bg_division_1" onclick="clearSessionFilters();loadSessionIndex(true);">' + trd('button-clear-filters') + '</div></td></tr></table></div>';
	html += '</div>';

	$('#session_index_filters').remove();

	$('.mainDiv').append(html);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('session_index_filters');", 1);
		} else {
			setTimeout("bringforward('session_index_filters');", 1);
		}
	} else {
		onPageChanged();
	}
}

function clearSessionFilters() {
	SESSION_FILTER_TAGS = [];
	SESSION_FILTER_SESSION_TYPE = -1;
	SESSION_FILTER_DAY = -1;
	SESSION_FILTER_LOCATION = -1;
}

function loadChooseDayFilter(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('program');

	var isCurrent = ($('#choose_day.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var html = '';

	html += '<div class="normal_page ' + initialPosition + '" id="choose_day">';
	html += '<div class="scroll_div short scroll">';

	html += '<div class="filter_type_option font_color_gray_1 list_element" onclick="SESSION_FILTER_DAY=-1;loadSessionIndexFilters(true);hideBothMenus();">' + trd('option-any-day') + '<span class="selected_filter_indicator"></span><div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';

	$.each(this_congress.congress_information.congress_days, function(index, this_day_id) {

		var this_day = this_congress.day_information['' + this_day_id];

		selectedModifier = '';
		if (SESSION_FILTER_DAY == this_day.day_id) {
			selectedModifier = 'selected';
		}

		html += '<div class="filter_type_option font_color_gray_1 list_element ' + selectedModifier + '" onclick="SESSION_FILTER_DAY=' + this_day.day_id + ';loadSessionIndexFilters(true);hideBothMenus();">' + this_day.day_name + '<div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';
	});


	html += '</div>';
	html += '<div class="bottom_actions"><div class="bottom_button color_bg_division_1" onclick="loadSessionIndexFilters(true);">OK</div></div>';

	html += '</div>';

	$('#choose_day').remove();

	$('.mainDiv').append(html);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('choose_day');", 1);
		} else {
			setTimeout("bringforward('choose_day');", 1);
		}
	} else {
		onPageChanged();
	}
}

function loadChooseSessionTypeFilter(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('program');

	var isCurrent = ($('#choose_session_type.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var html = '';

	html += '<div class="normal_page ' + initialPosition + '" id="choose_session_type">';
	html += '<div class="scroll_div short scroll">';

	html += '<div class="filter_type_option font_color_gray_1 list_element" onclick="SESSION_FILTER_SESSION_TYPE=-1;loadSessionIndexFilters(true);hideBothMenus();">' + trd('option-any-session-type') + '<span class="selected_filter_indicator"></span><div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';

	$.each(this_congress.congress_information.congress_session_types, function(index, this_session_type_id) {

		var this_session_type = this_congress.session_types_information['' + this_session_type_id];

		selectedModifier = '';
		if (SESSION_FILTER_SESSION_TYPE == this_session_type_id) {
			selectedModifier = 'selected';
		}

		html += '<div class="filter_type_option font_color_gray_1 list_element ' + selectedModifier + '" onclick="SESSION_FILTER_SESSION_TYPE=' + this_session_type.session_type_id + ';loadSessionIndexFilters(true);hideBothMenus();">' + this_session_type.session_type_name + '<div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div><div class="session_type_color_indicator" style="background-color:' + this_session_type.session_type_color + '"></div></div>';
	});

	html += '</div>';
	html += '<div class="bottom_actions"><div class="bottom_button color_bg_division_1" onclick="loadSessionIndexFilters(true);">OK</div></div>';

	html += '</div>';

	$('#choose_session_type').remove();

	$('.mainDiv').append(html);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('choose_session_type');", 1);
		} else {
			setTimeout("bringforward('choose_session_type');", 1);
		}
	} else {
		onPageChanged();
	}
}

function loadChooseSessionTagFilter(tag_id, fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('program');

	var isCurrent = ($('#choose_session_tag_' + tag_id + '.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var html = '';

	html += '<div class="normal_page ' + initialPosition + '" id="choose_session_tag_' + tag_id + '">';
	html += '<div class="scroll_div short scroll">';

	var this_session_tag = this_congress.session_tags_information['' + tag_id];


	$.each(this_session_tag.alternatives, function(index_alternative, this_session_tag_alternative_id) {

		var this_alternative = this_congress.session_tag_alternatives_information['' + this_session_tag_alternative_id];

		selectedModifier = '';
		if (array_contains(SESSION_FILTER_TAGS, this_session_tag_alternative_id)) {
			selectedModifier = 'selected';
		}

		html += '<div class="filter_type_option font_color_gray_1 list_element ' + selectedModifier + '" id="list_element_' + this_session_tag_alternative_id + '" onclick="filterSessionTag(' + this_session_tag_alternative_id + ');">' + this_alternative.alternative_name + '<div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';
	});

	html += '</div>';
	html += '<div class="bottom_actions"><div class="bottom_button color_bg_division_1" onclick="loadSessionIndexFilters(true);">OK</div></div>';

	html += '</div>';

	$('#choose_session_tag_' + tag_id + '').remove();

	$('.mainDiv').append(html);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('choose_session_tag_" + tag_id + "');", 1);
		} else {
			setTimeout("bringforward('choose_session_tag_" + tag_id + "');", 1);
		}
	} else {
		onPageChanged();
	}
}

function loadChooseLocationFilter(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('program');

	var isCurrent = ($('#choose_location.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var html = '';

	html += '<div class="normal_page  ' + initialPosition + '" id="choose_location">';
	html += '<div class="scroll_div short scroll">';

	html += '<div class="filter_type_option font_color_gray_1 list_element" onclick="SESSION_FILTER_LOCATION=-1;loadSessionIndexFilters(true);hideBothMenus();">' + trd('option-any-location') + '<span class="selected_filter_indicator"></span><div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';

	$.each(this_congress.congress_information.congress_locations, function(index, this_location_id) {

		var this_location = this_congress.locations_information['' + this_location_id];

		selectedModifier = '';
		if (SESSION_FILTER_LOCATION == this_location.location_id) {
			selectedModifier = 'selected';
		}

		html += '<div class="filter_type_option font_color_gray_1 list_element ' + selectedModifier + '" onclick="SESSION_FILTER_LOCATION=' + this_location.location_id + ';loadSessionIndexFilters(true);hideBothMenus();">' + this_location.location_name + '<div class="arrow_next"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';
	});


	html += '</div>';
	html += '<div class="bottom_actions"><div class="bottom_button color_bg_division_1" onclick="loadSessionIndexFilters(true);">Voltar</div></div>';

	html += '</div>';

	$('#choose_location').remove();

	$('.mainDiv').append(html);

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('choose_location');", 1);
		} else {
			setTimeout("bringforward('choose_location');", 1);
		}
	} else {
		onPageChanged();
	}
}

function filterSessionTag(alternative_id) {
	if (array_contains(SESSION_FILTER_TAGS, alternative_id)) {
		remove_from_tag_filter(alternative_id);
		$('#list_element_' + alternative_id).removeClass('selected');
	} else {
		SESSION_FILTER_TAGS.push(alternative_id);
		$('#list_element_' + alternative_id).addClass('selected');
	}
}


function loadResourcesFilters() {
	var filtersHtml = '';

	var selectedModifier = '';
	if (RESOURCE_FILTER_TYPE == -1) {
		selectedModifier = 'selected';
	}

	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white clearfix"><span class="area_title font_semibold"><span class="cg-icon-character cg-icon-resources font_color_white cg-icon-size-14"></span> | ' + trd('filter-resource-types') + ':</span><div class="clearfix"></div></div>';

	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="RESOURCE_FILTER_TYPE=-1;loadResourcesIndex(false);loadResourcesFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';


	$.each(this_congress.congress_information.congress_resources_types, function(index, this_resource_type_id) {

		selectedModifier = '';
		if (RESOURCE_FILTER_TYPE == this_resource_type_id) {
			selectedModifier = 'selected';
		}

		var this_resource_type = this_congress.resource_types_information['' + this_resource_type_id];

		filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="RESOURCE_FILTER_TYPE=' + this_resource_type_id + ';loadResourcesIndex(false);loadResourcesFilters();hideBothMenus();"><span class="area_title font_semibold">' + this_resource_type.resource_type_name + '</span></div>';
	});

	$('.side_menu_filter_container').html(filtersHtml);
}



function loadSpeakersFilters() {
	var filtersHtml = '';

	var selectedModifier = '';

	if (SPEAKER_FILTER_TYPE == -1) {
		selectedModifier = 'selected';
	}

	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white clearfix"><span class="area_title font_semibold"><span class="cg-icon-character cg-icon-speakers font_color_white cg-icon-size-14"></span> | ' + trd('filter-speaker-types') + ':</span><div class="clearfix"></div></div>';

	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="SPEAKER_FILTER_TYPE=-1;loadSpeakersIndex(false);loadSpeakersFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';


	$.each(this_congress.congress_information.congress_speaker_types, function(index, this_speaker_type_id) {


		selectedModifier = '';
		if (SPEAKER_FILTER_TYPE == this_speaker_type_id) {
			selectedModifier = 'selected';
		}

		var this_speaker_type = this_congress.speaker_types_information['' + this_speaker_type_id];

		filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="SPEAKER_FILTER_TYPE=' + this_speaker_type_id + ';loadSpeakersIndex(false);loadSpeakersFilters();hideBothMenus();"><span class="area_title font_semibold">' + this_speaker_type.speaker_type_name + '</span></div>';
	});

	$('.side_menu_filter_container').html(filtersHtml);
}




function loadExhibitorsFilters() {
	var filtersHtml = '';
	var selectedModifier = '';

	if (EXHIBITOR_FILTER_TYPE == -1) {
		selectedModifier = 'selected';
	}


	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white clearfix"><span class="area_title font_semibold"><span class="cg-icon-character cg-icon-exhibitors font_color_white cg-icon-size-14"></span> | ' + trd('filter-exhibitor-types') + ':</span><div class="clearfix"></div></div>';

	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="EXHIBITOR_FILTER_TYPE=-1;loadExhibitorsIndex(false);loadExhibitorsFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';


	$.each(this_congress.congress_information.congress_exhibitor_types, function(index, this_exhibitor_type_id) {

		var this_exhibitor_type = this_congress.exhibitor_types_information['' + this_exhibitor_type_id];

		selectedModifier = '';
		if (EXHIBITOR_FILTER_TYPE == this_exhibitor_type_id) {
			selectedModifier = 'selected';
		}

		filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="EXHIBITOR_FILTER_TYPE=' + this_exhibitor_type_id + ';loadExhibitorsIndex(false);loadExhibitorsFilters();hideBothMenus();">';


		filtersHtml += '<span class="area_title font_semibold">' + this_exhibitor_type.exhibitor_type_name + '</span></div>';
	});

	$('.side_menu_filter_container').html(filtersHtml);
}



function loadSponsorsFilters() {
	var filtersHtml = '';

	var selectedModifier = '';

	if (SPONSOR_FILTER_TYPE == -1) {
		selectedModifier = 'selected';
	}

	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white clearfix"><span class="area_title font_semibold"><span class="cg-icon-character cg-icon-sponsors font_color_white cg-icon-size-14"></span> | ' + trd('filter-sponsor-types') + ':</span><div class="clearfix"></div></div>';

	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="SPONSOR_FILTER_TYPE=-1;loadSponsorsIndex(false);loadSponsorsFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';

	$.each(this_congress.congress_information.congress_sponsor_types, function(index, this_sponsor_type_id) {

		selectedModifier = '';

		if (SPONSOR_FILTER_TYPE == this_sponsor_type_id) {
			selectedModifier = 'selected';
		}

		var this_sponsor_type = this_congress.sponsor_types_information['' + this_sponsor_type_id];

		filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="SPONSOR_FILTER_TYPE=' + this_sponsor_type_id + ';loadSponsorsIndex(false);loadSponsorsFilters();hideBothMenus();">';

		filtersHtml += '<span class="area_title font_semibold">' + this_sponsor_type.sponsor_type_name + '</span></div>';
	});

	$('.side_menu_filter_container').html(filtersHtml);
}

function loadPosterFilters() {
	var filtersHtml = '';

	var selectedModifier = '';

	if (POSTER_FILTER_TYPE == -1) {
		selectedModifier = 'selected';
	}



	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white clearfix"><span class="area_title font_semibold"><span class="cg-icon-character cg-icon-posters font_color_white cg-icon-size-14"></span> | ' + trd('filter-poster-types') + ':</span><div class="clearfix"></div></div>';


	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="POSTER_FILTER_TYPE=-1;loadPostersIndex(false);loadPosterFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';

	$.each(this_congress.congress_information.congress_poster_types, function(index, this_poster_type_id) {

		var selectedModifier = '';

		if (POSTER_FILTER_TYPE == this_poster_type_id) {
			selectedModifier = 'selected';
		}

		var this_poster_type = this_congress.poster_types_information['' + this_poster_type_id];

		filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="POSTER_FILTER_TYPE=' + this_poster_type_id + ';loadPostersIndex(false);loadPosterFilters();hideBothMenus();">';


		filtersHtml += '<span class="area_title font_semibold">' + this_poster_type.poster_type_name + '</span></div>';
	});

	$('.side_menu_filter_container').html(filtersHtml);
}

function loadPOIFilters() {
	var filtersHtml = '';

	var selectedModifier = '';

	if (POI_FILTER_TYPE == -1) {
		selectedModifier = 'selected';
	}


	filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="POI_FILTER_TYPE=-1;loadPOIIndex(false);loadPOIFilters();hideBothMenus();"><span class="area_title font_semibold">' + trd('filter-all') + '</span></div>';


	$.each(this_congress.congress_information.congress_poi_types, function(index, this_poi_type_id) {

		selectedModifier = '';

		if (POI_FILTER_TYPE == this_poi_type_id) {
			selectedModifier = 'selected';
		}

		var this_poi_type = this_congress.poi_types_information['' + this_poi_type_id];

		filtersHtml += '<div class="side_menu_item ' + selectedModifier + '" onclick="POI_FILTER_TYPE=' + this_poi_type_id + ';loadPOIIndex(false);loadPOIFilters();hideBothMenus();">';

		filtersHtml += '<span class="area_title font_semibold">' + this_poi_type.poi_type_name + '</span></div>';
	});

	$('.side_menu_filter_container').html(filtersHtml);
}



function loadMyAgendaFilters() {
	var filtersHtml = '';


	filtersHtml += '<div class="side_menu_item" onclick="loadMyAgenda(MY_AGENDA_FILTER_EXHIBITORS,false);hideBothMenus();">';

	filtersHtml += '<span class="area_title font_semibold">' + trd('filter-favourite-exhibitors') + '</span></div>';

	filtersHtml += '<div class="side_menu_item" onclick="loadMyAgenda(MY_AGENDA_FILTER_SESSIONS,false);hideBothMenus();">';

	filtersHtml += '<span class="area_title font_semibold">' + trd('filter-favourite-sessions') + '</span></div>';

	filtersHtml += '<div class="side_menu_item" onclick="loadMyAgenda(MY_AGENDA_FILTER_POSTERS,false);hideBothMenus();">';

	filtersHtml += '<span class="area_title font_semibold">' + trd('filter-favourite-posters') + '</span></div>';

	$('.side_menu_filter_container').html(filtersHtml);
}

function loadFloorplanFilters() {
	var filtersHtml = '';
	var selectedModifier = '';
	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white clearfix"><span class="area_title font_semibold"><span class="cg-icon-character cg-icon-floors font_color_white cg-icon-size-14"></span> | ' + trd('filter-floorplan') + '</span><div class="clearfix"></div></div>';

	$.each(this_congress.congress_information.congress_floorplans, function(index, this_floorplan_id) {

		selectedModifier = '';

		if (FLOORPLAN_FILTER_FLOORPLAN == this_floorplan_id) {
			selectedModifier = 'selected';
		}

		var this_floorplan = this_congress.floorplans_information['' + this_floorplan_id];

		filtersHtml += '<div class="side_menu_item clearfix ' + selectedModifier + '" onclick="loadFloorplan(' + this_floorplan.map_id + ',-1,false);hideBothMenus();">';

		filtersHtml += '<span class="area_title font_semibold">' + this_floorplan.map_name + '</span></div>';
	});

	filtersHtml += '<div class="side_menu_header_item color_bg_division_2 font_color_white clearfix"><span class="area_title font_semibold"><span class="cg-icon-character cg-icon-exhibitors font_color_white cg-icon-size-14"></span> | ' + trd('filter-exhibitors') + ':</span><div class="clearfix"></div></div>';

	filtersHtml += '<div id="list_exhibitors_container"></div>';

	$('.side_menu_filter_container').html(filtersHtml);


	$('#list_exhibitors_container').html('');

	var foundExhibitors = false;

	$.each(this_congress.locations_information, function(index, this_location) {
		if (!this_location) {
			return true;
		}
		if (FLOORPLAN_FILTER_FLOORPLAN != this_location.location_map) {
			return true;
		}

		$.each(this_location.exhibitors, function(index, this_exhibitor_id) {
			$('#list_exhibitors_container').append(getHtmlForExhibitorInfoSearch(this_exhibitor_id));
			foundExhibitors = true;
		});
	});
	if (!foundExhibitors) {

		var noExhibitorsHtml = ''

		noExhibitorsHtml += '<div class="side_menu_item clearfix">';

		noExhibitorsHtml += '<span class="area_title font_semibold">' + trd('no-floorplan-exhibitors') + '</span></div>';

		$('#list_exhibitors_container').html(noExhibitorsHtml);
	}



}

function getImageForSpeaker(speaker_id){
	var this_speaker = this_congress.speakers_information['' + speaker_id];
	if(this_congress.media_information['speaker'] && this_congress.media_information['speaker']['' + speaker_id]) {
		this_speaker_image = this_congress.media_information['speaker']['' + speaker_id];
		if(this_speaker_image.offline) {
			this_speaker.speaker_image = wwwRoot + '/' + this_speaker_image.name;
		}else{
			this_speaker.speaker_image = this_speaker_image.imgURL_small;
		}
	}else{
		this_speaker.speaker_image = 'img/defaults/Img_speaker.png';
	}
    return this_speaker.speaker_image;
}

function getHtmlForSpeakerInfo(speaker_id) {

	var this_speaker = this_congress.speakers_information['' + speaker_id];
    this_speaker.speaker_image = getImageForSpeaker(speaker_id);
	var speakerInfoHtml = '';
	speakerInfoHtml += '<div class="speaker_button border_bottom_color_dark" id="speaker_button_' + speaker_id + '" onclick="loadSpeakerDetail(' + speaker_id + ');">';
	speakerInfoHtml += '<table><tr><td><div class="small_pic"><img src="' + this_speaker.speaker_image + '" /></td>';
	speakerInfoHtml += '<td><div class="speaker_name font_bold font_color_dark">' + this_speaker.speaker_first_name + ' ' + this_speaker.speaker_last_name + '</div>';
	speakerInfoHtml += '<div class="speaker_short_description">' + this_speaker.speaker_subtitle + '</div></td></tr></table>';
	speakerInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_speaker_' + speaker_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
	speakerInfoHtml += '</div>';

	return speakerInfoHtml;
}


function getHtmlForPosterInfo(poster_id) {

	var this_poster = this_congress.posters_information['' + poster_id];


	var posterImageUrl = '';


	if (this_congress.media_information['poster'] && this_congress.media_information['poster']['' + poster_id]) {

		var poster_media = this_congress.media_information['poster']['' + poster_id];

		if (poster_media.offline) {
			posterImageUrl = fsRoot + '/' + poster_media.name;

		} else {
			posterImageUrl = poster_media.imgURL_small;
		}


	}

	var posterInfoHtml = '';

	var favModifier = '';

	if (array_contains(user_data.profile.agenda["posters"], poster_id)) {
		favModifier = 'favourite';
	}

	posterInfoHtml += '<div id="poster_element_' + poster_id + '" class="border_bottom_color_dark posterInfo list_element ' + favModifier + '" onclick="loadPosterDetail(' + poster_id + ');">';
	posterInfoHtml += '<div class="poster_button" id="poster_button_' + poster_id + '">';
	posterInfoHtml += '<table><tr><!--<td><div class="poster_small_pic"><img src="' + posterImageUrl + '" width="80" /></td>-->';
	posterInfoHtml += '<td><div class="poster_name kinda_title_color font_bold font_color_dark">' + this_poster.poster_title + '</div>';
	posterInfoHtml += '<div class="poster_short_description kinda_subtitle font_color_gray_1"></div></td></tr></table>';
	//posterInfoHtml += '<div class="add_session_to_favourites" id="add_to_favourites_button_'+poster_id+'" onclick="add_poster_to_my_agenda('+poster_id +');"><span class="cg-icon cg-icon-bt-fav color_icon_clickable cg-icon-size-20"></span></div>';
	posterInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_poster_' + poster_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
	posterInfoHtml += '</div>';
	posterInfoHtml += '</div>';

	return posterInfoHtml;
}

function getHtmlForLinkInfo(this_link_id) {

	var this_link = this_congress.links_information['' + this_link_id];


	var linkImageUrl = '';
	var has_image = true;

	if (this_congress.media_information['link'] && this_congress.media_information['link']['' + this_link_id]) {

		var link_media = this_congress.media_information['link']['' + this_link_id];

		if (link_media.offline) {
			linkImageUrl = fsRoot + '/' + link_media.name;

		} else {
			linkImageUrl = link_media.imgURL_small;
		}
	} else {
		has_image = false;
		linkImageUrl = 'img/defaults/Img_link.png';
	}

	var clickBehaviour = '';
	if (this_link.link_url && this_link.link_url != '') {
		clickBehaviour += 'openLink(\'' + this_link.link_url + '\');';
	}
	if (this_link.link_javascript && this_link.link_javascript != '') {
		clickBehaviour += this_link.link_javascript;
	}

	var linkInfoHtml = '';

	if (this_link.is_card && this_link.is_card == "1") {
		linkInfoHtml += '<div class="card_element" onclick="' + clickBehaviour + '" style="background-color:' + color_bg_card + ';border-radius:5px;box-shadow:1px 1px 10px gray;margin:15px">';
		if (has_image) {
			linkInfoHtml += '<img class="card_image" src="' + linkImageUrl + '" width="100%">';
		}
		linkInfoHtml += '<div class="card_details" style="padding:15px;">';
		linkInfoHtml += '<div class="card_title font_color_dark font_bold">' + this_link.link_title + '</div>';
		if (this_link.link_subtitle && this_link.link_subtitle != "") {
			linkInfoHtml += '<div class="card_subtitle font_color_gray_1">' + this_link.link_subtitle + '</div>';
		}
		if (this_link.link_description && this_link.link_description != "") {
			if (this_link.link_description.length > 120) { this_link.link_description = this_link.link_description.substr(0, 120); }
			linkInfoHtml += '<div class="card_description font_color_gray_1" style="max-height:100px;text-overflow:ellipsis;overflow:hidden;">' + this_link.link_description + '</div>';
		}
		linkInfoHtml += '</div>';
		linkInfoHtml += '</div>';
	} else {
		linkInfoHtml += '<div id="link_element_' + this_link_id + '" class="border_top_color_dark link_element linkInfo list_element" onclick="' + clickBehaviour + '">';
		linkInfoHtml += '<table><tr>';
		if (has_image) {
			linkInfoHtml += '<td><div class="small_pic"><img src="' + linkImageUrl + '" /></div></td>';
		}
		linkInfoHtml += '<td><div class="link_name font_bold font_color_dark">' + this_link.link_title + '</div>';
		if (this_link.link_subtitle) {
			linkInfoHtml += '<div class="link_short_description kinda_subtitle font_color_gray_1">' + this_link.link_subtitle + '</div>';
		}
		if (this_link.link_description) {
			linkInfoHtml += '<div class="link_short_description kinda_subtitle font_color_gray_1">' + this_link.link_description + '</div>';
		}
		linkInfoHtml += '</td></tr></table>';
		linkInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_link_' + this_link_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
		linkInfoHtml += '</div>';
	}






	return linkInfoHtml;
}

function getHtmlForExhibitorInfo(exhibitor_id) {

	var this_exhibitor = this_congress.exhibitors_information['' + exhibitor_id];


	var exhibitorImageUrl = '';


	if (this_congress.media_information['exhibitor'] && this_congress.media_information['exhibitor']['' + exhibitor_id]) {

		var exhibitor_media = this_congress.media_information['exhibitor']['' + exhibitor_id];

		if (exhibitor_media.offline) {
			exhibitorImageUrl = fsRoot + '/' + exhibitor_media.name;

		} else {
			exhibitorImageUrl = exhibitor_media.imgURL_small;
		}


	} else {
		exhibitorImageUrl = 'img/defaults/Img_exhibitor.png';
	}

	var exhibitorInfoHtml = '';

	var favModifier = '';

	if (array_contains(user_data.profile.agenda["exhibitors"], exhibitor_id)) {
		favModifier = 'favourite';
	}

	var featuredModifier = '';

	if (this_exhibitor.is_featured && this_exhibitor.is_featured == "1") {
		featuredModifier = 'featured';
	}

	exhibitorInfoHtml += '<div id="exhibitor_element_' + exhibitor_id + '" class="border_top_color_dark exhibitor_element exhibitorInfo list_element ' + favModifier + ' ' + featuredModifier + '" onclick="loadExhibitorDetail(' + exhibitor_id + ');">';

	exhibitorInfoHtml += '<table><tr><td><div class="small_pic"><img src="' + exhibitorImageUrl + '" /></div></td>';
	exhibitorInfoHtml += '<td><div class="exhibitor_name font_bold font_color_dark">' + this_exhibitor.exhibitor_name + '</div>';
	if (this_exhibitor.exhibitor_subtitle) {
		exhibitorInfoHtml += '<div class="exhibitor_short_description kinda_subtitle font_color_gray_1">' + this_exhibitor.exhibitor_subtitle + '</div>';
	}
	/*if (this_exhibitor.exhibitor_location){
	  var this_location = this_congress.locations_information['' + this_exhibitor.exhibitor_location];
	  if (this_location){
	    exhibitorInfoHtml += '<div class="exhibitor_short_description kinda_subtitle font_color_gray_1">'+this_location.location_name+'</div>';
	  }
	}*/
	exhibitorInfoHtml += '</td></tr></table>';
	//exhibitorInfoHtml += '<div class="add_session_to_favourites" id="add_to_favourites_button_'+exhibitor_id+'" onclick="add_exhibitor_to_my_agenda('+exhibitor_id +');"><span class="cg-icon cg-icon-bt-fav color_icon_clickable cg-icon-size-20"></span></div>';
	exhibitorInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_exhibitor_' + exhibitor_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
	exhibitorInfoHtml += '</div>';




	return exhibitorInfoHtml;
}

function getHtmlForExhibitorInfoSearch(exhibitor_id) {

	var this_exhibitor = this_congress.exhibitors_information['' + exhibitor_id];


	var exhibitorImageUrl = '';


	if (this_congress.media_information['exhibitor'] && this_congress.media_information['exhibitor']['' + exhibitor_id]) {

		var exhibitor_media = this_congress.media_information['exhibitor']['' + exhibitor_id];

		if (exhibitor_media.offline) {
			exhibitorImageUrl = fsRoot + '/' + exhibitor_media.name;

		} else {
			exhibitorImageUrl = exhibitor_media.imgURL_small;
		}


	} else {
		exhibitorImageUrl = 'img/defaults/Img_exhibitor.png';
	}

	var exhibitorInfoHtml = '';

	var favModifier = '';

	if (array_contains(user_data.profile.agenda["exhibitors"], exhibitor_id)) {
		favModifier = 'favourite';
	}

	var featuredModifier = '';

	if (this_exhibitor.is_featured && this_exhibitor.is_featured == "1") {
		featuredModifier = 'featured';
	}

	exhibitorInfoHtml += '<div id="exhibitor_search_element_' + exhibitor_id + '" class="border_top_color_dark search_list_element ' + favModifier + ' ' + featuredModifier + '" onclick="showExhibitor(' + exhibitor_id + ');">';

	exhibitorInfoHtml += '<table><tr><td><div class="tiny_pic"><img src="' + exhibitorImageUrl + '" /></div></td>';
	exhibitorInfoHtml += '<td><div class="exhibitor_name font_bold font_color_dark">' + this_exhibitor.exhibitor_name + '</div>';
	if (this_exhibitor.exhibitor_subtitle) {
		exhibitorInfoHtml += '<div class="exhibitor_short_description kinda_subtitle font_color_gray_1">' + this_exhibitor.exhibitor_subtitle + '</div>';
	}
	if (this_exhibitor.exhibitor_location) {
		var this_location = this_congress.locations_information['' + this_exhibitor.exhibitor_location];
		if (this_location) {
			exhibitorInfoHtml += '<div class="exhibitor_short_description kinda_subtitle font_color_gray_1">' + this_location.location_name + '</div>';
		}
	}
	exhibitorInfoHtml += '</td></tr></table>';
	exhibitorInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_exhibitor_' + exhibitor_id + '"><span class="cg-icon cg-icon-location font_color_dark"></span></div>';
	exhibitorInfoHtml += '</div>';




	return exhibitorInfoHtml;
}

function showExhibitor(this_exhibitor_id) {
	var this_exhibitor = this_congress.exhibitors_information['' + this_exhibitor_id];
	if (this_exhibitor.exhibitor_location) {
		var this_location = this_congress.locations_information['' + this_exhibitor.exhibitor_location];
		if (this_location) {
			if (!$('body').hasClass('widescreen')) {
				hideFilter();
			}
			zoomToLocation(this_exhibitor.exhibitor_location);
			touchedLocation(this_exhibitor.exhibitor_location);
		}
	}
}




function getHtmlForFeaturedExhibitor(exhibitor_id) {

	var this_exhibitor = this_congress.exhibitors_information['' + exhibitor_id];


	var exhibitorImageUrl = '';


	if (this_congress.media_information['exhibitor'] && this_congress.media_information['exhibitor']['' + exhibitor_id]) {

		var exhibitor_media = this_congress.media_information['exhibitor']['' + exhibitor_id];

		if (exhibitor_media.offline) {
			exhibitorImageUrl = fsRoot + '/' + exhibitor_media.name;

		} else {
			exhibitorImageUrl = exhibitor_media.imgURL_small;
		}


	}

	var exhibitorInfoHtml = '';

	var favModifier = '';

	if (array_contains(user_data.profile.agenda["exhibitors"], exhibitor_id)) {
		favModifier = 'favourite';
	}


	exhibitorInfoHtml += '<div id="exhibitor_element_' + exhibitor_id + '" class="featured_element ' + favModifier + '">';

	exhibitorInfoHtml += '<table><tr><td width="50%"><div class="featured_pic"><img src="' + exhibitorImageUrl + '" /></div></td>';
	exhibitorInfoHtml += '<td width="50%"><div class="font_color_dark" style="font-size:16pt">' + this_exhibitor.exhibitor_name + '</div>';
	if (this_exhibitor.exhibitor_subtitle) {
		exhibitorInfoHtml += '<div class="font_color_gray_1" style="font-size:16pt">' + this_exhibitor.exhibitor_subtitle + '</div>';
	}
	if (this_exhibitor.exhibitor_location) {
		var this_location = this_congress.locations_information['' + this_exhibitor.exhibitor_location];
		if (this_location) {
			exhibitorInfoHtml += '<div class="font_color_gray_1"  style="font-size:10pt">' + this_location.location_name + '</div>';
			if (this_location.location_map) {
				var this_map = this_congress.floorplans_information['' + this_location.location_map];
				exhibitorInfoHtml += '<div class="font_color_gray_1"  style="font-size:10pt">' + this_map.map_name + '</div>';
			}

		}
	}
	exhibitorInfoHtml += '</td></tr></table>';

	exhibitorInfoHtml += '<div class="feature_indicator"><span class="cg-icon cg-icon-exhibitors font_color_gray_1"></span></div>';

	exhibitorInfoHtml += '</div>';




	return exhibitorInfoHtml;
}



function getHtmlForFeedbackInfo(feedback_id) {

	var this_feedback = this_congress.feedback_information['' + feedback_id];


	var feedbackImageUrl = '';

	var feedbackInfoHtml = '';

	var checkedModifier = '';

	if (user_data.profile['feedback']['' + feedback_id]) {
		checkedModifier = 'selected';
	}

	feedbackInfoHtml += '<div id="feedback_element_' + feedback_id + '" class="border_top_color_dark feedback_element feedbackInfo list_element ' + checkedModifier + '" onclick="loadFeedbackDetail(' + feedback_id + ');">';

	feedbackInfoHtml += '<td><div class="feedback_name font_bold font_color_dark">' + this_feedback.feedback_title + '</div>';
	feedbackInfoHtml += '<div class="feedback_short_description kinda_subtitle font_color_gray_1">' + this_feedback.questions.length + ' ' + trd('questions') + '</div></td></tr></table>';
	//feedbackInfoHtml += '<div class="add_session_to_favourites" id="add_to_favourites_button_'+feedback_id+'" onclick="add_feedback_to_my_agenda('+feedback_id +');"><span class="cg-icon cg-icon-check font_color_dark cg-icon-size-16"></span></div>';
	feedbackInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_feedback_' + feedback_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
	feedbackInfoHtml += '</div>';




	return feedbackInfoHtml;
}


function getHtmlForSponsorInfo(sponsor_id) {

	var this_sponsor = this_congress.sponsors_information['' + sponsor_id];


	var sponsorImageUrl = '';


	if (this_congress.media_information['sponsor'] && this_congress.media_information['sponsor']['' + sponsor_id]) {

		var sponsor_media = this_congress.media_information['sponsor']['' + sponsor_id];

		if (sponsor_media.offline) {
			sponsorImageUrl = fsRoot + '/' + sponsor_media.name;

		} else {
			sponsorImageUrl = sponsor_media.imgURL_small;
		}
	} else {
		sponsorImageUrl = 'img/defaults/Img_sponsor.png';
	}

	var sponsorInfoHtml = '';

	sponsorInfoHtml += '<div id="sponsor_element_' + sponsor_id + '" class="border_top_color_dark sponsor_element sponsorInfo list_element" onclick="loadSponsorDetail(' + sponsor_id + ');">';

	sponsorInfoHtml += '<table><tr><td><div class="small_pic"><img src="' + sponsorImageUrl + '" /></div></td>';
	sponsorInfoHtml += '<td><div class="sponsor_name font_bold font_color_dark">' + this_sponsor.sponsor_name + '</div>';

	if (this_sponsor.sponsor_subtitle) {
		sponsorInfoHtml += '<div class="sponsor_short_description kinda_subtitle font_color_gray_1">' + this_sponsor.sponsor_subtitle + '</div>';
	}
	sponsorInfoHtml += '</td></tr></table>';
	sponsorInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_sponsor_' + sponsor_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
	sponsorInfoHtml += '</div>';




	return sponsorInfoHtml;
}

function getHtmlForFeaturedSponsor(sponsor_id) {

	var this_sponsor = this_congress.sponsors_information['' + sponsor_id];


	var sponsorImageUrl = '';


	if (this_congress.media_information['sponsor'] && this_congress.media_information['sponsor']['' + sponsor_id]) {

		var sponsor_media = this_congress.media_information['sponsor']['' + sponsor_id];

		if (sponsor_media.offline) {
			sponsorImageUrl = fsRoot + '/' + sponsor_media.name;
		} else {
			sponsorImageUrl = sponsor_media.imgURL_small;
		}
	}

	var sponsorInfoHtml = '';

	sponsorInfoHtml += '<div id="sponsor_element_' + sponsor_id + '" class="sponsor_element featured_element">';

	sponsorInfoHtml += '<table><tr><td ><div class="featured_pic"><img src="' + sponsorImageUrl + '" /></div></td>';

	sponsorInfoHtml += '</tr></table>';
	sponsorInfoHtml += '<div class="feature_indicator"><span class="cg-icon cg-icon-sponsors font_color_gray_1"></span></div>';

	sponsorInfoHtml += '</div>';




	return sponsorInfoHtml;
}



function getHtmlForPOIInfo(poi_id) {

	var this_poi = this_congress.poi_information['' + poi_id];

	var poiInfoHtml = '';


	var poi_image_url = '';
	if (this_congress.media_information['poi'] && this_congress.media_information['poi']['' + poi_id]) {
		var poi_media = this_congress.media_information['poi']['' + poi_id];

		if (poi_media.offline) {
			poi_image_url = fsRoot + '/' + poi_media.name;
		} else {
			poi_image_url = poi_media.imgURL_small;
		}
	} else {
		poi_image_url = 'img/defaults/Img_poi.png';
	}



	poiInfoHtml += '<div class="list_element border_top_color_dark poi_button" id="poi_button_' + poi_id + '" onclick="loadPOIDetail(' + poi_id + ');">';
	poiInfoHtml += '<table><tr><td><div class="small_pic"><img src="' + poi_image_url + '" /></td>';
	poiInfoHtml += '<td><div class="poi_name kinda_title_color font_bold font_color_dark">' + this_poi.poi_name + '</div>';

	if (this_poi.poi_subtitle) {
		poiInfoHtml += '<div class="poi_short_description kinda_subtitle font_color_gray_1">' + this_poi.poi_subtitle + '</div>';
	}

	poiInfoHtml += '</td></tr></table>';
	poiInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_poi_' + poi_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
	poiInfoHtml += '</div>';

	return poiInfoHtml;
}

function getHoursAndMinutesFromDate(date_string) {
	var date = new Date(date_string);
	return date.getHours() + ':' + date.getMinutes();
}

function getHtmlForMiniSessionInfo(session_id, this_callback) {
	var this_session = this_congress.sessions_information['' + session_id];
	var sessionInfoHtml = '';

	var this_location = this_congress.locations_information['' + this_session.session_location_id];


	var favModifier = '';

	if (array_contains(user_data.profile.agenda["sessions"], session_id)) {
		favModifier = 'favourite';
	}

	var clickBehaviour = '';

	if (this_callback) {
		clickBehaviour = this_callback;
	} else {
		if (this_session.has_detail && this_session.has_detail == "1") {
			clickBehaviour = "loadSessionDetail(" + session_id + ",false);";
		}
	}

	sessionInfoHtml += '<div class="session_info_element border_bottom_color_dark  ' + favModifier + '" id="session_element_' + session_id + '">';
	sessionInfoHtml += '<div class="sessionInfo" id="session_button_' + session_id + '" onclick="' + clickBehaviour + '">';

	var session_start_millis = getTimeForSession(session_id);
	var session_end_millis = getEndTimeForSession(session_id);
	var now = new Date();
	var now_millis = now.getTime();

	if (session_start_millis > now_millis && session_end_millis < now_millis) {
		sessionInfoHtml += '<div class="now_badge color_bg_division_1">' + trd('now-badge') + '</div>';
	}
	sessionInfoHtml += '<div class="session_name font_bold font_color_dark">' + this_session.session_title + '</div>';

	var this_day = this_congress.day_information['' + this_session.session_day_id];

	sessionInfoHtml += '<span class="session_list_header_session_time font_color_gray_1">' + this_day.day_name + '</span>';

	var session_time_string = '';
	if (this_session.session_start_time && this_session.session_start_time != null && this_session.session_start_time != '00:00') {
		session_time_string += this_session.session_start_time;
	}
	if (this_session.session_end_time && this_session.session_end_time != null && this_session.session_start_time != '00:00') {
		session_time_string += ' - ' + this_session.session_end_time;
	}

	if (session_time_string != '') {
		sessionInfoHtml += '<span class="inline_divider font_color_dark"> // </span><span class="session_list_header_session_time font_bold font_color_gray_1">' + session_time_string + '</span>';
	}


	if (this_location) {
		sessionInfoHtml += '<span class="inline_divider font_color_dark"> // </span><span class="session_header_sala font_color_gray_1">' + this_location.location_name + '</span>';
	}


	//sessionInfoHtml += '<div class="add_session_to_favourites" id="add_to_favourites_button_'+session_id+'" onclick="add_to_my_agenda('+session_id+');"><span class="cg-icon cg-icon-bt-fav color_icon_clickable cg-icon-size-20"></span></div>';
	if (this_session.has_detail && this_session.has_detail == "1") {
		sessionInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_session_' + session_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
	}

	if (this_session.session_session_type) {
		var this_session_type = this_congress.session_types_information['' + this_session.session_session_type];

		sessionInfoHtml += '<div class="session_type_line" style="background-color:' + this_session_type.session_type_color + '"></div>';
	}


	sessionInfoHtml += '</div>';
	sessionInfoHtml += '</div>';



	return sessionInfoHtml;
}

function getHtmlForSessionInfo(session_id, this_callback) {
	var this_session = this_congress.sessions_information['' + session_id];
	var sessionInfoHtml = '';
	var session_color = '';

	if (this_session.session_session_type) {
		console.log('evaluating session ' + session_id);
		console.log('session type is ' + this_session.session_session_type);
		var this_session_type = this_congress.session_types_information['' + this_session.session_session_type];
		session_color = this_session_type.session_type_color;
	}

	var this_location = this_congress.locations_information['' + this_session.session_location_id];


	var favModifier = '';

	if (array_contains(user_data.profile.agenda["sessions"], session_id)) {
		favModifier = 'favourite';
	}

	var featured_modifier = '';
	if (this_session.is_featured && this_session.is_featured == "1") {
		featured_modifier = 'featured';
	}

	var clickBehaviour = '';

	if (this_callback) {
		clickBehaviour = this_callback;
	} else {
		if (this_session.has_detail && this_session.has_detail == "1") {
			clickBehaviour = 'loadSessionDetail(' + session_id + ');';
		}
	}

	sessionInfoHtml += '<div class="session_info_element border_bottom_color_dark ' + favModifier + ' ' + featured_modifier + '" id="session_element_' + session_id + '">';
	sessionInfoHtml += '<div class="sessionInfo" id="session_button_' + session_id + '" onclick="' + clickBehaviour + '">';

	var session_time_string = '';
	if (this_session.session_start_time && this_session.session_start_time != null && this_session.session_start_time != '00:00') {
		session_time_string += this_session.session_start_time;
	}
	if (this_session.session_end_time && this_session.session_end_time != null && this_session.session_end_time != '00:00') {
		session_time_string += ' - ' + this_session.session_end_time;
	}

	if (session_time_string != '') {
		sessionInfoHtml += '<span class="session_list_header_session_time font_color_gray_1">' + session_time_string + '</span>';
	}

	sessionInfoHtml += '<div class="session_name font_bold font_color_dark">' + this_session.session_title + '</div>';

	var hasPrev = false;
	if (this_location) {
		sessionInfoHtml += '<span class="session_header_sala font_color_gray_1">' + this_location.location_name + '</span>';
		hasPrev = true;
	}


	if (this_session.session_session_type) {
		var this_session_type = this_congress.session_types_information['' + this_session.session_session_type];
		if (hasPrev) {
			sessionInfoHtml += '<span class="inline_divider font_color_dark"> // </span>';
		}
		sessionInfoHtml += '<span class="session_type font_color_gray_1">' + this_session_type.session_type_name + '</span>';
	}



	//sessionInfoHtml += '<div class="add_session_to_favourites" id="add_to_favourites_button_'+session_id+'" onclick="add_to_my_agenda('+session_id+');"><span class="cg-icon cg-icon-bt-fav color_icon_clickable cg-icon-size-20"></span></div>';
	if (this_session.has_detail && this_session.has_detail == "1") {
		sessionInfoHtml += '<div class="gotodetail_button" id="gotodetail_button_session_' + session_id + '"><span class="cg-icon cg-icon-fwd cg-icon-size-10 font_color_dark"></span></div>';
	}
	sessionInfoHtml += '<div class="session_speaker_div">';
	var first = true;
	$.each(this_session.session_speakers, function(index, this_speaker_id) {
		if (first) {
			first = false;
		} else {
			sessionInfoHtml += '<span class="inline_divider font_color_dark"> , </span>';
		}
		var this_speaker = this_congress.speakers_information['' + this_speaker_id];
		sessionInfoHtml += '<span class="session_speaker font_color_gray_1">';
		sessionInfoHtml += this_speaker.speaker_first_name + ' ' + this_speaker.speaker_last_name;
		if (this_speaker.speaker_subtitle && this_speaker.speaker_subtitle != '') {
			sessionInfoHtml += ' - ' + this_speaker.speaker_subtitle;
		}
		sessionInfoHtml += '</span>';

	});




	sessionInfoHtml += '</div>';

	if (this_session.session_session_type) {
		var this_session_type = this_congress.session_types_information['' + this_session.session_session_type];

		sessionInfoHtml += '<div class="session_type_line" style="background-color:' + this_session_type.session_type_color + '"></div>';
	}


	sessionInfoHtml += '</div>';
	sessionInfoHtml += '</div>';



	return sessionInfoHtml;
}

function getHtmlForFeaturedSession(session_id) {
	var this_session = this_congress.sessions_information['' + session_id];
	var sessionInfoHtml = '';

	var this_location = this_congress.locations_information['' + this_session.session_location_id];


	var favModifier = '';

	if (array_contains(user_data.profile.agenda["sessions"], session_id)) {
		favModifier = 'favourite';
	}


	sessionInfoHtml += '<div class="featured_element featured_session  ' + favModifier + '" id="session_element_' + session_id + '">';



	sessionInfoHtml += '<div id="session_button_' + session_id + '" style="height:100%;position:relative;padding-left:20px;padding-right:30px;display:block" height="100%">';

	sessionInfoHtml += '<table><tr><td>';

	sessionInfoHtml += '<div class="font_color_dark featured_session_name">' + this_session.session_title + '</div>';

	var this_session_day = this_congress.day_information['' + this_session.session_day_id];

	sessionInfoHtml += '<span class="font_color_gray_1 featured_session_day">' + this_session_day.day_name + '</span> <span class="inline_divider font_color_dark">//</span> ';

	sessionInfoHtml += '<span class="font_color_gray_1 featured_session_time">' + this_session.session_start_time + ' - ' + this_session.session_end_time + '</span>';


	sessionInfoHtml += '</td></tr></table>';

	sessionInfoHtml += '<div class="feature_indicator"><span class="cg-icon cg-icon-program font_color_gray_1"></span></div>';

	if (this_session.session_session_type) {
		var this_session_type = this_congress.session_types_information['' + this_session.session_session_type];

		sessionInfoHtml += '<div class="session_type_line" style="background-color:' + this_session_type.session_type_color + '"></div>';
	}


	sessionInfoHtml += '</div>';
	sessionInfoHtml += '</div>';

	return sessionInfoHtml;
}

function makeHistory(pageid) {
	my_history.push(pageid);
}


function confirmCloseGuide() {
	if (isMobile) {
		navigator.notification.confirm(trd('close-guide-message'), closeGuideCallback, trd('close-guide-title'), trd('close-guide-cancel') + ',' + trd('close-guide-ok'));
	} else {
		if (confirm(trd('close-guide-message'))) {
			unloadGuide();
		}
	}
}

function closeGuideCallback(button) {
	if (button == 2) {
		unloadGuide();
	} else {

	}
}

function confirmCloseApp(event) {
	navigator.notification.confirm(trd('close-app-message'), closeAppCallback, trd('close-app-title'), trd('close-app-cancel') + ',' + trd('close-app-ok'));
}

function closeAppCallback(button) {
	if (button == 2) {
		navigator.app.exitApp();
	} else {

	}
}

function goBack() {

	if (!this_congress || this_congress == null) {
		confirmCloseApp();
		return;
	}

	if ($('#imageZoom').length > 0) {
		dismissZoom();
		return;
	}
	if ($('.modal_page.show').length > 0 && $('.auth_explain_text').length == 0) {
		closeModal();
		return;
	}

	if (my_history.length == 0) {
		if ($('.side_menu_container').hasClass('show')) {
			if (app_type == 'single') {
				confirmCloseApp();
			} else {
				confirmCloseGuide();
			}

		} else {
			if ($('#dashboard.current').length > 0) {
				toggleMenu();
			} else {
				loadDashboard(true);
			}
		}

		return;
	}

	var destinationId = my_history.pop();

	if (destinationId.indexOf('session_index') > -1) {
		loadSessionIndex(true);
	} else if (destinationId.indexOf('forgotpasswordpage') > -1) {
		loadForgotPasswordPage(true);
	} else if (destinationId.indexOf('myprofile') > -1) {
		loadMyProfile(true);
	} else if (destinationId.indexOf('photo_feed') > -1) {
		loadPhotoFeed(true);
	} else if (destinationId.indexOf('loginpage') > -1) {
		loadLoginPage(true);
	} else if (destinationId.indexOf('registerpage') > -1) {
		loadRegisterPage(true);
	} else if (destinationId.indexOf('speakers_index_for_session_') > -1) {
		var string_divide = destinationId.split("_");
		var session_id = string_divide[string_divide.length - 1];
		loadSpeakersIndexForSession(session_id, true);
	} else if (destinationId.indexOf('speakers_index') > -1) {
		loadSpeakersIndex(true);
	} else if (destinationId.indexOf('conversations_index') > -1) {
		loadConversationsIndex(true);
	} else if (destinationId.indexOf('next_sessions_page') > -1) {
		loadNextSessions(true);
	} else if (destinationId.indexOf('moderation_sessions_page') > -1) {
		loadModerationSessions(true);
	} else if (destinationId.indexOf('polling_sessions_page') > -1) {
		loadPollingSessions(true);
	} else if (destinationId.indexOf('profiles_index_for_session_') > -1) {
		var string_divide = destinationId.split("_");
		var session_id = string_divide[string_divide.length - 1];
		loadProfilesIndexForSession(session_id, true);
	} else if (destinationId.indexOf('profiles_index') > -1) {
		loadProfilesIndex(true);
	} else if (destinationId.indexOf('editprofile') > -1) {
		loadEditProfile(true, false);
	} else if (destinationId.indexOf('speaker_detail') > -1) {
		var string_divide = destinationId.split("_");
		var speaker_id = string_divide[string_divide.length - 1];
		loadSpeakerDetail(speaker_id, true);
	} else if (destinationId.indexOf('conversation_detail_') > -1) {
		var string_divide = destinationId.split("_");
		var with_user_id = string_divide[string_divide.length - 1];
		loadConversationDetail(true, with_user_id);
	} else if (destinationId.indexOf('link_group_index_') > -1) {
		var string_divide = destinationId.split("_");
		var link_group_id = string_divide[string_divide.length - 1];
		loadLinksIndex(link_group_id, true);
	} else if (destinationId.indexOf('session_detail') > -1) {
		var string_divide = destinationId.split("_");
		var session_id = string_divide[string_divide.length - 1];
		loadSessionDetail(session_id, true);
	} else if (destinationId.indexOf('profile_detail') > -1) {
		var string_divide = destinationId.split("_");
		var profile_id = string_divide[string_divide.length - 1];
		loadProfileDetail(profile_id, true);
	} else if (destinationId.indexOf('poi_detail') > -1) {
		var string_divide = destinationId.split("_");
		var id = string_divide[string_divide.length - 1];
		loadPOIDetail(id, true);
	} else if (destinationId.indexOf('sponsor_detail') > -1) {
		var string_divide = destinationId.split("_");
		var id = string_divide[string_divide.length - 1];
		loadSponsorDetail(id, true);
	} else if (destinationId.indexOf('question_detail') > -1) {
		var string_divide = destinationId.split("_");
		var id = string_divide[string_divide.length - 1];
		loadQuestionDetail(id, true);
	} else if (destinationId.indexOf('exhibitor_detail') > -1) {
		var string_divide = destinationId.split("_");
		var exhibitor_id = string_divide[string_divide.length - 1];
		loadExhibitorDetail(exhibitor_id, true);
	} else if (destinationId.indexOf('meeting_detail') > -1) {
		var string_divide = destinationId.split("_");
		var meeting_id = string_divide[string_divide.length - 1];
		loadMeetingDetail(meeting_id, true);
	} else if (destinationId.indexOf('custom_area') > -1) {
		var string_divide = destinationId.split("_");
		var customarea_id = string_divide[string_divide.length - 1];
		loadCustomArea(customarea_id, true);
	} else if (destinationId.indexOf('posters_index') > -1) {
		loadPostersIndex(true);
	} else if (destinationId.indexOf('resources_index') > -1) {
		loadResourcesIndex(true);
	} else if (destinationId.indexOf('exhibitors_index') > -1) {
		loadExhibitorsIndex(true);
	} else if (destinationId.indexOf('poi_index') > -1) {
		loadPOIIndex(true);
	} else if (destinationId.indexOf('sponsors_index') > -1) {
		loadSponsorsIndex(true);
	} else if (destinationId.indexOf('feedback_index') > -1) {
		loadFeedbackIndex(true);
	} else if (destinationId.indexOf('mapDiv') > -1) {
		loadFloorplan(-1, -1, true);
	} else if (destinationId.indexOf('myagendaindex') > -1) {
		loadMyAgendaIndex(true);
	} else if (destinationId.indexOf('myagenda') > -1) {
		if ($('.current').attr('id').indexOf('meeting_detail') > -1)
			loadMyAgenda(MY_AGENDA_FILTER_MEETINGS, true);
		else
			loadMyAgenda(MY_AGENDA_NO_FILTER, true);
	} else if (destinationId.indexOf('dashboard') > -1) {
		loadDashboard(true);
	} else if (destinationId.indexOf('searchDiv') > -1) {
		loadSearch(true);
	} else if (html_page.showed[destinationId]) {
		var page_showed = html_page.showed[destinationId];
		console.log(page_showed);
		html_page.show(true, page_showed.requires_auth, destinationId, page_showed.html, page_showed.function_name);
	}

	saveActionInHistory("goBack()");


}

function bringFromHistory(page_id) {

	var options = {
		"direction": "right", // 'left|right|up|down', default 'left' (which is like 'next')
		"duration": 200, // in milliseconds (ms), default 400
		"slowdownfactor": 4, // overlap views (higher number is more) or no overlap (1). -1 doesn't slide at all. Default 4
		//"slidePixels"      :   100, // optional, works nice with slowdownfactor -1 to create a 'material design'-like effect. Default not set so it slides the entire page.
		"iosdelay": 60, // ms to wait for the iOS webview to update before animation kicks in, default 60
		"androiddelay": 70, // same as above but for Android, default 70
		"winphonedelay": 250, // same as above but for Windows Phone, default 200,
		"fixedPixelsTop": 0, // the number of pixels of your fixed header, default 0 (iOS and Android)
		"fixedPixelsBottom": 0 // the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
	};
	if ($('.smallscreen').length > 0 && $('.loading_page').length == 0 && isMobile && !isIOS) {
		window.plugins.nativepagetransitions.slide(options);
	}
	var currentId = $('.current').attr('id');
	$('.current').addClass('future');
	$('.current').removeClass('current');
	page_moving = true;


	if (isIOS) {
		setTimeout("$('#" + currentId + "').remove();", 200);
	} else {
		$('#' + currentId).remove();
	}


	$('#' + page_id).removeClass('past');
	$('#' + page_id).addClass('current');
	document.getElementById('mainDiv').scrollTop = 0;
	onPageChanged();
}

function toggle_day_container(day_id) {
	if ($('#day_container_' + day_id).hasClass('closed')) {
		$('#day_container_' + day_id).removeClass('closed');
		$('#day_container_' + day_id).addClass('open');
		open_days.push(day_id);
	} else {
		$('#day_container_' + day_id).removeClass('open');
		$('#day_container_' + day_id).addClass('closed');
		remove_open_day(day_id);
	}
	if ($.os.android) {

	}
}


function toggle_group_container(group_id) {
	if ($('.session_group_' + group_id).hasClass('closed')) {
		$('.session_group_' + group_id).removeClass('closed');
		$('.session_group_' + group_id).addClass('open');
		open_groups.push(group_id);
	} else {
		$('.session_group_' + group_id).removeClass('open');
		$('.session_group_' + group_id).addClass('closed');
		remove_open_group(group_id);
	}



	if ($.os.android) {

	}
}

function remove_open_group(group_id) {
	open_groups = $.grep(open_groups, function(value) {
		return value != group_id;
	});
}

function remove_open_day(day_id) {
	open_days = $.grep(open_days, function(value) {
		return value != day_id;
	});
}

function get_session_group_times(this_day_id, this_group_id) {
	var group_sessions = get_group_sessions(this_day_id, this_group_id);

	var earliest = 0;
	var latest = 0;

	$.each(group_sessions, function(index, this_session_id) {
		var this_session = this_congress.sessions_information['' + this_session_id];

		if (earliest != 0) {
			if (getTimeForSession(earliest) > getTimeForSession(this_session_id)) {
				earliest = this_session_id;
			}
		} else {
			earliest = this_session_id;
		}

		if (latest != 0) {
			if (getEndTimeForSession(latest) < getEndTimeForSession(this_session_id)) {
				latest = this_session_id;
			}
		} else {
			latest = this_session_id;
		}




	});

	var earliest_session = this_congress.sessions_information['' + earliest];
	var latest_session = this_congress.sessions_information['' + latest];

	return earliest_session.session_start_time + ' - ' + latest_session.session_end_time;
}

function get_group_sessions(this_day_id, this_group_id) {
	var group_sessions = [];

	var this_day = this_congress.day_information['' + this_day_id];

	if (this_day.sessions.length > 0) {
		group_sessions = $.grep(this_day.sessions, function(this_session_id) {
			var this_session = this_congress.sessions_information['' + this_session_id];

			return (this_session.session_group && this_session.session_group == this_group_id);
		});

	}



	return group_sessions;
}

function loadSessionIndex(fromHistory) {

	loadSessionIndexGrid(fromHistory);
	return;

	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}



	var isCurrent = ($('#session_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var sessionIndexHtml = '';

	sessionIndexHtml += '<div id="session_index" class="normal_page with_bottom_input ' + initialPosition + '">';
	sessionIndexHtml += '<div class="list_page_header ">';
	sessionIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + getNameForAreaType('program') + '</div></div>';

	/*if (this_congress.congress_information.has_session_filter && this_congress.congress_information.has_session_filter=="1"){
	  sessionIndexHtml += '<div class="filter_button cg-icon cg-icon-filter-funnel cg-icon-size-14 color_icon_second_menu selected_font_color_white" id="filter_button" onclick="toggleFilter();"></div><div onclick="toggleFilter();" class="filter_label right color_icon_second_menu">'+trd('filter-label')+'</div><div  onclick="toggleSearch();" class="filter_label left color_icon_second_menu">'+trd('filter-search')+'</div><div class="search_button cg-icon cg-icon-search cg-icon-size-14 color_icon_second_menu" id="search_button" onclick="toggleSearch();"></div>';
	  }*/


	sessionIndexHtml += '</div>';

	sessionIndexHtml += '<div class="sessionIndexHeader searchHeader">';
	sessionIndexHtml += '<input type="text" id="search_sessions" class="index_search_text" placeholder="' + trd('search-sessions') + '" onkeyup="search_sessions();" />';
	sessionIndexHtml += '<span class="cg-icon-character cg-icon-search-close search_close font_color_gray_1" onclick="toggleSearch();"></span>';
	sessionIndexHtml += '</div>';

	sessionIndexHtml += '<div class="list_page scroll">';

	sessionIndexHtml += '<div class="scroll_lock">';

	var day_sessions = {};
	var num_sessions = 0;
	$.each(this_congress.congress_information.congress_days, function(index, this_day_id) {
		day_sessions['' + this_day_id] = 0;

		if (SESSION_FILTER_DAY != -1 && SESSION_FILTER_DAY != this_day_id) {
			return true;
		}


		var this_day = this_congress.day_information['' + this_day_id];

		var closedModifier = '';

		if ((this_congress.congress_information.separate_by_day && this_congress.congress_information.separate_by_day == "0") || this_congress.congress_information.congress_days.length < 2) {
			closedModifier = 'open';
			open_days = this_congress.congress_information.congress_days;
		} else if (SESSION_FILTER_DAY != -1 || SESSION_FILTER_LOCATION != -1 || SESSION_FILTER_SESSION_TYPE != -1) {
			closedModifier = 'open';
		} else {
			closedModifier = 'closed';
		}
		console.log(closedModifier);
		sessionIndexHtml += '<div id="day_container_' + this_day_id + '" class="day_container ' + closedModifier + '">';

		if (this_congress.congress_information.separate_by_day && this_congress.congress_information.separate_by_day == "1") {

			sessionIndexHtml += '<div class="session_index_day_header font_bold font_color_white color_bg_division_1 " onclick="toggle_day_container(' + this_day_id + ');"><div class="day_name">' + this_day.day_name + '&nbsp;&nbsp;<span class="cg-icon-character cg-icon-arrow-toggle cg-icon-size-6"></span><br><span class="day_subtitle">' + this_day.day_subtitle + '</span></div></div>';
		}

		var current_group = 0;

		if (this_day.sessions && this_day.sessions.length > 0) {
			$.each(this_day.sessions, function(index, this_session_id) {

				var this_session = this_congress.sessions_information['' + this_session_id];

				if (SESSION_FILTER_SESSION_TYPE != -1 && this_session.session_session_type != SESSION_FILTER_SESSION_TYPE) {
					return true;
				}

				if (SESSION_FILTER_LOCATION != -1 && this_session.session_location_id != SESSION_FILTER_LOCATION) {
					return true;
				}

				if (SESSION_FILTER_TAGS.length > 0 && (this_session.session_tags.length == 0 || intersect(SESSION_FILTER_TAGS, this_session.session_tags).length == 0)) {
					return true;
				}

				day_sessions['' + this_day_id]++;
				num_sessions++;

				if (this_session.session_group) {

					var this_group = this_congress.session_groups_information['' + this_session.session_group];

					if (current_group == 0 || this_group.group_id != current_group) {
						if (current_group != 0) {
							sessionIndexHtml += '</div>';
						}
						sessionIndexHtml += '<div class="panel_container font_color_white session_group_' + this_group.group_id + ' open"><div class="panel_group_line color_bg_division_2"></div><div class="session_index_group_header color_bg_division_2 font_bold session_group_header_' + this_group.group_id + '">' + this_group.group_description + '&nbsp;&nbsp;</div>';
						current_group = this_group.group_id;
					}
				} else {
					if (current_group != 0) {
						sessionIndexHtml += '</div>';
					}
					current_group = 0;
				}
				console.log('1');
				sessionIndexHtml += '<div class="">';
				if (this_congress.congress_information.separate_by_day && this_congress.congress_information.separate_by_day == "1") {
					sessionIndexHtml += getHtmlForSessionInfo(this_session_id);
				} else {
					sessionIndexHtml += getHtmlForMiniSessionInfo(this_session_id);
				}

				sessionIndexHtml += '</div>';
			});
		}
		if (current_group != 0) {
			sessionIndexHtml += '</div>';
		}

		sessionIndexHtml += '</div>';

	});

	if (num_sessions == 0) {
		sessionIndexHtml += '<div class="font_color_gray_1" style="font-size:14pt;text-align:center;padding:20px">' + trd('filter-empty-sessions') + '</div>';
	}
	sessionIndexHtml += '</div>';
	sessionIndexHtml += '</div>';

	if (this_congress.congress_information.has_session_filter && this_congress.congress_information.has_session_filter == "1") {
		if (SESSION_FILTER_LOCATION == -1 && SESSION_FILTER_SESSION_TYPE == -1 && SESSION_FILTER_DAY == -1) {
			sessionIndexHtml += '<div class="filter_menu_button font_color_white color_bg_division_2" onclick="loadSessionIndexFilters(false);">' + trd('filter-menu-button') + '</div>';
		} else {
			var filterButtonLabel = '<div class="filter_menu_button_top">' + trd('filter-button-label-applied-filters') + '<div class="filter_edit_button cg-icon cg-icon-edit cg-icon-size-14 font_color_white"></div></div>';
			filterButtonLabel += '<div class="filter_menu_button_bottom">';

			var first = true;

			if (SESSION_FILTER_LOCATION != -1) {
				if (first) { first = false; } else {
					filterButtonLabel += ' | ';
					first = false;
				}
				var this_location = this_congress.locations_information['' + SESSION_FILTER_LOCATION];
				filterButtonLabel += this_location.location_name;
			}
			if (SESSION_FILTER_DAY != -1) {
				if (first) { first = false; } else {
					filterButtonLabel += ' | ';
					first = false;
				}
				var this_day = this_congress.day_information['' + SESSION_FILTER_DAY];
				filterButtonLabel += this_day.day_name;
			}
			if (SESSION_FILTER_SESSION_TYPE != -1) {
				if (first) { first = false; } else {
					filterButtonLabel += ' | ';
					first = false;
				}
				var this_session_type = this_congress.session_types_information['' + SESSION_FILTER_SESSION_TYPE];
				filterButtonLabel += this_session_type.session_type_name;
			}
			console.log('3');
			filterButtonLabel += '</div>';

			sessionIndexHtml += '<div class="filter_menu_button with_filters font_color_white color_bg_division_2" onclick="loadSessionIndexFilters(false);">' + filterButtonLabel + '</div>';
		}

	}


	sessionIndexHtml += '</div>';

	$('#session_index').remove();
	$('.mainDiv').append(sessionIndexHtml);
	console.log('4');
	$.each(open_days, function(index, day_id) {
		$('#day_container_' + day_id).removeClass('closed');
		$('#day_container_' + day_id).addClass('open');
	});

	$.each(open_groups, function(index, group_id) {
		$('.session_group_' + group_id).removeClass('closed');
		$('.session_group_' + group_id).addClass('open');
	});


	$('#session_index .scroll')[0].scrollTop = pastScroll;

	$('#session_index .scroll').scroll(function(event) {
		pastScroll = $('#session_index .scroll')[0].scrollTop;
	});
	console.log('5');
	$.each(this_congress.congress_information.congress_days, function(index, this_day_id) {
		if (!day_sessions['' + this_day_id] || day_sessions['' + this_day_id] == 0) {
			$('#day_container_' + this_day_id).hide();
		}
	});


	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('session_index');", 1);
		} else {
			setTimeout("bringforward('session_index');", 1);
		}

	} else {
		onPageChanged();
	}

}

function hexToRgb(hex) {
	var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
	return result ? {
		r: parseInt(result[1], 16),
		g: parseInt(result[2], 16),
		b: parseInt(result[3], 16)
	} : null;
}

function hexToRgbA(hex, op) {
	var c;
	if (/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)) {
		c = hex.substring(1).split('');
		if (c.length == 3) {
			c = [c[0], c[0], c[1], c[1], c[2], c[2]];
		}
		c = '0x' + c.join('');
		return 'rgba(' + [(c >> 16) & 255, (c >> 8) & 255, c & 255].join(',') + ',' + op + ')';
	}
	throw new Error('Bad Hex');
}

function loadSessionIndexGrid(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	var isCurrent = ($('#session_index_grid.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	var single_room_day = true;

	var this_day_id = SESSION_FILTER_DAY;
	if (SESSION_FILTER_DAY == -1) {
		var dayHasSessions = false;
		$.each(this_congress.congress_information.congress_days, function(index, current_day_id) {
			var this_day = this_congress.day_information['' + current_day_id];

			$.each(this_day.sessions, function(index_session, this_session_id) {
				var this_session = this_congress.sessions_information['' + this_session_id];

				if (SESSION_FILTER_SESSION_TYPE != -1 && this_session.session_session_type != SESSION_FILTER_SESSION_TYPE) {
					return true;
				}
				if (SESSION_FILTER_LOCATION != -1 && this_session.session_location_id != SESSION_FILTER_LOCATION) {
					return true;
				}

				dayHasSessions = true;

			});
			if (dayHasSessions) {
				this_day_id = current_day_id;
				return false;
			}


		});
	}

	var sessionIndexHtml = '';
	sessionIndexHtml += '<div id="session_index_grid" class="normal_page with_bottom_input ' + initialPosition + '">';
	sessionIndexHtml += '<div class="list_page_header color_font_second_menu">';
	sessionIndexHtml += '<div class="day_tabs">';
	$.each(this_congress.congress_information.congress_days, function(index, current_day_id) {
		var isSelected = false;
		if (current_day_id == this_day_id) { isSelected = true; }
		var current_day = this_congress.day_information['' + current_day_id];
		var current_day_ts = new Date(current_day.day_time);
		sessionIndexHtml += '<div class="day_tab ' + ((isSelected) ? 'selected' : '') + '" onclick="SESSION_FILTER_DAY=' + current_day_id + ';loadSessionIndexGrid()" style="' + ((isSelected) ? 'border-color:' + color_bg_division_1 + '' : '') + '">' + current_day_ts.getDate() + ' ' + trd('tab-month-' + (current_day_ts.getMonth() + 1)) + '</div>';
	});
	sessionIndexHtml += '</div>';
	sessionIndexHtml += '</div>';
	sessionIndexHtml += '<div class="list_page scroll">';
	sessionIndexHtml += '<div class="scroll_lock">';

	var this_day = this_congress.day_information['' + this_day_id];

	var session_start_times = {};

	var session_start_times_array = [];
	$.each(this_day.sessions, function(index_session, this_session_id) {
		var this_session = this_congress.sessions_information['' + this_session_id];

		if (SESSION_FILTER_SESSION_TYPE != -1 && this_session.session_session_type != SESSION_FILTER_SESSION_TYPE) {
			return true;
		}
		if (SESSION_FILTER_LOCATION != -1 && this_session.session_location_id != SESSION_FILTER_LOCATION) {
			return true;
		}

		if (!session_start_times['' + this_session.session_start_time]) {
			session_start_times['' + this_session.session_start_time] = [];
			session_start_times_array.push(this_session.session_start_time);
		} else {

		}
		session_start_times['' + this_session.session_start_time].push(this_session);
	});

	if (session_start_times_array.length == 0) {
		if (SESSION_FILTER_DAY == -1) {
			page_moving = false;

		}
		sessionIndexHtml += '<div class="font_color_gray_1" style="padding:20px;text-align:center;">' + trd('filter-program-no-results') + '</div>';
	}


	$.each(session_start_times_array, function(index, this_start_time) {

		var sessions_at_start_time = session_start_times['' + this_start_time];
		var this_start_time_string = this_start_time.replace(':', '');
		sessionIndexHtml += '<div class="session_index_grid_separator font_color_dark session_start_time_group border_top_color_dark" style="margin-top:15px">' + this_start_time + '</div>';
		sessionIndexHtml += '<div class="swiper-container swiper-container-' + this_start_time_string + '">';
		sessionIndexHtml += '  <div class="swiper-wrapper">';
		$.each(sessions_at_start_time, function(index_session, this_session) {
			if (index_session > 0) {
				single_room_day = false;
			}
			var this_session_type = this_congress.session_types_information['' + this_session.session_session_type];
			var this_session_location = this_congress.locations_information['' + this_session.session_location_id];
			var session_time_string = '';
			if (this_session.session_start_time && this_session.session_start_time != null && this_session.session_start_time != '00:00' &&
				this_session.session_end_time && this_session.session_end_time != null && this_session.session_end_time != '00:00') {
				session_time_string += this_session.session_start_time;
				session_time_string += ' - ' + this_session.session_end_time;
			}

			var session_bg = this_congress.congress_information.color_bg_card;
			if (this_session_type && this_session_type.session_type_color) {
				var rgb = hexToRgb(this_session_type.session_type_color);
				if (rgb) {
					session_bg = 'rgba(' + rgb.r + ',' + rgb.g + ',' + rgb.b + ',0.05)';
				}
			}

			var clickBehaviour = 'false';
			if (this_session.has_detail && this_session.has_detail == "1") {
				clickBehaviour = "loadSessionDetail(" + this_session.session_id + ")";
			}

			sessionIndexHtml += '<div class="swiper-slide font_color_dark" onclick="' + clickBehaviour + '">';
			sessionIndexHtml += '<div class="inner-slide" style="background-color:' + session_bg + '">';
			sessionIndexHtml += '<div class="session_type_color_indicator" style="background-color:' + ((this_session_type) ? (this_session_type.session_type_color) : 'lightGray') + '"></div>';
			sessionIndexHtml += '<div class="session_time font_color_gray_1">' + session_time_string + '</div>';
			sessionIndexHtml += '<div class="session_title font_color_dark">' + this_session.session_title + '</div>';
			sessionIndexHtml += '<div class="session_location font_color_gray_1">' + ((this_session_location) ? (this_session_location.location_name) : '') + '</div>';
			if (this_session.has_detail && this_session.has_detail == "1") {
				sessionIndexHtml += '<div style="position:absolute;right:5px;height:16px;width:16px;top:50%;margin-top:-8px;"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark" style="font-size:8px;height:16px;width:16px;line-height:16px"></span></div>';
			}
			sessionIndexHtml += '</div>';
			sessionIndexHtml += '</div>';
		});
		sessionIndexHtml += '  </div>';
		sessionIndexHtml += '</div>';
	});
	sessionIndexHtml += '</div>';
	sessionIndexHtml += '</div>';

	if (this_congress.congress_information.has_session_filter && this_congress.congress_information.has_session_filter == "1") {
		if (SESSION_FILTER_LOCATION == -1 && SESSION_FILTER_SESSION_TYPE == -1 && SESSION_FILTER_DAY == -1) {
			sessionIndexHtml += '<div class="filter_menu_button font_color_white color_bg_division_2" onclick="loadSessionIndexFilters(false);">' + trd('filter-menu-button') + '</div>';
		} else {
			var filterButtonLabel = '<div class="filter_menu_button_top">' + trd('filter-button-label-applied-filters') + '<div class="filter_edit_button cg-icon cg-icon-edit cg-icon-size-14 font_color_white"></div></div>';
			filterButtonLabel += '<div class="filter_menu_button_bottom">';

			var first = true;

			if (SESSION_FILTER_LOCATION != -1) {
				if (first) { first = false; } else {
					filterButtonLabel += ' | ';
					first = false;
				}
				var this_location = this_congress.locations_information['' + SESSION_FILTER_LOCATION];
				filterButtonLabel += this_location.location_name;
			}
			if (SESSION_FILTER_DAY != -1) {
				if (first) { first = false; } else {
					filterButtonLabel += ' | ';
					first = false;
				}
				var this_day = this_congress.day_information['' + SESSION_FILTER_DAY];
				filterButtonLabel += this_day.day_name;
			}
			if (SESSION_FILTER_SESSION_TYPE != -1) {
				if (first) { first = false; } else {
					filterButtonLabel += ' | ';
					first = false;
				}
				var this_session_type = this_congress.session_types_information['' + SESSION_FILTER_SESSION_TYPE];
				filterButtonLabel += this_session_type.session_type_name;
			}
			console.log('3');
			filterButtonLabel += '</div>';

			sessionIndexHtml += '<div class="filter_menu_button with_filters font_color_white color_bg_division_2" onclick="loadSessionIndexFilters(false);">' + filterButtonLabel + '</div>';
		}

	}


	sessionIndexHtml += '</div>';

	$('#session_index_grid').remove();
	$('.mainDiv').append(sessionIndexHtml);

	$.each(session_start_times_array, function(index, this_start_time) {

		var sessions_at_start_time = session_start_times['' + this_start_time];
		var slides_per_view = 2.2;
		if (sessions_at_start_time.length < 2) {
			slides_per_view = sessions_at_start_time.length;
		}
		var this_start_time_string = this_start_time.replace(':', '');

		var swiper = new Swiper('.swiper-container-' + this_start_time_string, {
			spaceBetween: 1,
			freeMode: false,
			freeModeSticky: true,
			slidesPerView: slides_per_view
		});
	});

	var slides_per_view = 2.2;
	/*if ($('body').hasClass('widescreen')){
	  slides_per_view = 2.2;
	}*/

	/*if (single_room_day){
	  slides_per_view = 1;
	}

	var swiper = new Swiper('.swiper-container', {
	        spaceBetween: 1,
	        freeMode: false,
	        freeModeSticky: true,
	        slidesPerView: slides_per_view
	    });
	*/
	if (fromHistory) {
		$('#session_index_grid .scroll')[0].scrollTop = pastScrollGrid;
	} else {
		pastScrollGrid = 0;
	}

	$('#session_index_grid .scroll').scroll(function(event) {
		pastScrollGrid = $('#session_index_grid .scroll')[0].scrollTop;
	});

	/*
	$('#session_index_grid .scroll')[0].scrollTop = pastScroll;

	$('#session_index_grid .scroll').scroll(function(event){
	  pastScroll = $('#session_index_grid .scroll')[0].scrollTop;
	});*/

	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('session_index_grid');", 1);
		} else {
			setTimeout("bringforward('session_index_grid');", 1);
		}

	} else {
		onPageChanged();
	}

}

function cropString(string, chars) {
	if (string.length > chars) {
		return string.substr(0, chars) + '...';
	} else {
		return string;
	}
}

function intersect(a, b) {
	var d = {};
	var results = [];
	for (var i = 0; i < b.length; i++) {
		d[b[i]] = true;
	}
	for (var j = 0; j < a.length; j++) {
		if (d[a[j]])
			results.push(a[j]);
	}
	return results;
}

function ColorLuminance(hex, lum) {

	// validate hex string
	hex = String(hex).replace(/[^0-9a-f]/gi, '');
	if (hex.length < 6) {
		hex = hex[0] + hex[0] + hex[1] + hex[1] + hex[2] + hex[2];
	}
	lum = lum || 0;

	// convert to decimal and change luminosity
	var rgb = "#",
		c, i;
	for (i = 0; i < 3; i++) {
		c = parseInt(hex.substr(i * 2, 2), 16);
		c = Math.round(Math.min(Math.max(0, c + (c * lum)), 255)).toString(16);
		rgb += ("00" + c).substr(c.length);
	}

	return rgb;
}

function getHtmlForNewsInfo(this_news_id) {
	var this_news = this_congress.news_information['' + this_news_id];
	var clickBehaviour = '';
	if (this_news.news_link) {

		var message = this_news.news_title;
		var string_divide = this_news.news_link.split("_");
		var ntype = '';
		var nvalue = '';

		if (string_divide.length > 1) {
			ntype = string_divide[0];
			//nvalue = string_divide[string_divide.length - 1];
			nvalue = this_news.news_link.replace(ntype + '_', '');
		} else {
			ntype = string_divide[0];
		}
		clickBehaviour = "processMessage('" + message + "','" + ntype + "','" + nvalue + "');";
	}

	var newsInfoHtml = '';
	newsInfoHtml += '<div class="news_container color_bg_card" onclick="' + clickBehaviour + '" id="news_container_' + this_news_id + '">';
	newsInfoHtml += '<div id="news_element_' + this_news_id + '" class="news_element ">';
	newsInfoHtml += '<div class="font_color_gray_1">' + this_news.news_timestamp.substr(0, 16) + '</div>';
	newsInfoHtml += '<div class="news_title kinda_title_color font_bold font_color_dark">' + this_news.news_title + '</div>';
	newsInfoHtml += '<div class="news_description font_color_gray_1">' + ((this_news.news_description && this_news.news_description != '' && this_news.news_description != 'null') ? this_news.news_description : '') + '</div>';

	newsInfoHtml += '</div>';
	newsInfoHtml += '</div>';

	return newsInfoHtml;

}

function loadNewsIndex(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}
	setSelectedMenuArea('news');

	var isCurrent = ($('#news_index.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}


	var newsIndexHtml = '';


	newsIndexHtml += '<div id="news_index" class="normal_page  ' + initialPosition + '">';

	newsIndexHtml += '<div class="list_page_header ">';
	newsIndexHtml += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('header-news') + '</div></div>';
	newsIndexHtml += '</div>';

	newsIndexHtml += '<div class="list_page scroll">';
	newsIndexHtml += '<div class="scroll_lock">';



	newsIndexHtml += '<div id="news_list">';
	newsIndexHtml += '</div>';

	newsIndexHtml += '</div>';
	newsIndexHtml += '</div>';
	newsIndexHtml += '</div>';

	$('#news_index').remove();
	$('.mainDiv').append(newsIndexHtml);
	var now = new Date();

	var url = services_home + 'get_user_notifications.php?rand=' + now.getTime() + '&id=' + this_congress.congress_information.congress_id + '&locale=' + this_congress.congress_information.congress_lang;

	$.ajax({
		type: 'GET',
		url: url,
		cache: false,
		dataType: 'json',
		success: function loadNotifications(response) {
			if (response && response.object && response.object.notifications && response.object.notifications.length > 0) {
				this_congress.news_information = response.object.notifications_information;
				this_congress.congress_information.congress_news = response.object.notifications;
				populateNews();
			} else {
				$('#news_list').append('<div class="font_color_gray_1" style="font-size:14pt;text-align:center;padding:20px">' + trd('no-notifications') + '</div>');
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			$('#news_list').append('<div class="font_color_gray_1" style="font-size:14pt;text-align:center;padding:20px">' + trd('count-not-get-notifications') + '</div>');
		}
	});


	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('news_index');", 1);
		} else {
			setTimeout("bringforward('news_index');", 1);
		}

	} else {
		onPageChanged();
	}

}

function refreshNews() {

	if(!this_congress || !this_congress.congress_information || polling_socket || moderation_socket || chat_rooms.room.socket){ return false; }
    if ($('#dashboard.current').length == 0){ return false; }

	var now = new Date();

	var url = services_home + 'get_user_notifications.php?rand=' + now.getTime() + '&id=' + this_congress.congress_information.congress_id + '&locale=' + this_congress.congress_information.congress_lang + '&last_news=1';


	$.ajax({
		type: 'GET',
		url: url,
		cache: false,
		dataType: 'json',
		success: function loadNotifications(response) {
			if (response && response.object && response.object.notifications && response.object.notifications.length > 0) {
                var last_news = response.object.notifications_information[response.object.notifications[0]];
                $('.last_news').html(last_news.news_title);
                $('.last_news_timestamp').html(last_news.news_timestamp.substr(0, 16));
			} else {
				$('.last_news').html(trd('no-news-dashboard'));
				$('.last_news_timestamp').html('');
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {

		}
	});
}

function populateNews() {
	$('#news_list').html('');
	if (this_congress.congress_information.congress_news.length > 0) {
		$.each(this_congress.congress_information.congress_news, function(index, this_news_id) {
			$('#news_list').append(getHtmlForNewsInfo(this_news_id));
		});
	} else {

	}
	replaceLinks();
}

function dismissNews(news_id) {
	$('#news_container_' + news_id).addClass('selected');
	var options = { opacity: 0 };
	$('#news_container_' + news_id).animate(options, 1000, 'ease-out', function() { $('#news_container_' + news_id).hide(); });
}



function showFilter() {

	var hasFilters = false;

	if ($('.current').attr('id') == 'speakers_index' && this_congress.congress_information.congress_speaker_types.length > 0) {
		hasFilters = true;
	}

	if ($('.current').attr('id') == 'resources_index' && this_congress.congress_information.congress_resources_types.length > 0) {
		hasFilters = true;
	}

	if ($('.current').attr('id') == 'session_index') {
		hasFilters = true;
	}

	if ($('.current').attr('id') == 'sponsors_index' && this_congress.congress_information.congress_sponsor_types.length > 0) {
		hasFilters = true;
	}

	if ($('.current').attr('id') == 'posters_index' && this_congress.congress_information.congress_poster_types.length > 0) {
		hasFilters = true;
	}

	if ($('.current').attr('id') == 'poi_index' && this_congress.congress_information.congress_poi_types.length > 0) {
		hasFilters = true;
	}

	if ($('.current').attr('id') == 'exhibitors_index' && this_congress.congress_information.congress_exhibitor_types.length > 0) {
		hasFilters = true;
	}

	if ($('.current').attr('id') == 'mapDiv') {
		hasFilters = true;
	}

	if (hasFilters) {
		$('.side_menu_filter_container').show();
		$('.side_menu_filter_container').removeClass('hidden');
		$('.side_menu_filter_container').addClass('show');
		//$('.mainDiv').addClass('pulledleft');
		//$('.header').addClass('pulledleft');
		mainDivOverlay();
		if ($('body').hasClass('widescreen')) {
			hideMenu(true);
		}
	}
}

function hideFilter() {
	$('.side_menu_filter_container').removeClass('show');
	$('.side_menu_filter_container').addClass('hidden');
	//$('.mainDiv').removeClass('pulledleft');
	//$('.header').removeClass('pulledleft');
	$('#headerOverlay').remove();
	clearOverlays();
}

function showMenu() {
	clearOverlays();
	$('.menu_container').removeClass('noTransition');
	$('.side_menu_container').removeClass('noTransition');
	$('.toggle_menu_button').addClass('selected');
	//$('#back_button').hide();
	$('.side_menu_container').show();
	$('.side_menu_container').removeClass('hidden');
	$('.side_menu_container').addClass('show');
	if ($('.widescreen').length > 0) {
		$('.mainDiv').addClass('pulledright');
		$('.header').addClass('pulledright');
		$('.toggle_menu_button').hide();
	} else if ($('#headerOverlay').length == 0) {
		$('.header').append('<div id="headerOverlay"></div>')
	}
	mainDivOverlay();
	if ($('body').hasClass('widescreen')) {
		hideFilter();
	}
	saveActionInHistory("showMenu()");
}

function hideMenu(byForce) {
	if ($('body').hasClass('widescreen') || byForce) {
		return;
	} else if ($('.side_menu_container.show').length > 0) {
		console.log('Menu Item transition');
		$('.menu_container').addClass('noTransition');
		$('.side_menu_container').addClass('noTransition');
		//$('.menu_container')[0].offsetHeight;
		//$('.side_menu_container')[0].offsetHeight;
		$('.menu_container').removeClass('show');
		$('.menu_container').addClass('hidden');
		$('.side_menu_container').removeClass('show');
		$('.side_menu_container').addClass('hidden');
		$('.toggle_menu_button').removeClass('selected');

		$('.menu_container').removeClass('noTransition');
		$('.side_menu_container').removeClass('noTransition');

		clearMainDivOverlay();
	}
}

function toggleMenu() {
	if ($('.side_menu_container').hasClass('show')) {
		hideMenu(true);
	} else {
		showMenu();
	}
	setTimeout("resetFeaturedSwipe();", 300);
}

function toggleFilter() {
	if ($('.side_menu_filter_container').hasClass('show')) {
		hideFilter();
	} else {
		showFilter();
	}
}

function clearSearchList() {
	$('.index_search_text').val('');
	if ($('#poi_index.current').length > 0)
		search_poi();
	if ($('#exhibitors_index.current').length > 0)
		search_exhibitors();
	if ($('#posters_index.current').length > 0)
		search_posters();
	if ($('#speakers_index.current').length > 0)
		search_speakers();
	if ($('#session_index.current').length > 0)
		search_sessions();

}

function toggleSearch(function_call) {
	if ($('.searchHeader').hasClass('show')) {
		$('.searchHeader').removeClass('show');
		$('.list_page').css('top', '51px');
		clearSearchList();
	} else {
		$('.searchHeader').addClass('show');
		$('.list_page').css('top', '100px');
		$('.searchHeader input').show();
		$('.searchHeader input').focus();
	}
	if (function_call) { eval(function_call); }
}

function array_contains(array, value) {

	if (!array || array.length == 0) {
		return false;
	}

	for (i = 0; i < array.length; i++) {
		if (array[i] == value) {
			return true;
		}
	}
	return false;
}

function trd(trd_key) {
	if (this_congress && this_congress.translations && this_congress.translations['' + trd_key]) {
		return this_congress.translations['' + trd_key];
	} else if (app_translations && app_translations['' + trd_key]) {
		return app_translations['' + trd_key];
	}
	return trd_key;
}

String.prototype.hashCode = function() {
	var hash = 0,
		i, chr, len;
	if (this.length === 0) return hash;
	for (i = 0, len = this.length; i < len; i++) {
		chr = this.charCodeAt(i);
		hash = ((hash << 5) - hash) + chr;
		hash |= 0; // Convert to 32bit integer
	}
	return hash;
};


function stringToDate(datetime_string) {

	var return_date = new Date();

	try {

		var date_string_array = datetime_string.split(' ');
		var time_string = date_string_array[1];
		var date_string = date_string_array[0];


		var date_array = date_string.split('-');
		var year = parseInt(date_array[0]);
		var month = parseInt(date_array[1]) - 1;
		var day = parseInt(date_array[2]);

		var time_array = time_string.split(':');
		var hours = parseInt(time_array[0]);
		var minutes = parseInt(time_array[1]);

		return_date.setYear(year);
		return_date.setMonth(month);
		return_date.setDate(day);
		return_date.setHours(hours);
		return_date.setMinutes(minutes);

	} catch (err) {
		return_date = null;
	}

	return return_date;

}

function schedule_local_notification(ntype, nvalue, title, message, time, offset) {
	var not_date = stringToDate(time);
	not_date = new Date(not_date.getTime() - offset * 1000 * 60);
	var id = parseInt(Math.abs(ntype.hashCode()).toString() + nvalue);

	if (isMobile) {
		cordova.plugins.notification.local.schedule({
			id: id,
			title: title,
			text: message,
			at: not_date,
			data: { ntype: ntype, nvalue: nvalue }
		});
	}

	/*cordova.plugins.notification.local.on("click", function (notification) {
	    //alert("ola");
	    navigator.notification.confirm(trd('session') + ' ' + this_session.session_title + ' ' + trd('is-about-to-start'),function sessionStartCallback(buttonIndex){
	      if (buttonIndex == 1){
	        loadSessionDetail(session_id);
	      }
	      if (buttonIndex == 2){
	                                                         // DO NOTHING
	     }
	   },trd('session-reminder-title'), [''+trd('button-go-to-session'),''+trd('button-ok')]);
	});
	*/

}

function cancel_local_notification(ntype, nvalue) {
	var id = parseInt(ntype.hashCode().toString() + nvalue);
	cordova.plugins.notification.local.cancel(id, function() {

	});
}

function getProfileFromLinkedIn() {
	var url = "https://www.linkedin.com/oauth/v2/authorization?response_type=code&client_id=78mpee2xnd8muc&redirect_uri=http%3A%2F%2Fcms.cloudguideapp.com%2Fservices%2Fintegrations%2Flinkedin.php&state=v3&scope=r_basicprofile";
	var ref = cordova.InAppBrowser.open(url, '_blank', 'location=yes');
	ref.addEventListener('loadstop', function() {
		ref.executeScript({ code: "function test(){ return returnable_object; } test();" }, returnTest);
	});

	function returnTest(response) {
		if (response) {
			ref.close();
			var linkedInUser = response[0];
			user_data.profile.user_pic = linkedInUser.base64_image;
			user_data.profile.user_linkedin_url = linkedInUser.publicProfileUrl;
			saveUserProfile(true);
			loadMyProfile();
			$('.btn_link_with_linkedin').hide();
			return response;
		}
	}
}

function openMyQRCode() {
	createQRCodePage(user_data.profile.user_code);
	//new QRCode(document.getElementById("qrcode"), user_data.profile.user_code);
	//var url = 'http://chart.apis.google.com/chart?cht=qr&chs=300x300&chl='+user_data.profile.user_code;
	//cordova.InAppBrowser.open(url,'_blank','location=no');
}

function createQRCodePage(qrcode, html_ready) {
	if (!html_ready) {
		html_page.show(false, false, 'qrcode_page',
			'<div id="qrcode" style="width:256px;margin:100px auto"></div>',
			createQRCodePage.bind(this, qrcode, true))
	} else {
		new QRCode(document.getElementById('qrcode'), qrcode);
	}
}


function showQueryUserLocation() {

	var userLocationHtml = '';
	userLocationHtml += '             <div class="section_title color_bg_division_1 font_color_white">' + trd('travel-by-title') + '</div>';
	userLocationHtml += '<select class="user_field_choose_one" id="travel_by" style="width: 100%; padding: 5px 10px; margin-bottom: 5px;"><option value="car">' + trd('travel-by-car') + '</option><option value="airplane">' + trd('travel-by-airplane') + '</option><option value="train">' + trd('travel-by-train') + '</option><option value="bus">' + trd('travel-by-bus') + '</option><option value="bicycle">' + trd('travel-by-bicycle') + '</option><option value="other">' + trd('travel-by-other') + '</option></select>';
	userLocationHtml += '             <div class="section_title color_bg_division_1 font_color_white">' + trd('query-location-title') + '</div>';
	userLocationHtml += '             <div class="profile_header" style="margin-top: 5px; margin-bottom: 5px;">';
	userLocationHtml += '                 <div class="profile_details">';
	userLocationHtml += '                     <div class="profile_name font_color_dark">' + trd('query-location-explain') + '</div>';
	userLocationHtml += '                 </div>';
	userLocationHtml += '             </div>';
	userLocationHtml += '<div class="block_text_holder"><input type="text"  id="userlocation_textarea" class="block_text_visible font_color_gray_1" value="" style="border:1px solid #404040;text-align:center;margin-bottom:15px;background-color:white;font-size:25px;" /></div>';

	userLocationHtml += '         </div>';
	userLocationHtml += '     </div>';
	userLocationHtml += '     <div onclick="queryGooglePlaces()" class="block_button color_bg_division_1 font_color_white" >' + trd('query-location-search') + '</div>';
	userLocationHtml += '<div id="google_places_list"></div>';

	$('.modal_page').html(userLocationHtml);
	showModal();
	document.getElementById('userlocation_textarea').focus();
}

function queryGooglePlaces() {
	var inputLocation = $('#userlocation_textarea').val();
	if (inputLocation == '') {
		showToastrAlert('error', trd('error-location-query-empty'));
		return;
	}
	var url = 'https://maps.googleapis.com/maps/api/place/autocomplete/json?input=' + encodeURIComponent(inputLocation) + '&types=(cities)&key=AIzaSyAxzTQQ1pXQNNMoxvCC9L4nJFVJUXBCixQ';
	showLoadingOverlay();
	$.ajax({
		type: 'GET',
		url: url,
		cache: true,
		dataType: 'json',
		success: function(response) {
			hideLoadingOverlay();
			var resultsGoogleHtml = '';
			if (response.predictions && response.predictions.length > 0) {
				$.each(response.predictions, function(index, this_prediction) {
					resultsGoogleHtml += '<div class="query_location_item font_color_dark border_bottom_color_dark" onclick="setUserLocation(\'' + this_prediction.place_id + '\')">' + this_prediction.description + '</div>';
				});
			} else {
				resultsGoogleHtml += '<div class="query_location_item" style="text-align:center">' + trd('no-location-query-results') + '</div>';
			}
			$('#google_places_list').html(resultsGoogleHtml);
		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(xhr));
		}
	});
}

function setUserLocation(place_id) {
	var url = 'https://maps.googleapis.com/maps/api/place/details/json?placeid=' + place_id + '&key=AIzaSyAxzTQQ1pXQNNMoxvCC9L4nJFVJUXBCixQ';
	showLoadingOverlay();
	$.ajax({
		type: 'GET',
		url: url,
		cache: true,
		dataType: 'json',
		success: function(response) {
			hideLoadingOverlay();
			var params = {
				lat: response.result.geometry.location.lat,
				lng: response.result.geometry.location.lng,
				place: response.result.formatted_address,
				user_id: user_data.profile.user_id,
				travel_by: $('#travel_by').val()
			}
			saveUserLocation(params);
		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
		}
	});
}

function saveUserLocation(params) {
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	user_data.location = { lat: params.lat, lng: params.lng, place: params.place, travel_by: params.travel_by };
	saveUserDataToStorage();

	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				'f': 'setUserLocation',
				'lat': params.lat,
				'lng': params.lng,
				'place': params.place,
				'user_id': params.user_id,
				'travel_by': params.travel_by
			}
		},
		dataType: 'json',
		success: function(response) {
			hideLoadingOverlay();

			if (response.success) {
				closeModal();
				showToastrAlert('success', trd('user-location-updated'));
			} else {

			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(xhr));
			user_location = false;
		}
	});
}

function showUserInputBox() {

	var userinputboxHTML = '';
	userinputboxHTML += '             <div class="section_title color_bg_division_1 font_color_white">' + trd('onewordfeedback-title') + '</div>';
	userinputboxHTML += '             <div class="profile_header">';
	userinputboxHTML += '                 <div class="profile_details">';
	userinputboxHTML += '                     <div class="profile_name font_size_big font_color_dark">' + trd('onewordfeedback-label') + '</div>';
	userinputboxHTML += '                 </div>';
	userinputboxHTML += '             </div>';
	//userinputboxHTML += '             <textarea id="userinputbox_textarea" style="width:50%; margin-left:25%; border:1px solid '+color_bg_division_2+'; padding:5px; -webkit-appearance:none; resize:none"></textarea>';
	userinputboxHTML += '<div class="block_text_holder"><input type="text"  id="userinputbox_textarea" class="block_text_visible font_color_gray_1" value="" style="border:1px solid #404040;text-align:center;margin-bottom:15px;background-color:white;font-size:25px;" /></div>';

	userinputboxHTML += '         </div>';
	userinputboxHTML += '     </div>';
	userinputboxHTML += '     <div onclick="verifyUserInputBox()" class="block_button color_bg_division_1 font_color_white" >' + trd('onewordfeedback-send') + '</div>';
	userinputboxHTML += '     <div class="modal_button_bottom font_color_white color_bg_division_1" onclick="closeModal();">' + trd('bt-cancel') + '</div>';
	$('.modal_page').html(userinputboxHTML);
	showModal();

	setTimeout(function() { $('#userinputbox_textarea').focus(); }, 1000);
}


function verifyUserInputBox() {
	var text = $('#userinputbox_textarea').val();
	var wordcount = countWords(text);
	if (wordcount != 1) { showToastrAlert('error', trd('onewordfeedback-label')); } else { setUseriInputBox(text); }
}

function countWords(s) {
	if (s != '') {
		s = s.replace(/(^\s*)|(\s*$)/gi, "");
		s = s.replace(/[ ]{2,}/gi, " ");
		s = s.replace(/\n /, "\n");
		return s.split(' ').length;
	} else {
		return 0;
	}
}

function setUseriInputBox(text) {
	showLoadingOverlay();
	var user_id = user_data.profile.user_id;
	var congress_id = this_congress.congress_information.congress_id;
	var url = services_home + 'services.php?rand=' + (new Date()).getTime();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			params: {
				'f': 'setUserInputBox',
				'user_id': user_id,
				'congress_id': congress_id,
				'text': text
			}
		},
		dataType: 'json',
		success: function(response) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(response));
			closeModal();
			showToastrAlert('success', trd('onewordfeedback-thankyou'));
			if (response.success) {} else {}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got' + JSON.stringify(xhr));
		}
	});
}


function saveActionInHistory(action) {
	var saved_history = JSON.parse(window.localStorage['saved_history'] || "[]");
	saved_history.push(action);
	var history_string = JSON.stringify(saved_history)
	window.localStorage['saved_history'] = history_string;
	return saved_history;
}

function logSavedHistory() {
	var saved_history = JSON.parse(window.localStorage['saved_history'] || "[]");
	var relevant_history = saved_history.filter(function(value, index, self) {
		return (value != 'dashboard' && self.indexOf(value) === index);
		//if it's not dashboard and is an unique value
	});
	if (relevant_history.length > 0) {
		window.localStorage['saved_history'] = "[]";
		var params = {
			'f': 'logSavedHistory',
			'user_id': user_data.profile.user_id,
			'congress_id': this_congress.congress_information.congress_id,
			'history': relevant_history
		}
		console.log(JSON.stringify(params));
		var url = services_home + 'services.php?rand=' + (new Date()).getTime();
		$.ajax({
			type: 'POST',
			url: url,
			cache: false,
			dataType: 'json',
			data: { params: params },
			success: function(response) {
				console.log(JSON.stringify(response));
			},
			error: function(xhr, ajaxOptions, thrownError) {
				console.log('ERROR:' + JSON.stringify(xhr));
			}
		});
	}
}


function loadUserRSVP(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}
	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage();
		console.log('not logged in');
		return;
	}
	var rsvp_html = '';
	rsvp_html += '<div id="rsvp" class="normal_page ' + initialPosition + '">';

	rsvp_html += '             <div class="section_title color_bg_division_1 font_color_white">' + trd('rsvp-title') + '</div>';
	rsvp_html += '             <div class="profile_header">';
	rsvp_html += '                 <div class="profile_details">';
	if (user_data.profile.user_rsvp == "0") {
		rsvp_html += '     <div onclick="confirmPresence()" style="text-transform:initial; margin-top:40px" class="block_button color_bg_division_1 font_color_white" >' + trd('rsvp-confirm') + '</div>';
	} else {
		rsvp_html += '                     <div class="profile_name font_size_big font_color_dark">' + trd('rsvp-label') + '</div>';
	}
	rsvp_html += '                 </div>';
	rsvp_html += '             </div>';
	rsvp_html += '</div>';
	var isCurrent = ($('#myprofile.current').length > 0);
	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}
	$('#rsvp').remove();
	$('.mainDiv').append(rsvp_html);
	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('rsvp');", 1);
		} else {
			setTimeout("bringforward('rsvp');", 1);
		}
	} else {
		onPageChanged();
	}
}

function confirmPresence() {
	user_data.profile.user_rsvp = "1";
	loadDashboard();
	updateProfile();
	showToastrAlert('success', trd('rsvp-confirmed'));
}

function loadPhotoContest(fromHistory) {
	if (page_moving) {
		return;
	} else {
		page_moving = true;
	}

	var initialPosition = '';
	if (isCurrent) {
		initialPosition = 'current';
	} else if (fromHistory) {
		initialPosition = 'past';
	} else {
		initialPosition = 'future';
	}

	if (!user_data || user_data.profile.anonymous == "1") {
		loadAuthPage();
		console.log('not logged in');
		return;
	}
	//var mainDivWidth = $('.mainDiv').width();
	var mainDivWidth = Math.floor($('.mainDiv').width() * 0.7);
	var contest_html = '';
	contest_html += '<div id="photocontest" class="normal_page ' + initialPosition + '">';

	contest_html += '<div class="color_bg_division_1" style="color:white;padding:8px;font-size:10px;">';
	contest_html += '<table style="width:100%;text-align:center;"><tr>';
	contest_html += '<td onclick="takePhotoForFeed()">' + trd('option-post-take-a-photo') + '</td>';
	contest_html += '<td onclick="choosePhotoForFeed();">' + trd('option-post-choose-photo') + '</td>';
	contest_html += '</tr></table>';
	contest_html += '</div>';
	contest_html += '<div id="post_temp_img" onclick="choosePhotoMethod()" style="height:' + mainDivWidth + 'px;background-size:cover;background-color:gray;position:relative;"><div class="post_temp_img_placeholder"></div></div>';
	contest_html += '<input type="hidden" id="post_img_src" value="" />';

	contest_html += '<div class="section_title font_bold color_bg_division_1 font_color_white">Smartphone</div>';
	contest_html += '<select style="border: 2px solid #e16f38; margin: 20px; width:200px;" class="user_field_choose_one" id="post_text">';
	//contest_html += '<option value="Iphone 4">Iphone 4</option>';
	//contest_html += '<option value="Iphone 5">Iphone 5</option>';
	//contest_html += '<option value="Iphone 6">Iphone 6</option>';
	//contest_html += '<option value="Iphone 7">Iphone 7</option>';
	//contest_html += '<option value="Samsung Galaxy s3">Samsung Galaxy s3</option>';
	//contest_html += '<option value="Samsung Galaxy s4">Samsung Galaxy s4</option>';
	//contest_html += '<option value="Samsung Galaxy s5">Samsung Galaxy s5</option>';
	//contest_html += '<option value="Samsung Galaxy s6">Samsung Galaxy s6</option>';
	//contest_html += '<option value="Samsung Galaxy s7">Samsung Galaxy s7</option>';
	contest_html += trd('phone-options');
	contest_html += '</select>';

	contest_html += '<div style="margin-top:20px" class="button_cancel font_color_white color_bg_division_2 block_button" onclick="submitPhotoContestData()">' + trd('bt-send') + '</div>';

	contest_html += '</div>';
	var isCurrent = ($('#photocontest.current').length > 0);

	$('#photocontest').remove();
	$('.mainDiv').append(contest_html);
	if (!isCurrent) {
		if (fromHistory) {
			setTimeout("bringFromHistory('photocontest');", 1);
		} else {
			setTimeout("bringforward('photocontest');", 1);
		}
	} else {
		onPageChanged();
	}
}

function submitPhotoContestData() {

	if ($('#post_img_src').val() == '') {
		showToastrAlert('error', trd('invalid-post-no-image'));
		return;
	}
	if ($('#post_text').val() == '') {
		cgAlert(trd('invalid-post-no-text'));
		return;
	}

	var this_post = {
		image: $('#post_img_src').val(),
		text: $('#post_text').val()
	}

	var url = services_home + 'tools/photosubmit/index.php';
	showLoadingOverlay();
	$.ajax({
		type: 'POST',
		url: url,
		cache: false,
		data: {
			user_data: user_data,
			base64_image: this_post.image,
			post_data: { 'text': this_post.text }

		},
		dataType: 'json',
		success: function photoPosted(response) {
			hideLoadingOverlay();
			console.log('got response:' + JSON.stringify(response));
			if (response.success) {
				showToastrAlert('success', trd('success-image-posted-to-feed'));
				loadDashboard();
			} else {
				showToastrAlert('error', trd('error-could-not-save-profile'));
			}

		},
		error: function(xhr, ajaxOptions, thrownError) {
			hideLoadingOverlay();
			console.log('got error: ' + JSON.stringify(xhr));
		}
	});

}

function showModalHtml(dismissable, html, show) {
	var modal_html = '';
	if (dismissable) { var style_bottom = ' style="bottom:40px;"'; } else { var style_bottom = ''; }
	modal_html += '<div class="normal_page scroll" ' + style_bottom + '>';
	modal_html += '<div class="scroll_lock">';
	if (html) { modal_html += html; }
	modal_html += '</div>';
	modal_html += '</div>';
	if (dismissable) {
		modal_html += '<div class="modal_button_bottom font_color_white color_bg_division_1" onclick="closeModal();">' + trd('bt-cancel') + '</div>';
	}
	$('.modal_page').html(modal_html);
	if (show) {
		$('.modal_page').addClass('show');
	}
}

function showDuplicateUsersModal(users) {
	//var users = [{user_id:'1', user_name:'Ricardo'}, {user_id:'2', user_name:'Rocky'}];
	html = '<div class="list_page_header  ">';
	html += '<div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + 'Please select your identification' + '</div></div>';
	users.map(function(m) {
		html += '<div class="speaker_button border_bottom_color_dark" id="speaker_button_' + m.user_id + '" onclick="getUserProfile(\'profile_user_id\', ' + m.user_id + ');">';
		html += '<table><tr><td><div class="small_pic" style="background-image:url(\'img/defaults/img_user.png\');background-size:cover"></div></td>';
		html += '<td><div class="speaker_name font_bold font_color_dark">' + m.user_name + '</div>';
		html += '<div class="speaker_short_description">' + '' + '</div></td></tr></table>';
		html += '<div class="gotodetail_button" id="gotodetail_button_speaker_' + m.user_id + '"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div>';
		html += '</div>';
	});
	showModalHtml(false, html, true);
}

function getAppGraphic(name) {
	if (this_congress.media_information[name] && this_congress.media_information[name]['' + this_congress.congress_information.congress_id]) {
		return this_congress.media_information[name]['' + this_congress.congress_information.congress_id].imgURL_original;
	} else { return false; }

}

var blocks = {
	replaceSources: function(html) {
		if (this_congress.media_information.block) {
			$.each(this_congress.media_information.block, function(id, media) {
				if (media.offline) {
					html = html.replace('block_' + id + '_src', wwwRoot + '/' + media.name);
				}
			});
		}

		return html;
	}
};

function stripTags(str) {
	str = str.toString();
	return str.replace(/<\/?[^>]+>/gi, '');
}

function addSessionToCalendar(session_id) {
	console.log(session_id);

	var this_session = this_congress.sessions_information['' + session_id];
	var this_day = this_congress.day_information['' + this_session.session_day_id];
	var date = this_day.day_time.split("-");
	var start_time = this_session.session_start_time.split(":");
	var end_time = null;
	var endDate = null;
	if (this_session.session_end_time != null) {
		end_time = this_session.session_end_time.split(":");
	} else {
		end_time = start_time;
	}
	endDate = new Date(date[0], date[1] - 1, date[2], end_time[0], end_time[1], 0, 0, 0);
	var startDate = new Date(date[0], date[1] - 1, date[2], start_time[0], start_time[1], 0, 0, 0); // beware: month 0 = january, 11 = december

	var title = this_session.session_title;
	var location = '';
	if (this_congress.locations_information['' + this_session.session_location_id])
		location = this_congress.locations_information['' + this_session.session_location_id].location_name;
	var notes = stripTags(this_session.session_description);
	if (isMobile) {
		// if(this_session.session_end_time == null) {
		//  showToastrAlert('info','No end time. Session added with 1h duration');
		// }
		var success = function(message) {
			console.log("Success: " + JSON.stringify(message));
			//showToastrAlert('info', trd('session-added-calendar'));
		};
		var error = function(message) {
			console.log("Error: " + message);
			showToastrAlert('info', trd('session-add-calendar-error'));
		};

		console.log(startDate + ',' + endDate)
		window.plugins.calendar.createEvent(title, location, notes, startDate, endDate, success, error);
	} else {
		getICS(title, notes, location, startDate, endDate);
	}
}

function removeSessionFromCalendar(session_id) {
	var this_session = this_congress.sessions_information['' + session_id];
	var this_day = this_congress.day_information['' + this_session.session_day_id];
	var date = this_day.day_time.split("-");
	var start_time = this_session.session_start_time.split(":");
	var end_time = null;
	var endDate = null;
	if (this_session.session_end_time != null) {
		end_time = this_session.session_end_time.split(":");
	} else {
		end_time = start_time;
	}
	endDate = new Date(date[0], date[1] - 1, date[2], end_time[0], end_time[1], 0, 0, 0);
	var startDate = new Date(date[0], date[1] - 1, date[2], start_time[0], start_time[1], 0, 0, 0); // beware: month 0 = january, 11 = december
	var title = this_session.session_title;
	var location = '';
	if (this_congress.locations_information['' + this_session.session_location_id])
		location = this_congress.locations_information['' + this_session.session_location_id].location_name;
	var notes = stripTags(this_session.session_description);

	var success = function(message) { console.log("Success: " + JSON.stringify(message)); };
	var error = function(message) { console.log("Error: " + message); };

	console.log(startDate + ',' + endDate)
	if (isMobile) {
		window.plugins.calendar.deleteEvent(title, location, notes, startDate, endDate, success, error);
	}
}

function syncMyAgendaWithCalendar() {
	showLoadingOverlay();
	var first_day = this_congress.day_information[this_congress.congress_information.congress_days[0]].day_time.split("-");
	var last_day = this_congress.day_information[this_congress.congress_information.congress_days[this_congress.congress_information.congress_days.length - 1]].day_time.split("-");
	var startDate = new Date(first_day[0], first_day[1] - 1, first_day[2], 0, 0, 0, 0, 0);
	var endDate = new Date(last_day[0], last_day[1] - 1, last_day[2], 23, 59, 0, 0, 0);
	console.log(startDate);
	console.log(endDate);
	var success = function(message) { console.log("Success: " + JSON.stringify(message)); };
	var error = function(message) { console.log("Error: " + message); };

	if (isMobile) {
		window.plugins.calendar.deleteEvent('', '', '', startDate, endDate, success, error);
	}
	//$.each(user_data.profile.agenda["sessions"], function(index, session_id) {
	//window.plugins.calendar.deleteEvent(this_congress.sessions_information[''+session_id].session_title,'','',startDate,endDate,success,error);
	//removeSessionFromCalendar(session_id);
	//addSessionToCalendar(session_id);
	//});

	setTimeout(function() {
		$.each(user_data.profile.agenda["sessions"], function(index, session_id) {
			addSessionToCalendar(session_id);
		});
		hideLoadingOverlay();
		showToastrAlert('info', trd('calendar-updated'));
	}, 100);
}

function getICS(title, notes, location, startDate, endDate) {
	var event = {
		'summary': title,
		'location': location,
		'description': notes,
		'dtstart': startDate,
		'dtend': endDate
	};

	$.ajax({
		type: 'POST',
		url: services_home + '/tools/generateICS/download.php',
		cache: false,
		dataType: 'json',
		data: {
			name: '',
			event: event
		},
		success: function(response) {
			window.location = services_home + '/tools/generateICS/' + response.link;
		},
		error: function(xhr, ajaxOptions, thrownError) {
			console.log('ERROR:' + JSON.stringify(xhr));

		}
	});
}

var profile_selection = {
	list: [],
	excluded: [],
	search: '',
	load_limit: 200,
	clear: function() {
		profile_selection.list = [];
		profile_selection.search = '';
	},
	show: function(function_name, exclude_array, select_array) {
		if (!user_data || user_data.profile.anonymous == "1") { loadAuthPage(false); return; }
		if (!this_congress.profiles_information) {
			if (exclude_array) { exclude_array = ', ' + JSON.stringify(exclude_array); } else { exclude_array = ', false'; }
			if (select_array) { select_array = ', ' + JSON.stringify(select_array); } else { select_array = ', false'; }
			refreshUserProfiles('profile_selection.show("' + function_name + '"' + exclude_array + select_array + ')');
			return;
		}
		profile_selection.clear();
		if (exclude_array) { profile_selection.excluded = exclude_array; } else { profile_selection.excluded = []; }
		if (select_array) { profile_selection.list = select_array; }
		var modal_html = '';
		modal_html += '<div class="scroll_lock">';
		modal_html += '<div class="list_page_header" style="height:25px; box-shadow: 0px 1px 2px 0px silver;"><div class="list_page_header_content color_font_second_menu" style="height:25px; line-height:25px;"><div class="list_page_header_title font_bold" style="height:25px; line-height:25px;">' + trd('selected-participants') + ': <span id="profile_selection_count">0</span></div></div>';
		modal_html += '</div>';
		modal_html += '</div>';
		modal_html += '<div id="profile_selection_items" style="position:absolute; width:100%; bottom:100px; top:25px; overflow-y:scroll"></div>';
		modal_html += '</div>';
		modal_html += '</div>';
		modal_html += '</div>';
		modal_html += '<div class="modal_button_bottom" style="height:80px;background-color: white; box-shadow: 0px 0px 4px 1px silver;"><div class="block_text_holder" style="height:40px;"><span class="cg-icon cg-icon-search" style="position:absolute; left:-5px; font-size:14pt; color:grey; z-index:1; line-height:30px;"></span><input type="text" autofocus="" placeholder="' + trd('type-search-here') + '" id="profile_selection_search" class="block_text_visible font_color_gray_1" style="border:1px solid grey; width:calc(100% - 40px); padding-left: 40px !important; text-align:left; text-transform:none; bottom:10px;background-color:white;" onfocus="profile_selection.resetSearch()" onkeyup="profile_selection.renderItems()"></div><div class="button_cancel font_color_white color_bg_division_2" onclick="profile_selection.clear(); closeModal()" style="padding:10px; width:30%; float:left; ">' + trd('bt-cancel') + '</div><div class="button_cancel font_color_white color_bg_division_2" onclick="if(profile_selection.list.length>0){ closeModal(); ' + function_name + '(profile_selection.list); }" style="padding:10px; margin-left:calc(30% + 25px); opacity:0.5;" id="profile_selection_ok">OK</div></div>';
		$('.modal_page').html(modal_html);
		$('.modal_page').addClass('show');
		$('#profile_selection_search').focus();
	},
	renderItems: function(load_more) {
		profile_selection.search = $('#profile_selection_search').val().toLowerCase();
		var search = profile_selection.search;
		var items = [];
		var searchable_string = false;
		$.each(this_congress.profiles_information, function(id, profile) {
			if (search.length > 2) { searchable_string = profile.user_name + profile.user_subtitle; } else if (search.length > 0) { searchable_string = profile.user_name; }
			if (!profile_selection.excluded.contains(id)) {
				if (searchable_string) {
					searchable_string = searchable_string.toLowerCase();
					if (searchable_string.indexOf(search) > -1) { items.push(profile); }
				} else {
					items.push(profile);
				}
			}
		});
		if (items.length > profile_selection.load_limit) {
			if (!load_more) {
				items = items.slice(0, profile_selection.load_limit);
				var has_more = true;
			} else {
				items = items.slice(profile_selection.load_limit + 1, items.length - 1);
				var has_more = false;
			}
		} else {
			var has_more = false;
		}
		var html = '';
		items.map(function(m) {
			if (m.user_subtitle && m.user_subtitle != '') { var title = m.user_name + '<br><div style="font-size:10px;">' + m.user_subtitle + '</div>' } else { var title = m.user_name }
			if (profile_selection.list.contains(m.user_id)) { var selected = 'selected'; } else { var selected = ''; }
			html += '<div class="selected_color_bg_division_1 font_color_gray_1 option_element ' + selected + '" id="profile_element_' + m.user_id + '" onclick="profile_selection.selectItem(' + m.user_id + ')" style="border-radius:0px; border-color: grey;"><table><tbody><tr><td width="44"><span class="cg-icon align-left cg-icon-bt-checkbox color_icon_clickable"></span></td><td><span class="option_text font_color_dark">' + title + '</span></td></tr></tbody></table></div>';
		});
		if (has_more) { html += '<div id="profile_selection_more"><div class="block_button color_bg_division_2 font_color_white" style="margin:20px;font-size:12px; text-transform:none;" onclick="profile_selection.renderItems(true)">' + trd('load-more') + '</div></div>'; }
		if (load_more) {
			$('#profile_selection_more').html(html);
		} else {
			$('#profile_selection_items').html(html);
		}
	},
	selectItem: function(user_id) {
		if ($('#profile_element_' + user_id + '.selected').length > 0) {
			$('#profile_element_' + user_id).removeClass('selected');
			profile_selection.list = profile_selection.list.filter(function(f) { return f != user_id; });
		} else {
			$('#profile_element_' + user_id).addClass('selected');
			profile_selection.list.push(user_id);
		}
		if (profile_selection.list.length > 0) { $('#profile_selection_ok').css({ 'opacity': '1' }); } else { $('#profile_selection_ok').css({ 'opacity': '0.5' }); }
		$('#profile_selection_count').html(profile_selection.list.length);
	},
	resetSearch: function() {
		profile_selection.search = '';
		$('#profile_selection_search').val('');
		profile_selection.renderItems();
	}
}
var html_page = {
	show: function(fromHistory, requires_auth, container_id, html, function_name) {
		if (page_moving) { return; } else { page_moving = true; }
		var initialPosition = '';
		if (isCurrent) { initialPosition = 'current'; } else if (fromHistory) { initialPosition = 'past'; } else { initialPosition = 'future'; }
		if (requires_auth) {
			if (!user_data || user_data.profile.anonymous == "1") {
				loadAuthPage();
				console.log('not logged in');
				return;
			}
		}
		var container_html = '<div class="normal_page scroll ' + initialPosition + '" id="' + container_id + '">';
		container_html += html;
		container_html += '</div>';
		$('#' + container_id).remove();
		$('.mainDiv').append(container_html);
		var isCurrent = $('#' + container_id + '.current').length > 0;
		if (!isCurrent) {
			if (fromHistory) {
				setTimeout("bringFromHistory('" + container_id + "');", 1);
				if (function_name) {
					function_name.call();
				}
			} else {
				setTimeout("bringforward('" + container_id + "');", 1);
				html_page.showed[container_id] = {
					requires_auth: requires_auth,
					html: html,
					function_name: function_name
				};
				if (function_name) {
					function_name.call();

					// var f_array = function_name.split('.');
					// if(f_array.length == 1){ window[function_name].call(); }
					// if(f_array.length == 2){ window[f_array[0]][f_array[1]].call(); }
					// if(f_array.length == 3){ window[f_array[0]][f_array[1]][f_array[2]].call(); }
				}
			}
		} else {
			onPageChanged();
		}
	},
	showed: {}
};



var chat_rooms = {
	list: [],
	lobby: {
		page: function() {
			var html = '';
			html += '<div class="list_page_header"><div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('chat-rooms') + '</div></div></div>';
			html += '<div class="list_page scroll">';
			html += '<div id="chat_rooms_lobby_items"></div>';
			html += '<div class="link_element linkInfo list_element" onclick="chat_rooms.edit.page()" style="border:1px solid silver; margin:20px 12px; box-shadow: -2px 2px 2px silver;"><table><tbody><tr><td><div class="link_name font_bold font_color_dark">' + trd('chat-rooms-create-title') + '</div><div class="link_short_description font_color_gray_1" style="font-size:12px">' + trd('chat-rooms-create-subtitle') + '</div></td></tr></tbody></table><div class="gotodetail_button"><span class="cg-icon cg-icon-fwd  cg-icon-size-10 font_color_dark"></span></div></div>';
			html += '</div>';
			if (!this_congress.profiles_information || this_congress.profiles_information.legth == 0) {
				console.log('REFRESHING PROFILES');
				refreshUserProfiles('html_page.show(false, true, \'chat_rooms_lobby\', \'' + html + '\', chat_rooms.lobby.items)');
			} else {
				html_page.show(false, true, 'chat_rooms_lobby', html, chat_rooms.lobby.items);
			}
		},
		items: function() {
			showLoadingOverlay();
			var params = {
				f: 'getUserChatRooms',
				user_id: user_data.profile.user_id,
				congress_id: this_congress.congress_information.congress_id
			};
			var url = services_home + 'services.php?rand=' + (new Date()).getTime();
			console.log('calling ' + url);
			$.ajax({
				type: 'POST',
				url: url,
				cache: false,
				dataType: 'json',
				data: { params: params },
				success: function roomSaved(response) {
					hideLoadingOverlay();
					if (response.success) {
						chat_rooms.list = response.object.list;
						var html = '';
						response.object.list.forEach(function(room) {
							html += '<div style="position:relative; margin: 10px 10px 0px 10px; box-shadow: 0px -2px 1px silver; padding:10px; color:#404040; border-bottom: 1px solid ' + color_bg_division_1 + '; border-right: 1px solid silver; background-color:white;">';
							if (room.user_id == user_data.profile.user_id) {
								html += '<div onclick="chat_rooms.edit.page(' + room.room_id + ')" class="edit_button cg-icon cg-icon-edit cg-icon-size-14 color_icon_second_menu selected_font_color_white" style="position:absolute;top:0px;;right:0px;"></div>';
							}
							html += '<div class="font_bold">' + room.room_title + '</div>';
							html += '<div style="color: grey">' + room.online_count + ' online';
							if (room.new_messages) {
								html += ', ' + room.new_messages + ' ' + trd('new-messages') + '</div>';
							} else { html += '</div>'; }
							html += '<div id="chat_rooms_last_message_' + room.room_id + '" style="font-style: italic; font-size:12px;">' + (room.last_message == null ? 'No messages' : room.last_message.message_text) + '</div>';
							html += '<div style="display:flex;height: 30px;line-height: 30px;margin-top:5px"><div onclick="chat_rooms.lobby.updateChatUser(' + room.room_id + ',this)" class="chat_rooms_notify ' + (room.notifiable == '1' ? 'selected' : '') + '" style="flex-shrink:1;"><span class="cg-icon cg-icon-bt-checkbox color_icon_clickable" style="width:unset;height:unset;line-height:unset;margin-right:5px"></span>Notify me</div><div onclick="chat_rooms.room.join(' + room.room_id + ')" style="text-align:right; color:' + color_bg_division_1 + ';height: 30px;line-height: 30px; flex:1">' + trd('chat-rooms-enter') + '</div></div>';
							html += '</div>';
						});
						$('#chat_rooms_lobby_items').html(html);
					} else {
						showToastrAlert('success', trd(response.message));
					}
				},
				error: function(xhr, ajaxOptions, thrownError) {
					hideLoadingOverlay();
					console.log('ERROR:' + JSON.stringify(xhr));
					showToastrAlert('error', trd('error-getting-code'));
				}
			});
		},
		updateChatUser: function(room_id, el) {
			var params = {
				f: 'updateChatUser',
				user_id: user_data.profile.user_id,
				room_id: room_id,
				notifiable: $(el).hasClass('selected') ? '0' : '1'
			};
			var url = services_home + 'services.php?rand=' + (new Date()).getTime();
			console.log('calling ' + url);
			$.ajax({
				type: 'POST',
				url: url,
				cache: false,
				dataType: 'json',
				data: { params: params },
				success: function roomSaved(response) {
					showToastrAlert('success', trd(response.message));
					if ($(el).hasClass('selected')) {
						$(el).removeClass('selected');
					} else {
						$(el).addClass('selected');
					}
					chat_rooms.list.forEach(function(room) {
						if (room.room_id == room_id) {
							if ($(el).hasClass('selected'))
								room.notifiable = '1';
							else
								room.notifiable = '0';
						}
					});

				},
				error: function(xhr, ajaxOptions, thrownError) {
					console.log('ERROR:' + JSON.stringify(xhr));
					showToastrAlert('error', trd(response.message));

				}
			});
		}
	},

	edit: {
		room: false,
		page: function(room_id) {
			if (room_id) {
				chat_rooms.edit.room = chat_rooms.list.filter(function(this_room) { return room_id == this_room.room_id; })[0];
			} else {
				chat_rooms.edit.room = {
					room_id: 0,
					room_title: '',
					invites: []
				};
			}

			var html = '';
			html += '<div class="list_page_header"><div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold">' + trd('chat-room-settings') + '</div></div></div>';
			html += '<div class="list_page scroll">';
			html += '<div class="section_title color_bg_division_1 font_color_white">' + trd('chat-rooms-section-name') + '</div>';

			html += '<div id="chat_rooms_new_name">';
			html += '<input id="chat_rooms_new_name_input" style="width:calc(100% - 2px);height:42px; border:1px solid silver;padding-left:5px;padding-right:5px" placeholder="' + trd('chat-rooms-create-placeholder') + '">';
			html += '</div>';
			html += '<div class="section_title color_bg_division_1 font_color_white">' + trd('chat-rooms-section-participants') + '</div>';
			html += '<div class="chat_rooms_participant_card font_color_dark" style="position:relative" onclick="profile_selection.show(\'chat_rooms.edit.updateParticipants\',[' + user_data.profile.user_id + '],chat_rooms.edit.room.invites);">' + trd('chat-rooms-create-select-participants') + '<div style="position:absolute; right:5px;top:0;height:100%;width:20px;background-image:url(img/plus.png);background-position:center;background-repeat:no-repeat;background-size:contain"></div></div>';
			html += '<div id="chat_rooms_new_participants"></div>';
			html += '</div>';
			html += '<div id="chat_rooms_new_action_button" style="margin-top:40px"><div class="modal_button_bottom color_bg_division_2 font_color_white" onclick="chat_rooms.edit.' + (room_id ? 'updateRoom' : 'addRoom') + '()">' + trd('chat-rooms-create-save') + '</div></div>';

			html_page.show(false, true, 'chat_rooms_edit', html, chat_rooms.edit.items);
		},
		items: function() {
			$('#chat_rooms_new_name_input').val(chat_rooms.edit.room.room_title);
			chat_rooms.edit.refreshParticipantsHtml();
		},
		updateParticipants: function(result) {
			this.room.invites = result;
			this.refreshParticipantsHtml();

		},
		refreshParticipantsHtml: function() {
			var html = '<div class="list_empty" style="margin:15px;color:silver">' + trd('chat-rooms-no-participants') + '</div>';
			this.room.invites.forEach(function(user_id) {
				html += ' <div class="chat_rooms_participant_card font_color_dark">' + this_congress.profiles_information['' + user_id].user_name + '</div> ';
			});
			$('#chat_rooms_new_participants').html(html);
		},
		addRoom: function() {
			if (!$('#chat_rooms_new_name_input').val()) { showToastrAlert('error', trd('chat-rooms-missing-title')); return false; }
			if (chat_rooms.edit.room.invites.length == 0) { showToastrAlert('error', trd('chat-rooms-missing-invites')); return false; }
			showLoadingOverlay();
			var params = {
				f: 'createChatRoom',
				user_id: user_data.profile.user_id,
				congress_id: this_congress.congress_information.congress_id,
				room_title: $('#chat_rooms_new_name_input').val(),
				invites: chat_rooms.edit.room.invites
			};
			var url = services_home + 'services.php?rand=' + (new Date()).getTime();
			console.log('calling ' + url);
			$.ajax({
				type: 'POST',
				url: url,
				cache: false,
				dataType: 'json',
				data: { params: params },
				success: function roomSaved(response) {
					if (response.success) {
						showToastrAlert('success', trd(response.message));
					} else {
						showToastrAlert('error', trd(response.message));
					}
					hideLoadingOverlay();
					goBack();

				},
				error: function(xhr, ajaxOptions, thrownError) {
					console.log('ERROR:' + JSON.stringify(xhr));
					showToastrAlert('error', trd('error-getting-code'));
					hideLoadingOverlay();
					goBack();

				}
			});
		},
		updateRoom: function() {
			if (!$('#chat_rooms_new_name_input').val()) { showToastrAlert('error', trd('chat-rooms-missing-title')); return false; }
			if (chat_rooms.edit.room.invites.length == 0) { showToastrAlert('error', trd('chat-rooms-missing-invites')); return false; }
			showLoadingOverlay();
			var params = {
				f: 'updateChatRoom',
				user_id: user_data.profile.user_id,
				congress_id: this_congress.congress_information.congress_id,
				room_id: chat_rooms.edit.room.room_id,
				room_title: $('#chat_rooms_new_name_input').val(),
				invites: chat_rooms.edit.room.invites
			};
			var url = services_home + 'services.php?rand=' + (new Date()).getTime();
			console.log('calling ' + url);
			$.ajax({
				type: 'POST',
				url: url,
				cache: false,
				dataType: 'json',
				data: { params: params },
				success: function roomSaved(response) {
					if (response.success) {
						showToastrAlert('success', trd(response.message));
					} else {
						showToastrAlert('error', trd(response.message));
					}
					hideLoadingOverlay();
					goBack();

				},
				error: function(xhr, ajaxOptions, thrownError) {
					console.log('ERROR:' + JSON.stringify(xhr));
					showToastrAlert('error', trd('error-getting-code'));
					hideLoadingOverlay();
					goBack();

				}
			});
		}

	},
	room: {
		socket: false,
		current_room: false,
		last_message: false,
		users_online: [],
		join: function(room_id) {
			chat_rooms.room.current_room = chat_rooms.list.filter(function(room) { return room.room_id == room_id; })[0];
			chat_rooms.room.socket = io.connect('http://94.46.160.248:3003');
			chat_rooms.room.socket.on('connect', function() {
				chat_rooms.room.socket.emit('joinRoom', { 'user_id': user_data.profile.user_id, 'room_id': room_id, 'congress_id': this_congress.congress_information.congress_id });
			});
			chat_rooms.room.socket.on('renderRoomMessages', function(data) {
				chat_rooms.room.renderMessages(data);
				//console.log('rendering all messages:');
				//console.log(data);
			});
			chat_rooms.room.socket.on('renderRoomMessage', function(data) {
				chat_rooms.room.renderMessage(data);
				//console.log('rendering one message:');
				//console.log(data);
			});
			chat_rooms.room.socket.on('renderRoomUsers', function(data) {
				chat_rooms.room.renderRoomUsers(data);
				//console.log('rendering room users:');
				//console.log(data);
			});
			chat_rooms.room.socket.on('userJoinsRoom', function(user_id) {
				chat_rooms.room.users_online.push(user_id);
				chat_rooms.room.renderRoomUsers(chat_rooms.room.users_online);
				var html = '<div class="chat_room_user_action">' + this_congress.profiles_information['' + user_id].user_name + ' ' + trd('user-joins-room') + '</div>';
				$('.chat_room_messages').append(html);
				$(".chat_room_modal")[0].scrollTop = $('.chat_room_messages').height();
			});

			chat_rooms.room.socket.on('userLeavesRoom', function(user_id) {
				chat_rooms.room.users_online = chat_rooms.room.users_online.filter(function(f) { return f != user_id; });
				chat_rooms.room.renderRoomUsers(chat_rooms.room.users_online);
				var html = '<div class="chat_room_user_action">' + this_congress.profiles_information['' + user_id].user_name + ' ' + trd('user-leaves-room') + '</div>';
				$('.chat_room_messages').append(html);
				$(".chat_room_modal")[0].scrollTop = $('.chat_room_messages').height();
			});

			chat_rooms.room.socket.on('disconnect', function() {
				console.log('disconnecting');
				chat_rooms.room.socket = false;
			});

			chat_rooms.room.socket.on('failed', function(error) {
				console.log('server sent an error:');
				console.log(error);
			});
			var room = chat_rooms.list.filter(function(this_room) { return room_id == this_room.room_id; })[0];
			var modalHtml = '<div class="section_title font_bold color_bg_division_1 font_color_white">' + room.room_title + '</div>';
			modalHtml += '<div class="section_title color_bg_division_2 font_color_white" style="text-transform: none; padding: 2px 10px 4px 10px; height: 14px; text-overflow: ellipsis; overflow: hidden; white-space: nowrap;" id="chat_room_users_online"></div>';
			modalHtml += '<div class="chat_room_modal normal_page scroll" onclick="event.stopPropagation();">';
			modalHtml += '<div class="chat_room_messages">';
			messagesHtml = '<div class="">' + trd('retrieving-messages') + '</div>';
			modalHtml += '</div>';
			modalHtml += '</div>';
			modalHtml += '<div class="chat_room_input_container">';
			modalHtml += '<input class="chat_room_input" maxlength="200" type="text" placeholder="' + trd('chat-message-placeholder') + '"/>';
			modalHtml += '<div class="chat_room_input_button" ' + clickAttribute + '="chat_rooms.room.sendMessage(' + room.room_id + ')" ></div>';
			modalHtml += '</div>';
			modalHtml += '<div class="button_cancel font_color_white color_bg_division_2 modal_button_bottom" onclick="chat_rooms.lobby.items();closeModal()">' + trd('chat-room-close-button') + '</div>';
			modalHtml += '<script> $(".chat_room_input").on("focus", function(){ setTimeout(function() { $(".chat_room_modal")[0].scrollTop=$(\'.chat_room_messages\').height(); },500); }); $(".chat_room_input").on("keyup", function(){ if($(this).val()=="") $(\'.chat_room_input_button\').css(\'opacity\',\'0\'); else $(\'.chat_room_input_button\').css(\'opacity\',\'.5\'); }); </script>';
			showModalHtml(false, modalHtml, true);

		},
		getColorForUser: function(user_id) {
			//console.log(chat_rooms.room.current_room);
			//var colors = ['#4F6D7A', '#EADC96', '#C1B2AB', '#006992', '#60BFBF', '#F58276', '#5B504D', '#936E41', '#8C5383', '#725A51'];
			var colors = ['blue', 'green', 'red', 'purple', 'brown', 'pink', 'cyan', 'beige'];

			var color = colors[0];
			chat_rooms.room.current_room.invites.forEach(function(user, index) {
				//console.log(user);
				if (user_id == user) {
					//console.log(color);
					color = colors[index];
				}
			});
			return color;
		},
		renderMessages: function(messages) {
			var messagesHtml = '<div class="list_empty">No messages</div>';
			var previous_day = '2000-01-01 00:00:00';
			messages.reverse().forEach(function(message) {
				console.log(Date.parse(previous_day.split(' ')[0]));
				console.log((Date.parse(previous_day.split(' ')[0]) - Date.parse(message.timestamp.split(' ')[0])) / 86400000);
				if ((Date.parse(previous_day.split(' ')[0]) - Date.parse(message.timestamp.split(' ')[0])) / 86400000 < 0) {
					messagesHtml += '<div class="chat_room_message_day">' + daysString(message.timestamp.split(' ')[0]) + '</div>';
				}
				//console.log(message);
				var direction = 'TO';
				if (message.user_id == user_data.profile.user_id) {
					direction = 'FROM';
				}
				messagesHtml += '<div class="chat_room_message_detail ' + direction + '" style="color:grey;"><span class="chat_room_message_timestamp">' + message.timestamp + ' </span></div>';
				messagesHtml += '<div class="chat_message ' + direction + '" id="list_element_' + message.message_id + '"><div class="chat_room_message_user" style="color:' + chat_rooms.room.getColorForUser(message.user_id) + '">' + this_congress.profiles_information['' + message.user_id].user_name + '</div><div>' + convertLineBreaks(message.message_text) + '</div><div class="perninha"></div></div>';
				chat_rooms.room.last_message = message;
				previous_day = message.timestamp;
			});

			$('.chat_room_messages').html(messagesHtml);
			$(".chat_room_modal")[0].scrollTop = $('.chat_room_messages').height();

		},
		renderMessage: function(message) {
			var messagesHtml = '';
			var previous_day = '2000-01-01 00:00:00';
			if (chat_rooms.room.last_message) {
				previous_day = chat_rooms.room.last_message.timestamp;
			}
			if ((Date.parse(previous_day.split(' ')[0]) - Date.parse(message.timestamp.split(' ')[0])) / 86400000 < 0) {
				messagesHtml += '<div class="chat_room_message_day">' + daysString(message.timestamp.split(' ')[0]) + '</div>';
			}
			previous_day = message.timestamp.split(' ')[0];
			//console.log(message);

			var direction = 'TO';
			if (message.user_id == user_data.profile.user_id) {
				direction = 'FROM';
			}
			messagesHtml += '<div class="chat_room_message_detail ' + direction + '" style="color:grey;"><span class="chat_room_message_timestamp">' + message.timestamp + ' </span></div>';
			messagesHtml += '<div class="chat_message ' + direction + '" id="list_element_' + message.message_id + '"><div class="chat_room_message_user" style="color:' + chat_rooms.room.getColorForUser(message.user_id) + '">' + this_congress.profiles_information['' + message.user_id].user_name + '</div><div>' + convertLineBreaks(message.message_text) + '</div><div class="perninha"></div></div>';

			$('.chat_room_messages').append(messagesHtml);
			setTimeout(function() { $(".chat_room_modal")[0].scrollTop = $('.chat_room_messages').height(); }, 500);
			chat_rooms.room.last_message = message;
			$('#chat_rooms_last_message_' + chat_rooms.room.current_room.room_id).html(message.message_text);

		},
		renderRoomUsers: function(user_ids) {
			user_ids = user_ids.filter(function(item, pos, self) { return self.indexOf(item) == pos; }) //remove duplicates
			console.log('rendering room users');
			console.log(user_ids);
			var enumeration = '';
			var user_icon = '<span class="cg-icon cg-icon-user" style="font-size: 8px;line-height: initial;width: 12px;height: 12px;"></span>';
			user_ids.map(function(id, index) {
				if (index == 3) { enumeration += '... +' + (user_ids.length - 3); } else if (index < 3) {
					enumeration += user_icon + '<span>' + this_congress.profiles_information['' + id].user_name + '&nbsp;&nbsp;</span>';
				}
			});
			$('#chat_room_users_online').html(enumeration);
		},
		sendMessage: function(room_id) {
			var message_text = $('.chat_room_input').val();
			if (message_text == '') {
				showToastrAlert('error', trd(invalid - message));
				return;
			}
			chat_rooms.room.socket.emit('messageRoom', { 'user_id': user_data.profile.user_id, 'room_id': room_id, 'congress_id': this_congress.congress_information.congress_id, 'message_text': $('.chat_room_input').val() });
			$('.chat_room_input').val('');
			$('.chat_room_input').blur();
		}
	}
}

function daysString(day_timestamp) {
	var day_strings = ['sunday', 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday'];
	var current_day_time = Date.now() - (Date.now() % 86400000);
	var input_day_time = Date.parse(day_timestamp);
	var days = (current_day_time - input_day_time) / 86400000;
	console.log(current_day_time, input_day_time);
	console.log(days);
	var day = new Date(day_timestamp);
	if (days == 0)
		return trd('days-today');
	if (days == 1)
		return trd('days-yesterday');
	if (days > 1 && days < 6)
		return trd('days-' + day_strings[day.getUTCDay()]);
	return day_timestamp;
}

var photo_share = {
	url: false,
	onSuccess: function(result) {
		console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
		console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
	},
	onError: function(msg) {
		console.log("Sharing failed with message: " + msg);
	},
	imageLink: function(link) {
		if (link) { var url = link; } else if (photo_share.url) { var url = photo_share.url; } else { return false; }
		var options = {
			message: this_congress.congress_information.congress_name, // not supported on some apps (Facebook, Instagram)
			subject: this_congress.congress_information.congress_name, // fi. for email
			files: [url] // an array of filenames either locally or remotely
		}
		saveActionInHistory("photo_share.imageLink('" + url + "')");
		window.plugins.socialsharing.shareWithOptions(options, photo_share.onSuccess, photo_share.onError);
		photo_share.url = false;
	}
}

function availableSoon(title) {
	var html = '';
	html += '<div class="list_page_header"><div class="list_page_header_content color_font_second_menu"><div class="list_page_header_title font_bold" style="opacity:0.6">' + title + '</div></div></div>';
	html += '<div style="margin-top:100px;"><p style="text-align: center;"><b class="color_font_dark">' + trd('content-available-soon') + '</b></p></div>';
	html += '<div style="margin-left:-10px;text-align: center;" onclick="goBack();"><div class="cg-icon cg-icon-back cg-icon-size-12 color_icon_top_menu"> </div><div class="color_icon_top_menu" style="display:inline-block; margin-left:-5px;">' + trd('go-back') + '</div></div>';
	html_page.show(false, false, 'content_available_soon', html, false);
}

var one_liner = {
	html: function(tag, css, attributes, content) {
		if (!tag) { return false; }
		var element = this.getElement(tag);
		var id_string = this.getId(tag);
		var class_string = this.getClass(tag);
		var html = '<' + element;
		if (id_string) { html += ' ' + this.getId(tag); }
		if (class_string) { html += ' ' + this.getClass(tag); }
		if (css) { html += ' style="' + this.stringEscape(css) + '" '; }
		if (attributes) { html += ' ' + this.translate(attributes); }
		html += '>';
		if (content) {
			html += this.translate(content);
			html += '</' + element + '>';
		}
		return html;
	},
	getElement: function(tag) {
		var id_split = tag.split('#');
		if (id_split.length > 1) { return id_split[0]; }
		var class_split = tag.split('.');
		if (class_split.length > 1) { return class_split[0]; }
	},
	getId: function(tag) {
		var tag_split = tag.split('#');
		if (tag_split.length > 1) {
			tag_split = tag_split[1].split('.');
			return 'id="' + tag_split[0] + '"';
		} else {
			return false;
		}
	},
	getClass: function(tag) {
		var tag_split = tag.split('.');
		if (tag_split.length > 1) {
			delete(tag_split[0]);
			return 'class="' + tag_split.join(' ').slice(1) + '"';
		} else {
			return false;
		}
	},
	translate(html) {
		var html_split = html.split('ºº');
		if (html_split.length > 1) {
			html_split = html_split.map(function(m, i) {
				if ((i + 1) % 2 == 0) { return this.stringEscape(trd(m)); } else { return m; }
			});
			return html_split.join('');
		} else {
			return html;
		}
	},
	stringEscape(s) {
		return s ? s.replace(/\\/g, '\\\\').replace(/\n/g, '\\n').replace(/\t/g, '\\t').replace(/\v/g, '\\v').replace(/'/g, "\\'").replace(/"/g, '\\"').replace(/[\x00-\x1F\x80-\x9F]/g, hex) : s;

		function hex(c) {
			var v = '0' + c.charCodeAt(0).toString(16);
			return '\\x' + v.substr(v.length - 2);
		}
	}
}

function º(tag, css, attributes, content) { return one_liner.html(tag, css, attributes, content); }
